#! /usr/bin/env python
# -*- coding: latin1 -*-

import ginv

st = ginv.SystemType("Polynomial")
ic = ginv.CoeffInterface("NParameterGmpZ", st, ['c[1]', 'c[2]', 'c[7]', 'c[8]', 'c[9]'])
im = ginv.MonomInterface("DegRevLex", st, ['a[1]', 'a[3]', 'b[1]'])
ip = ginv.PolyInterface("PolyList", st, im, ic)
iw = ginv.WrapInterface("Without", ip)
iD = ginv.DivisionInterface("Janet", iw)

eqs = [\
"(-a[1])*b[1] + (-c[1])",\
"(2) + (-1)*b[1]^2 + (-1)*a[1]^2 + (-c[2])",\
"(-1)*a[3]^2 + (-c[8])"]

basis = ginv.basisBuild("TQ", iD, eqs)

print "         lengthIB = ", basis.lengthIB()
print "         lengthGB = ", basis.lengthGB()
print "     numCriterion = ", basis.numCriterion()
print "         numSpoly = ", basis.numSpoly()
print "     numReduction = ", basis.numReduction()
print "         userTime = ", basis.userTime()
print "          sysTime = ", basis.sysTime()
print "         realTime = ", basis.realTime()
print "hilbertPolynomial = ", basis.hilbertPolynomial()

f = file("challenge2b.janet", "w")
print >> f, "_IB_RESULT := ["
len = basis.lengthIB()
i = 1
for p in basis.iterIB():
    if i < len:
        print >> f, p, ","
    else:
        print >> f, p
    i = i+1
print >> f, "]:"
print >> f, "_IB_RESULTlm := ["
i = 1
for p in basis.iterLmIB():
    if i < len:
        print >> f, p, ","
    else:
        print >> f, p
    i = i+1
print >> f, "]:"
f.close()

