from gzip import GzipFile
import os, xml.dom.minidom
import ginv

folder = os.path.join(".", "polynomial")
fname = "cyclic8.xml.gz"

def readExample(fname):
  try:
    print fname
    file = GzipFile(fname, 'rb')
    doc = xml.dom.minidom.parse(file)
    root = doc.documentElement
    description = root.getElementsByTagName('Description').item(0).firstChild.nodeValue.strip()
    systemType = root.getElementsByTagName('SystemType').item(0).getAttribute("System")
    independ = map(lambda var: var.firstChild.nodeValue.strip(), root.getElementsByTagName('Variables').item(0).\
                                                                      getElementsByTagName('Independent').item(0).\
                                                                      getElementsByTagName('Variable'))
    equations = map(lambda eq: eq.firstChild.nodeValue.strip(), root.getElementsByTagName('Equations').item(0).\
                                                                     getElementsByTagName('Equation'))
    return (description, systemType, independ, equations)
  except Exception, val:
    print val
    return None

(description, systemType, independ, equations) = readExample(os.path.join(folder, fname))
print description

equations = map(lambda eq: eq.encode('latin1'), equations)

st = ginv.SystemType(systemType)
im = ginv.MonomInterface("DegRevLexByte", st, independ)
# im = ginv.MonomInterface("Lex", st, independ)
ic = ginv.CoeffInterface("GmpZ", st)
# ic = ginv.CoeffInterface("ModularShort", st, modularShort=31013)
ip = ginv.PolyInterface("PolyList", st, im, ic)
iw = ginv.WrapInterface("CritPartially", ip)
# iw = ginv.WrapInterface("C1C2C3C4", ip)
id = ginv.DivisionInterface("Janet", iw)

basis = ginv.basisBuild("TQBlockMax", id, equations)

print "         lenghtIB = ", basis.lenghtIB()
print "         lenghtGB = ", basis.lenghtGB()
print "     numCriterion = ", basis.numCriterion()
print "         numSpoly = ", basis.numSpoly()
print "     numReduction = ", basis.numReduction()
print "         userTime = ", basis.userTime()
print "          sysTime = ", basis.sysTime()
print "         realTime = ", basis.realTime()
print "hilbertPolynomial = ", basis.hilbertPolynomial()

