#! /usr/bin/env python
# -*- coding: utf-8 -*-

import os
from gzip import GzipFile
import ginv

folder = os.path.join(".", "polynomial")
fname = "gggcoeffspolyeqs.gz"

file = GzipFile(os.path.join(folder, fname), 'rb')
lines = file.readlines()

independ = lines[5][lines[5].find(":")+2:-3].split(",")
print independ

equations = {}
for i in range(8, len(lines)):
  j = lines[i].find(":=")
  if j < 0:
    equations[name].append(lines[i].strip().replace("\\", "").replace(":", ""))
  else:
    name = lines[i][:j].strip()
    equations[name] = [lines[i][j+2:].strip().replace("\\", "").replace(":", "")]
    print "%6d %s" % (i, name)
for (name, equaition) in equations.iteritems():
  equations[name] = "".join(equaition)


st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("DegRevLexByte", st, independ)
#ic = ginv.CoeffInterface("GmpZ", st)
ic = ginv.CoeffInterface("ModularShort", st, modularShort=31013)
ip = ginv.PolyInterface("PolyList", st, im, ic)
# ip = ginv.PolyInterface("PolyArray", st, im, ic)
iw = ginv.WrapInterface("CritPartially", ip)
# iw = ginv.WrapInterface("Without", ip)
id = ginv.DivisionInterface("Janet", iw)

basis = ginv.basisBuild("TQBlockLow", id, equations.values())

print "         lengthIB = ", basis.lengthIB()
print "         lengthGB = ", basis.lengthGB()
print "     numCriterion = ", basis.numCriterion()
print "         numSpoly = ", basis.numSpoly()
print "     numReduction = ", basis.numReduction()
print "         userTime = ", basis.userTime()
print "          sysTime = ", basis.sysTime()
print "         realTime = ", basis.realTime()
print "hilbertPolynomial = ", basis.hilbertPolynomial()

#try:
  #import Gnuplot

  #s = 0
  #step, stepTime, Tlength, Qlength, EqLmLength = [], [], [], [], []
  #for (sT, lenT, lenQ, lenEqLm) in basis.iterStatistics():
    #s += 1
    #step.append(s)
    #stepTime.append(sT)
    #Tlength.append(lenT)
    #Qlength.append(lenQ)
    #EqLmLength.append(lenEqLm)

  #g = Gnuplot.Gnuplot()
  #g.xlabel('time')
  #g.ylabel('size')
  #g.title(fname)
  #g.plot(Gnuplot.Data(step, Tlength, title='T', with='lines'),\
         #Gnuplot.Data(step, Qlength,  title='Q', with='lines'),\
         #Gnuplot.Data(step, EqLmLength, title='eqQ', with='lines'))
  #raw_input('Press return to show results...\n')

#except Exception, val:
    #print val
    #print "not module 'gnuplot-py' or 'gnuplot'"

for p in basis.iterGB():
  print p
