#! /usr/bin/env python
# -*- coding: latin1 -*-

import ginv

st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("DegRevLexByte", st, ['u0', 'u1', 'u2', 'u3', 'u4', 'u5', 'u6', 'u7'])
ic = ginv.CoeffInterface("GmpZ", st)
ip = ginv.PolyInterface("PolyList", st, im, ic)

iw = ginv.WrapInterface("CritPartially", ip)
iD = ginv.DivisionInterface("Janet", iw)

eqs = \
["u0^2-u0+2*u1^2+2*u2^2+2*u3^2+2*u4^2+2*u5^2+2*u6^2+2*u7^2",\
 "2*u0*u1+2*u1*u2-u1+2*u2*u3+2*u3*u4+2*u4*u5+2*u5*u6+2*u6*u7",\
 "2*u0*u2+u1^2+2*u1*u3+2*u2*u4-u2+2*u3*u5+2*u4*u6+2*u5*u7",\
 "2*u0*u3+2*u1*u2+2*u1*u4+2*u2*u5+2*u3*u6-u3+2*u4*u7",\
 "2*u0*u4+2*u1*u3+2*u1*u5+u2^2+2*u2*u6+2*u3*u7-u4",\
 "2*u0*u5+2*u1*u4+2*u1*u6+2*u2*u3+2*u2*u7-u5",\
 "2*u0*u6+2*u1*u5+2*u1*u7+2*u2*u4+u3^2-u6",\
 "u0+2*u1+2*u2+2*u3+2*u4+2*u5+2*u6+2*u7-1"]

basis = ginv.basisBuild("TQ", iD, eqs, time=1)

print "         lengthIB = ", basis.lengthIB()
print "         lengthGB = ", basis.lengthGB()
print "     numCriterion = ", basis.numCriterion()
print "         numSpoly = ", basis.numSpoly()
print "     numReduction = ", basis.numReduction()
print "         userTime = ", basis.userTime()
print "          sysTime = ", basis.sysTime()
print "         realTime = ", basis.realTime()
print "hilbertPolynomial = ", basis.hilbertPolynomial()

print "      out of time = ", basis.outOfTime()
print "comp. interrupted = ", basis.computationInterrupted()
