/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// #include "../util/iutil.h"
// #include "./ialgorithm.h"
//
// class IRefPoly {
// public:
//   struct Term {
//     IPoly   *mRef;
//     IMonom  mMonom;
//     ICoeff  mCoeff;
//
//     Term(): mRef(NULL), mCoeff(NULL) {}
//     ~Term() {
//       delete mRef;
//       delete mCoeff;
//     }
//   };
//
// protected:
//   typedef IList<Term>::Iterator      Iterator;
//   typedef IList<Term>::ConstIterator ConstIterator;
//
//   IList<Term>  mHead;
//   IMonom       mMonom;
//   ICoeff       mCoeff;
//
//   void mult()
//
// };
//
// class ISPoly {
// public:
//   struct Term {
//     IPoly   *mRef;
//     ICoeff  *mCoeff;
//
//     Term(): mRef(NULL), mCoeff(NULL) {}
//     ~Term() {
//       delete mRef;
//       delete mCoeff;
//     }
//   };
//
// protected:
//   typedef IList<Term>::Iterator      Iterator;
//   typedef IList<Term>::ConstIterator ConstIterator;
//
//   IList<Term>  mHead;
//
// public:
//   ISPoly(IPoly *ref, ICoeff* coeff): mHead() {
//     Iterator i = mHead.begin();
//     i.insert();
//     (*i)->mRef = ref;
//     (*i)->mCoeff = coeff;
//   }
//   ISPoly(const ISPoly& a): mHead(a.mHead) {}
//   ~ISPoly() {}
//
//   void multAdd(ICoeff* coeff1, ISPoly &a, ICoeff* coeff2);
//   void pp();
//   bool isPp() const;
//
//   void assertValid(const char* fileName, int fileLine) const;
// };
//
// class IRefPoly {
// public:
//   struct Term {
//     ISPoly   *mRef;
//     IPoly    *mCoeff;
//
//     Term(): mRef(NULL), mCoeff(NULL) {}
//     ~Term() {
//       delete mCoeff;
//     }
//   };
//
// protected:
//   typedef IList<Term>::Iterator      Iterator;
//   typedef IList<Term>::ConstIterator ConstIterator;
//
//   IList<Term>  mHead;
//   IMonom      mMonom;
//   IMonom      *mRef;
//
// public:
//   IRefPoly(IMonom  *monom): mHead(), mMonom(monom) {}
//   IRefPoly(const IRefPoly& a): mHead(a.mHead) {}
//   ~IRefPoly() { delete mMonom; }
//
//   void add(ISPoly *ref, ICoeff* coeff) {
//     Iterator i = mHead.begin();
//     i.insert();
//     (*i).mRef = ref;
//     (*i).mCoeff = coeff;
//   }
//   void reduction();
//
//   void assertValid(const char* fileName, int fileLine) const;
// };
//
//
// void IRefPoly::reduction() {
//   ConstIterator i = mHead.begin();
//   IASSERT(i);
//   ConstIterator j = i;
//   int norm = (*j).mCoeff->norm();
//   ++i;
//   while(i) {
//     int norm1 = (*i).mCoeff->norm();
//     if (norm1 < norm) {
//       norm = norm1;
//       j = i;
//     }
//     ++i;
//   }
//   i = mHead.begin();
//   while(i) {
//     if (i)
//   }
// }
//
// bool IAlgorithmTQBlock::reduceQBlock(ISetWrap &block) {
//   IASSERT(block.isEmpty());
//   ISetQ::Iterator i(mSetT->setQ()->begin());
//   int deg = -1;
//   int r;
//
//   ISetWrap::Iterator j(block.begin());
//   mNumEq = 0;
//   while(i && block.isEmpty()) {
//     if (i)
//       deg = (*i)->poly().degree();
//     while(i) {
// /*      if (!(*i)->isZero() && deg < (*i)->poly().degree())
//         break;*/
//       if (!reduce(**i))
//         i.del();
//       else {
//         if (deg < (*i)->poly().degree())
//           break;
//         j.insert(i.get());
//       }
//     }
//   }
//
//   if (block.isEmpty())
//     return false;
//
//   ICoeff *multiplier = mDivision->wrapInterface()->coeffInterface()->create();
//   multiplier->setZero();
//   j = block.begin();
//   while(j) {
//     if (deg < (*j)->poly().degree()) {
//       mSetT->setQ()->insert(j.get());
//     }
//     else {
//       (*j)->updateProlong();
//       r = mDivision->nfTail(*multiplier, (*j)->poly());
//       if (r) {
//         mStatistics.mReduction += r;
//         (*j)->poly().pp();
//       }
//       ++j;
//     }
//   }
//
//   mNumEq = 1;
//   int numEq;
//   ISetWrap stack;
//   ISetWrap::Iterator k(stack.begin());
//   do {
//     numEq = 1;
//     j = block.begin();
//     ISetWrap::Iterator r = j;
//     int normr = (*r)->poly().norm();
//     int lenr = (*r)->poly().length();
//     ++j;
//     while(j) {
//       int cmp = (*j)->lm().compare((*r)->lm());
//       if (cmp > 0) {
//         numEq = 1;
//         normr = (*j)->poly().norm();
//         lenr = (*j)->poly().length();
//         r = j;
//       }
//       else if (cmp == 0) {
//         ++numEq;
//         int normj = (*j)->poly().norm();
//         if (normj < normr) {
//           normr = normj;
//           lenr = (*j)->poly().length();
//           r = j;
//         }
//         else if (normj == normr) {
//           int lenj = (*j)->poly().length();
//           if (lenj < lenr) {
//             lenr = lenj;
//             normr = (*j)->poly().norm();
//             r = j;
//           }
//         }
//       }
//       ++j;
//     }
//     stack.begin().insert(r.get());
//     if (numEq > mNumEq)
//       mNumEq = numEq;
//
//     IWrap *wrap = *stack.begin();
// /*    mStatistics.mTimer.stop();
//     std::cerr << wrap->lm() << std::endl;
//     mStatistics.mTimer.cont();*/
//     if (wrap->poly().degree() < deg)
//       deg = wrap->poly().degree();
//
//     j = block.begin();
//     while(j) {
//       int cmp = (*j)->lm().compare(wrap->lm());
//       if (cmp != 0) {
//         ++j;
//       }
//       else {
//         if ((*j)->criterion(*wrap, *mSetT)) {
//           ++mStatistics.mCriterion;
//           j.del();
//         }
//         else {
//           wrap->setEquivalent(*(*j));
//           (*j)->poly().reduction(*multiplier, wrap->poly());
//           ++mStatistics.mReduction;
//           if ((*j)->poly().isZero()) {
//             ++mStatistics.mSpoly;
//             j.del();
//           }
//           else {
//             (*j)->poly().pp();
//             (*j)->update();
//             if ((*j)->poly().degree() < deg) {
//               deg = (*j)->poly().degree();
//             }
//             ++j;
//           }
//         }
//       }
//     }
//   } while(!block.isEmpty());
//
//   k = stack.begin();
//   j = block.begin();
//   while(k) {
//     if ((*k)->poly().degree() > deg)
//       break;
//     j.insert(k.get());
//   }
//   while(k)
//     mSetT->setQ()->insert(k.get());
//
//   delete multiplier;
//   return true;
// }
//
// IAlgorithmTQBlock::IAlgorithmTQBlock(ISetQ *setQ, IDivision *division):
//     IAlgorithmTQ(setQ, division) {
//   if (!(mSetT->monomInterface()->order() & IMonomInterface::DegRevLex))
//     IERROR("monomInterface is not DegRevLex order");
// }
//
// IAlgorithmTQBlock::~IAlgorithmTQBlock() {
// }
//
// void IAlgorithmTQBlock::build() {
//   mStatistics.mTimer.cont();
//   int step = 0;
//   bool field = mSetT->coeffInterface()->isField();
//   int Tlength = 0, Qlength = 0, Blength = 0;
//   ICoeff *multiplier = mDivision->wrapInterface()->coeffInterface()->create();
//   multiplier->setZero();
//   int r;
//
//   ISetWrap block;
//   while(reduceQBlock(block)) {
//     ++step;
//
//     mStatistics.mTimer.stop();
//     Tlength = mSetT->length();
//     Qlength = mSetT->setQ()->length();
//     mStatistics.append(mStatistics.mTimer.userTime(), Tlength, Qlength, mNumEq);
//     fprintf(stdout, "%d %d %d %d\n", step, Tlength, Qlength, mNumEq);
//     mStatistics.mTimer.cont();
//
//     int path = 0;
//     ISetWrap::ConstIterator i = block.begin();
//     while(i) {
//       if ((*i)->lm().degree() == 0 &&
//           (*i)->lm().monomInterface()->depend() == NULL) {
//         path = -1;
//         break;
//       }
//       if (!mSetT->isEmpty() &&
//           !(*i)->isProlong() &&
//           !isMinimalBasis((*i)->lm())) {
//         path = 1;
//         break;
//       }
//       ++i;
//     }
//
//     if (path == -1) {
//       mStatistics.mTimer.stop();
//       delete mDivision;
//       mDivision = NULL;
//       IWrapInterface* wrapInterface = mSetT->wrapInterface();
//       delete mSetT;
//       mSetT = new ISetT(wrapInterface);
//       break;
//     }
//     else {
//       if (path == 1) {
//         ISetT::Iterator j = mSetT->begin();
//
//         int degree = (*block.begin())->poly().degree();
//         while(j && (*j)->poly().degree() > degree) {
//           mSetT->setQ()->insert(j.get());
//         }
//         mDivision->clear();
//
//         j = mSetT->begin();
//         while(j) {
//           mDivision->insert(*j);
//           ++j;
//         }
//
//         j = mSetT->begin();
//         while(j) {
//           mDivision->update(*j, *mSetT->setQ());
//           ++j;
//         }
//       }
//
//       i = block.begin();
//       while(i) {
//         IASSERT(!mDivision->find((*i)->lm()));
//         mDivision->insert(*i, *mSetT->setQ());
//         ++i;
//       }
//
//       i = block.begin();
//       while(i) {
//         r = mDivision->nfTail(*multiplier, (*i)->poly());
//         if (r) {
//           mStatistics.mReduction += r;
//           (*i)->poly().pp();
//         }
//         ++i;
//       }
//
//       ISetT::Iterator j = mSetT->begin();
//       ISetWrap::Iterator k = block.begin();
//       while(j && k) {
//         r = mDivision->nfTail(*multiplier, (*j)->poly());
//         if (r) {
//           mStatistics.mReduction += r;
//           (*j)->poly().pp();
//         }
//         if ((*j)->lm().compare((*k)->lm()) < 0)
//           j.insert(k.get());
//         ++j;
//       }
//       while(k)
//         j.insert(k.get());
//     }
//   }
//   delete multiplier;
//   mStatistics.mTimer.stop();
//   buildStatistics();
// }
