/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "./isett.h"


void ISetT::read(std::istream& in) {
  clear();
  int l;
  in.read((char*)(&l), sizeof(l));
  Iterator i(begin());
  while(l) {
    i.insert();
    *i = mWrapInterface->create();
    (*i)->read(in);
    ++i;
    --l;
  }
}

void ISetT::write(std::ostream& out) const {
  int l = length();
  out.write((char*)(&l), sizeof(l));
  ConstIterator i(begin());
  while(i) {
    (*i)->write(out);
    ++i;
  }
}

void ISetT::assertValid(const char* fileName, int fileLine) const {
  if (!isEmpty()) {
    ConstIterator i(begin());
    ConstIterator prev = i;
    ++i;
    while(i) {
      IASSERT2(fileName, fileLine, (*prev)->lm().compare((*i)->lm()) > 0);
      prev = i;
      ++i;
    }
  }
}
