/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IFACTORIZATIONZASSENHAUS_H
#define IFACTORIZATIONZASSENHAUS_H

#include "ifactorizationalgorithm.h"

#ifdef TEST
class IFactorizationZassenhausTest;
#endif

class IFactorizationZassenhaus {//: public IFactorizationAlgorithm {
#ifdef TEST
friend class IFactorizationZassenhausTest;
#endif

protected:
  void randomPolynomial(IAlgExtModularShortAux& a, unsigned n);

  void repeatedSquaring(IAlgExtModularShortAux& a, 
      MP_INT& n, 
      IAlgExtModularShortAux& rem);
  
  void equalDegreeSplitting(IAlgExtModularShortAux& f, 
      IAlgExtModularShortAux& a, 
      unsigned d, 
      IAlgExtModularShortAux& g);

  void equalDegreeFactorization(IAlgExtModularShortAux& f, 
      unsigned d, 
      IList<IAlgExtModularShortAux*>& factors);

public:
  void factor(IAlgExtModularShortAux& f, 
      IList<IAlgExtModularShortAux*>& factors, 
      IList<unsigned>& multiplicities);
  
  void degrees(IAlgExtModularShortAux& a, IList<unsigned>& degrees);

};

#endif // IFACTORIZATIONZASSENHAUS_H
