/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IGCDBROWN_H
#define IGCDBROWN_H

#include "./igcdalgorithm.h"
#include "../monom/imonom.h"

#ifdef TEST
class IGcdZippelTest;
#endif 

class IGcdBrown: public IGcdAlgorithm {
#ifdef TEST
friend class IGcdZippelTest;
#endif 

private:
  void brownP(INParameterModularShortAux& a, INParameterModularShortAux& b, 
	  INParameterModularShortAux& g, INParameterModularShortAux& a_, INParameterModularShortAux& b_);
  void brownM(INParameterGmpZAux& a, INParameterGmpZAux& b, INParameterGmpZAux& g);

public:
  void gcd(INParameterGmpZAux& a, INParameterGmpZAux& b, INParameterGmpZAux& g);
};

#endif // IGCDBROWN_H
