/***************************************************************************
 *   Copyright (C) 2004 by Brendt V.                                       *
 *   vanessa@momo.math.rwth-aachen.de                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "./igcddivbro.h" 
#include "./idivbrofailure.h" 
#include <vector>


//void IGcdDivbro::gcd(INParameterGmpZAux& a, INParameterGmpZAux& b, INParameterGmpZAux& g) {
//  divbroM(a, b, g, g.monomInterface()->dimIndepend());
//}
//
//void IGcdDivbro::divbroP(INParameterGmpZAux& a, INParameterGmpZAux& b, INParameterGmpZAux& g, int n, IMonom& e0, const MP_INT& p) {
//  bool failed_once = false;
//  g.setZero();
//
//  // STEP 1: If n=1 then compute the GCD using Euclid's algorithm
//  if (n == 1) {
//    g = a;
//
//    g.gcd(b, n-1, p);
//
//    return;
//  }
//
//  // otherwise compute the contents in Z_p[x_n] and their GCD.
//  INParameterGmpZAux ca(a.mi), cb(a.mi);
//  a.pp(ca, n-1, p);
//  b.pp(cb, n-1, p);
//  INParameterGmpZAux cg(ca);
//  cg.gcd(cb, n-1, p);
//
//  // STEP 2: compute the correction coefficient
//  //std::cout << "P.2" << std::endl;
//  INParameterGmpZAux la(a.mi), lb(a.mi);
//  a.lp(la, n-1);
//  b.lp(lb, n-1);
//  INParameterGmpZAux gamma(la);
//  gamma.gcd(lb, n-1, p);
//  
//  // STEP 3: Set the initial degree bounds for this computation
//  //std::cout << "P.3" << std::endl;
//  IMonom* e = e0.monomInterface()->copy(e0);
//  
//  // STEP 4:
//  //std::cout << "P.4" << std::endl;
//  std::vector<INParameterGmpZAux*> g_seq;
//  std::vector<MP_INT*> v_seq;
//  g_seq.reserve(e0[n-1]);
//  v_seq.reserve(e0[n-1]);
//
//  // LOOP
//
//  MP_INT alpha;
//  for (mpz_init_set_ui(&alpha, 1ul); 
//      mpz_cmp(&alpha, &p) < 0; 
//      mpz_add_ui(&alpha, &alpha, 1ul)) {
//    // STEP 6: Choose a new evaluation point alpha in Z_p such that
//    // x_n - alpha does not divide la x lb. If no such evaluation
//    // point exists then p is to small and the algorithm fails.
//    //std::cout << "P.6" << std::endl;
//
//    INParameterGmpZAux evalA(la);
//    evalA.eval(alpha, n-1, p);
//    if (evalA.isZero()) 
//      continue;
//
//    INParameterGmpZAux evalB(lb);
//    evalB.eval(alpha, n-1, p);
//    if (evalB.isZero()) 
//      continue;
//
//    // STEP 7: compute a_alpha = a mod <x_n - alpha>, b_alpha.
//    //std::cout << "P.7" << std::endl;
//    INParameterGmpZAux a_alpha(a);
//    a_alpha.eval(alpha, n-1, p);
//    INParameterGmpZAux b_alpha(b);
//    b_alpha.eval(alpha, n-1, p);
//
//    INParameterGmpZAux* g_alpha = new INParameterGmpZAux(a.mi);
//
//    try {
//      // STEP 8: compute g_alpha the monic GCD of a_alpha and b_alpha with a
//      // recursive call to this algorithm
//      //std::cout << "P.8" << std::endl;
//      divbroP(a_alpha, b_alpha, *g_alpha, n-1, *e, p);
//
//      // STEP 10: If the recursive call fails (n > 2), or if the GCD is of too high a degree 
//      // (n = 2) then (skip this unlucky evaluation) goto Loop unless this has occured twice with no
//      // successful images, in which case we assume that a higher prime or evaluation
//      // is unlucky and return fail
//      if (n == 2 && g_alpha->lm().compare(*e) > 0) {
//        if (failed_once) {
//          //std::cout << "failed twice and n = 2" << std::endl;
//
//          mpz_clear(&alpha);
//          delete e;
//          delete g_alpha;
//          for (int i = 0; i < g_seq.size(); i++) {
//            delete g_seq[i];
//            mpz_clear(&(*(v_seq[i])));
//            delete v_seq[i];
//          }
//          throw IDivbroFailure();
//        }
//        failed_once = true;
//        continue;
//      }
//    } catch (IDivbroFailure()) {
//      if (failed_once) {
//        //std::cout << "failed twice and n > 2" << std::endl;
//
//        mpz_clear(&alpha);
//        delete e;
//        delete g_alpha;
//        for (int i = 0; i < g_seq.size(); i++) {
//          delete g_seq[i];
//          mpz_clear(&(*(v_seq[i])));
//          delete v_seq[i];
//        }
//        throw IDivbroFailure();
//      }
//      failed_once = true;
//      continue;
//    }
//
//    // STEP 9: Test for a, b relatively prime: If g_alpha.degree() == 0 then output cg.
//    //std::cout << "P.9" << std::endl;
//    if (g_alpha->degree() == 0) {
//      g.swap(cg);
//
//      mpz_clear(&alpha);
//      delete e;
//      delete g_alpha;
//      for (int i = 0; i < g_seq.size(); i++) {
//        delete g_seq[i];
//        mpz_clear(&(*(v_seq[i])));
//        delete v_seq[i];
//      }
//
//      return;
//    }
//
//    // STEP 11: Leading coefficient correction in Z_p[x_n]
//    //std::cout << "P.11" << std::endl;
//    INParameterGmpZAux evalG(gamma);
//    evalG.eval(alpha, n-1, p);
//    MP_INT gamma_lc;
//    evalG.lc(gamma_lc);
//    g_alpha->mult(gamma_lc, p);
//    mpz_clear(&gamma_lc);
//
//    // TODO 8
//    //correction of a_alpha, b_alpha!!
//
//    // STEP 12: First Image?
//    // If g_seq = Null then set g_seq = g_alpha, v_seq = alpha, e = g_alpha.degree() and goto Loop
//    // STEP 13: If deg(g_alpha) < e then all previous evaluations and the degree bound were unlucky.
//    // Restart the algorithm keeping only the current evaluation.
//    //std::cout << "P.12" << std::endl;
//    if (g_seq.empty() || g_alpha->lm().compare(*e, n-1) < 0) {
//      g_seq.clear();
//      v_seq.clear();
//
//      g_seq.push_back(g_alpha);
//      MP_INT* temp = new MP_INT;
//      mpz_init_set(&(*temp), &alpha);
//      v_seq.push_back(temp);
//
//      for (int i = 0; i < n-1; i++) 
//        e->prolong(i, g_alpha->degree(i) - e->deg(i));
//
//      continue;
//    }
//
//    // STEP 14: Add the new image and evaluation point
//    //std::cout << "P.14" << std::endl;
//    g_seq.push_back(g_alpha);
//    MP_INT* temp = new MP_INT;
//    mpz_init_set(&(*temp), &alpha);
//    v_seq.push_back(temp);
//    
//    // STEP 15: If we have enough images to construct to the degree bound in
//    // x_n + deg_{x_n}(gamma) then goto 10, otherwise goto loop
//    //std::cout << "P.15" << std::endl;
//    if (g_seq.size() <= (*e)[n-1] + gamma.degree()) 
//      continue;
//
//    // STEP 18: Compute the GCD g via Newton interpolation in x_n using the 
//    // sequence of GCDs g_seq and points v_seq
//    newton(g, g_seq, v_seq, n-1, p);
//    
//    // STEP 19: Test for correctness.
//    // Remove the content g = pp_{x_1, \dotsc, x_{n-1}}(g_m) and check that
//    // g divides a and b. If so, output cg x g, otherwise return fail
//    // (unlucky content in x_n)
//    g.pp(n-1, p);
//
//    if (a.isdivisible(g, p) && b.isdivisible(g, p)) {
//      g.mult(cg, p);
//
//      mpz_clear(&alpha);
//      delete e;
//      for (int i = 0; i < g_seq.size(); i++) {
//        delete g_seq[i];
//        mpz_clear(&(*(v_seq[i])));
//        delete v_seq[i];
//      }
//
//      return;
//    }
//
////    std::cout << "g := ";
////    g.output(std::cout);
////    std::cout << ";" << std::endl;
////    std::cout << "a := ";
////    a.output(std::cout);
////    std::cout << ";" << std::endl;
////    std::cout << "p := " << &p << ";" << std::endl;
////
////    std::cout << "Division check failed" << std::endl;
////
//    throw IDivbroFailure();
//  }
//
////  std::cout << "not enough evaluation points" << std::endl;
//  throw IDivbroFailure();
//}
//
//
//void IGcdDivbro::divbroM(INParameterGmpZAux& a, INParameterGmpZAux& b, INParameterGmpZAux& g, int n) {
//  g.setZero();
//
//  // STEP 1: Compute integer contents and their GCD
//  MP_INT ca, cb, cg;
//  a.cont(ca);
//  b.cont(cb);
//  mpz_init(&cg);
//  mpz_gcd(&cg, &ca, &cb);
//
//  if (a.degree() == 0 || b.degree() == 0) {
//    g.setOne();
//    g.mult(cg);
//    mpz_clear(&ca);
//    mpz_clear(&cb);
//    mpz_clear(&cg);
//    return;
//  }
//
//  //Achtung: Seiteneffekt (a,b)! Wird vor dem return behoben.
//  a.div(ca);
//  b.div(cb);
//  
//  // STEP 2: compute the correction coefficients
//  MP_INT la, lb, gamma;
//  a.lc(la);
//  b.lc(lb);
//  mpz_init(&gamma);
//  mpz_gcd(&gamma, &la, &lb);
//
//  // STEP 4: set m = 1
//  MP_INT m;
//  mpz_init_set_ui(&m, 1ul);
//  IMonom* e = NULL;
//
//  //LOOP
//  INParameterGmpZAux g_m(a.mi);
//
//  MP_INT p;
//  // set p = prime < half of word length = 2^31
//  // is there a less random choice of a prime ???
//  mpz_init_set_ui(&p, 20000000);
//
//  while (true) {
//    // STEP 6: choose a new prime p that does not divide la or lb
//    mpz_nextprime(&p, &p);
//
//    if (mpz_divisible_p(&la, &p) || mpz_divisible_p(&lb, &p)) {
//      continue;
//    }
//
//    //std::cout << "Using prime " << &p << std::endl;
//
//    // STEP 7: compute a_p = a mod p, b_b = b mod p
//    //std::cout << "M.7" << std::endl;
//    INParameterGmpZAux a_p(a.mi);
//    INParameterGmpZAux b_p(a.mi);
//    a.mod(a_p, p);
//    b.mod(b_p, p);
//
//    // STEP 4: compute degree bounds e for the GCD in x_1, \dotsc, x_n
//    if (e == NULL) {
//      e = a.mi->create();
//      degreeBounds(*e, a_p, b_p, p);
//
//      //std::cout << "Degree bounds: " << *e << std::endl;
//    }
//
//
//    // STEP 8: compute g_p, a_p_, b_p_ using algorithm p
//    //std::cout << "M.8" << std::endl;
//    INParameterGmpZAux g_p(a.mi);
//
//    try {
//      divbroP(a_p, b_p, g_p, n, *e, p);
//    } catch (IDivbroFailure) {
//      //std::cout << "failure!" << std::endl;
//      continue;
//    }
//
//    // STEP 9: Test for a, b relatively prime: If g_p.degree() = 0 then output g
//    //std::cout << "M.9" << std::endl;
//    if (g_p.degree() == 0) {
//      // revert change of a and b
//      a.mult(ca);
//      b.mult(cb);
//
//      g.setOne();
//      g.mult(cg);
//
//      delete e;
//      mpz_clear(&p);
//      mpz_clear(&ca);
//      mpz_clear(&cb);
//      mpz_clear(&cg);
//      mpz_clear(&gamma);
//      return;
//    }
//
//    // STEP 11: Leading coefficient correction in Z
//    //std::cout << "M.11" << std::endl;
//    g_p.mult(gamma, p);
//
//    // STEP 12: First Image?
//    // If m=1 then set g_m = g_p, a_m_ = a_p_, b_m_ = g_p_, 
//    // m = p, e = deg(g_p) and goto Loop
//    // STEP 13: If deg(g_alpha) < e then all previous evaluations were
//    // unlucky. Restart the algorithm keeping only the current evaluation.
//    //std::cout << "M.12" << std::endl;
//    bool lowdegree = false;
//    for (int i = 0; i < n; i++) 
//      lowdegree |= (g_p.degree(i) < (*e)[i]);
//    if ((mpz_cmp_ui(&m, 1ul) == 0) || lowdegree) {
//      g_m.swap(g_p);
//
//      mpz_set(&m, &p);
//
//      // Error in Wittkopf?
//      for (int i = 0; i < n; i++) 
//        e->prolong(i, g_m.degree(i) - (*e)[i]);
//
//      continue;
//    }
//
//    // STEP 14: Combine the new image with the old using the CRA
//    //std::cout << "M.14" << std::endl;
//    bool changed = cracheck(m, p, g_m, g_p);
//
//    // STEP 15: Set m = m x p, and if g_m changed in Step 14 goto loop
//    //std::cout << "M.15" << std::endl;
//    mpz_mul(&m, &m, &p);
//    if (changed) 
//      continue;
//
//    // STEP 16: Test for termination computing g = pp(g_m) and performing a division
//    // check to assure that g divides both a and b. If so, we are done so output cg x g.
//    //std::cout << "M.16" << std::endl;
//
//    // FIXME: would g_m.pp() affect the test for change in step 15?
//    g = g_m;
//    g.pp();
//
//    if (a.isdivisible(g) && b.isdivisible(g)) {
//      g.mult(cg);
//
//      delete e;
//      mpz_clear(&p);
//      mpz_clear(&ca);
//      mpz_clear(&cb);
//      mpz_clear(&cg);
//      mpz_clear(&gamma);
//      return;
//    }
//
//    // STEP 17: Goto Loop. All primes were unlucky.
//  }
//}
//
//void IGcdDivbro::degreeBounds(IMonom& e, const INParameterGmpZAux& a, const INParameterGmpZAux& b, const MP_INT& p) {
//  e.setZero();
//
//  for (int i = 0; i < e.dimIndepend(); i++) {
//    e.prolong(i, degreeBounds(a, b, i, p));
//  }
//}
//
//int IGcdDivbro::degreeBounds(const INParameterGmpZAux& a, const INParameterGmpZAux& b, int var, const MP_INT& p) {
//  INParameterGmpZAux a2(a);
//  INParameterGmpZAux b2(b);
//
//  INParameterGmpZAux lpa(a.mi);
//  INParameterGmpZAux lpb(a.mi);
//
//  MP_INT alpha;
//  mpz_init_set_ui(&alpha, 0ul);
//
//  for (int i = 0; i < a.mi->dimIndepend(); i++) {
//    if (i != var) {
//      b2.lp2(lpb, i);
//      lpa.setZero();
//      // FIXME: handle the case where not enough evaluation points exist
//      while (lpa.isZero()) {
//        mpz_add_ui(&alpha, &alpha, 1ul);
//        a2.lp2(lpa, i);
//        lpa.gcd(lpb, i, p);
//
//        lpa.eval2(alpha, i, p);
//      }
//
//      a2.eval2(alpha, i, p);
//      b2.eval2(alpha, i, p);
//    }
//  }
//  mpz_clear(&alpha);
//
//  a2.gcd(b2, var, p);
//
//  return a2.degree(var);
//}
