/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "./ic1.h"


IC1Interface::IC1Interface():
    IWrapInterface() {
  mType = IWrapInterface::C1;
}

IWrap* IC1Interface::create(IPoly* a) {
  return new IC1(this, a);
}

IWrap* IC1Interface::create(IWrap& a, int var, unsigned deg) {
  IASSERT(this == a.wrapInterface());
  IASSERT(deg > 0);
  return new IC1((IC1&)a, var, deg);
}

IWrap* IC1Interface::create() {
  return new IC1(this);
}

IC1::IC1(IWrapInterface *r, IPoly *poly):
    IWrap(r, poly) {
}

IC1::IC1(IC1& w, int var, unsigned deg):
    IWrap(w, var, deg) {
}

IC1::IC1(IWrapInterface *r):
    IWrap(r) {
}

bool IC1::criterion(IWrap& divisor, ISetT& ) {
  bool r = false;
  if (monomInterface()->depend() == NULL && systemType()->module() < 2 &&
    lm().degree() != ancestor().degree())
    if (lm().degree() >= ancestor().degree() + divisor.ancestor().degree())
      r = true;

  return r;
}
