/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "./icritpartially.h"


ICritPartiallyInterface::ICritPartiallyInterface():
    IWrapInterface() {
  mType = IWrapInterface::CritPartially;
}

IWrap* ICritPartiallyInterface::create(IPoly* a) {
  return new ICritPartially(this, a);
}

IWrap* ICritPartiallyInterface::create(IWrap& a, int var, unsigned deg) {
  IASSERT(this == a.wrapInterface());
  IASSERT(deg > 0);
  return new ICritPartially((ICritPartially&)a, var, deg);
}

IWrap* ICritPartiallyInterface::create() {
  return new ICritPartially(this);
}

ICritPartially::ICritPartially(IWrapInterface *r, IPoly *poly):
    IWrap(r, poly) {
}

ICritPartially::ICritPartially(ICritPartially& w, int var, unsigned deg):
    IWrap(w, var, deg) {
}

ICritPartially::ICritPartially(IWrapInterface *r):
    IWrap(r) {
}

ICritPartially::~ICritPartially() {}

bool ICritPartially::criterion(IWrap& divisor, ISetT& ) {
  bool r = false;
  if (lm().degree() != ancestor().degree()) {
    if (monomInterface()->depend() == NULL &&
        systemType()->module() < 2 &&
        lm().degree() >= ancestor().degree() + divisor.ancestor().degree())
      r = true;
    else if (lm().degree() > ancestor().lcm(divisor.ancestor()))
      r = true;
  }

  return r;
}

