/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ICRITPARTIALLY_H
#define ICRITPARTIALLY_H

#include "./iwrap.h"

class ICritPartially;
class ICritPartiallyInterface: public IWrapInterface {
  friend class ICritPartially;

public:
  ICritPartiallyInterface();
  ~ICritPartiallyInterface() {}

  IWrap* create(IPoly* a);
  IWrap* create(IWrap& a, int var, unsigned deg);
  IWrap* create();
};

class ICritPartially: public IWrap {
  friend class ICritPartiallyInterface;

protected:
  ICritPartially(IWrapInterface *r, IPoly *poly);
  ICritPartially(ICritPartially& w, int var, unsigned deg);
  ICritPartially(IWrapInterface *r);

public:
  ~ICritPartially();

  bool criterion(IWrap& divisor, ISetT&);
};

#endif // ICRITPARTIALLY_H

