/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "./iwithout.h"


IWithoutInterface::IWithoutInterface():
    IWrapInterface() {
  mType = IWrapInterface::Without;
}

IWrap* IWithoutInterface::create(IPoly* a) {
  return new IWithout(this, a); 
}

IWrap* IWithoutInterface::create(IWrap& a, int var, unsigned deg) {
  IASSERT(this == a.wrapInterface());
  IASSERT(deg > 0);
  return new IWithout((IWithout&)a, var, deg);    
}

IWrap* IWithoutInterface::create() {
  return new IWithout(this); 
}

IWithout::IWithout(IWrapInterface *r, IPoly *poly):
    IWrap(r, poly) {
}

IWithout::IWithout(IWithout& w, int var, unsigned deg):
    IWrap(w, var, deg) {
}

IWithout::IWithout(IWrapInterface *r):
    IWrap(r) {
}

bool IWithout::criterion(IWrap& , ISetT& ) {
  return false;
}
