/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IADDMULTOPERATION_H
#define IADDMULTOPERATION_H

#include "ioperation.h"

class IAddMultOperation: public IOperation {
private:
  int mi;
  int mj;
  ICoeff* mc;

public:
  IAddMultOperation(int i, int j, ICoeff* c): mi(i), mj(j), mc(c) { }

  ~IAddMultOperation() {
    delete mc;
  }

  void apply(ICoeff** v) const;

  bool isEmpty() const {
    return false;
  }
};

#endif // IADDMULTOPERATION_H
