/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IPOSELIM_H
#define IPOSELIM_H

#include "../util/iallocator.h"
#include "./itopdegrevlex.h"


class IPosElim;
class IPosElimInterface: public ITopDegRevLexInterface {
  friend class IPosElim;

protected:
  int                  mTupElim;

public:
  IPosElimInterface(const ISystemType *systemType, IVariables* independ, IVariables* depend, int elim);
  ~IPosElimInterface() {}

  int elim() const;

  IMonom* create();
  IMonom* copy(const IMonom& a);
};

class IPosElim: public ITopDegRevLex {
  friend class IPosElimInterface;

protected:
  static IAllocator     sAllocator;

  int elim() const { return ((const IPosElimInterface*)mRealization)->mTupElim; }

  IPosElim(IPosElimInterface* r);
  IPosElim(const IMonom& a);

public:
  void* operator new(size_t) { return sAllocator.allocate(); }
  void operator delete(void *ptr) { sAllocator.deallocate(ptr); }

  ~IPosElim();

  int compare(const IMonom& a) const;
  int compare(const IMonom& a, const IMonom& b) const;
  int setQcompare(const IMonom& a) const;

  void assertValid(const char* fileName, int fileLine) const;
};

#endif // IPOSELIM_H
