/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "./ipolylist.h"


// IPolyListInterface::IPolyListInterface():
//     IPolyInterface() {
//   mType = IPolyInterface::PolyList;
// }
//
// IPoly* IPolyListInterface::create() {
//   return new IPolyList(this);
// }
//
// IPoly* IPolyListInterface::copy(const IPoly& a) {
//   IASSERT(this == a.polyInterface());
//   return new IPolyList((const IPolyList&)a);
// }
//
// IPoly* IPolyListInterface::copy(const IPoly& a, int var) {
//   IASSERT(this == a.polyInterface());
//   return new IPolyList((const IPolyList&)a, var);
// }
//
// IPoly* IPolyListInterface::copy(const IPoly& a, int var, unsigned deg)  {
//   IASSERT(this == a.polyInterface());
//   return new IPolyList((const IPolyList&)a, var, deg);
// }
//
// IPolyList::IPolyList(IPolyListInterface* r):
//     IPoly(r),
//     mHead() {
// }
//
// IPolyList::IPolyList(const IPolyList& a):
//     IPoly(a),
//     mHead() {
//   It i(mHead.begin());
//   ConstIt ia(a.mHead.begin());
//   while(ia) {
//     i.insert();
//     (*i).mMonom = monomInterface()->copy(*(*ia).mMonom);
//     (*i).mCoeff = coeffInterface()->copy(*(*ia).mCoeff);
//     ++i;
//     ++ia;
//   }
//   IASSERTVALID(*this);
// }
//
// IPolyList::IPolyList(const IPolyList& a, int var):
//     IPoly(a),
//     mHead() {
//   It i(mHead.begin());
//   ConstIt ia(a.mHead.begin());
//   while(ia) {
//     i.insert();
//     (*i).mMonom = monomInterface()->copy(*(*ia).mMonom);
//     (*i).mMonom->prolong(var);
//     (*i).mCoeff = coeffInterface()->copy(*(*ia).mCoeff);
//     ++i;
//     ++ia;
//   }
//   IASSERTVALID(*this);
// }
//
// IPolyList::IPolyList(const IPolyList& a, int var, unsigned deg):
//     IPoly(a),
//     mHead() {
//   It i(mHead.begin());
//   ConstIt ia(a.mHead.begin());
//   while(ia) {
//     i.insert();
//     (*i).mMonom = monomInterface()->copy(*(*ia).mMonom);
//     (*i).mMonom->prolong(var, deg);
//     (*i).mCoeff = coeffInterface()->copy(*(*ia).mCoeff);
//     ++i;
//     ++ia;
//   }
//   IASSERTVALID(*this);
// }
//
// IPolyList::IPolyList(const IPolyList& a, const IMonom& m, const ICoeff& c):
//     IPoly(a),
//     mHead() {
//   It i(mHead.begin());
//   ConstIt ia(a.mHead.begin());
//   while(ia) {
//     i.insert();
//     (*i).mMonom = monomInterface()->copy(*(*ia).mMonom);
//     (*i).mMonom->mult(m);
//     (*i).mCoeff = coeffInterface()->copy(*(*ia).mCoeff);
//     (*i).mCoeff->mult(c);
//     ++i;
//     ++ia;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::setZero() {
//   mHead.clear();
// }
//
// void IPolyList::setDependVar(int var) {
//   ConstIt i(mHead.begin());
//   while(i) {
//     IASSERT((*i).mMonom->dependVar() < 0);
//     (*i).mMonom->setDependVar(var);
//     ++i;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::setMonom(IMonom *m) {
//   mHead.clear();
//   It i(mHead.begin());
//   i.insert();
//   (*i).mMonom = m;
//   (*i).mCoeff = coeffInterface()->create();
//   (*i).mCoeff->setOne();
// }
//
// void IPolyList::setCoeff(ICoeff *c) {
//   mHead.clear();
//   It i(mHead.begin());
//   i.insert();
//   (*i).mMonom = monomInterface()->create();
//   (*i).mMonom->setZero();
//   (*i).mCoeff = c;
// }
//
// void IPolyList::setPoly(const IPoly& a, int dependVar) {
//   mHead.clear();
//   It i(mHead.begin());
//   ConstIt ia(((const IPolyList&)a).mHead.begin());
//   while(ia) {
//     if ((*ia).mMonom->dependVar() == dependVar) {
//       i.insert();
//       (*i).mMonom = monomInterface()->copy(*(*ia).mMonom);
//       (*i).mCoeff = coeffInterface()->copy(*(*ia).mCoeff);
//       ++i;
//     }
//     ++ia;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::set(const IPoly& a) {
//   IASSERT(polyInterface() == a.polyInterface());
//   mHead.clear();
//   It i(mHead.begin());
//   ConstIt ia(((const IPolyList&)a).mHead.begin());
//   while(ia) {
//     i.insert();
//     (*i).mMonom = monomInterface()->copy(*(*ia).mMonom);
//     (*i).mCoeff = coeffInterface()->copy(*(*ia).mCoeff);
//     ++i;
//     ++ia;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::swap(IPoly& a) {
//   IASSERT(polyInterface() == a.polyInterface());
//   mHead.swap(((IPolyList&)a).mHead);
// }
//
// bool IPolyList::isZero() const {
//   return mHead.isEmpty();
// }
//
// int IPolyList::length() const {
//   return mHead.length();
// }
//
// int IPolyList::degree() const {
//   ConstIt i(mHead.begin());
//   unsigned max=0;
//
//   if (monomInterface()->order() & IMonomInterface::DegRevLex) {
//     if (i)
//       max = (*i).mMonom->degree();
//   }
//   else {
//     while(i) {
//       if ((*i).mMonom->degree() > max)
//         max = (*i).mMonom->degree();
//       ++i;
//     }
//   }
//   return max;
// }
//
// int IPolyList::norm() const {
// /*  ConstIt i(mHead.begin());
//   int sum = 0;
//   while(i) {
//     int n = (*i).mCoeff->norm();
//     sum += n;
//     ++i;
//   }
//   return sum;*/
// /*  ConstIt i(mHead.begin());
//   int sum = 0;
//   while(i) {
//     int n = (*i).mCoeff->norm();
//     sum += n*n;
//     ++i;
//   }
//   return sum;*/
// /*  ConstIt i(mHead.begin());
//   int sum = 0;
//   while(i) {
//     int n = (*i).mCoeff->norm()*(*i).mMonom->degree();
//     sum += n;
//     ++i;
//   }
//   return sum;*/
//   ConstIt i(mHead.begin());
//   int max = -1;
//   while(i) {
//     int n = (*i).mCoeff->norm();
//     if (max < 0 || n > max)
//       max = n;
//     ++i;
//   }
//   return max;
// //   return lc().norm();
// //   return length();
// }
//
// const IMonom& IPolyList::lm() const {
//   IASSERT(!IPolyList::isZero());
//   return *(*mHead.begin()).mMonom;
// }
//
// const ICoeff& IPolyList::lc() const {
//   IASSERT(!IPolyList::isZero());
//   return *(*mHead.begin()).mCoeff;
// }
//
// void IPolyList::minus() {
//   ConstIt i(mHead.begin());
//   while(i) {
//     (*i).mCoeff->minus();
//     ++i;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::add(IPoly &a) {
//   IASSERT(polyInterface() == a.polyInterface());
//   It i1(mHead.begin()),
//      i2(((IPolyList&)a).mHead.begin());
//   while(i1 && i2)
//     switch((*i1).mMonom->compare(*(*i2).mMonom)) {
//     case 1:
//       ++i1;
//       break;
//     case -1:
//       i1.insert(i2.get());
//       ++i1;
//       break;
//     default:
//       (*i1).mCoeff->add(*(*i2).mCoeff);
//       if ((*i1).mCoeff->isZero())
//         i1.del();
//       else
//         ++i1;
//       ++i2;
//     }
//
//   while(i2) {
//     i1.insert(i2.get());
//     ++i1;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::sub(IPoly &a) {
//   IASSERT(polyInterface() == a.polyInterface());
//   It i1(mHead.begin()),
//      i2(((IPolyList&)a).mHead.begin());
//   while(i1 && i2)
//     switch((*i1).mMonom->compare(*(*i2).mMonom)) {
//     case 1:
//       ++i1;
//       break;
//     case -1:
//       i1.insert(i2.get());
//       (*i1).mCoeff->minus();
//       ++i1;
//       break;
//     default:
//       (*i1).mCoeff->sub(*(*i2).mCoeff);
//       if ((*i1).mCoeff->isZero())
//         i1.del();
//       else
//         ++i1;
//       ++i2;
//     }
//
//   while(i2) {
//     i1.insert(i2.get());
//     (*i1).mCoeff->minus();
//     ++i1;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::mult(int var) {
//   ConstIt i(mHead.begin());
//   while(i) {
//     (*i).mMonom->prolong(var);
//     ++i;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::mult(int var, unsigned deg) {
//   ConstIt i(mHead.begin());
//   while(i) {
//     (*i).mMonom->prolong(var, deg);
//     ++i;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::mult(const IMonom& m) {
//   ConstIt i(mHead.begin());
//   while(i) {
//     (*i).mMonom->mult(m);
//     ++i;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::mult(const ICoeff& c) {
//   if (c.isZero())
//     IPolyList::setZero();
//   else {
//     ConstIt i(mHead.begin());
//     while(i) {
//       (*i).mCoeff->mult(c);
//       ++i;
//     }
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::mult(const IPoly &a) {
//   IASSERT(polyInterface() == a.polyInterface());
//   IPolyList *p = new IPolyList((IPolyListInterface*)polyInterface());
//   ConstIt ia(((IPolyList&)a).mHead.begin());
//   while(ia) {
//     IPolyList *tmp = new IPolyList(*this, *(*ia).mMonom, *(*ia).mCoeff);
//     p->IPolyList::add(*tmp);
//     delete tmp;
//     ++ia;
//     IASSERTVALID(*p);
//   }
//   swap(*p);
//   delete p;
//   IASSERTVALID(*this);
// }
//
// void IPolyList::pow(unsigned deg) {
//   IASSERT(deg > 0);
//   if (deg > 1) {
//     IPolyList *p = new IPolyList(*this);
//     while(--deg > 0) {
//       p->mult(*this);
//     }
//
//     swap(*p);
//     delete p;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::div(const ICoeff& c) {
//   IASSERT(!c.isZero());
//   if (!c.isOne()) {
//     ConstIt i(mHead.begin());
//     while(i) {
//       (*i).mCoeff->div(c);
//       ++i;
//     }
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::content(ICoeff& c) const {
// }
//
// void IPolyList::pp() {
//   if(IPolyList::isZero())
//     return;
//   if (coeffInterface()->isField()) {
//     ICoeff *c(coeffInterface()->copy(IPolyList::lc()));
//     if (!c->isOne()) {
//       c->inverse();
//       mult(*c);
//     }
//     delete c;
//     IASSERT(isPp());
//     IASSERTVALID(*this);
//   }
//   else {
//     ICoeff *c(coeffInterface()->copy(IPolyList::lc()));
//     ConstIt i(mHead.begin());
//     ++i;
//     while(i && !c->isOne()) {
//       c->gcd(*(*i).mCoeff);
//       ++i;
//     }
//     if (!c->isOne())
//       div(*c);
//
//     IASSERT(isPp());
//     IASSERTVALID(*this);
//   }
// /*  else {
//     ICoeff *c(coeffInterface()->create());
//     ConstIt i(mHead.begin());
//     ICoeff *c1 = (*i).mCoeff,
//            *c2 = NULL;
//     ++i;
//     while(i) {
//       if (c1->norm() > (*i).mCoeff->norm()) {
//         c2 = c1;
//         c1 = (*i).mCoeff;
//       }
//       if (!c2)
//         c2 = (*i).mCoeff;
//       ++i;
//     }
//     if (c2 && !c1->isOne()) {
//       c->gcd(*c1, *c2);
//       if (!c->isOne()) {
//         i = mHead.begin();
//         while(i && !c->isOne()) {
//           c->gcd(*(*i).mCoeff);
//           ++i;
//         }
//         if (!c->isOne())
//           div(*c);
//
//         IASSERT(isPp());
//         IASSERTVALID(*this);
//       }
//     }
//   }*/
// }
//
// bool IPolyList::isPp() const {
//   IASSERT(!IPolyList::isZero());
//   bool r = true;
//   if (coeffInterface()->isField())
//     r = lc().isOne();
//   else {
//     ICoeff *c(coeffInterface()->copy(IPolyList::lc()));
//     ConstIt i(mHead.begin());
//     ++i;
//     if (i) {
//       while(i && !c->isOne()) {
//         c->gcd(*(*i).mCoeff);
//         ++i;
//       }
//       r = c->isOne();
//       delete c;
//     }
//   }
//   return r;
// }
//
// void IPolyList::reduction(ICoeff& multiplier, const IPoly & a) {
//   IASSERT(polyInterface() == a.polyInterface());
//   if (coeffInterface()->isField()) {
//     IASSERT(IPolyList::lm().divisibility(((const IPolyList&)a).IPolyList::lm()));
//     IASSERT(((const IPolyList&)a).IPolyList::lc().isOne());
//
//     It i1(mHead.begin());
//     ConstIt i2(((const IPolyList&)a).mHead.begin());
//
//     IMonom *m2(monomInterface()->create());
//     m2->divide(*(*i1).mMonom, *(*i2).mMonom);
//     ICoeff *k2(coeffInterface()->copy(*(*i1).mCoeff));
//     k2->minus();
//
//     i1.del();
//     ++i2;
//     while(i1 && i2)
//       switch((*i1).mMonom->compare(*(*i2).mMonom, *m2)) {
//       case 1:
//         ++i1;
//         break;
//       case -1:
//         i1.insert();
//         (*i1).mMonom = monomInterface()->copy(*(*i2).mMonom);
//         (*i1).mMonom->mult(*m2);
//         (*i1).mCoeff = coeffInterface()->copy(*(*i2).mCoeff);
//         (*i1).mCoeff->mult(*k2);
//         ++i1;
//         ++i2;
//         break;
//       default:
//         (*i1).mCoeff->addmul(*(*i2).mCoeff, *k2);
//         if ((*i1).mCoeff->isZero())
//           i1.del();
//         else
//           ++i1;
//         ++i2;
//       }
//     while(i2) {
//       i1.insert();
//       (*i1).mMonom = monomInterface()->copy(*(*i2).mMonom);
//       (*i1).mMonom->mult(*m2);
//       (*i1).mCoeff = coeffInterface()->copy(*(*i2).mCoeff);
//       (*i1).mCoeff->mult(*k2);
//       ++i1;
//       ++i2;
//     }
//     delete m2;
//     delete k2;
//   }
//   else {
//     IASSERT(IPolyList::lm().divisibility(((const IPolyList&)a).IPolyList::lm()));
//
//     It i1(mHead.begin());
//     ConstIt i2(((const IPolyList&)a).mHead.begin());
//
//     IMonom *m2(monomInterface()->create());
//     m2->divide(*(*i1).mMonom, *(*i2).mMonom);
//     ICoeff *k1(coeffInterface()->create()),
//            *k2(coeffInterface()->create()),
//            *tmp(coeffInterface()->create());
//     tmp->gcd(*(*i1).mCoeff, *(*i2).mCoeff);
//     k1->div(*(*i2).mCoeff, *tmp);
//     k2->div(*(*i1).mCoeff, *tmp);
//     k2->minus();
//
//     i1.del();
//     ++i2;
//     while(i1 && i2)
//       switch((*i1).mMonom->compare(*(*i2).mMonom, *m2)) {
//       case 1:
//         (*i1).mCoeff->mult(*k1);
//         ++i1;
//         break;
//       case -1:
//         i1.insert();
//         (*i1).mMonom = monomInterface()->copy(*(*i2).mMonom);
//         (*i1).mMonom->mult(*m2);
//         (*i1).mCoeff = coeffInterface()->copy(*(*i2).mCoeff);
//         (*i1).mCoeff->mult(*k2);
//         ++i1;
//         ++i2;
//         break;
//       default:
//         (*i1).mCoeff->mult(*k1);
//         (*i1).mCoeff->addmul(*(*i2).mCoeff, *k2);
//         if ((*i1).mCoeff->isZero())
//           i1.del();
//         else
//           ++i1;
//         ++i2;
//       }
//     while(i1) {
//       (*i1).mCoeff->mult(*k1);
//       ++i1;
//     }
//     while(i2) {
//       i1.insert();
//       (*i1).mMonom = monomInterface()->copy(*(*i2).mMonom);
//       (*i1).mMonom->mult(*m2);
//       (*i1).mCoeff = coeffInterface()->copy(*(*i2).mCoeff);
//       (*i1).mCoeff->mult(*k2);
//       ++i1;
//       ++i2;
//     }
//     multiplier.mult(*k1);
//     delete m2;
//     delete k1;
//     delete k2;
//     delete tmp;
//   }
//   IASSERTVALID(*this);
// }
//
// void IPolyList::redTail(ICoeff &multiplier, IPoly::Iterator& i, const IPoly& a) {
//   IASSERT(polyInterface() == a.polyInterface());
//   It i1(((IPolyList::Iterator&)i).mIt);
//   if (coeffInterface()->isField()) {
//     IASSERT((*i1).mMonom->divisibility(((const IPolyList&)a).IPolyList::lm()));
//     IASSERT(((const IPolyList&)a).IPolyList::lc().isOne());
//
//     ConstIt i2(((const IPolyList&)a).mHead.begin());
//
//     IMonom *m2(monomInterface()->create());
//     m2->divide(*(*i1).mMonom, *(*i2).mMonom);
//     ICoeff *k2(coeffInterface()->copy(*(*i1).mCoeff));
//     k2->minus();
//
//     i1.del();
//     ++i2;
//     while(i1 && i2)
//       switch((*i1).mMonom->compare(*(*i2).mMonom, *m2)) {
//       case 1:
//         ++i1;
//         break;
//       case -1:
//         i1.insert();
//         (*i1).mMonom = monomInterface()->copy(*(*i2).mMonom);
//         (*i1).mMonom->mult(*m2);
//         (*i1).mCoeff = coeffInterface()->copy(*(*i2).mCoeff);
//         (*i1).mCoeff->mult(*k2);
//         ++i1;
//         ++i2;
//         break;
//       default:
//         (*i1).mCoeff->addmul(*(*i2).mCoeff, *k2);
//         if ((*i1).mCoeff->isZero())
//           i1.del();
//         else
//           ++i1;
//         ++i2;
//       }
//     while(i2) {
//       i1.insert();
//       (*i1).mMonom = monomInterface()->copy(*(*i2).mMonom);
//       (*i1).mMonom->mult(*m2);
//       (*i1).mCoeff = coeffInterface()->copy(*(*i2).mCoeff);
//       (*i1).mCoeff->mult(*k2);
//       ++i1;
//       ++i2;
//     }
//     delete m2;
//     delete k2;
//   }
//   else {
//     IASSERT((*i1).mMonom->divisibility(((const IPolyList&)a).IPolyList::lm()));
//
//     It i(mHead.begin());
//     ConstIt i2(((const IPolyList&)a).mHead.begin());
//
//     IMonom *m2(monomInterface()->create());
//     m2->divide(*(*i1).mMonom, *(*i2).mMonom);
//     ICoeff *k1(coeffInterface()->create()),
//            *k2(coeffInterface()->create()),
//            *tmp(coeffInterface()->create());
//     tmp->gcd(*(*i1).mCoeff, *(*i2).mCoeff);
//     k1->div(*(*i2).mCoeff, *tmp);
//     k2->div(*(*i1).mCoeff, *tmp);
//     k2->minus();
//
//     while(i1 != i) {
//       (*i).mCoeff->mult(*k1);
//       ++i;
//     }
//
//     i1.del();
//     ++i2;
//     while(i1 && i2)
//       switch((*i1).mMonom->compare(*(*i2).mMonom, *m2)) {
//       case 1:
//         (*i1).mCoeff->mult(*k1);
//         ++i1;
//         break;
//       case -1:
//         i1.insert();
//         (*i1).mMonom = monomInterface()->copy(*(*i2).mMonom);
//         (*i1).mMonom->mult(*m2);
//         (*i1).mCoeff = coeffInterface()->copy(*(*i2).mCoeff);
//         (*i1).mCoeff->mult(*k2);
//         ++i1;
//         ++i2;
//         break;
//       default:
//         (*i1).mCoeff->mult(*k1);
//         (*i1).mCoeff->addmul(*(*i2).mCoeff, *k2);
//         if ((*i1).mCoeff->isZero())
//           i1.del();
//         else
//           ++i1;
//         ++i2;
//       }
//     while(i1) {
//       (*i1).mCoeff->mult(*k1);
//       ++i1;
//     }
//     while(i2) {
//       i1.insert();
//       (*i1).mMonom = monomInterface()->copy(*(*i2).mMonom);
//       (*i1).mMonom->mult(*m2);
//       (*i1).mCoeff = coeffInterface()->copy(*(*i2).mCoeff);
//       (*i1).mCoeff->mult(*k2);
//       ++i1;
//       ++i2;
//     }
//     multiplier.mult(*k1);
//     delete m2;
//     delete k1;
//     delete k2;
//     delete tmp;
//   }
//   IASSERTVALID(*this);
// }
//
// IPoly::ConstIterator* IPolyList::begin() const {
//   return new ConstIterator(mHead.begin());
// }
//
// IPoly::ConstIterator* IPolyList::beginReverse() const {
//   IERROR("beginReverse");
//   return NULL;
// }
//
// IPoly::Iterator* IPolyList::begin() {
//   return new Iterator(mHead.begin());
// }
//
// IPoly::Iterator* IPolyList::beginReverse() {
//   IERROR("beginReverse");
//   return NULL;
// }
//
// void IPolyList::assertValid(const char* fileName, int fileLine) const {
//   if (!mHead.isEmpty()) {
//     ConstIt i(mHead.begin());
//     IASSERT2(fileName, fileLine, (*i).mMonom);
//     IASSERT2(fileName, fileLine, (*i).mCoeff);
//     ConstIt prev(i);
//     ++i;
//     while(i) {
//       IASSERT2(fileName, fileLine, (*i).mMonom);
//       IASSERT2(fileName, fileLine, (*i).mCoeff);
//       IASSERT2(fileName, fileLine, !(*i).mCoeff->isZero());
// /*      if ((*prev).mMonom->compare(*(*i).mMonom) <= 0)
//         std::cerr << (*(*prev).mMonom) << " > " << (*(*i).mMonom)
//           << " = " << (*prev).mMonom->compare(*(*i).mMonom) << std::endl;*/
//       IASSERT2(fileName, fileLine, (*prev).mMonom->compare(*(*i).mMonom) > 0);
//       prev = i;
//       ++i;
//     }
//   }
// }
//
// template <>
// IAllocator IList<IPolyList::Term>::Node::sAllocator(sizeof(IList<IPolyList::Term>::Node));
