/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ISYSTEMTYPE_H
#define ISYSTEMTYPE_H

class ISystem;
class ISystemType {
  friend class ISystem;

public:
  enum Type {Indefinitely,
             Polynomial,
             DifferentialEquation,
             FiniteDifferenceScheme
  };

protected:
  Type mSystem;
  int  mModule;
  int  mRightPart;

public:
  ISystemType():
      mSystem(Indefinitely),
      mModule(0),
      mRightPart(0) {
  }
  ISystemType(Type type, int module, int rightPart):
      mSystem(type),
      mModule(module),
      mRightPart(rightPart) {
  }
  ~ISystemType() {}

  Type type() const { return mSystem; }
  int module() const { return mModule; }
  int rightPart() const { return mRightPart; }
};

#endif // ISYSTEMTYPE_H


