/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IFACTORIZATIONZASSENHAUSTEST_H
#define IFACTORIZATIONZASSENHAUSTEST_H

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "iginvtest.h"

#include "../coeff/ialgextmodularshortaux.h"
#include "../coeff/ifactorizationzassenhaus.h"

#include "../poly/iexpression.h"

#include "../util/imodular.h"
#include "../util/ivariables.h"

class IFactorizationZassenhaus;

class IFactorizationZassenhausTest: public IGinvTest {
CPPUNIT_TEST_SUITE(IFactorizationZassenhausTest);
CPPUNIT_TEST(testRandomPolynomial);
CPPUNIT_TEST(testRepeatedSquaring);
CPPUNIT_TEST(testEqualDegreeSplitting);
CPPUNIT_TEST(testEqualDegreeSplittingMod2);
CPPUNIT_TEST(testEqualDegreeFactorization);
CPPUNIT_TEST(testFactorization);
CPPUNIT_TEST(testFactorizationMod2);
CPPUNIT_TEST_SUITE_END();
private:
  IVariables* vars;
  IFactorizationZassenhaus* alg;
  
  IAlgExtModularShortAux* getPoly(std::string str, ModularShort prime);
public:
  void setUp();

  void testRandomPolynomial();

  void testRepeatedSquaring();

  void testEqualDegreeSplitting();

  void testEqualDegreeSplittingMod2();

  void testEqualDegreeFactorization();

  void testFactorization();

  void testFactorizationMod2();

  void tearDown();
};

#endif // IFACTORIZATIONZASSENHAUSTEST_H
