/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IFACTORIZATIONZTEST_H
#define IFACTORIZATIONZTEST_H

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "iginvtest.h"

#include "../coeff/ifactorizationz.h"

#include "../poly/iexpression.h"

#include "../util/imodular.h"
#include "../util/ivariables.h"

class IFactorizationZ;

class IFactorizationZTest: public IGinvTest {
CPPUNIT_TEST_SUITE(IFactorizationZTest);
CPPUNIT_TEST(testFactor);
CPPUNIT_TEST_SUITE_END();
private:
  IVariables* vars;
  IFactorizationZ* alg;
  
  IOneParameterGmpZAux* getOneParameterPoly(std::string str);
public:
  void setUp();

  void testFactor();

  void tearDown();
};

#endif // IFACTORIZATIONZTEST_H
