/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IGCDZIPPELTEST_H
#define IGCDZIPPELTEST_H

#include <list>

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "iginvtest.h"

#include "../coeff/inparametergmpz.h"
#include "../coeff/inparametermodularshortaux.h"
#include "../coeff/igcdzippel.h"

class IGcdZippelTest: public IGinvTest {
CPPUNIT_TEST_SUITE(IGcdZippelTest);
CPPUNIT_TEST(testZippelPDeg1);
CPPUNIT_TEST(testZippelPDeg2);
CPPUNIT_TEST(testZippelPDeg3);
CPPUNIT_TEST(testZippelMDeg1);
CPPUNIT_TEST(testZippelMDeg2);
CPPUNIT_TEST(testZippelMDeg3);
CPPUNIT_TEST(testZippelDeg2);
//CPPUNIT_TEST(testZippelDeg3);
CPPUNIT_TEST_SUITE_END();
private:
//  IVariables* coeffvars;
//  IVariables* polyvars;
//  
//  ISystemType* st;
//  IMonomInterface* im;
//  ICoeffInterface* ic;
//  IPolyInterface* ip;
//
  ICoeffInterface* icdeg1;
  ICoeffInterface* icdeg2;
  ICoeffInterface* icdeg3;
  IPolyInterface* ipdeg1;
  IPolyInterface* ipdeg2;
  IPolyInterface* ipdeg3;

public:
  void setUp();

  void testZippelPDeg1();

  void testZippelPDeg2();

  void testZippelPDeg3();

  void testZippelMDeg1();

  void testZippelMDeg2();

  void testZippelMDeg3();

  void testZippelDeg2();

  void testZippelDeg3();

  void tearDown();
};

#endif // IGCDZIPPELTEST_H
