/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IGINVTEST_H
#define IGINVTEST_H

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "../coeff/icoeff.h"
#include "../coeff/inparametermodularshortaux.h"
#include "../coeff/inparametergmpz.h"

#include "../poly/iexpression.h"
#include "../poly/ipoly.h"

#include "../util/imodular.h"

class IGinvTest: public CppUnit::TestFixture {
protected:
  IVariables* coeffvars;
  IVariables* polyvars;
  
  ISystemType* st;
  IMonomInterface* im;
  ICoeffInterface* ic;
  IPolyInterface* ip;

  ICoeff* getCoeff(IPolyInterface* ip, std::string str);
  IPoly* getPoly(IPolyInterface* ip, std::string str);

  INParameterModularShortAux* getModularPoly(std::string str, ModularShort p, int endVar);
  INParameterGmpZAux* getGmpZPoly(std::string str, int endVar);
public:
  void setUp();

  void tearDown();
};

#endif // IGINVTEST_H
