/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "inparametergmpzauxtest.h"
#include "../coeff/imonomaux.h"

#include <cppunit/extensions/HelperMacros.h>

CPPUNIT_TEST_SUITE_REGISTRATION(INParameterGmpZAuxTest);

void INParameterGmpZAuxTest::setUp() {
  IGinvTest::setUp();
}

void INParameterGmpZAuxTest::tearDown() {
  IGinvTest::tearDown();
}

void INParameterGmpZAuxTest::testRemoveTrivialFactor() {
  INParameterGmpZAux* p = getGmpZPoly("x^3 + x^2 + x", 1);
  INParameterGmpZAux* expected = getGmpZPoly("x^2 + x + 1", 1);

  IMonomAuxInterface::MonomIterator m = p->removeTrivialFactors();

  p->sub(*expected);

  CPPUNIT_ASSERT(p->isZero());
  CPPUNIT_ASSERT(p->interface().deg(m, 0) == 1);
}
