/***************************************************************************
 *   Copyright (C) 2007 by Sebastian Jambor                                *
 *   sebastian@momo.math.rwth-aachen.de                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IZIPPELGAUSSTEST_H
#define IZIPPELGAUSSTEST_H

#include <list>

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "iginvtest.h"

#include "../coeff/icoeff.h"
#include "../coeff/inparametergmpz.h"
#include "../coeff/inparametermodularshortaux.h"

#include "../criteria/iwrap.h"

#include "../gauss/izippelgauss.h"

#include "../poly/iexpression.h"
#include "../poly/ipoly.h"

#include "../monom/imonom.h"

#include "../system/isystemtype.h"

class IZippelGaussTest: public IGinvTest {
CPPUNIT_TEST_SUITE(IZippelGaussTest);
CPPUNIT_TEST(testDegreeOfFreedom);
CPPUNIT_TEST(testSingleSystem);
CPPUNIT_TEST(testSingleSystemBug);
CPPUNIT_TEST(testSubsystem);
CPPUNIT_TEST_SUITE_END();
private:
  INParameterModularShortAux* form;
  INParameterModularShortAux* eval1;
  INParameterModularShortAux* eval2;
  INParameterModularShortAux* eval3;
  INParameterModularShortAux* g;

  ModularShort *alpha1;
  ModularShort *alpha2;
  ModularShort *alpha3;

  void getList(std::list<ModularShort>& l, ModularShort c[], int n);

public:
  void setUp();

  void testDegreeOfFreedom();

  void testSingleSystem();

  void testSingleSystemBug();

  void testSubsystem();

  void tearDown();
};

#endif // IZIPPELGAUSSTEST_H
