/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IMODULAR_H
#define IMODULAR_H

#include "./iutil.h"

typedef long int ModularShort;

bool iIsPrime(ModularShort p);

ModularShort iGcd(ModularShort a, ModularShort b, ModularShort& x0, ModularShort& y0);

inline ModularShort iInverse(ModularShort a, ModularShort m) {
  IASSERT(0 < a && a < m);
  ModularShort x, y;
  iGcd(a, m, x, y);
  if (x < 0)
    x += m;
  IASSERT((a * x) % m == 1);
  return x;
}

inline ModularShort iDiv(ModularShort a, ModularShort b, ModularShort p) {
  IASSERT(0 <= a && a < p);
  IASSERT(0 < b && b < p);
  ModularShort result = a * iInverse(b, p);
  result %= p;
  return result;
}

ModularShort iPow1(ModularShort a, unsigned deg, ModularShort m);

inline ModularShort iPow0(ModularShort a, unsigned deg, ModularShort m) {
  return (deg) ? iPow1(a, deg, m): 1;
}

ModularShort iRandom(ModularShort m);

#endif // IMODULAR_H

