/***************************************************************************
 *   Copyright (C) 2005 by Blinkov Yu. A.                                  *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "./istatistics.h"

void IStatistics::append(double userTime, int Tlength, int Qlength, int EqLmLength) {
  mMovementEnd.insert();
  (*mMovementEnd).mUserTime = userTime;
  (*mMovementEnd).mTlength = Tlength;
  (*mMovementEnd).mQlength = Qlength;
  (*mMovementEnd).mEqLmLength = EqLmLength;
  ++mMovementEnd;
}

std::ostream& operator<<(std::ostream& out, const IStatistics& a) {
  out << "Number of Spolynomial: " << a.mSpoly << std::endl;
  out << "Number of reductions: " << a.mReduction << std::endl;
  out << "criterion: " << a.mCriterion << std::endl;
  out << "IB length: " << a.mLengthIB << std::endl;
  out << "GB length: " << a.mLengthGB << std::endl;
  out << "Hilbert polynomial: " << a.mHilbertPoly << std::endl;
  out << a.mTimer << std::endl;
  return out;
}

void IStatistics::read(std::istream& in) {
  in.read((char*)(&mCriterion), sizeof(mCriterion));
  in.read((char*)(&mSpoly), sizeof(mSpoly));
  in.read((char*)(&mReduction), sizeof(mReduction));
  in.read((char*)(&mLengthGB), sizeof(mLengthGB));
  in.read((char*)(&mLengthIB), sizeof(mLengthIB));
  mHilbertPoly.read(in);
  in.read((char*)(&mOutOfTime), sizeof(mOutOfTime));
  in.read((char*)(&mComputationInterrupted), sizeof(mComputationInterrupted));
}

void IStatistics::write(std::ostream& out) const {
  out.write((char*)(&mCriterion), sizeof(mCriterion));
  out.write((char*)(&mSpoly), sizeof(mSpoly));
  out.write((char*)(&mReduction), sizeof(mReduction));
  out.write((char*)(&mLengthGB), sizeof(mLengthGB));
  out.write((char*)(&mLengthIB), sizeof(mLengthIB));
  mHilbertPoly.write(out);
  out.write((char*)(&mOutOfTime), sizeof(mOutOfTime));
  out.write((char*)(&mComputationInterrupted), sizeof(mComputationInterrupted));
}

template <>
IAllocator IList<IStatistics::Movement>::Node::sAllocator(sizeof(IList<IStatistics::Movement>::Node));
