/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <cctype>

#include "./ivariables.h"

IVariables::~IVariables() {
}

void IVariables::add(const char *var) {
  int n = strlen(var);
  char *name = new char[n+1];
  int k = 0;
  while (k < n && isspace(var[k])) {
    ++k;
  }
  int i = 0;
  while (k < n && !isspace(var[k])) {
    name[i] = var[k];
    ++i;
    ++k;
  }
  name[i] = '\0';
  if (find(name) >= 0)
    IERROR("find(name) < 0");
  IList<const char*>::Iterator j(mList.begin());
  while (j)
    ++j;
  j.insert(name);
}

int IVariables::find(const char *var) const {
  int r=0;
  ConstIterator i(mList.begin());
  while (i && strcmp(*i, var) != 0) {
    ++i;
    ++r;
  }
  if (!i)
    r = -1;
  return r;
}

static int readVariable(std::istream& in, const char *var) {
  in >> std::ws;
  int r=0;
  int i=0;
  while (var[i] && var[i] == in.get()) {
    ++i;
    ++r;
  }
  int ch = in.peek();
  if (var[i] ||                             // variable name is longer than input
    isalnum(ch) || ch == '[' || ch == '_')  // the other way round
    r = 0;
  if (in.eof())
    in.clear();
  return r;
}

int IVariables::read(std::istream& in) const {
  std::streampos posbeg = in.tellg();
  int var=0;
  ConstIterator i=mList.begin();
  while(i) {
    if (readVariable(in, *i) > 0)
      break;
    ++var;
    ++i;
    in.seekg(posbeg);
  }

  if (!i)
    var = -1;

  return var;
}

template <>
IAllocator IList<const char*>::Node::sAllocator(sizeof(IList<const char*>::Node));
