/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IVARIABLES_H
#define IVARIABLES_H

#include <cstring>
#include <iostream>

#include "./iutil.h"
#include "./ilist.h"


class IVariables {
public:
  typedef IList<const char*>                List;
  typedef IList<const char*>::ConstIterator ConstIterator;

private:
  List mList;

public:
  IVariables(): mList() {}
  ~IVariables();

  void add(const char *var);

  int dim() const { return mList.length(); }
  ConstIterator begin() const { return mList.begin(); }
  const char* variable(int var) const {
    IASSERT(0 <= var && var < dim());
    ConstIterator i(mList.begin());
    while (var > 0) {
      ++i;
      --var;
    }
    return *i;
  }
  int find(const char *var) const;
  int read(std::istream& in) const;
};

#endif // IVARIABLES_H
