/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef COEFF_H
#define COEFF_H

#include <Python.h>
#include <structmember.h>

#include "../ginv/coeff/icoeff.h"

struct  CoeffInterface {
  PyObject_HEAD
  ICoeffInterface *coeffInterface;
};

void coeffInterface_dealloc(CoeffInterface *self);
PyObject* coeffInterface_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int coeffInterface_init(CoeffInterface *self, PyObject *args, PyObject *kwds);
PyObject *coeffInterface_getattr(CoeffInterface *self, char *name);
PyObject* coeffInterface_getType(CoeffInterface *self);
PyObject* coeffInterface_isField(CoeffInterface *self);
PyObject* coeffInterface_isPseudo(CoeffInterface *self);
PyObject* coeffInterface_parameter(CoeffInterface *self);
PyObject* coeffInterface_iterDenom(CoeffInterface *self);
PyObject* coeffInterface_lengthDenom(CoeffInterface *self);

extern PyTypeObject coeffInterface_type;

struct  Coeff {
  PyObject_HEAD
  ICoeff *coeff;
};

void coeff_dealloc(Coeff *self);
PyObject* coeff_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int coeff_init(Coeff *self, PyObject *args, PyObject *kwds);
int coeff_print(Coeff *m, FILE *fp, int flags);
PyObject* coeff_str(Coeff *m);
PyObject* coeff_getattr(Coeff *self, char *name);
PyObject* coeff_isZero(Coeff *self);
PyObject* coeff_isOne(Coeff *self);
PyObject* coeff_setZero(Coeff *self);
PyObject* coeff_setOne(Coeff *self);
PyObject* coeff_inverse(Coeff *self);
PyObject* coeff_gcd(Coeff *self, PyObject *args);
PyObject* coeff_diff(Coeff *self, PyObject *args);
PyObject* coeff_shift(Coeff *self, PyObject *args);

extern PyTypeObject coeff_type;


struct  DenomIterator {
  PyObject_HEAD
  IList<ICoeff*>::ConstIterator iter;
};

void denomIterator_dealloc(DenomIterator *self);
PyObject* denomIterator_getiter(DenomIterator *self);
PyObject* denomIterator_next(DenomIterator *self);

extern PyTypeObject denomIterator_type;


#endif // COEFF_H
