/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef MONOM_H
#define MONOM_H

#include <Python.h>
#include <structmember.h>

#include "../ginv/monom/imonom.h"

struct  MonomInterface {
  PyObject_HEAD
  IMonomInterface *monomInterface;
};

void monomInterface_dealloc(MonomInterface *self);
PyObject* monomInterface_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int monomInterface_init(MonomInterface *self, PyObject *args, PyObject *kwds);
PyObject *monomInterface_getattr(MonomInterface *self, char *name);
PyObject* monomInterface_order(MonomInterface *self);
PyObject* monomInterface_dimIndepend(MonomInterface *self);
PyObject* monomInterface_independ(MonomInterface *self);
PyObject* monomInterface_dimDepend(MonomInterface *self);
PyObject* monomInterface_depend(MonomInterface *self);
PyObject* monomInterface_varSep(MonomInterface *self);

extern PyTypeObject monomInterface_type;

struct  Monom {
  PyObject_HEAD
  IMonom *monom;
};

void monom_dealloc(Monom *self);
PyObject* monom_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int monom_init(Monom *self, PyObject *args, PyObject *kwds);
int monom_print(Monom *m, FILE *fp, int flags);
PyObject* monom_str(Monom *m);
PyObject* monom_getattr(Monom *self, char *name);
int monom_compare(Monom *o1, PyObject *o2);
PyObject* monom_richCompare(Monom *o1, PyObject *o2, int opid);
PyObject* monom_degree(Monom *self);
PyObject* monom_dependVar(Monom *self);
PyObject* monom_setZero(Monom *self);
PyObject* monom_prolong(Monom *self, PyObject *args);
PyObject* monom_gcd(Monom *self, PyObject *args);
PyObject* monom_lcm(Monom *self, PyObject *args);
PyObject* monom_divisibility(Monom *self, PyObject *args);
PyObject* monom_divisibilityTrue(Monom *self, PyObject *args);
PyObject* monom_getiter(Monom *self);

PyObject* monom_cmp(Monom *self, PyObject *args);

extern PyTypeObject monom_type;

struct  MonomIterator {
  PyObject_HEAD
  IMonom *monom;
  int iter;
};

void monomIterator_dealloc(MonomIterator *self);
PyObject* monomIterator_next(MonomIterator *self);

extern PyTypeObject monomIterator_type;

#endif // MONOM_H
