/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ONEPARAMETERPOLY_H
#define ONEPARAMETERPOLY_H

#include <Python.h>
#include <structmember.h>

#include "../ginv/poly/ioneparameterpoly.h"
#include "../ginv/coeff/icoeff.h"

struct  OneParameterPoly {
  PyObject_HEAD
  IOneParameterPoly *poly;
};

void oneparameterpoly_dealloc(OneParameterPoly *self);
PyObject* oneparameterpoly_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int oneparameterpoly_init(OneParameterPoly *self, PyObject *args, PyObject *kwds);
int oneparameterpoly_print(OneParameterPoly *m, FILE *fp, int flags);
PyObject* oneparameterpoly_str(OneParameterPoly *m);
PyObject* oneparameterpoly_getattr(OneParameterPoly *self, char *name);
//int oneparameterpoly_compare(OneParameterPoly *o1, PyObject *o2);
//PyObject* oneparameterpoly_richCompare(OneParameterPoly *o1, PyObject *o2, int opid);
//PyObject* oneparameterpoly_isZero(OneParameterPoly *self);
//PyObject* oneparameterpoly_getLength(OneParameterPoly *self);
//PyObject* oneparameterpoly_degree(OneParameterPoly *self);
//PyObject* oneparameterpoly_norm(OneParameterPoly *self);
//PyObject* oneparameterpoly_lm(OneParameterPoly *self);
//PyObject* oneparameterpoly_lc(OneParameterPoly *self);
//PyObject* oneparameterpoly_setZero(OneParameterPoly *self);
//PyObject* oneparameterpoly_pp(OneParameterPoly *self);
//PyObject* oneparameterpoly_isPp(OneParameterPoly *self);
//PyObject* oneparameterpoly_prolong(OneParameterPoly *self, PyObject *args);
//PyObject* oneparameterpoly_mult(OneParameterPoly *self, PyObject *args);
//PyObject* oneparameterpoly_diff(OneParameterPoly *self, PyObject *args);
//PyObject* oneparameterpoly_shift(OneParameterPoly *self, PyObject *args);
//PyObject* oneparameterpoly_reduction(OneParameterPoly *self, PyObject *args);
//PyObject* oneparameterpoly_soneparameterpoly(OneParameterPoly *self, PyObject *args);
//PyObject* oneparameterpoly_getiter(OneParameterPoly *self);

extern PyTypeObject oneparameterpoly_type;


//struct  OneParameterPolyIterator {
//  PyObject_HEAD
//  IOneParameterPoly::ConstIterator *iter;
//};
//
//void oneparameterpolyIterator_dealloc(OneParameterPolyIterator *self);
//PyObject* oneparameterpolyIterator_getiter(OneParameterPoly *self);
//PyObject* oneparameterpolyIterator_next(OneParameterPolyIterator *self);
//
//extern PyTypeObject oneparameterpolyIterator_type;

#endif // ONEPARAMETERPOLY_H
