/***************************************************************************
 *   Copyright (C) 2004 by Blinkov Yu.A.                                   *
 *   BlinkovUA@info.sgu.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WRAP_H
#define WRAP_H

#include <Python.h>
#include <structmember.h>

#include "../ginv/criteria/iwrap.h"

struct  WrapInterface {
  PyObject_HEAD
  IWrapInterface *wrapInterface;
};

void wrapInterface_dealloc(WrapInterface *self);
PyObject* wrapInterface_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int wrapInterface_init(WrapInterface *self, PyObject *args, PyObject *kwds);
PyObject *wrapInterface_getattr(WrapInterface *self, char *name);
PyObject* wrapInterface_getType(WrapInterface *self);

extern PyTypeObject wrapInterface_type;

struct  Wrap {
  PyObject_HEAD
  IWrap *wrap;
};

void wrap_dealloc(Wrap *self);
PyObject* wrap_new(PyTypeObject *type, PyObject *args, PyObject *kwds);
int wrap_init(Wrap *self, PyObject *args, PyObject *kwds);
PyObject* wrap_getattr(Wrap *self, char *name);
PyObject* wrap_lm(Wrap *self);
PyObject* wrap_ancestor(Wrap *self);
PyObject* wrap_poly(Wrap *self);
PyObject* wrap_multi(Wrap *self);
PyObject* wrap_degProlong(Wrap *self);
PyObject* wrap_isProlong(Wrap *self);
PyObject* wrap_buildProlong(Wrap *self);

extern PyTypeObject wrap_type;

#endif // WRAP_H
