import ginv

st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("Lex", st, ['x', 'y', 'z'])
ic = ginv.CoeffInterface("GmpZ", st)
ip = ginv.PolyInterface("PolyList", st, im, ic)
iw = ginv.WrapInterface("CritPartially", ip)
id = ginv.DivisionInterface("Janet", iw)

def printStatistics(basis):
  print "         lenghtIB = ", basis.lenghtIB()
  print "         lenghtGB = ", basis.lenghtGB()
  print "     numCriterion = ", basis.numCriterion()
  print "         numSpoly = ", basis.numSpoly()
  print "     numReduction = ", basis.numReduction()
  print "         userTime = ", basis.userTime()
  print "          sysTime = ", basis.sysTime()
  print "         realTime = ", basis.realTime()
  print "hilbertPolynomial = ", basis.hilbertPolynomial()

def printWrap(w):
  print "          lm =", w.lm()
  print "    ancestor =", w.ancestor()
  print "        poly =", w.poly()
  print "       multi =", w.multi()
  print "  degProlong =", w.degProlong()
  print "   isProlong =", w.isProlong()
  print "buildProlong =", w.buildProlong()

poly = ginv.Poly(ip, "y^3 - z^2 + x - 1")
basis = ginv.basisBuild("TQ", id, \
  ["x^3 - y^2 + z - 1",\
   poly,\
   "z^3 - x^2 + y - 1"])

printStatistics(basis)

basis = ginv.basisBuild("TQDegree", ginv.DivisionInterface("JanetLike", iw), \
  ["x^3 - y^2 + z - 1",\
   poly,\
   "z^3 - x^2 + y - 1"])

basis = ginv.basisBuild("TQBlockLow", id, \
  ["x^3 - y^2 + z - 1",\
   poly,\
   "z^3 - x^2 + y - 1"],\
   10)

printStatistics(basis)

print "len(basis) = ", len(basis)
printWrap(basis[9])
print

for w in basis:
  printWrap(w)
  print

for (st, lenT, lenQ, lenAdd) in basis.iterStatistics():
  print st, lenT, lenQ, lenAdd

for p in basis.iterIB():
  print p

for p in basis.iterGB():
  print p

for lm in basis.iterLmIB():
  print lm,
print

for lm in basis.iterLmGB():
  print lm,
print

print "find division -", basis.find("x*x*y^12").poly()
monom = ginv.Monom(im, "x*x*y^12")
print "find division -", basis.find(monom).lm()

print basis.nf("x*x*y^12 + 1")
poly = ginv.Poly(ip, "x^12*x*y^12*(z + 1)^3")
print basis.nf(poly)

print basis.nfTail(poly)
print basis.nfTail("x*x*y^12 + 1")

print basis.isNf("x*x*y^12 + 1")
poly = ginv.Poly(ip, "x^2 + 2")
print basis.isNf(poly)

print basis.isNfTail("x*x*y^12 + 1")
print basis.isNfTail(poly)
