import ginv

st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("DegRevLex", st, ['x', 'y', 'z'])
print im.order()
im = ginv.MonomInterface("DegRevLexByte", st, ['x', 'y', 'z'])
print im.order()
im = ginv.MonomInterface("Lex", st, ['x', 'y', 'z'])
print im.order()
im = ginv.MonomInterface("Elim", st, ['x', 'y', 'z'], varSep=1)
print im.order()
im = ginv.MonomInterface("TopDegRevLexByte", st, ['x', 'y', 'z'], ['u', 'v'])
print im.order()
im = ginv.MonomInterface("TopDegRevLex", st, ['x', 'y', 'z'], ['u', 'v'])
print im.order()
im = ginv.MonomInterface("TopElim", st, ['x', 'y', 'z'], ['u', 'v'], varSep=1)
print im.order()
im = ginv.MonomInterface("TopLex", st, ['x', 'y', 'z'], ['u', 'v'])
print im.order()
im = ginv.MonomInterface("PotDegRevLex", st, ['x', 'y', 'z'], ['u', 'v'])
print im.order()
im = ginv.MonomInterface("PotLex", st, ['x', 'y', 'z'], ['u', 'v'])
print im.order()
im = ginv.MonomInterface("PosElim", st, ['x', 'y', 'z'], ['u', 'v'], varSep=1)
print im.order()
print im.dimIndepend()
print im.independ()
print im.dimDepend()
print im.depend()
print im.varSep()

im = ginv.MonomInterface("DegRevLex", st, ['x', 'y', 'z'])
m0 = ginv.Monom(im)
print m0
m1 = ginv.Monom(im, monom="x^3*y*x*z*z")
print m1
print m1.degree()
print m1.setZero()
print m0.prolong(2, 13)
print m1.gcd(m0)
print m1.divisibility(m0)
print m1.divisibilityTrue(m0)

lst = map(lambda k: ginv.Monom(im, "%s^%d" % (im.independ()[k], k)), range(2,-1,-1))
print lst
lst.sort()
print lst
print lst[2] >= lst[1]

if lst[0]: print lst[0]
if lst[1]: print lst[1]

print len(m1)
print m1[1]

print lst[1]*lst[2]*m0.prolong(2, 11)
print m0 / m0
print m0
m0 *= lst[1]*lst[2]
print m0
print m0.prolong(2, 13)
print m1.gcd(m0)
print m1.divisibility(m0)
print m1.divisibilityTrue(m0)

print "*"*20
st = ginv.SystemType("DifferentialEquation")
im = ginv.MonomInterface("TopDegRevLex", st, ['x', 'y', 'z'], ['u', 'v'])
print im.order()
print im.dimIndepend()
print im.independ()
print im.dimDepend()
print im.depend()
print im.varSep()

print "*"*20
m1 = ginv.Monom(im, 'df(u, y, 3, x, x, x)')
print m1
print m1.degree()
print m1.dependVar()
print m1.prolong(2, 13)

print "*"*20
st = ginv.SystemType("FiniteDifferenceScheme")
im = ginv.MonomInterface("PotDegRevLex", st, ['x', 'y', 'z'], ['u', 'v'])
print im.order()
print im.dimIndepend()
print im.independ()
print im.dimDepend()
print im.depend()
print im.varSep()

print "*"*20
m1 = ginv.Monom(im, 'T(u, y, 3, x, x, x)')
print m1
print m1.degree()
print m1.dependVar()
print m1.prolong(2, 13)
