#! /usr/bin/env python
# -*- coding: latin1 -*-

import ginv

st = ginv.SystemType("Polynomial")
im = ginv.MonomInterface("DegRevLexByte", st, ['r', 'u'])
ic = ginv.CoeffInterface("AlgebraicFieldExtensionGmpQ", st, parametr=["phi"],
      extension="phi^24-phi^23+phi^19-phi^18+phi^17-phi^16+phi^14-phi^13+phi^12-phi^11+phi^10-phi^8+phi^7-phi^6+phi^5-phi+1")
ip = ginv.PolyInterface("PolyList", st, im, ic)

iw = ginv.WrapInterface("CritPartially", ip)
iD = ginv.DivisionInterface("Janet", iw)

eqs = \
["-(-1+phi^3+phi^23+phi^18-phi^21+phi^8-phi^7-phi^14+phi^13)*(-2*r+2*r*u*c+c-3*phi^23*r*c+3*r^2*phi^16+phi^5*c-12*phi^9*r*u^2*c+7*phi^9*u^3*r-3*phi^15*r*u^2*c+3*phi^15*u^3*r+14*r^2*u+3*phi^9*u*r*c^2-20*phi^9*r*u*c+5*phi^9*r*c^2-r*phi^14-12*phi^16*r*c-22*phi^23*r*u*c-2*phi^2*r-3*phi^21*r*u^2+4*phi^21*u^3*r-3*phi^6*u*r^3+2*r*phi^16-2*phi^11*u*c+5*phi^23*r*u+phi^19*c-3*phi^5*r-10*r*u+12*r*phi^16*u-2*phi^10*r+4*r*phi^18+5*u*phi^2*r-2*phi^17*r-r^2+2*u*c+6*u^2*c+u^3*c-c^2+c^3-6*r*u^2*c-u^4*c-3*r*u^2+9*r*c-7*r^2*c+7*u^3*r-6*u*c^2+7*phi^2*r^2*c-3*u^3*phi^14*c+2*phi^6*r^2*u-3*phi^18*r^3*u+3*phi^17*r^3*u-3*phi^16*r^3*u+3*phi^12*r^3*u-3*phi^11*r^3*u+3*phi^10*r^3*u+3*phi^7*r^3*u+3*phi^5*r^3*u-3*phi^23*r^3*u+3*phi^15*r^3*u-3*phi^9*r^3*u-3*phi^4*r^3*u+3*phi^22*r^3*u+phi^2*u^5*r-phi^8*u^3*c+phi^13*r^2-6*phi^4*u*r^2*c+3*phi^2*r*u^2*c+phi^4*r^3-phi^23*u^3*c-2*phi^23*u*c-2*phi^16*u*c+2*phi^14*u*c+phi^6*r+phi^16*c^2+2*phi^23*r+2*r*phi^11+r*phi^9-2*phi^23*c-phi^18*c+phi^10*c+phi^23*c^2-phi^14*c^2+phi^11*c^2+phi^15*c-2*phi^2*c^2-5*phi^10*r*u+3*phi^10*r*c-5*phi^5*r*u+3*phi^5*r*c-2*phi^16*u^2*c+2*phi^16*u*c^2+5*phi^23*r*c^2+15*phi^23*r*u^2+7*phi^23*r^2*c+7*phi^16*r^2*c-7*phi^10*r^2*c-2*phi^6*r^2*c-7*phi^5*r^2*c+phi^7*u^3*c-3*phi^23*r^2*u^2-phi^21*u^4*c-5*phi^20*r*u+3*phi^20*r*c-5*phi^15*r*u+3*phi^15*r*c-7*phi^15*r^2*c+5*phi^9*r*u-3*phi^9*r*c+5*phi^9*r^2*c+12*phi^4*r^2*u^2+2*phi^2*u*c-3*phi^2*u^3*r-3*phi^2*r*c+3*phi^14*u^2*c^2-phi^13*u^3*c+3*phi^20*u^3*r+phi^14*r^2+phi^3*r*c+phi^21*c+12*phi^9*r*u^2+phi^3*r^2+phi^4*r+3*phi^2*r^2+4*phi^14*u^3*r+phi^12*u^3*r+4*phi^7*u^3*r+3*r^3*u-phi^19*r-2*phi^7*r+phi^13*r-2*phi^12*r+phi*r+phi*c-3*phi^18*r*c-2*phi^3*r*u-phi^21*r^2+r*u^2*phi^17+6*phi^11*r*u^2+5*phi^18*r*u-3*phi^11*r*c+5*phi^11*r*u+u*r*phi^22+12*phi^16*r*u^2-phi^22*r+phi^22*c-3*phi^13*r^3*u-4*phi^18*r^2*u^3-2*phi^18*r*u*c-20*phi^16*r*u*c-2*phi^13*r*u*c-8*phi^11*r*u*c+2*phi^7*r*u*c+3*phi^23*r*u^2*c+3*phi^16*r*u^2*c-3*phi^10*r*u^2*c-3*phi^5*r*u^2*c+4*phi^23*r*u^3*c-3*phi^20*r*u^2*c+phi^14*c-phi^10*c^2-phi^7*c^2-3*phi^5*c^2+4*phi^23*r^2+phi^18*r^2+4*phi^11*r^2-phi^7*r^2+4*phi^21*c^2-phi^20*r-3*phi^20*r^3-phi^15*r+3*phi^9*r^2+5*phi^4*r*u+2*phi^10*u*c+2*phi^7*u*c+5*phi^5*u*c+3*phi^18*r*u^2+5*phi^16*r*c^2+2*phi^11*r*c^2-12*phi^23*r^2*u-12*phi^16*r^2*u+12*phi^10*r^2*u+12*phi^5*r^2*u-phi^18*u^3*c-3*phi^23*u^3*r-3*phi^16*u^3*r+3*phi^10*u^3*r+3*phi^5*u^3*r-5*phi^23*u^4*r-5*phi^21*u*c+12*phi^20*r^2*u-7*phi^20*r^2*c+phi^21*u^3*c-20*phi^2*r*u*c+12*phi^15*r^2*u-6*phi^9*r^2*u-3*phi^4*r*c+5*phi^2*r*c^2+12*phi^2*r*u^2-12*phi^2*r^2*u-6*phi^14*r*u*c-2*phi^8*r*u*c+2*phi^21*r*u*c-3*phi^21*r*u^2*c-3*phi^14*r*u^2*c-3*phi^7*r*u^2*c-2*phi^3*r*u*c+phi^21*r+phi^7*u^4*r+3*phi^19*r*u-3*phi^19*r*c+2*phi^21*r^2*u+2*phi^14*r^2*u+2*phi^7*r^2*u-phi^14*u^4*c-phi^7*u^4*c+2*phi^19*u*c-2*phi^18*u*c+2*phi^17*u*c-2*phi^13*u*c+2*phi^12*u*c-phi^8*u*c-2*phi^6*u*c-2*phi*u*c+2*phi^19*u*c^2-3*phi^19*u^2*c+3*phi^14*r*u^2+phi^14*r*c^2+3*phi^13*r*u^2+3*phi^8*r*u^2-3*phi^7*r*u^2+phi^12*c+2*phi^7*c+phi^18*c^2-phi^19*c^2-phi^17*c^2+phi^13*c^2-phi^12*c^2+phi^8*c^2+phi^6*c^2+phi*c^2-phi^3*c+phi^3*u^2*c+3*phi^3*r*u^2-phi^3*u^3*c+phi^8*r^2)",\
"-(-1+phi^4-phi^5+phi^6-phi^7+phi^9-phi^10+phi^11-phi^12+phi^13-phi^15+phi^16-phi^17+phi^18-phi^22+phi^23)*(-r-2*r*u*c+c-7*phi^23*r*c+phi^5*c+2*r^2*u-r*phi^14-7*phi^16*r*c+2*phi^23*r*u*c+2*phi^21*r*u^2-phi^2*c+3*phi^18*r*u^2*c+7*phi^23*r*u-7*r*u+7*r*phi^16*u+r*phi^18+phi^17*r+7*r*phi^6*u+3*r^2+u^2*c+r^3-3*r*u^2*c+2*r*u^2+7*r*c+4*u^3*r-2*phi^19*r*c*u+3*phi*r*u^2+3*phi^22*r*u^2+4*phi^17*r*u^3+2*phi^17*r^2*u+2*phi^12*r^2*u-2*phi^6*r^2*u-7*phi^6*r*c-phi^8*u^3*c-3*phi^13*r^2+2*phi^23*r-phi^23*c-phi^16*c+phi^10*c+phi^20*c+phi^15*c-2*phi^10*r*u+phi^10*r*c-7*phi^5*r*u+7*phi^5*r*c-phi^23*u^2*c-phi^16*u^2*c+phi^10*u^2*c+phi^7*u^2*c+phi^5*u^2*c-2*phi^23*r*u^2-2*phi^18*r^2*u-2*phi^5*r^2*c+phi^15*r*u-2*phi^15*r*c-2*phi^15*u^2*c+2*phi^15*u*c^2+2*phi^9*r*u-phi^9*u^2*c-phi^9*r*c+phi*r^2+3*phi^14*r^2-phi*u^3*c+4*phi^19*u^3*r-6*phi^3*r*c-4*phi^6*u^3*r-3*phi^3*r^2-phi^4*r+phi^3*r+4*phi^14*u^3*r+4*phi^12*u^3*r+4*phi^7*u^3*r+2*phi^12*r*u^2+phi^8*r-phi^7*r+phi^13*r+3*phi^19*r^2+phi^6*c-phi*r-2*phi*r*u*c-phi^18*u^2*c+phi^17*u^2*c-phi^13*u^2*c+phi^12*u^2*c-phi^11*u^2*c-7*phi^18*r*c+5*phi^3*r*u+3*phi^21*r^2+8*phi^18*r*u+phi^17*r*c-2*phi^17*r*u+6*phi^14*r*c-5*phi^14*r*u-7*phi^13*r*c+7*phi^13*r*u+5*phi^12*r*c-5*phi^12*r*u-7*phi^11*r*c-3*phi^19*r^2*u^2+phi^4*u*c+7*phi^11*r*u-6*phi^8*r*c+5*phi^8*r*u-2*u*r*phi^22-3*phi^17*r*u^2*c+3*phi^13*r*u^2*c+3*phi^6*r*u^2*c+3*phi^8*r*u^2*c+3*phi*r*u^2*c-2*phi^8*r^2*u-2*phi*r^2*u+2*phi^19*r*u^2+6*phi^10*r*u^2+2*phi^5*r*u^2-4*phi^13*u^3*r-3*phi^8*u^3*r-4*phi*u^3*r-phi^22*c-6*phi*r*c+5*phi*r*u+7*phi^7*r*c-7*phi^7*r*u+phi^22*u^2*c-phi^22*u^3*c+phi^22*r*c-phi^15*u^3*c+3*phi^15*r*u^2+2*phi^18*r*u*c+2*phi^13*r*u*c-2*phi^12*r*u*c-8*phi^10*r*u*c-2*phi^7*r*u*c-2*phi^5*r*u*c+3*phi^23*r*u^2*c+3*phi^16*r*u^2*c+3*phi^11*r*u^2*c-3*phi^10*r*u^2*c-3*phi^5*r*u^2*c-2*phi^15*r*u*c-2*phi^22*r*u*c+3*phi^12*r^2-3*phi^23*r^2-3*phi^18*r^2+2*phi^10*r^2+3*phi^7*r^2+3*phi^5*r^2+phi^20*r+phi^20*c^2+phi^15*r^2+phi^22*r^2+2*phi^4*r*u-2*phi^18*r*u^2+phi^10*r*c^2-2*phi^23*r^2*u-2*phi^16*r^2*u-2*phi^13*r^2*u-2*phi^11*r^2*u+2*phi^10*r^2*u+8*phi^5*r^2*u-4*phi^23*u^3*r-4*phi^18*u^3*r-4*phi^16*u^3*r-4*phi^11*u^3*r+4*phi^10*u^3*r+4*phi^5*u^3*r-2*phi^20*u*c-phi^4*u^2*c-phi^4*r*c-3*phi^19*r*u^2*c-2*phi^14*r*u*c-2*phi^21*r*u*c-3*phi^14*r*u^2*c-3*phi^12*r*u^2*c-3*phi^7*r*u^2*c+2*phi^3*r*u*c-phi^21*r-5*phi^19*r*u+6*phi^19*r*c+2*phi^14*r^2*u+2*phi^7*r^2*u-phi^17*u*c+3*phi*u*c+2*phi^14*r*u^2-phi^13*r*u^2+phi^8*r*u^2+2*phi^7*r*u^2+phi^17*c^2-2*phi*c^2+phi^3*u^4*r-2*phi^3*r*u^2-phi^6*u^2*c-2*phi^8*r^2+2*r^2*u*phi^19)",\
"-phi^13*(-4*r+2*r*u*c-2*c-6*phi^23*r*c+6*phi^23*u*r^2*c-12*r^2*u^2*c-r*c^2-phi^5*c-15*phi^9*r*u^2*c+10*phi^9*u^3*r-30*phi^15*r*u^2*c+13*phi^15*u^3*r-28*r^2*u+3*phi^9*u*r*c^2+6*r^2*u^2-3*r*phi^14-6*phi^23*r^3-6*phi^16*r*c-4*phi^23*r*u*c-phi^2*r-phi^21*r*u^2+phi^2*c+15*phi^15*u*r*c^2-3*phi^6*u*r^3+4*r*phi^16-2*phi^11*u*c-36*phi^18*r*u^2*c-14*phi*r*c^2+5*phi^23*r*u+6*phi^18*u*r^2*c+phi^19*c-5*phi^5*r-7*r*u+5*r*phi^16*u-5*phi^10*r+4*r*phi^18+5*u*phi^2*r-6*phi^17*r-7*r*phi^6*u-2*r^2+6*u*c+7*u^2*c+phi^14*u^2*c+6*r^3-6*c^2+c^3+33*r*u^2*c-6*u*r^2*c-9*u*r*c^2+5*u^4*c-r*u^2+7*r*c+19*r^2*c-22*u^3*r-6*u*c^2-4*u^3*c^2-21*phi*r*u^2+phi^7*u^5*r+5*phi^12*u^4*c-10*phi^17*r*u^3-2*u*phi^21*r-6*phi^17*r^2*u-22*phi^12*r^2*u+28*phi^6*r^2*u-20*phi^11*r^2*u^3-3*phi^18*r^3*u+3*phi^17*r^3*u-3*phi^16*r^3*u+3*phi^12*r^3*u-3*phi^11*r^3*u+3*phi^10*r^3*u+3*phi^7*r^3*u-3*phi^5*r^3*c+15*phi^5*r^3*u-3*phi^23*r^3*u+14*phi^15*u^4*r-phi^20*u^4*r+9*phi^6*r*c+15*phi^22*r*u^2*c-3*phi^22*u*r*c^2-20*phi^20*r*u*c+12*phi^18*r^2*u^2*c-12*phi^17*r^2*u^2*c-14*phi^6*u*c^2-6*phi^22*r^2*u+phi^11*u^4*r+3*phi^10*u^4*r-phi^23*u^5*r-phi^16*u^5*r-3*phi^4*u^2*c^2+phi^4*u^4*r-3*phi^13*r^2*u^2+3*phi^10*r^2*c^2+5*phi^20*r*c^2+2*phi^13*r^2-u^4*r-27*phi^10*u*r^2*c-6*phi^5*u*r^2*c-6*phi^15*u*r^2*c+8*phi^4*r*u*c-phi^23*u^3*c-3*phi^23*u*c-4*phi^16*u*c+phi^14*u*c+3*phi^6*r+4*phi^16*c^2+3*phi^23*r+4*r*phi^11+r*phi^9+phi^23*c+phi^18*c+2*phi^16*c+phi^11*c-phi^10*c+4*phi^23*c^2-phi^14*c^2+2*phi^11*c^2-6*phi^13*r^3-phi^20*c+phi^15*c+phi^9*c-phi^9*c^3+phi^4*c-2*phi^4*r^2+4*phi^9*c^2-2*phi^2*c^2-5*phi^10*r*u+6*phi^10*r*c-5*phi^5*r*u+6*phi^5*r*c-6*phi^23*u^2*c+6*phi^23*u*c^2-6*phi^16*u^2*c+6*phi^16*u*c^2+6*phi^10*u^2*c-6*phi^10*u*c^2+phi^7*u^2*c+6*phi^5*u^2*c-6*phi^5*u*c^2+phi^23*r*c^2+4*phi^23*r*u^2-19*phi^23*r^2*c+30*phi^18*r^2*u-19*phi^18*r^2*c+2*phi^17*r^2*c-19*phi^16*r^2*c+13*phi^12*r^2*c-19*phi^11*r^2*c+2*phi^10*r^2*c-19*phi^13*r^2*c+19*phi^7*r^2*c-19*phi^6*r^2*c+19*phi^5*r^2*c-6*phi^23*r^2*u^2-6*phi^18*r^2*u^2+30*phi^10*r^2*u^2+6*phi^5*r^2*u^2+phi^16*u^4*r+2*phi^22*r^2*c-5*phi^20*r*u+6*phi^20*u^2*c+6*phi^20*r*c-6*phi^20*u*c^2+phi^21*u^2*c-5*phi^15*r*u+6*phi^15*r*c+6*phi^15*u^2*c-6*phi^15*u*c^2-5*phi^15*r^2*c+2*phi^9*r*u-3*phi^9*u^2*c-3*phi^9*r*c-2*phi^9*r^2*c+4*phi^9*u*c^2+12*phi^15*r^2*u^2-phi^4*r*c^2-6*phi^4*r*u^2-4*phi^9*u*c-2*phi^4*r^2*c+3*phi^2*u*c-6*phi^2*u^2*c-phi^2*u^3*r+6*phi^2*u*c^2-6*phi^2*r*c-6*phi^22*u*r^2*c+u^5*r-4*phi*r^2-2*phi^14*r^2+3*phi*u^3*c-3*phi*u^2*c^2-12*phi^19*u^3*r+6*phi^3*r*c+5*phi^10*u^4*c+22*phi^6*u^3*r+22*phi^3*r^2*u-6*phi^3*r^2*u^2-17*phi^3*r^2*c+12*phi^3*u^3*r+2*phi^3*r^2-6*phi^3*r^3+2*phi^4*r-phi^3*r+20*r^2*u^3-20*phi^6*r^2*u^3-phi^22*u^6*r-phi^18*u^5*r-phi^11*u^5*r-phi^4*u^5*r+20*phi^17*r^2*u^3+12*phi^6*r^2*u^2*c-12*phi^14*u^3*r-22*phi^12*u^3*r-22*phi^7*u^3*r+6*phi^22*u^2*c^2*r-10*phi^22*u^3*r+17*phi^19*r^2*c-6*phi^19*u*r*c^2+phi^17*u^5*r+5*phi^22*u^4*c-4*phi^22*u^3*c^2+6*phi^3*u*r^2*c+6*phi^3*u*r*c^2-18*phi^3*r*u^2*c-12*phi^14*r^2*u^2*c+12*phi^13*r^2*u^2*c+3*r^3*u+6*phi^4*c^2-3*phi^19*r+6*phi^19*r^3+6*phi^14*r^3-5*phi^8*r^3+phi*r^3-phi^8*r-4*phi^7*r+2*phi^13*r-5*phi^12*r+3*phi*r+2*phi*c+40*phi*r*u*c+15*phi^22*u^4*r+phi^3*u*c-10*phi^3*r*u-2*phi^21*r^2-3*phi*r^3*u+12*phi*r^2*u^2*c+15*r*u^2*phi^17-20*phi*r^2*u^3+12*phi^8*r^2*u^2*c-6*phi^19*u*r^2*c-6*phi^14*u*r^2*c-6*phi*u*r^2*c+5*phi^15*u^4*c-4*phi^15*u^3*c^2-4*phi^10*u^3*c^2+4*phi^9*u^3*c^2-5*phi^4*u^4*c+4*phi^4*u^3*c^2+phi^14*r*c-2*phi^14*r*u-phi^12*r*u+6*phi^19*r^2*u^2+6*phi^14*r^2*u^2+6*phi^12*r^2*u^2-7*phi^4*u*c+6*phi^8*r^2*u^2+12*phi*r^2*u^2+11*u*r*phi^22+15*phi*u^4*r+12*phi^20*r*u^2-phi^16*c^3-phi^2*c^3+phi^15*c^3+3*phi^20*r^2+phi^20*c^3+phi^10*c^3+3*phi^6*c^3+phi^5*c^3-4*phi^10*r*u^3*c-24*phi^15*r*u^3*c+6*phi^15*u^2*c^2*r-12*phi^7*r^2*u^2*c-3*phi^17*u*r*c^2+15*phi^17*r*u^2*c+9*phi^13*u*r*c^2-33*phi^13*r*u^2*c+9*phi^6*u*r*c^2-33*phi^6*r*u^2*c-12*phi^12*r^2*u^2*c+12*phi^11*r^2*u^2*c+6*phi^13*u*r^2*c-18*phi^8*r*u^2*c+6*phi^8*u*r*c^2-18*phi*r*u^2*c+6*phi*u*r*c^2-17*phi^8*r^2*c+22*phi^8*r^2*u-17*phi*r^2*c+22*phi*r^2*u+22*phi^13*u^3*r+12*phi^8*u^3*r+12*phi*u^3*r+3*phi^19*r^3*u-5*phi^9*u^4*c-2*phi^22*r+2*phi^22*c-6*phi^22*c^2-2*phi^22*c^3+6*phi^21*r^3-3*phi^20*c^3*u-24*phi*r*u^3*c+6*phi*u^2*c^2*r-12*phi^19*r^2*u^2*c-24*phi^22*r*u^3*c-6*phi^21*u*r^2*c+3*phi^14*r^3*u-3*phi^13*r^3*u-3*phi^8*r^3*u+phi^7*r*c-2*phi^7*r*u-4*phi^17*u^3*c^2+20*phi^19*r^2*u^3-20*phi^18*r^2*u^3+20*phi^14*r^2*u^3-20*phi^13*r^2*u^3+20*phi^12*r^2*u^3-16*phi^8*r^2*u^3+20*phi^7*r^2*u^3+7*phi^22*u*c-6*phi^22*u^2*c-12*phi^22*r*c+8*phi^22*u*c^2+phi^10*u^5*r+6*phi^8*u^5*r+6*phi^21*r^2*u^2+phi^21*r*c+phi^22*u^5*r-10*phi^20*u^3*c+12*phi^20*u^2*c^2+phi^15*u^5*r-2*phi^18*r*u*c-20*phi^17*r*u*c-2*phi^13*r*u*c+2*phi^7*r*u*c-33*phi^23*r*u^2*c+9*phi^23*u*r*c^2+9*phi^18*u*r*c^2-33*phi^16*r*u^2*c+9*phi^16*u*r*c^2-33*phi^11*r*u^2*c+9*phi^11*u*r*c^2+15*phi^10*r*u^2*c-3*phi^10*u*r*c^2+33*phi^5*r*u^2*c-9*phi^5*u*r*c^2-6*phi^12*u*r^2*c-6*phi^7*u*r^2*c-6*phi^10*c^2-6*phi^7*c^2-6*phi^5*c^2+3*phi^23*r^2+2*phi^18*r^2+5*phi^17*r^2-2*phi^7*r^2-phi^23*c^3-6*phi^18*r^3+6*phi^12*r^3+3*phi^10*r^3+6*phi^7*r^3+6*phi^5*r^3+phi^22*r^3-2*phi^20*r-6*phi^20*c^2-2*phi^15*r+phi^15*r^3-6*phi^15*c^2+7*phi^10*u*c+6*phi^7*u*c+7*phi^5*u*c+phi^18*r*c^2+phi^18*r*u^2+8*phi^17*r*c^2+phi^13*r*c^2-phi^7*r*c^2+28*phi^23*r^2*u+28*phi^16*r^2*u+28*phi^13*r^2*u+28*phi^11*r^2*u-6*phi^10*r^2*u-28*phi^5*r^2*u+22*phi^23*u^3*r+26*phi^18*u^3*r+22*phi^16*u^3*r+22*phi^11*u^3*r-10*phi^10*u^3*r-22*phi^5*u^3*r-5*phi^16*u^4*c+4*phi^16*u^3*c^2+phi^23*u^4*r-phi^21*u*c+7*phi^20*u*c+7*phi^15*u*c+10*phi^4*u^3*r-15*phi^4*r*u^2*c+3*phi^4*u*r*c^2+12*phi^23*r^2*u^2*c+12*phi^16*r^2*u^2*c-12*phi^10*r^2*u^2*c-12*phi^5*r^2*u^2*c-20*phi^23*r^2*u^3-20*phi^16*r^2*u^3+20*phi^10*r^2*u^3+20*phi^5*r^2*u^3+6*phi^15*r^2*u-phi^9*u^5*r+6*phi^9*r^2*u+6*phi^4*r^2*u+phi^9*u^4*r+phi^2*u^4*r+18*phi^19*r*u^2*c+r^4-4*phi^13*r*u^3*c-24*phi^8*r*u^3*c+6*phi^8*u^2*c^2*r+2*phi^14*r*u*c-2*phi^8*r*u*c+2*phi^21*r*u*c+18*phi^14*r*u^2*c-6*phi^14*u*r*c^2+33*phi^12*r*u^2*c-9*phi^12*u*r*c^2+33*phi^7*r*u^2*c-9*phi^7*u*r*c^2-2*phi^3*r*u*c+phi^21*r+phi^18*u^4*r+5*phi^13*u^4*r+15*phi^8*u^4*r+6*phi^7*r^2*u^2-phi^5*u^4*r+phi^5*u^5*r-22*phi^14*r^2*u+17*phi^14*r^2*c-28*phi^7*r^2*u-5*phi^23*u^4*c+4*phi^23*u^3*c^2-6*phi^18*u^4*c+4*phi^18*u^3*c^2-5*phi^13*u^4*c+4*phi^13*u^3*c^2-4*phi^12*u^3*c^2-5*phi^11*u^4*c+4*phi^11*u^3*c^2+5*phi^7*u^4*c-4*phi^7*u^3*c^2-5*phi^6*u^4*c+4*phi^6*u^3*c^2+5*phi^5*u^4*c-4*phi^5*u^3*c^2-6*phi^18*u*c+7*phi^17*u*c+phi^13*u*c+7*phi^12*u*c+6*phi^8*u*c-phi^14*r*u^2-phi^14*r*c^2+phi^13*r*u^2+phi^8*r*u^2+phi^8*r*c^2-2*phi^7*r*u^2-phi^13*u^5*c+2*phi^13*c+2*phi^8*c+6*phi^18*c^2-6*phi^17*c^2-6*phi^12*c^2-3*phi^8*c^2-phi^3*c-phi^21*r*c^2+phi^3*r*u^2+phi^3*r*c^2+12*phi^6*u^2*c+4*phi^4*u^3*c-6*r^3*u^2*phi^19+u^5*r*phi^20+u^5*r*phi^12+5*r^2*u^4*phi^3+5*u^4*c*phi^17-r*c^3*phi^15-5*u^4*r*c*phi^8+2*phi^8*r^2-22*r^2*u*phi^19+12*phi^22*r^2*u^2)",\
"phi^13*(-6*r+4*r*u*c-3*c-8*phi^23*r*c+14*phi^23*u*r^2*c-24*r^2*u^2*c-3*r*c^2-2*u^4*r*c+6*u*r^2*c^2+4*u^3*c^2*r*phi^8+3*u*r^3*c*phi^19-4*r^2*u^3*c*phi^3+4*r*c^3*phi^12-2*phi^5*c+3*u^2*c^3*phi^17-22*phi^9*r*u^2*c+10*phi^9*u^3*r-38*phi^15*r*u^2*c+13*phi^15*u^3*r+u^4*c^2*phi^13-28*r^2*u+11*phi^9*u*r*c^2+6*r^2*u^2-4*r*phi^14-6*phi^23*r^3-8*phi^16*r*c-8*phi^23*r*u*c-phi^2*r-phi^21*r*u^2+2*phi^2*c+29*phi^15*u*r*c^2-3*phi^6*u*r^3+6*r*phi^16-3*phi^11*u*c-58*phi^18*r*u^2*c-26*phi*r*c^2+5*phi^23*r*u+14*phi^18*u*r^2*c+phi^19*c-7*phi^5*r-7*r*u+5*r*phi^16*u-7*phi^10*r+6*r*phi^18+5*u*phi^2*r-8*phi^17*r-8*r*phi^6*u-4*r^2-phi^3*c^2+7*u*c+7*u^2*c+phi^14*u^2*c+6*r^3-7*c^2+3*c^3+52*r*u^2*c-14*u*r^2*c-33*u*r*c^2+5*u^4*c-r*u^2+10*r*c+27*r^2*c-23*u^3*r-11*u*c^2-8*u^3*c^2-4*phi^16*c^3*r-22*phi*r*u^2+phi^7*u^5*r+5*phi^12*u^4*c-10*phi^17*r*u^3-2*u*phi^21*r-r^3*c+4*r^2*c^2+4*r*c^3-6*phi^17*r^2*u-20*phi^12*r^2*u+28*phi^6*r^2*u-20*phi^11*r^2*u^3-3*phi^18*r^3*u-phi^17*r^3*c+3*phi^17*r^3*u+phi^16*r^3*c-3*phi^16*r^3*u-phi^12*r^3*c+3*phi^12*r^3*u+phi^11*r^3*c-3*phi^11*r^3*u-phi^10*r^3*c+3*phi^10*r^3*u+phi^8*r^3*c-phi^7*r^3*c+3*phi^7*r^3*u-7*phi^5*r^3*c+15*phi^5*r^3*u+phi^23*r^3*c-3*phi^23*r^3*u+phi^18*r^3*c+14*phi^15*u^4*r-phi^20*u^4*r+11*phi^6*r*c+2*phi^15*r^2*c^2+22*phi^22*r*u^2*c-11*phi^22*u*r*c^2-phi^4*r*u^3*c-27*phi^20*r*u*c+24*phi^18*r^2*u^2*c-24*phi^17*r^2*u^2*c-4*phi^23*r^2*c^2-21*phi^6*u*c^2-6*phi^22*r^2*u+phi^11*u^4*r+3*phi^10*u^4*r-phi^23*u^5*r-phi^16*u^5*r-6*phi^4*u^2*c^2+2*phi^4*c^3*u+phi^4*u^4*r-4*phi^18*r^2*c^2-3*phi^13*r^2*u^2-4*phi^13*r^2*c^2+10*phi^10*r^2*c^2+4*phi^5*r^2*c^2+12*phi^20*r*c^2+4*phi^13*r^2+r*u^3*c-u^4*r-41*phi^10*u*r^2*c-14*phi^5*u*r^2*c-phi^16*r*u^3*c-12*phi^15*u*r^2*c+12*phi^4*r*u*c+phi^2*r*u^2*c-phi^23*u^3*c-4*phi^23*u*c-5*phi^16*u*c+phi^14*u*c+4*phi^6*r+4*phi^16*c^2+5*phi^23*r+5*r*phi^11+2*r*phi^9+2*phi^23*c+2*phi^18*c+3*phi^16*c+2*phi^11*c-2*phi^10*c+3*phi^23*c^2-phi^14*c^2+2*phi^11*c^2-6*phi^13*r^3-2*phi^20*c+phi^15*c+2*phi^9*c-2*phi^9*c^3+2*phi^4*c-2*phi^4*r^2+4*phi^9*c^2-4*phi^2*c^2-5*phi^10*r*u+8*phi^10*r*c-5*phi^5*r*u+8*phi^5*r*c-6*phi^23*u^2*c+10*phi^23*u*c^2-6*phi^16*u^2*c+10*phi^16*u*c^2-phi^14*u*c^2+6*phi^10*u^2*c-10*phi^10*u*c^2+phi^7*u^2*c-phi^7*u*c^2+6*phi^5*u^2*c-10*phi^5*u*c^2+4*phi^23*r*c^2+4*phi^23*r*u^2-27*phi^23*r^2*c+30*phi^18*r^2*u-28*phi^18*r^2*c+4*phi^17*r^2*c-27*phi^16*r^2*c+18*phi^12*r^2*c-27*phi^11*r^2*c+4*phi^10*r^2*c-27*phi^13*r^2*c+27*phi^7*r^2*c-27*phi^6*r^2*c+27*phi^5*r^2*c+phi^23*u^2*c^2-6*phi^23*r^2*u^2-6*phi^18*r^2*u^2+30*phi^10*r^2*u^2+6*phi^5*r^2*u^2+phi^16*u^4*r+4*phi^22*r^2*c-5*phi^20*r*u+6*phi^20*u^2*c+8*phi^20*r*c-10*phi^20*u*c^2+phi^21*u^2*c-phi^21*u*c^2-5*phi^15*r*u+8*phi^15*r*c+6*phi^15*u^2*c-10*phi^15*u*c^2-7*phi^15*r^2*c+2*phi^9*r*u-3*phi^9*u^2*c-3*phi^9*r*c-4*phi^9*r^2*c+6*phi^9*u*c^2+12*phi^15*r^2*u^2-4*phi^4*r*c^2-6*phi^4*r*u^2-5*phi^9*u*c-4*phi^4*r^2*c+3*phi^2*u*c-6*phi^2*u^2*c-phi^2*u^3*r+10*phi^2*u*c^2-8*phi^2*r*c+phi^3*c^3-12*phi^22*u*r^2*c+u^5*r+phi^20*c^4-4*phi*r^2-4*phi^14*r^2+3*phi*u^3*c-8*phi*u^2*c^2-13*phi^19*u^3*r+12*phi^3*r*c+5*phi^10*u^4*c+23*phi^6*u^3*r+22*phi^3*r^2*u-6*phi^3*r^2*u^2-23*phi^3*r^2*c+13*phi^3*u^3*r-4*phi^3*r^2*c^2-3*phi^3*r*c^3+3*u^2*c^3+4*phi^3*r^2-6*phi^3*r^3+3*phi^4*r-phi^3*r+20*r^2*u^3-20*phi^6*r^2*u^3-phi^22*u^6*r-phi^18*u^5*r-phi^11*u^5*r-phi^4*u^5*r+20*phi^17*r^2*u^3+24*phi^6*r^2*u^2*c-13*phi^14*u^3*r-23*phi^12*u^3*r-23*phi^7*u^3*r+21*phi^22*u^2*c^2*r-10*phi^22*u^3*r+23*phi^19*r^2*c-22*phi^19*u*r*c^2+phi^17*u^5*r-2*phi^17*u^4*r*c+5*phi^22*u^4*c-8*phi^22*u^3*c^2+14*phi^3*u*r^2*c+22*phi^3*u*r*c^2-6*phi^23*u*r^2*c^2-30*phi^3*r*u^2*c+6*phi^14*u*r^2*c^2+6*phi^5*u*r^2*c^2+6*phi^7*u*r^2*c^2-6*phi^13*u*r^2*c^2-3*phi*c^3*u*r-24*phi^14*r^2*u^2*c+24*phi^13*r^2*u^2*c+3*r^3*u+8*phi^4*c^2-4*phi^19*r+6*phi^19*r^3+6*phi^14*r^3-5*phi^8*r^3+phi*r^3-phi^8*r-6*phi^7*r+3*phi^13*r-7*phi^12*r+4*phi*r+3*phi*c+50*phi*r*u*c-4*phi^23*r*c^3+15*phi^22*u^4*r-3*phi^8*r*c^3+4*phi^7*r*c^3+phi^3*u*c-13*phi^3*r*u-4*phi^21*r^2-4*phi^18*r*c^3-3*phi*r^3*u+24*phi*r^2*u^2*c+4*phi^5*r*c^3+18*r*u^2*phi^17-20*phi*r^2*u^3+6*phi^12*u*r^2*c^2+21*phi^8*r^2*u^2*c+6*phi^19*u*r^2*c^2-14*phi^19*u*r^2*c-14*phi^14*u*r^2*c+2*phi^8*u*r^2*c-12*phi*u*r^2*c+4*phi*c^3*u+5*phi^15*u^4*c-7*phi^15*u^3*c^2-8*phi^10*u^3*c^2+8*phi^9*u^3*c^2-5*phi^4*u^4*c+8*phi^4*u^3*c^2+2*phi^14*r*c-2*phi^14*r*u+phi^12*r*c-phi^12*r*u+3*phi^14*r*c^3+6*phi^19*r^2*u^2+4*phi^19*r^2*c^2+6*phi^14*r^2*u^2+4*phi^14*r^2*c^2+6*phi^12*r^2*u^2+4*phi^12*r^2*c^2-8*phi^4*u*c+6*phi^8*r^2*u^2-2*phi^8*r^2*c^2+4*phi^7*r^2*c^2+12*phi*r^2*u^2+2*phi*r^2*c^2+phi^17*r*c^3-4*phi^13*r*c^3-3*phi*r*c^3+13*u*r*phi^22+15*phi*u^4*r+12*phi^20*r*u^2-3*phi^16*c^3-3*phi^2*c^3+3*phi^15*c^3+3*phi^20*r^2+3*phi^20*c^3+3*phi^10*c^3+8*phi^6*c^3+3*phi^5*c^3-10*phi^10*r*u^3*c+6*phi^10*u^2*c^2*r-34*phi^15*r*u^3*c+21*phi^15*u^2*c^2*r-24*phi^7*r^2*u^2*c-11*phi^17*u*r*c^2+22*phi^17*r*u^2*c+33*phi^13*u*r*c^2-52*phi^13*r*u^2*c+33*phi^6*u*r*c^2-52*phi^6*r*u^2*c+phi^20*r*u^3*c+2*phi^23*u^4*r*c-24*phi^12*r^2*u^2*c+24*phi^11*r^2*u^2*c-6*phi^11*u*r^2*c^2+2*phi^16*u^4*r*c+2*phi^11*u^4*r*c+12*phi^13*u*r^2*c-30*phi^8*r*u^2*c+22*phi^8*u*r*c^2-30*phi*r*u^2*c+22*phi*u*r*c^2-6*phi^8*u*r^2*c^2-23*phi^8*r^2*c+22*phi^8*r^2*u-23*phi*r^2*c+22*phi*r^2*u+23*phi^13*u^3*r+13*phi^8*u^3*r+13*phi*u^3*r-phi^19*r^3*c+3*phi^19*r^3*u-5*phi^9*u^4*c-3*phi^22*r+4*phi^22*c-8*phi^22*c^2-6*phi^22*c^3+6*phi^21*r^3-9*phi^20*c^3*u+3*phi^15*u^2*c^3+3*phi^10*u^2*c^3-3*phi^9*u^2*c^3-3*phi^4*u^2*c^3-35*phi*r*u^3*c+21*phi*u^2*c^2*r-24*phi^19*r^2*u^2*c-35*phi^22*r*u^3*c-phi^19*u^4*r*c+2*phi^18*u^4*r*c-phi^14*u^4*r*c+phi^13*u^4*r*c-2*phi^12*u^4*r*c-2*phi^10*u^4*r*c-2*phi^7*u^4*r*c-14*phi^21*u*r^2*c-phi^22*u^4*r*c-phi^15*u^4*r*c-phi^14*r^3*c+3*phi^14*r^3*u+phi^13*r^3*c-3*phi^13*r^3*u-3*phi^8*r^3*u+2*phi^7*r*c-2*phi^7*r*u-8*phi^17*u^3*c^2+20*phi^19*r^2*u^3-20*phi^18*r^2*u^3+20*phi^14*r^2*u^3-20*phi^13*r^2*u^3+20*phi^12*r^2*u^3-16*phi^8*r^2*u^3+20*phi^7*r^2*u^3+8*phi^22*u*c+phi*u^4*r*c-3*phi^8*c^3*u*r-6*phi^18*u*r^2*c^2-7*phi^22*u^2*c-16*phi^22*r*c+13*phi^22*u*c^2+phi^10*u^5*r+6*phi^8*u^5*r+6*phi^21*r^2*u^2+2*phi^21*r*c+4*phi^21*r^2*c^2+phi^22*u^5*r+phi^21*r^3*c-10*phi^20*u^3*c+19*phi^20*u^2*c^2+phi^15*u^5*r-4*phi^18*r*u*c-32*phi^17*r*u*c-4*phi^13*r*u*c+5*phi^7*r*u*c-52*phi^23*r*u^2*c+33*phi^23*u*r*c^2+35*phi^18*u*r*c^2-52*phi^16*r*u^2*c+33*phi^16*u*r*c^2-52*phi^11*r*u^2*c+33*phi^11*u*r*c^2+22*phi^10*r*u^2*c-11*phi^10*u*r*c^2+52*phi^5*r*u^2*c-33*phi^5*u*r*c^2-14*phi^12*u*r^2*c-14*phi^7*u*r^2*c-phi^23*r*u^3*c-phi^11*r*u^3*c-8*phi^10*c^2-7*phi^7*c^2-8*phi^5*c^2+5*phi^23*r^2+4*phi^18*r^2+6*phi^17*r^2-4*phi^7*r^2-3*phi^23*c^3-6*phi^18*r^3+6*phi^12*r^3+3*phi^10*r^3+6*phi^7*r^3+6*phi^5*r^3+phi^22*r^3+phi^21*c^2-3*phi^20*r-8*phi^20*c^2-3*phi^15*r+phi^15*r^3-8*phi^15*c^2+8*phi^10*u*c+7*phi^7*u*c+8*phi^5*u*c+3*phi^18*r*c^2+phi^18*r*u^2+17*phi^17*r*c^2+3*phi^13*r*c^2-3*phi^7*r*c^2+28*phi^23*r^2*u+28*phi^16*r^2*u+28*phi^13*r^2*u+28*phi^11*r^2*u-6*phi^10*r^2*u-28*phi^5*r^2*u+23*phi^23*u^3*r+27*phi^18*u^3*r+23*phi^16*u^3*r+23*phi^11*u^3*r-10*phi^10*u^3*r-23*phi^5*u^3*r-5*phi^16*u^4*c+8*phi^16*u^3*c^2+phi^23*u^4*r-phi^21*u*c+8*phi^20*u*c+8*phi^15*u*c+10*phi^4*u^3*r-22*phi^4*r*u^2*c+11*phi^4*u*r*c^2+24*phi^23*r^2*u^2*c+24*phi^16*r^2*u^2*c-24*phi^10*r^2*u^2*c-27*phi^5*r^2*u^2*c+phi^9*u^4*r*c-phi^9*r*u^3*c-phi^2*r*u^3*c+phi^6*r^3*c-20*phi^23*r^2*u^3-20*phi^16*r^2*u^3+20*phi^10*r^2*u^3+20*phi^5*r^2*u^3+6*phi^15*r^2*u-phi^9*u^5*r+6*phi^9*r^2*u+6*phi^4*r^2*u+phi^9*u^4*r+phi^2*u^4*r+30*phi^19*r*u^2*c+r^4-phi^18*r*u^3*c-8*phi^13*r*u^3*c+3*phi^13*u^2*c^2*r-35*phi^8*r*u^3*c+21*phi^8*u^2*c^2*r+phi^5*r*u^3*c-2*phi^5*u^4*r*c+4*phi^14*r*u*c-4*phi^8*r*u*c+4*phi^21*r*u*c+30*phi^14*r*u^2*c-22*phi^14*u*r*c^2+50*phi^12*r*u^2*c-31*phi^12*u*r*c^2+52*phi^7*r*u^2*c-33*phi^7*u*r*c^2-4*phi^3*r*u*c+phi^21*r+phi^18*u^4*r+5*phi^13*u^4*r+15*phi^8*u^4*r+6*phi^7*r^2*u^2+phi^19*r*u-2*phi^19*r*c-phi^5*u^4*r+phi^5*u^5*r-22*phi^14*r^2*u+23*phi^14*r^2*c-28*phi^7*r^2*u-5*phi^23*u^4*c+8*phi^23*u^3*c^2-3*phi^23*u^2*c^3-6*phi^18*u^4*c+9*phi^18*u^3*c^2-3*phi^18*u^2*c^3-3*phi^16*u^2*c^3-5*phi^13*u^4*c+8*phi^13*u^3*c^2-3*phi^13*u^2*c^3-8*phi^12*u^3*c^2+3*phi^12*u^2*c^3-5*phi^11*u^4*c+8*phi^11*u^3*c^2-3*phi^11*u^2*c^3+5*phi^7*u^4*c-8*phi^7*u^3*c^2+3*phi^7*u^2*c^3-5*phi^6*u^4*c+8*phi^6*u^3*c^2-3*phi^6*u^2*c^3+5*phi^5*u^4*c-8*phi^5*u^3*c^2+3*phi^5*u^2*c^3-7*phi^18*u*c+8*phi^17*u*c+phi^13*u*c+8*phi^12*u*c+8*phi^8*u*c-phi^14*r*u^2-3*phi^14*r*c^2+phi^13*r*u^2+phi^8*r*u^2+3*phi^8*r*c^2-2*phi^7*r*u^2-phi^13*u^5*c+3*phi^13*c+3*phi^8*c+7*phi^18*c^2-8*phi^17*c^2-phi^13*c^2-8*phi^12*c^2-7*phi^8*c^2-phi^3*c-phi^3*u*c^2-3*phi^21*r*c^2+phi^3*r*u^2+3*phi^3*r*c^2+12*phi^6*u^2*c+4*phi^4*u^3*c-6*r^3*u^2*phi^19+u^5*r*phi^20+u^5*r*phi^12+5*r^2*u^4*phi^3+5*u^4*c*phi^17-5*r*c^3*phi^15-9*u^4*r*c*phi^8+4*phi^8*r^2+phi^22*r*c^3+6*phi^10*u*r^2*c^2-6*phi^16*u*r^2*c^2-3*phi^15*c^3*u*r-phi^4*r*c^3-phi^9*r*c^3-phi^20*u^4*r*c+phi^4*u^4*r*c-6*phi^6*u*r^2*c^2+6*phi^17*u*r^2*c^2+3*phi^22*u^2*c^3-4*phi^6*r*c^3-4*phi^11*r*c^3+phi^10*r*c^3+phi^6*u^4*r*c-3*phi^22*c^3*u*r+phi^22*u^5*r*c+2*phi^22*r^2*c^2-22*r^2*u*phi^19+3*phi^19*r*c^3+12*phi^22*r^2*u^2+phi*r^3*c-6*phi*u*r^2*c^2)",\
"-(phi^2+phi^23+phi^9+phi^16)*(-1+6*phi^23*u*r^2*c+4*r^2*phi^16-phi^5-phi^7-6*phi^9*r*u^2*c+6*phi^9*u^3*r+3*r^2*u-16*phi^9*r*u*c+4*phi^9*r*c^2-phi^21-6*phi^16*r*c-16*phi^23*r*u*c-4*phi^2*r+10*phi^21*u^3*r+4*phi^14*u^4-phi^14-5*r*u+10*r*phi^16*u+12*u^2*c-7*u^3+c^3+u^5-12*r*u^2*c+3*u*r*c^2-u^4*c+4*r*c-3*r^2*c+10*u^3*r-7*u*c^2+3*phi^2*r^2*c+2*phi^16*u^3-7*u^3*phi^14*c-3*phi^18*r^3*u+3*phi^4*r^3+2*phi^23*u-2*phi^23*c+phi^21*u^5-2*phi^2*u^2-2*phi^2*c^2-4*phi^16*u^2*c+2*phi^16*u*c^2+4*phi^23*r*c^2+12*phi^23*r*u^2+3*phi^23*r^2*c+3*phi^16*r^2*c-3*phi^10*r^2*c-3*phi^5*r^2*c-12*phi^23*r^2*u^2-phi^21*u^4*c-3*phi^15*r^2*c-3*phi^9*r^2*c+4*phi^2*u*c+3*phi^14*u^2*c^2+7*u^2*phi^21+12*phi^9*r*u^2+4*phi^2*r^2+10*phi^14*u^3*r+10*phi^7*u^3*r-phi^21*u^5*r+12*phi^16*r*u^2-16*phi^16*r*u*c+4*phi^23*r^2+3*phi^21*c^2+4*phi^9*r^2+4*phi^16*r*c^2-3*phi^23*r^2*u-3*phi^16*r^2*u+3*phi^10*r^2*u+3*phi^5*r^2*u-9*phi^21*u*c+3*phi^20*r^2*u-3*phi^20*r^2*c-16*phi^2*r*u*c+3*phi^15*r^2*u+9*phi^9*r^2*u+4*phi^2*r*c^2+12*phi^2*r*u^2-3*phi^2*r^2*u+4*phi^2*r^2*u^3-4*phi^7*r*u^3*c-12*phi^14*r*u*c-12*phi^21*r*u^2*c+3*phi^21*u*r*c^2-12*phi^14*r*u^2*c+3*phi^14*u*r*c^2-12*phi^7*r*u^2*c+3*phi^7*u*r*c^2+phi^21*r+5*phi^7*u^4*r-phi^14*u^4*c-phi^7*u^4*c+10*phi^14*r*u^2+3*phi^14*r*c^2+3*phi^7*c-4*phi^7*u+phi^14*u^5+phi^7*u^5)",\
"-phi^15*(-1-2*r-4*r*u*c-3*phi^23*r*c+phi-phi^5-phi^7-2*r*phi^14-3*phi^16*r*c+4*phi^23*r*u*c+4*phi^21*r*u^2-phi^14-phi^19+phi^16+3*phi^18*r*u^2*c+4*phi^23*r*u-4*r*u-phi^10+4*r*phi^16*u-u^2+phi^23+2*r*phi^18+phi^17*r+4*r*phi^6*u+phi^18+phi^11+3*r^2+phi^3*c^2-phi^12+2*u*c+5*u^2*c-3*u^3+5*phi^14*u^2*c+r^3-c^2-3*r*u^2*c+4*r*u^2+3*r*c+4*u^3*r-2*u*c^2-4*phi^19*r*c*u-3*phi^5*u^3+3*phi^16*u^3+4*phi^17*r*u^3-3*phi^6*r*c+2*phi^6*u*c^2+3*phi^3*u^3-3*phi^13*r^2-2*phi^23*u*c+2*phi^14*u*c+2*phi^23*r+phi^23*c^2+phi^23*u^2-phi^14*c^2-phi^14*u^2-3*phi^14*u^3-3*phi^7*u^3-4*phi^5*r*u+3*phi^5*r*c-5*phi^23*u^2*c+2*phi^23*u*c^2-5*phi^16*u^2*c+2*phi^16*u*c^2-2*phi^14*u*c^2+5*phi^7*u^2*c-2*phi^7*u*c^2+5*phi^5*u^2*c-2*phi^5*u*c^2-4*phi^23*r*u^2-2*phi^5*r^2*c+phi^13-phi^17+phi^6+3*phi^14*r^2+4*phi^19*u^3*r-3*phi^3*r*c-u^2*phi^21-4*phi^6*u^3*r-3*phi^3*r^2+2*phi^3*r+4*phi^14*u^3*r+4*phi^12*u^3*r+4*phi^7*u^3*r+4*phi^12*r*u^2+2*phi^8*r-2*phi^7*r+2*phi^13*r+3*phi^19*r^2+2*phi^18*u*c^2-5*phi^18*u^2*c+2*phi^13*u*c^2-5*phi^13*u^2*c-2*phi^12*u*c^2+5*phi^12*u^2*c+2*phi^11*u*c^2-5*phi^11*u^2*c+2*phi^8*u*c^2-5*phi^8*u^2*c+2*phi*u*c^2-5*phi*u^2*c-3*phi^18*r*c-2*phi^3*u*c+4*phi^3*r*u+3*phi^18*u^3+3*phi^13*u^3+3*phi^8*u^3+phi^3*u^2+3*phi^21*r^2+4*phi^18*r*u+3*phi^14*r*c-4*phi^14*r*u-3*phi^13*r*c+4*phi^13*r*u-phi^12*r*c-3*phi^11*r*c-3*phi^19*r^2*u^2+4*phi^11*r*u-3*phi^8*r*c+4*phi^8*r*u-3*phi^17*r*u^2*c+3*phi^13*r*u^2*c+3*phi^6*r*u^2*c+3*phi^8*r*u^2*c+3*phi*r*u^2*c+4*phi^19*r*u^2+6*phi^10*r*u^2+4*phi^5*r*u^2-4*phi^13*u^3*r-4*phi^8*u^3*r-4*phi*u^3*r-phi^10*u^3*c-3*phi*r*c+4*phi*r*u+3*phi^7*r*c-4*phi^7*r*u+4*phi^18*r*u*c+4*phi^13*r*u*c-4*phi^12*r*u*c-6*phi^10*r*u*c-4*phi^7*r*u*c-4*phi^5*r*u*c+3*phi^23*r*u^2*c+3*phi^16*r*u^2*c+3*phi^11*r*u^2*c-3*phi^10*r*u^2*c-3*phi^5*r*u^2*c+3*phi^12*r^2-phi^7*c^2-phi^7*u^2-3*phi^23*r^2-3*phi^18*r^2+3*phi^7*r^2+3*phi^5*r^2+3*phi^23*u^3-phi^21*c^2+2*phi^7*u*c-4*phi^18*r*u^2+phi^10*r*c^2+6*phi^5*r^2*u-4*phi^23*u^3*r-4*phi^18*u^3*r-4*phi^16*u^3*r-4*phi^11*u^3*r+4*phi^10*u^3*r+4*phi^5*u^3*r+2*phi^21*u*c-3*phi^19*r*u^2*c-4*phi^14*r*u*c+4*phi^8*r*u*c-4*phi^21*r*u*c-3*phi^14*r*u^2*c-3*phi^12*r*u^2*c-3*phi^7*r*u^2*c+4*phi^3*r*u*c+phi^8-2*phi^21*r-4*phi^19*r*u+3*phi^19*r*c-2*phi^18*u*c-5*phi^17*u*c-2*phi^13*u*c-2*phi^8*u*c-2*phi^19*u*c^2+5*phi^19*u^2*c+4*phi^14*r*u^2-4*phi^13*r*u^2-4*phi^8*r*u^2+4*phi^7*r*u^2+phi^18*c^2+phi^18*u^2+2*phi^17*c^2+4*phi^17*u^2+phi^13*c^2+phi^13*u^2+phi^8*c^2+phi^8*u^2-3*phi^19*u^3+2*phi^3*c-3*phi^3*u-5*phi^3*u^2*c+2*phi^3*u*c^2+phi^3*u^4*r-4*phi^3*r*u^2-5*phi^6*u^2*c+phi^10*u^4-3*phi^8*r^2-3*phi^12*u^3+3*phi^11*u^3+3*phi^6*u^3+3*phi*u^3)",\
"-(phi+phi^22+phi^8+phi^15)*(1-6*r+6*r*u*c+9*phi^23*u*r^2*c-12*r^2*u^2*c-phi-3*r*c^2+phi^5+phi^7-30*phi^15*r*u^2*c+20*phi^15*u^3*r-20*r^2*u+9*r^2*u^2-6*r*phi^14-6*phi^23*r^3-6*phi^23*r*u*c-3*phi^21*r*u^2+phi^14+12*phi^15*u*r*c^2+phi^19+6*r*phi^16-phi^16-10*phi^11*u*c-36*phi^18*r*u^2*c-6*phi*r*c^2+9*phi^18*u*r^2*c-6*phi^5*r-7*u^2-phi^15-phi^23-6*phi^10*r+6*r*phi^18-6*phi^17*r-phi^18-phi^11-3*r^2+phi^12+10*u*c+6*r^3-3*c^2+36*r*u^2*c-9*u*r^2*c-12*u*r*c^2-3*r*u^2+12*r^2*c-24*u^3*r-15*phi*r*u^2-5*phi^22*u-11*phi^12*r^2*u+20*phi^6*r^2*u-20*phi^11*r^2*u^3-3*phi^5*r^3*c+12*phi^5*r^3*u+15*phi^15*u^4*r+12*phi^18*r^2*u^2*c-12*phi^17*r^2*u^2*c+8*phi^10*u^4*r-9*phi^13*r^2*u^2+3*phi^10*r^2*c^2-6*phi^3*u^3+3*phi^13*r^2-24*phi^10*u*r^2*c-9*phi^5*u*r^2*c-10*phi^23*u*c-10*phi^16*u*c+10*phi^14*u*c+6*phi^6*r+3*phi^16*c^2+7*phi^16*u^2+6*phi^23*r+6*r*phi^11-4*u*phi^10+7*phi^11*u^2+4*phi^10*c+3*phi^23*c^2+7*phi^23*u^2-3*phi^14*c^2-7*phi^14*u^2+3*phi^11*c^2-6*phi^13*r^3+4*phi^15*c-5*phi^15*u+3*phi^23*r*c^2+3*phi^23*r*u^2-12*phi^23*r^2*c+20*phi^18*r^2*u-12*phi^18*r^2*c-12*phi^16*r^2*c+3*phi^12*r^2*c-12*phi^11*r^2*c-12*phi^13*r^2*c+12*phi^7*r^2*c-12*phi^6*r^2*c+12*phi^5*r^2*c-9*phi^23*r^2*u^2-9*phi^18*r^2*u^2+30*phi^10*r^2*u^2+9*phi^5*r^2*u^2-phi^13-phi^6+2*phi^3*c^3+3*phi^17*u^4-3*phi^14*r^2-11*phi*u^4+22*phi*u^3*c-15*phi*u^2*c^2-24*phi^19*u^3*r+12*phi^3*r*c-6*phi^17*u^3*c+3*phi^17*u^2*c^2+24*phi^6*u^3*r+20*phi^3*r^2*u-9*phi^3*r^2*u^2-12*phi^3*r^2*c+24*phi^3*u^3*r+3*phi^3*r^2-6*phi^3*r^3+20*r^2*u^3-20*phi^6*r^2*u^3+u^6*phi^22+u^6*phi^15-phi^22*u^6*r+20*phi^17*r^2*u^3+12*phi^6*r^2*u^2*c-24*phi^14*u^3*r-24*phi^12*u^3*r-24*phi^7*u^3*r+6*phi^22*u^2*c^2*r+12*phi^19*r^2*c-12*phi^19*u*r*c^2-phi^22*u^5*c+9*phi^3*u*r^2*c+12*phi^3*u*r*c^2-36*phi^3*r*u^2*c-12*phi^14*r^2*u^2*c+12*phi^13*r^2*u^2*c-6*phi^19*r+6*phi^19*r^3+6*phi^14*r^3-6*phi^8*r^3+5*phi^8*r-6*phi^7*r+6*phi^13*r-6*phi^12*r+6*phi*r+4*phi*c+20*phi*r*u*c+15*phi^22*u^4*r-20*phi^3*r*u-5*phi*u+phi^8*u^6+phi*u^6-3*phi^21*r^2+12*phi*r^2*u^2*c+30*r*u^2*phi^17-20*phi*r^2*u^3-phi*u^5*c+12*phi^8*r^2*u^2*c-9*phi^19*u*r^2*c-9*phi^14*u*r^2*c+9*phi^8*u*r^2*c+3*phi*c^3*u-9*phi^15*u^4*c+4*phi^15*u^3*c^2+9*phi^19*r^2*u^2+9*phi^14*r^2*u^2+9*phi^12*r^2*u^2-9*phi^8*r^2*u^2+6*u*r*phi^22+15*phi*u^4*r-8*phi^10*r*u^3*c-20*phi^15*r*u^3*c+6*phi^15*u^2*c^2*r-12*phi^7*r^2*u^2*c+12*phi^13*u*r*c^2-36*phi^13*r*u^2*c+12*phi^6*u*r*c^2-36*phi^6*r*u^2*c-12*phi^12*r^2*u^2*c+12*phi^11*r^2*u^2*c+9*phi^13*u*r^2*c-36*phi^8*r*u^2*c+12*phi^8*u*r*c^2-36*phi*r*u^2*c+12*phi*u*r*c^2-12*phi^8*r^2*c+20*phi^8*r^2*u-12*phi*r^2*c+20*phi*r^2*u+24*phi^13*u^3*r+24*phi^8*u^3*r+24*phi*u^3*r+4*phi^22*c-3*phi^22*c^3+6*phi^21*r^3-20*phi*r*u^3*c+6*phi*u^2*c^2*r-12*phi^19*r^2*u^2*c-20*phi^22*r*u^3*c-9*phi^21*u*r^2*c+20*phi^19*r^2*u^3-20*phi^18*r^2*u^3+20*phi^14*r^2*u^3-20*phi^13*r^2*u^3+20*phi^12*r^2*u^3-20*phi^8*r^2*u^3+20*phi^7*r^2*u^3-25*phi^22*u^2*c-5*phi^22*r*c+15*phi^22*u*c^2+6*phi^8*u^5*r+9*phi^21*r^2*u^2-phi^15*u^5*c-6*phi^18*r*u*c-36*phi^17*r*u*c-6*phi^13*r*u*c+6*phi^7*r*u*c-36*phi^23*r*u^2*c+12*phi^23*u*r*c^2+12*phi^18*u*r*c^2-36*phi^16*r*u^2*c+12*phi^16*u*r*c^2-36*phi^11*r*u^2*c+12*phi^11*u*r*c^2+36*phi^5*r*u^2*c-12*phi^5*u*r*c^2-9*phi^12*u*r^2*c-9*phi^7*u*r^2*c-3*phi^10*c^2-7*phi^10*u^2-3*phi^7*c^2-7*phi^7*u^2-3*phi^5*c^2-7*phi^5*u^2+3*phi^23*r^2+3*phi^18*r^2+5*phi^17*r^2-3*phi^7*r^2-6*phi^18*r^3+6*phi^12*r^3+6*phi^7*r^3+6*phi^5*r^3+10*phi^10*u*c+10*phi^7*u*c+10*phi^5*u*c+3*phi^18*r*c^2+3*phi^18*r*u^2+12*phi^17*r*c^2+3*phi^13*r*c^2-3*phi^7*r*c^2+20*phi^23*r^2*u+20*phi^16*r^2*u+20*phi^13*r^2*u+20*phi^11*r^2*u-20*phi^5*r^2*u+24*phi^23*u^3*r+24*phi^18*u^3*r+24*phi^16*u^3*r+24*phi^11*u^3*r-24*phi^5*u^3*r+12*phi^23*r^2*u^2*c+12*phi^16*r^2*u^2*c-12*phi^10*r^2*u^2*c-12*phi^5*r^2*u^2*c-20*phi^23*r^2*u^3-20*phi^16*r^2*u^3+20*phi^10*r^2*u^3+20*phi^5*r^2*u^3+36*phi^19*r*u^2*c+r^4-20*phi^8*r*u^3*c+6*phi^8*u^2*c^2*r+6*phi^14*r*u*c-6*phi^8*r*u*c+6*phi^21*r*u*c+36*phi^14*r*u^2*c-12*phi^14*u*r*c^2+36*phi^12*r*u^2*c-12*phi^12*u*r*c^2+36*phi^7*r*u^2*c-12*phi^7*u*r*c^2-6*phi^3*r*u*c-phi^3-phi^8+15*phi^8*u^4*r+9*phi^7*r^2*u^2-20*phi^14*r^2*u+12*phi^14*r^2*c-20*phi^7*r^2*u+10*phi^19*u*c-10*phi^18*u*c+10*phi^17*u*c-10*phi^13*u*c+10*phi^12*u*c+5*phi^8*u*c-10*phi^6*u*c-10*phi*u*c-3*phi^14*r*u^2-3*phi^14*r*c^2+3*phi^13*r*u^2+3*phi^8*r*u^2+3*phi^8*r*c^2-3*phi^7*r*u^2-phi^8*u^5*c+4*phi^8*c-5*phi^8*u-7*phi^19*u^2+3*phi^18*c^2-3*phi^19*c^2+7*phi^18*u^2-3*phi^17*c^2-7*phi^17*u^2+3*phi^13*c^2+7*phi^13*u^2-3*phi^12*c^2-7*phi^12*u^2-2*phi^8*c^2-4*phi^8*u^2+3*phi^6*c^2+7*phi^6*u^2+3*phi*c^2+7*phi*u^2+14*phi^3*u^2*c-10*phi^3*u*c^2-3*phi^21*r*c^2+3*phi^3*r*u^2+3*phi^3*r*c^2-6*r^3*u^2*phi^19+5*r^2*u^4*phi^3-r*c^3*phi^15-5*u^4*r*c*phi^8+5*phi^15*u^5+3*phi^8*r^2-20*r^2*u*phi^19+14*phi^22*u^3)",\
"(phi+phi^22+phi^8+phi^15)*(2-7*r+10*r*u*c+18*phi^23*u*r^2*c-24*r^2*u^2*c-2*phi-7*r*c^2-u^4*r*c+6*u*r^2*c^2+4*u^3*c^2*r*phi^8+3*u*r^3*c*phi^19-4*r^2*u^3*c*phi^3+5*r*c^3*phi^12+2*phi^5+2*phi^7-40*phi^15*r*u^2*c+20*phi^15*u^3*r-20*r^2*u+9*r^2*u^2-7*r*phi^14-6*phi^23*r^3-10*phi^23*r*u*c-3*phi^21*r*u^2+2*phi^14+24*phi^15*u*r*c^2+2*phi^19+7*r*phi^16-2*phi^16-18*phi^11*u*c-54*phi^18*r*u^2*c-10*phi*r*c^2+18*phi^18*u*r^2*c-7*phi^5*r-9*u^2-phi^15-2*phi^23-7*phi^10*r+7*r*phi^18-7*phi^17*r-2*phi^18-2*phi^11-5*r^2+2*phi^12+18*u*c+6*r^3-8*c^2+54*r*u^2*c-18*u*r^2*c-34*u*r*c^2+u^4*c-3*r*u^2+16*r^2*c-25*u^3*r-u^3*c^2-5*phi^16*c^3*r-15*phi*r*u^2+phi^12*u^4*c+5*r^2*c^2+5*r*c^3-5*phi^22*u-9*phi^12*r^2*u+20*phi^6*r^2*u-20*phi^11*r^2*u^3-6*phi^5*r^3*c+12*phi^5*r^3*u+15*phi^15*u^4*r+24*phi^18*r^2*u^2*c-24*phi^17*r^2*u^2*c-5*phi^23*r^2*c^2+8*phi^10*u^4*r-5*phi^18*r^2*c^2-9*phi^13*r^2*u^2-5*phi^13*r^2*c^2+9*phi^10*r^2*c^2+5*phi^5*r^2*c^2-7*phi^3*u^3+5*phi^13*r^2-36*phi^10*u*r^2*c-18*phi^5*u*r^2*c-18*phi^23*u*c-18*phi^16*u*c+18*phi^14*u*c+7*phi^6*r+8*phi^16*c^2+9*phi^16*u^2+7*phi^23*r+7*r*phi^11-6*u*phi^10+9*phi^11*u^2+6*phi^10*c+8*phi^23*c^2+9*phi^23*u^2-8*phi^14*c^2-9*phi^14*u^2+8*phi^11*c^2-6*phi^13*r^3+5*phi^15*c-5*phi^15*u+7*phi^23*r*c^2+3*phi^23*r*u^2-16*phi^23*r^2*c+20*phi^18*r^2*u-16*phi^18*r^2*c-16*phi^16*r^2*c+4*phi^12*r^2*c-16*phi^11*r^2*c-16*phi^13*r^2*c+16*phi^7*r^2*c-16*phi^6*r^2*c+16*phi^5*r^2*c-9*phi^23*r^2*u^2-9*phi^18*r^2*u^2+30*phi^10*r^2*u^2+9*phi^5*r^2*u^2-2*phi^13-2*phi^6+6*phi^3*c^3+3*phi^17*u^4-5*phi^14*r^2-11*phi*u^4+29*phi*u^3*c-27*phi*u^2*c^2-25*phi^19*u^3*r+19*phi^3*r*c-11*phi^17*u^3*c+12*phi^17*u^2*c^2-4*phi^17*c^3*u+25*phi^6*u^3*r+20*phi^3*r^2*u-9*phi^3*r^2*u^2-16*phi^3*r^2*c+25*phi^3*u^3*r-5*phi^3*r^2*c^2-5*phi^3*r*c^3+5*phi^3*r^2-6*phi^3*r^3+20*r^2*u^3-20*phi^6*r^2*u^3+u^6*phi^22+u^6*phi^15-phi^22*u^6*r+20*phi^17*r^2*u^3+24*phi^6*r^2*u^2*c-25*phi^14*u^3*r-25*phi^12*u^3*r-25*phi^7*u^3*r+18*phi^22*u^2*c^2*r+u^4*c^2*phi^8+16*phi^19*r^2*c-34*phi^19*u*r*c^2-phi^17*u^4*r*c-2*phi^22*u^5*c+18*phi^3*u*r^2*c+34*phi^3*u*r*c^2-6*phi^23*u*r^2*c^2-54*phi^3*r*u^2*c+6*phi^14*u*r^2*c^2+6*phi^5*u*r^2*c^2+6*phi^7*u*r^2*c^2-6*phi^13*u*r^2*c^2-3*phi*c^3*u*r-24*phi^14*r^2*u^2*c+24*phi^13*r^2*u^2*c-7*phi^19*r+6*phi^19*r^3+6*phi^14*r^3-6*phi^8*r^3+6*phi^8*r-7*phi^7*r+7*phi^13*r-7*phi^12*r+7*phi*r+5*phi*c+25*phi*r*u*c-5*phi^23*r*c^3+15*phi^22*u^4*r-5*phi^8*r*c^3+5*phi^7*r*c^3-23*phi^3*r*u-5*phi*u+phi^8*u^6+phi*u^6-5*phi^21*r^2-5*phi^18*r*c^3+24*phi*r^2*u^2*c+5*phi^5*r*c^3+33*r*u^2*phi^17-20*phi*r^2*u^3-2*phi*u^5*c+6*phi^12*u*r^2*c^2+24*phi^8*r^2*u^2*c+6*phi^19*u*r^2*c^2-18*phi^19*u*r^2*c-18*phi^14*u*r^2*c+18*phi^8*u*r^2*c+10*phi*c^3*u-13*phi^15*u^4*c+11*phi^15*u^3*c^2+5*phi^14*r*c^3+9*phi^19*r^2*u^2+5*phi^19*r^2*c^2+9*phi^14*r^2*u^2+5*phi^14*r^2*c^2+9*phi^12*r^2*u^2+5*phi^12*r^2*c^2-9*phi^8*r^2*u^2-5*phi^8*r^2*c^2+5*phi^7*r^2*c^2-5*phi^13*r*c^3-5*phi*r*c^3+6*u*r*phi^22+15*phi*u^4*r-18*phi^10*r*u^3*c+9*phi^10*u^2*c^2*r-30*phi^15*r*u^3*c+18*phi^15*u^2*c^2*r-24*phi^7*r^2*u^2*c+34*phi^13*u*r*c^2-54*phi^13*r*u^2*c+34*phi^6*u*r*c^2-54*phi^6*r*u^2*c+phi^23*u^4*r*c-24*phi^12*r^2*u^2*c+24*phi^11*r^2*u^2*c-6*phi^11*u*r^2*c^2+phi^16*u^4*r*c+phi^11*u^4*r*c+18*phi^13*u*r^2*c-54*phi^8*r*u^2*c+34*phi^8*u*r*c^2-54*phi*r*u^2*c+34*phi*u*r*c^2-6*phi^8*u*r^2*c^2-16*phi^8*r^2*c+20*phi^8*r^2*u-16*phi*r^2*c+20*phi*r^2*u+25*phi^13*u^3*r+25*phi^8*u^3*r+25*phi*u^3*r+5*phi^22*c-6*phi^22*c^3+6*phi^21*r^3-3*phi^15*u^2*c^3-30*phi*r*u^3*c+18*phi*u^2*c^2*r-24*phi^19*r^2*u^2*c-30*phi^22*r*u^3*c-phi^19*u^4*r*c+phi^18*u^4*r*c-phi^14*u^4*r*c+phi^13*u^4*r*c-phi^12*u^4*r*c-phi^10*u^4*r*c-phi^7*u^4*r*c-18*phi^21*u*r^2*c+20*phi^19*r^2*u^3-20*phi^18*r^2*u^3+20*phi^14*r^2*u^3-20*phi^13*r^2*u^3+20*phi^12*r^2*u^3-20*phi^8*r^2*u^3+20*phi^7*r^2*u^3+phi*u^4*r*c-3*phi^8*c^3*u*r-6*phi^18*u*r^2*c^2-32*phi^22*u^2*c-6*phi^22*r*c+24*phi^22*u*c^2+6*phi^8*u^5*r+9*phi^21*r^2*u^2+5*phi^21*r^2*c^2+phi^21*r^3*c-2*phi^15*u^5*c+phi^15*u^4*c^2-10*phi^18*r*u*c-52*phi^17*r*u*c-10*phi^13*r*u*c+10*phi^7*r*u*c-54*phi^23*r*u^2*c+34*phi^23*u*r*c^2+34*phi^18*u*r*c^2-54*phi^16*r*u^2*c+34*phi^16*u*r*c^2-54*phi^11*r*u^2*c+34*phi^11*u*r*c^2+54*phi^5*r*u^2*c-34*phi^5*u*r*c^2-18*phi^12*u*r^2*c-18*phi^7*u*r^2*c-8*phi^10*c^2-9*phi^10*u^2-8*phi^7*c^2-9*phi^7*u^2-8*phi^5*c^2-9*phi^5*u^2+5*phi^23*r^2+5*phi^18*r^2+5*phi^17*r^2-5*phi^7*r^2-6*phi^18*r^3+6*phi^12*r^3+6*phi^7*r^3+6*phi^5*r^3+18*phi^10*u*c+18*phi^7*u*c+18*phi^5*u*c+7*phi^18*r*c^2+3*phi^18*r*u^2+21*phi^17*r*c^2+7*phi^13*r*c^2-7*phi^7*r*c^2+20*phi^23*r^2*u+20*phi^16*r^2*u+20*phi^13*r^2*u+20*phi^11*r^2*u-20*phi^5*r^2*u+25*phi^23*u^3*r+25*phi^18*u^3*r+25*phi^16*u^3*r+25*phi^11*u^3*r-25*phi^5*u^3*r-phi^16*u^4*c+phi^16*u^3*c^2+24*phi^23*r^2*u^2*c+24*phi^16*r^2*u^2*c-24*phi^10*r^2*u^2*c-27*phi^5*r^2*u^2*c-20*phi^23*r^2*u^3-20*phi^16*r^2*u^3+20*phi^10*r^2*u^3+20*phi^5*r^2*u^3+54*phi^19*r*u^2*c-c^4*phi-phi^19*c^3+r^4-30*phi^8*r*u^3*c+18*phi^8*u^2*c^2*r-phi^5*u^4*r*c+10*phi^14*r*u*c-10*phi^8*r*u*c+10*phi^21*r*u*c+54*phi^14*r*u^2*c-34*phi^14*u*r*c^2+50*phi^12*r*u^2*c-30*phi^12*u*r*c^2+54*phi^7*r*u^2*c-34*phi^7*u*r*c^2-10*phi^3*r*u*c-2*phi^3-2*phi^8+15*phi^8*u^4*r+9*phi^7*r^2*u^2+2*phi^19*r*u-4*phi^19*r*c-20*phi^14*r^2*u+16*phi^14*r^2*c-20*phi^7*r^2*u-phi^23*u^4*c+phi^23*u^3*c^2+phi^19*u^4*c-phi^19*u^3*c^2-phi^18*u^4*c+phi^18*u^3*c^2+phi^14*u^4*c-phi^14*u^3*c^2-phi^13*u^4*c+phi^13*u^3*c^2-phi^12*u^3*c^2-phi^11*u^4*c+phi^11*u^3*c^2-phi^8*u^4*c+phi^8*u^3*c^2+phi^7*u^4*c-phi^7*u^3*c^2-phi^6*u^4*c+phi^6*u^3*c^2+phi^5*u^4*c-phi^5*u^3*c^2-phi*u^4*c+phi*u^3*c^2+18*phi^19*u*c-18*phi^18*u*c+18*phi^17*u*c-18*phi^13*u*c+18*phi^12*u*c+phi^8*u*c-18*phi^6*u*c-18*phi*u*c+2*phi^19*u*c^2-phi^19*u^2*c-3*phi^14*r*u^2-7*phi^14*r*c^2+3*phi^13*r*u^2+3*phi^8*r*u^2+7*phi^8*r*c^2-3*phi^7*r*u^2-2*phi^8*u^5*c+5*phi^8*c-5*phi^8*u-9*phi^19*u^2+8*phi^18*c^2-8*phi^19*c^2+9*phi^18*u^2-8*phi^17*c^2-9*phi^17*u^2+8*phi^13*c^2+9*phi^13*u^2-8*phi^12*c^2-9*phi^12*u^2-2*phi^8*u^2+8*phi^6*c^2+9*phi^6*u^2+8*phi*c^2+9*phi*u^2+21*phi^3*u^2*c-phi^3*u^4*c-19*phi^3*u*c^2+phi^3*u^3*c^2-7*phi^21*r*c^2+3*phi^3*r*u^2+7*phi^3*r*c^2-6*r^3*u^2*phi^19+5*r^2*u^4*phi^3-4*r*c^3*phi^15-9*u^4*r*c*phi^8+5*phi^15*u^5+5*phi^8*r^2+6*phi^10*u*r^2*c^2-6*phi^16*u*r^2*c^2-3*phi^15*c^3*u*r-6*phi^6*u*r^2*c^2+6*phi^17*u*r^2*c^2-5*phi^6*r*c^3-5*phi^11*r*c^3+phi^6*u^4*r*c-3*phi^22*c^3*u*r+phi^22*u^5*r*c+phi^22*u^4*c^2-20*r^2*u*phi^19+5*phi^19*r*c^3+14*phi^22*u^3+phi*u^4*c^2-6*phi*u*r^2*c^2)",\
"-phi^21*(-5*u+3*c-phi^2+3*r^2*u^2+phi^21+6*phi^23*r*u*c+3*phi^2*r+3*r*phi^16-15*u^2*c+14*u^3-15*phi^14*u^2*c+u^6+3*u*c^2-2*phi^4*r*u*c-6*phi^2*r*u^2*c+3*phi^23*u^3*c-5*phi^23*u*c-5*phi^16*u*c-10*phi^14*u*c+7*phi^16*u^2+3*phi^23*r+3*r*phi^9-3*phi^23*u^4+4*phi^16*u-2*phi^16*c+7*phi^23*u^2+phi^14*c^2+11*phi^14*u^2+14*phi^14*u^3+14*phi^7*u^3+11*phi^7*u^4-5*phi^21*u^5+14*phi^21*u^3+6*phi^9*u^3+phi^4*r^2+7*phi^9*u^2+7*phi^2*u^2+3*phi^14*u*c^2-15*phi^7*u^2*c+3*phi^7*u*c^2-15*phi^23*r*u^2-3*phi^18*r^2*u-12*phi^7*u^3*c+3*phi^7*u^2*c^2-3*phi^23*r^2*u^2-3*phi^18*r^2*u^2-3*phi^16*r^2*u^2-3*phi^11*r^2*u^2+3*phi^10*r^2*u^2+3*phi^5*r^2*u^2-4*phi^16*u^4*r+4*phi^21*u^4*c-15*phi^21*u^2*c+3*phi^21*u*c^2+10*phi^9*r*u-8*phi^9*u^2*c-2*phi^9*r*c+2*phi^9*u*c^2+3*phi^20*r^2*u^2+3*phi^15*r^2*u^2-3*phi^9*r^2*u^2-3*phi^4*r^2*u^2+2*phi^4*r*u^2-5*phi^9*u*c-5*phi^2*u*c+12*phi^2*u^3*r-3*phi^2*r^2*u^2)",\
"-phi^23*(-1+r^2*u-phi^2*c-5*phi^23*r*u+7*u^2+2*u*phi^2+phi^12-5*u*c+u^5-5*phi^14*u*c+2*r*phi^9+2*u*phi^9+2*phi^23*u-phi^23*c+2*phi^16*u-phi^16*c+7*phi^14*u^2+7*phi^7*u^3-phi^9*c+2*phi^9*u^2+2*phi^23*u^2*c-6*phi^7*u^2*c+phi^7*u*c^2-phi^18*r^2*u-2*phi^9*u*c+7*u^2*phi^21+4*phi^14*u-2*phi^14*c+7*phi^7*u^2-2*phi^23*u^3-4*phi^21*u^4-5*phi^7*u*c-phi^23*r^2*u-phi^16*r^2*u-phi^11*r^2*u+phi^10*r^2*u+phi^5*r^2*u-3*phi^16*u^3*r-5*phi^21*u*c+phi^20*r^2*u+3*phi^21*u^3*c-2*phi^2*r*u*c+phi^15*r^2*u-phi^9*r^2*u-phi^4*r^2*u+6*phi^2*r*u^2-phi^2*r^2*u)",\
"-(-1+phi^4-phi^5+phi^6-phi^7+phi^9-phi^10+phi^11-phi^12+phi^13-phi^15+phi^16-phi^17+phi^18-phi^22+phi^23)*(18*r*u*c-8*u+3*c-2*phi^23*r*c-phi-12*u^4+3*phi^5*c+9*r^2*u-12*phi^12*u^4-18*phi^23*r*u*c+6*phi^21*u^3*r-12*phi^14*u^4+6*phi^18*r*u^2*c+4*phi^23*r*u+3*phi^19*c-4*r*u-2*phi^10+16*phi^22*u^5-phi^15+8*phi^11*u-2*phi^3*c^2+2*u^2*c-u^3+18*u^3*c+2*phi^14*u^2*c-6*r*u^2*c-32*r*u^2+2*r*c+6*u^3*r-u*c^2+18*phi^19*r*c*u+32*phi*r*u^2+18*u^3*phi^14*c-4*u*phi^21*r+9*phi^12*r^2*u-20*phi^11*u^4*r+20*phi^10*u^4*r+6*phi^13*u^2*c^2-18*phi^8*u^3*c+phi^3*u^3-12*r*u^3*c-6*u^2*c^2+20*u^4*r-3*phi^5*u*r^2*c+12*phi^16*r*u^3*c-18*phi^23*u^3*c-8*u*phi^10+12*phi^23*u^4+8*phi^23*u-3*phi^23*c+8*phi^18*u-3*phi^18*c+8*phi^16*u-3*phi^16*c-3*phi^11*c+3*phi^10*c-8*phi^5*u-phi^14*u^3-phi^7*u^3-12*phi^7*u^4-phi^21*u^3-2*phi^23*u^2*c+phi^23*u*c^2-phi^14*u*c^2+2*phi^7*u^2*c-phi^7*u*c^2+32*phi^23*r*u^2-9*phi^18*r^2*u+6*phi^23*u^2*c^2+18*phi^7*u^3*c-6*phi^7*u^2*c^2+12*phi^5*r^2*u^2-20*phi^16*u^4*r+2*phi^21*u^2*c-phi^21*u*c^2-phi^22-phi^22*u^7-6*phi^14*u^2*c^2-18*phi^13*u^3*c+6*phi^8*u^2*c^2+12*phi^6*u^4-12*phi^5*u^4+12*phi*u^4-8*phi^17*u-18*phi^11*u^3*c-18*phi*u^3*c+6*phi*u^2*c^2+6*phi^19*u^3*r-2*phi^3*r*c+18*phi^19*u^3*c-4*phi^10*u^4*c-6*phi^19*u^2*c^2-9*phi^3*r^2*u-6*phi^3*u^3*r+20*phi^17*u^4*r-4*phi^3*r+6*phi^14*u^3*r+6*phi^12*u^3*r+6*phi^7*u^3*r-20*phi^22*u^4*c+6*phi^22*u^3*c^2+6*phi^3*r*u^2*c-26*phi^12*r*u^2+r^3*u+3*phi^17*c-3*phi^6*c-3*phi*c-18*phi*r*u*c+phi^18*u*c^2-2*phi^18*u^2*c+6*phi^17*u*c^2-21*phi^17*u^2*c+phi^13*u*c^2-2*phi^13*u^2*c+phi^8*u*c^2-2*phi^8*u^2*c-9*phi*u*c^2+32*phi*u^2*c-2*phi^18*r*c+14*phi^3*u*c+4*phi^3*r*u+8*phi^6*u+8*phi*u-12*phi^19*u^4+4*phi^10*u^5+6*phi^8*u^6+phi^18*u^3+18*phi^17*u^3+phi^13*u^3+phi^8*u^3-16*phi^3*u^2+12*phi^16*u^4+12*phi^11*u^4+5*phi^3*u^5*r-20*phi^15*u^4*c+6*phi^15*u^3*c^2+32*phi^11*r*u^2+4*phi^18*r*u-6*phi^17*r*c+17*phi^17*r*u+2*phi^14*r*c-4*phi^14*r*u-2*phi^13*r*c+4*phi^13*r*u-20*phi^6*u^4*r-2*phi^8*r*c+4*phi^8*r*u-20*phi*u^4*r-12*phi^10*r*u^3*c+6*phi^13*r*u^2*c+6*phi^8*r*u^2*c-9*phi^8*r^2*u-32*phi^19*r*u^2+32*phi^16*r*u^2+32*phi^6*r*u^2-32*phi^5*r*u^2-6*phi^13*u^3*r-6*phi^8*u^3*r+3*phi^22*c^2-phi^15*c^3*u+12*phi*r*u^3*c-18*phi^16*u^3*c+6*phi^16*u^2*c^2-18*phi^6*u^3*c+6*phi^6*u^2*c^2+18*phi^5*u^3*c-6*phi^5*u^2*c^2+2*phi^7*r*c-4*phi^7*r*u-6*phi^19*r^2*u^3-17*phi^22*u*c-12*phi^17*r*u^3*c+12*phi^6*r*u^3*c+2*phi^21*r*c-34*phi^15*u^3*c+12*phi^15*u^2*c^2-18*phi^18*r*u*c-18*phi^16*r*u*c-18*phi^13*r*u*c+12*phi^12*r*u*c-18*phi^11*r*u*c+18*phi^7*r*u*c-18*phi^6*r*u*c+18*phi^5*r*u*c+6*phi^23*r*u^2*c-24*phi^10*r*u^2*c+3*phi^10*u*r*c^2-6*phi^5*r*u^2*c+12*phi^23*r*u^3*c+12*phi^11*r*u^3*c+3*phi^12*r^2-8*phi^14*u+3*phi^14*c+phi^23*u^3+32*phi^18*r*u^2-9*phi^23*r^2*u-9*phi^13*r^2*u+9*phi^5*r^2*u-18*phi^18*u^3*c+6*phi^18*u^2*c^2-6*phi^23*u^3*r-6*phi^18*u^3*r+34*phi^10*u^3*r+6*phi^5*u^3*r-20*phi^23*u^4*r-6*phi^19*r*u^2*c-6*phi^12*u^2*c^2+6*phi^11*u^2*c^2+18*phi^12*u^3*c+12*phi^18*u^4-12*phi^19*r*u^3*c+12*phi^18*r*u^3*c-12*phi^14*r*u^3*c+12*phi^13*r*u^3*c-12*phi^12*r*u^3*c+12*phi^8*r*u^3*c-12*phi^7*r*u^3*c-12*phi^5*r*u^3*c+18*phi^14*r*u*c-18*phi^8*r*u*c-6*phi^21*r*u^2*c-6*phi^14*r*u^2*c-6*phi^12*r*u^2*c-6*phi^7*r*u^2*c-18*phi^3*r*u*c-phi^8+20*phi^19*u^4*r-20*phi^18*u^4*r+20*phi^14*u^4*r-20*phi^13*u^4*r+20*phi^12*u^4*r-20*phi^8*u^4*r+20*phi^7*u^4*r+20*phi^5*u^4*r+9*phi^21*r^2*u+9*phi^14*r^2*u+9*phi^7*r^2*u-20*phi^8*u^4*c+6*phi^8*u^3*c^2-20*phi*u^4*c+6*phi*u^3*c^2-32*phi^14*r*u^2+32*phi^13*r*u^2+32*phi^8*r*u^2-32*phi^7*r*u^2-5*phi^8*u^5*c-8*phi^19*u-3*phi^13*c+8*phi^13*u+3*phi^12*c-8*phi^12*u+phi^8*c+2*phi^8*u+3*phi^7*c-8*phi^7*u+16*phi^8*u^5+16*phi*u^5+12*phi^13*u^4+12*phi^8*u^4+12*phi^3*u^4-2*phi^3*u^2*c+phi^3*u*c^2+32*phi^3*r*u^2-18*phi^3*u^3*c+6*phi^3*u^2*c^2+25*phi^15*u^4+16*phi^15*u^5+9*r^2*u*phi^19-25*phi*u^3+16*u^2*phi^22)",\
"(-1+phi^4-phi^5+phi^6-phi^7+phi^9-phi^10+phi^11-phi^12+phi^13-phi^15+phi^16-phi^17+phi^18-phi^22+phi^23)*(28*r*u*c-11*u+6*c-4*phi^23*r*c-phi-2*r*c^2-13*u^4+6*phi^5*c+9*r^2*u-13*phi^12*u^4-28*phi^23*r*u*c-phi^5*u^5*c+6*phi^21*u^3*r-13*phi^14*u^4-6*phi^23*u^2*c^2*r+14*phi^18*r*u^2*c+2*phi*r*c^2+6*phi^23*r*u+6*phi^19*c-6*r*u-3*phi^10+16*phi^22*u^5-phi^15+11*phi^11*u-6*phi^3*c^2+3*c^3*u*phi^12+4*u^2*c-u^3+31*u^3*c+4*phi^14*u^2*c-14*r*u^2*c+4*u*r*c^2-32*r*u^2+4*r*c-r^2*c+6*u^3*r-3*u*c^2-u^5*c+28*phi^19*r*c*u+32*phi*r*u^2+31*u^3*phi^14*c-6*u*phi^21*r+9*phi^12*r^2*u-20*phi^11*u^4*r+20*phi^10*u^4*r+20*phi^13*u^2*c^2-3*phi^13*c^3*u-31*phi^8*u^3*c+phi^3*u^3-24*r*u^3*c+6*u^2*c^2*r-20*u^2*c^2+3*c^3*u+20*u^4*r-6*phi^5*u*r^2*c+24*phi^16*r*u^3*c-31*phi^23*u^3*c-11*u*phi^10+13*phi^23*u^4+11*phi^23*u-6*phi^23*c+11*phi^18*u-6*phi^18*c+11*phi^16*u-6*phi^16*c-6*phi^11*c+6*phi^10*c-11*phi^5*u-phi^14*u^3-phi^7*u^3-13*phi^7*u^4-phi^21*u^3-4*phi^23*u^2*c+3*phi^23*u*c^2-3*phi^14*u*c^2+4*phi^7*u^2*c-3*phi^7*u*c^2+2*phi^23*r*c^2+32*phi^23*r*u^2+phi^23*r^2*c-9*phi^18*r^2*u+phi^18*r^2*c-phi^12*r^2*c+phi^13*r^2*c-phi^7*r^2*c-phi^5*r^2*c+20*phi^23*u^2*c^2+31*phi^7*u^3*c-20*phi^7*u^2*c^2+3*phi^7*c^3*u+12*phi^5*r^2*u^2-20*phi^16*u^4*r+4*phi^21*u^2*c-3*phi^21*u*c^2-phi^22-phi^22*u^7-20*phi^14*u^2*c^2+3*phi^14*c^3*u-31*phi^13*u^3*c-phi^17*u^5*c+20*phi^8*u^2*c^2-3*phi^8*c^3*u+13*phi^6*u^4-13*phi^5*u^4+13*phi*u^4-11*phi^17*u-31*phi^11*u^3*c-31*phi*u^3*c+20*phi*u^2*c^2+6*phi^19*u^3*r-4*phi^3*r*c+31*phi^19*u^3*c-11*phi^10*u^4*c-20*phi^19*u^2*c^2-3*phi^11*c^3*u+3*phi^5*c^3*u-9*phi^3*r^2*u+phi^3*r^2*c-6*phi^3*u^3*r+20*phi^17*u^4*r-4*phi^3*r+phi*c^3+phi^6*u^5*c+phi^22*u^6*c+6*phi^14*u^3*r+6*phi^12*u^3*r+6*phi^7*u^3*r+6*phi^17*u^2*c^2*r+4*u^4*c^2*phi^8-phi^19*r^2*c+4*phi^19*u*r*c^2-31*phi^22*u^4*c+18*phi^22*u^3*c^2-4*phi^3*u*r*c^2+14*phi^3*r*u^2*c-4*phi^3*u^4*r*c-24*phi^12*r*u^2+r^3*u+phi^19*r+6*phi^17*c-6*phi^6*c-6*phi*c-28*phi*r*u*c+3*phi^18*u*c^2-4*phi^18*u^2*c+16*phi^17*u*c^2-37*phi^17*u^2*c+3*phi^13*u*c^2-4*phi^13*u^2*c+3*phi^8*u*c^2-4*phi^8*u^2*c-19*phi*u*c^2+43*phi*u^2*c-4*phi^18*r*c+24*phi^3*u*c+6*phi^3*r*u+11*phi^6*u+11*phi*u-13*phi^19*u^4+4*phi^10*u^5+6*phi^8*u^6+phi^18*u^3+21*phi^17*u^3+phi^13*u^3+phi^8*u^3-20*phi^3*u^2+13*phi^16*u^4+13*phi^11*u^4+5*phi^3*u^5*r+phi*u^5*c-3*phi*c^3*u-31*phi^15*u^4*c+18*phi^15*u^3*c^2+6*phi^10*u^3*c^2+32*phi^11*r*u^2+6*phi^18*r*u-9*phi^17*r*c+17*phi^17*r*u+4*phi^14*r*c-6*phi^14*r*u-4*phi^13*r*c+6*phi^13*r*u-20*phi^6*u^4*r-4*phi^8*r*c+6*phi^8*r*u-20*phi*u^4*r-6*phi^11*u^2*c^2*r-24*phi^10*r*u^3*c+6*phi^10*u^2*c^2*r-4*phi^13*u*r*c^2+14*phi^13*r*u^2*c+14*phi^8*r*u^2*c-4*phi^8*u*r*c^2+phi^8*r^2*c-9*phi^8*r^2*u-32*phi^19*r*u^2-2*phi^19*r*c^2+32*phi^16*r*u^2+32*phi^6*r*u^2-32*phi^5*r*u^2-6*phi^13*u^3*r-6*phi^8*u^3*r+6*phi^22*c^2+phi^11*u^5*c-4*phi^15*c^3*u-3*phi^15*u^2*c^3-6*phi^6*u^2*c^2*r+24*phi*r*u^3*c-6*phi*u^2*c^2*r+3*phi^19*r^2*u^2*c+phi^21*u*r^2*c-31*phi^16*u^3*c+20*phi^16*u^2*c^2-31*phi^6*u^3*c+20*phi^6*u^2*c^2-3*phi^6*c^3*u+31*phi^5*u^3*c-20*phi^5*u^2*c^2+4*phi^7*r*c-6*phi^7*r*u-6*phi^19*r^2*u^3-22*phi^22*u*c-24*phi^17*r*u^3*c+24*phi^6*r*u^3*c+4*phi^21*r*c-48*phi^15*u^3*c+27*phi^15*u^2*c^2-28*phi^18*r*u*c-28*phi^16*r*u*c-28*phi^13*r*u*c+17*phi^12*r*u*c-28*phi^11*r*u*c+28*phi^7*r*u*c-28*phi^6*r*u*c+28*phi^5*r*u*c+14*phi^23*r*u^2*c-4*phi^23*u*r*c^2-4*phi^18*u*r*c^2-39*phi^10*r*u^2*c+9*phi^10*u*r*c^2-14*phi^5*r*u^2*c+4*phi^5*u*r*c^2+24*phi^23*r*u^3*c+24*phi^11*r*u^3*c+3*phi^12*r^2-11*phi^14*u+6*phi^14*c+phi^23*u^3+2*phi^18*r*c^2+32*phi^18*r*u^2+2*phi^16*r*c^2+2*phi^13*r*c^2-2*phi^12*r*c^2+2*phi^11*r*c^2-2*phi^7*r*c^2+2*phi^6*r*c^2-2*phi^5*r*c^2-9*phi^23*r^2*u-9*phi^13*r^2*u+9*phi^5*r^2*u-31*phi^18*u^3*c+20*phi^18*u^2*c^2-6*phi^23*u^3*r-6*phi^18*u^3*r+34*phi^10*u^3*r+6*phi^5*u^3*r-20*phi^23*u^4*r+phi^23*u^5*c+phi^16*u^5*c-phi^14*u^5*c-6*phi^16*u^2*c^2*r-14*phi^19*r*u^2*c-18*phi^12*u^2*c^2+20*phi^11*u^2*c^2+29*phi^12*u^3*c-3*phi^23*c^3*u-3*phi^18*c^3*u+13*phi^18*u^4-24*phi^19*r*u^3*c+6*phi^19*u^2*c^2*r+24*phi^18*r*u^3*c-6*phi^18*u^2*c^2*r-24*phi^14*r*u^3*c+6*phi^14*u^2*c^2*r+24*phi^13*r*u^3*c-6*phi^13*u^2*c^2*r-24*phi^12*r*u^3*c+6*phi^12*u^2*c^2*r+24*phi^8*r*u^3*c-6*phi^8*u^2*c^2*r-24*phi^7*r*u^3*c+6*phi^7*u^2*c^2*r-27*phi^5*r*u^3*c+6*phi^5*u^2*c^2*r+28*phi^14*r*u*c-28*phi^8*r*u*c-14*phi^21*r*u^2*c+4*phi^21*u*r*c^2-14*phi^14*r*u^2*c+4*phi^14*u*r*c^2-14*phi^12*r*u^2*c+4*phi^12*u*r*c^2-14*phi^7*r*u^2*c+4*phi^7*u*r*c^2-28*phi^3*r*u*c-phi^8+20*phi^19*u^4*r-20*phi^18*u^4*r+20*phi^14*u^4*r-20*phi^13*u^4*r+20*phi^12*u^4*r-20*phi^8*u^4*r+20*phi^7*u^4*r+20*phi^5*u^4*r+9*phi^21*r^2*u-phi^21*r^2*c+9*phi^14*r^2*u-phi^14*r^2*c+9*phi^7*r^2*u-31*phi^8*u^4*c+18*phi^8*u^3*c^2-3*phi^8*u^2*c^3-31*phi*u^4*c+18*phi*u^3*c^2-3*phi*u^2*c^3-3*phi^19*u*c-32*phi^14*r*u^2-2*phi^14*r*c^2+32*phi^13*r*u^2+32*phi^8*r*u^2+2*phi^8*r*c^2-32*phi^7*r*u^2-phi^19*u^5*c+phi^18*u^5*c+phi^13*u^5*c-phi^12*u^5*c-phi^10*u^5*c-9*phi^8*u^5*c-phi^7*u^5*c-11*phi^19*u-6*phi^13*c+11*phi^13*u+6*phi^12*c-11*phi^12*u-phi^8*c+5*phi^8*u+6*phi^7*c-11*phi^7*u+16*phi^8*u^5+16*phi*u^5+phi^19*u^2+phi^19*c^2+13*phi^13*u^4+13*phi^8*u^4+13*phi^3*u^4-4*phi^3*u^2*c+3*phi^3*u*c^2+32*phi^3*r*u^2+2*phi^3*r*c^2-31*phi^3*u^3*c+20*phi^3*u^2*c^2-3*phi^3*c^3*u+25*phi^15*u^4+16*phi^15*u^5-3*phi^22*u^2*c^3+3*phi^19*c^3*u+9*r^2*u*phi^19-3*phi^16*c^3*u-25*phi*u^3+16*u^2*phi^22)",\
"-(1+phi^14+phi^7+phi^21)*(-4*phi^23*r*c-12*phi^9*r*u^2*c+16*phi^9*u^3*r+9*r^2*u-18*phi^9*r*u*c+3*phi^9*r*c^2-10*phi^16*r*c-18*phi^23*r*u*c-phi^2*r+10*phi^14*u^4+4*phi^23*r*u-4*r*u+12*r*phi^16*u+2*r*phi^18+4*u*phi^2*r+18*u^2*c-10*u^3+c^3+5*u^5-5*u^4*c+4*r*c-3*r^2*c-9*u*c^2+3*phi^2*r^2*c+9*phi^16*u^3-16*u^3*phi^14*c+4*phi^2*u^4-4*phi^23*u^3*c+4*phi^23*u^4+5*phi^23*u-3*phi^23*c+5*phi^21*u^5-9*phi^2*u^2-4*phi^2*c^2-4*phi^10*r*u+4*phi^10*r*c-4*phi^5*r*u+4*phi^5*r*c-15*phi^16*u^2*c+6*phi^16*u*c^2+3*phi^23*r*c^2+18*phi^23*r*u^2+3*phi^23*r^2*c+3*phi^16*r^2*c-3*phi^10*r^2*c-3*phi^5*r^2*c-5*phi^21*u^4*c-4*phi^20*r*u+4*phi^20*r*c-4*phi^15*r*u+4*phi^15*r*c-3*phi^15*r^2*c+4*phi^9*r*u-4*phi^9*r*c+3*phi^9*r^2*c+6*phi^4*r^2*u^2+10*phi^2*u*c-4*phi^2*r*c-phi^9+6*phi^14*u^2*c^2+5*u^2*phi^21+18*phi^9*r*u^2-4*phi^9*u^3*c-4*phi^18*r*c+phi^7*u^6+4*phi^16*u^4+4*phi^9*u^4+6*phi^11*r*u^2+4*phi^18*r*u-4*phi^11*r*c+4*phi^11*r*u+18*phi^16*r*u^2-4*phi^16*u^3*c-18*phi^16*r*u*c-6*phi^11*r*u*c+3*phi^11*r^2+3*phi^21*c^2-phi^20*r^3+4*phi^4*r*u+3*phi^16*r*c^2-9*phi^23*r^2*u-9*phi^16*r^2*u+9*phi^10*r^2*u+9*phi^5*r^2*u-5*phi^23*u^4*r-8*phi^21*u*c+9*phi^20*r^2*u-3*phi^20*r^2*c-18*phi^2*r*u*c+9*phi^15*r^2*u-9*phi^9*r^2*u-4*phi^4*r*c+3*phi^2*r*c^2-4*phi^2*u^3*c+18*phi^2*r*u^2-9*phi^2*r^2*u-5*phi^14*u^4*c-5*phi^7*u^4*c-2*phi^18*u*c+phi^7*c-phi^7*u+5*phi^14*u^5+5*phi^7*u^5+phi^18*c^2+phi^18*u^2)",\
"phi^2*(4*phi^23*r*c+3*r^2*u-phi^2*c+phi^16-6*phi^23*r*u+4*u^2+3*u*phi^2-6*u*c+2*c^2+u^5-6*phi^14*u*c+r*phi^9+3*u*phi^9+3*phi^23*u-phi^23*c+3*phi^16*u-phi^16*c+2*phi^14*c^2+4*phi^14*u^2+6*phi^7*u^3-phi^9*c+2*phi^9*c^2+4*phi^9*u^2+3*phi^23*u^2*c-9*phi^7*u^2*c+3*phi^7*u*c^2-3*phi^18*r^2*u-6*phi^9*u*c+4*u^2*phi^21+phi^14*u-phi^14*c+2*phi^7*c^2+4*phi^7*u^2-2*phi^18*r^2-3*phi^23*u^3+2*phi^21*c^2-4*phi^21*u^4+2*phi^4*r*u-6*phi^7*u*c-3*phi^23*r^2*u-3*phi^16*r^2*u-3*phi^11*r^2*u+3*phi^10*r^2*u+3*phi^5*r^2*u-4*phi^16*u^3*r-6*phi^21*u*c+3*phi^20*r^2*u+4*phi^21*u^3*c-6*phi^2*r*u*c+3*phi^15*r^2*u-3*phi^9*r^2*u-3*phi^4*r^2*u-2*phi^4*r*c+9*phi^2*r*u^2-3*phi^2*r^2*u)",\
"-1-4*r-24*r*u*c-8*phi^23*r*c+6*r*c^2-4*r^2*phi^16+20*u^4-12*phi^9*r*u*c+3*phi^9*r*c^2-3*phi^23*r^3-8*phi^16*r*c+24*phi^23*r*u*c+4*phi^2*r+u*phi^21+20*phi^14*u^4+5*phi^2*c-10*phi^4*r^2*u^3+5*r*phi^16-4*phi^11*u*c+10*phi^23*r*u+12*phi^18*u*r^2*c-4*phi^5*r+10*r*phi^16*u-8*u^2+phi^23-4*phi^10*r+4*r*phi^18-7*u*phi^2+10*u*phi^2*r+4*r^2+14*u*c-40*u^3*c-30*phi^14*u^2*c+3*r^3-6*c^2+18*r*u^2+22*phi^16*u^3-40*u^3*phi^14*c-10*phi^11*r^2*u^3-24*phi^20*r*u*c-6*phi^16*u^5*r+6*phi^20*r*c^2+24*u^2*c^2-4*c^3*u-3*phi^9*r^3-3*phi^4*r^3-4*phi^23*u*c-24*phi^16*u*c+8*phi^16*c^2+19*phi^16*u^2+4*phi^23*r+4*r*phi^11+4*r*phi^9+2*phi^11*u^2+2*phi^18*u-2*phi^18*c+2*phi^23*c^2+2*phi^23*u^2+2*phi^11*c^2+15*phi^14*u^3-3*phi^14*c^3-3*phi^13*r^3+20*phi^7*u^4+22*phi^9*u^3-3*phi^9*c^3+2*phi^9*c^2+2*phi^9*u^2+2*phi^2*u^2+2*phi^2*c^2-36*phi^23*u^2*c+21*phi^23*u*c^2-36*phi^16*u^2*c+21*phi^16*u*c^2+18*phi^14*u*c^2-6*phi^23*r*c^2-18*phi^23*r*u^2-40*phi^7*u^3*c+24*phi^7*u^2*c^2-4*phi^7*c^3*u-24*phi^18*r^2*u^2+10*phi^9*r*u-36*phi^9*u^2*c-8*phi^9*r*c+21*phi^9*u*c^2-4*phi^9*u*c-9*phi^4*r^2*c-4*phi^2*u*c-36*phi^2*u^2*c+21*phi^2*u*c^2-8*phi^2*r*c+24*phi^14*u^2*c^2-4*phi^14*c^3*u+6*phi^21*u^5*c+u^7-phi^21*c+12*phi^9*r*u^2-28*phi^9*u^3*c+12*phi^9*u^2*c^2+4*phi^4*r-4*phi^2*r^2+10*r^2*u^3+2*phi^4*c^2-3*phi^6*r^3+3*phi^11*u*c^2-6*phi^11*u^2*c+16*phi^9*u^4-6*phi^11*r*c-4*phi^4*u*c+12*phi^11*r*u+18*phi^20*r*u^2-3*phi^16*c^3-3*phi^2*c^3+22*phi^2*u^3+4*phi^20*r^2-18*phi^16*r*u^2+18*phi^10*r*u^2+18*phi^5*r*u^2-4*phi^13*r^3*u-10*phi^18*r^2*u^3+18*phi^15*r*u^2+24*phi^16*r*u*c-24*phi^10*r*u*c-24*phi^5*r*u*c+48*phi^23*r*u^2*c-12*phi^23*u*r*c^2-24*phi^15*r*u*c-2*phi^10*c^2-2*phi^10*u^2-2*phi^5*c^2-2*phi^5*u^2-4*phi^23*r^2+4*phi^10*r^2+4*phi^5*r^2+22*phi^23*u^3-3*phi^23*c^3-3*phi^18*r^3+3*phi^17*r^3-3*phi^16*r^3+3*phi^12*r^3-3*phi^11*r^3+3*phi^10*r^3+3*phi^7*r^3+3*phi^5*r^3+3*phi^22*r^3-4*phi^20*r-2*phi^20*c^2+20*phi^21*u^4-4*phi^15*r-2*phi^15*u^2+4*phi^15*r^2+3*phi^15*r^3-2*phi^15*c^2-2*phi^20*u^2-4*phi^9*r^2+4*phi^10*u*c+4*phi^5*u*c-6*phi^16*r*c^2+6*phi^10*r*c^2+6*phi^5*r*c^2-40*phi^23*u^3*r-3*phi^20*r^2*u+4*phi^20*u*c+3*phi^20*r^2*c-40*phi^21*u^3*c+24*phi^21*u^2*c^2-4*phi^21*c^3*u+6*phi^15*r*c^2+4*phi^15*u*c+12*phi^4*u^3*r-12*phi^4*r*u^2*c+24*phi^2*r*u*c-20*phi^2*r*u^3*c-10*phi^23*r^2*u^3-10*phi^16*r^2*u^3+10*phi^10*r^2*u^3+10*phi^5*r^2*u^3+18*phi^4*r^2*u-6*phi^2*r*c^2-18*phi^2*r*u^2+25*phi^2*u^4*r+10*phi^20*r^2*u^3+10*phi^15*r^2*u^3-10*phi^9*r^2*u^3-10*phi^2*r^2*u^3-6*phi^21*u^6+5*phi^23*u^4*c-25*phi^7*u^4*c+10*phi^7*u^3*c^2-4*phi^18*u*c-5*phi^23*u^5+15*phi^7*u^5+2*phi^18*c^2+2*phi^18*u^2+2*phi^4*u^2+3*phi^11*u^3",\
"-(1+phi^14+phi^7+phi^21)*(-34*r*u*c+4*u-5*c-21*phi^23*u*r^2*c+14*r*c^2-4*r^2*phi^16+20*u^4+phi^2-4*phi^5*c+66*phi^9*r*u^2*c-40*phi^9*u^3*r-3*r^2*u-30*phi^9*u*r*c^2+34*phi^9*r*u*c-14*phi^9*r*c^2-24*r^2*u^2+34*phi^23*r*u*c+u*phi^21+4*phi^2*c-10*phi^4*r^2*u^3+phi^16-21*phi^16*u*r^2*c+phi^23-3*u*phi^2+10*u*phi^2*r+phi^11+4*r^2-53*u^3*c-6*u^6+21*u*r^2*c+21*r*u^2+5*r^2*c+11*u^5*c+3*phi^16*c^3*r-5*u^4*c^2-3*r^2*c^2-3*phi^17*r^2*u-3*phi^12*r^2*u-phi^20*r^3*c+3*phi^9*r^2*c^2+3*phi^2*r^2*c^2-3*phi^20*r^2*c^2-3*phi^15*r^2*c^2+6*phi^4*r^2*u^2*c-34*phi^20*r*u*c+3*phi^23*r^2*c^2-8*phi^2*u^3*c^2-3*phi^22*r^2*u+6*phi^23*u^5*r-3*phi^4*u^2*c^2+4*phi^20*r^3*u+3*phi^16*r^2*c^2-3*phi^10*r^2*c^2-3*phi^5*r^2*c^2+14*phi^20*r*c^2+3*phi^2*r*c^3-phi^13*r^2+4*r*u^3*c+45*u^2*c^2-13*c^3*u+21*phi^10*u*r^2*c+21*phi^5*u*r^2*c-4*phi^16*r*u^3*c+21*phi^20*u*r^2*c+21*phi^15*u*r^2*c-21*phi^9*u*r^2*c+34*phi^4*r*u*c+66*phi^2*r*u^2*c-30*phi^2*u*r*c^2-21*phi^2*u*r^2*c+3*phi^23*u^3*c+30*phi^23*u*c-phi^23*r+3*u*phi^10+5*u*phi^9-3*phi^23*u+4*phi^23*c-3*phi^16*u+4*phi^16*c-4*phi^10*c+3*phi^5*u-11*phi^23*c^2-20*phi^23*u^2+3*phi^20*u-4*phi^20*c-15*phi^21*u^3+6*phi^21*c^3-4*phi^15*c+3*phi^15*u-3*phi^9*c-4*phi^4*r^2-14*phi^23*r*c^2-21*phi^23*r*u^2-5*phi^23*r^2*c+3*phi^18*r^2*u-5*phi^18*r^2*c+5*phi^17*r^2*c-5*phi^16*r^2*c+5*phi^12*r^2*c+7*phi^11*r^2*c+5*phi^10*r^2*c+5*phi^7*r^2*c+5*phi^5*r^2*c-3*phi^23*u^2*c^2+24*phi^23*r^2*u^2+24*phi^16*r^2*u^2-24*phi^10*r^2*u^2-24*phi^5*r^2*u^2+5*phi^22*r^2*c+35*phi^21*u^2*c-26*phi^21*u*c^2+5*phi^15*r^2*c-5*phi^9*r^2*c-24*phi^20*r^2*u^2-24*phi^15*r^2*u^2+24*phi^9*r^2*u^2-14*phi^4*r*c^2-21*phi^4*r*u^2-5*phi^4*r^2*c-52*phi^2*u^2*c+13*phi^2*u^4*c-40*phi^2*u^3*r+37*phi^2*u*c^2-9*phi^2*r*c+24*phi^2*r^2*u^2+phi^9+11*phi^21*u^5*c+3*phi^11*u^3*c+c^4-phi^21*c-21*phi^9*r*u^2+3*phi^9*u^3*c-3*phi^9*u^2*c^2+5*phi^4*r-4*phi^2*r^2+3*phi^4*c^2-3*phi^6*r^3+3*phi^18*c^3+3*phi^23*r*c^3-11*phi^18*u*c^2+11*phi^18*u^2*c+11*phi^18*r*c-6*phi^7*u^6-3*phi^18*u^3-17*phi^16*u^4+3*phi^6*u*r^2*c-8*phi^9*u^3*c^2-21*phi^11*r*u^2-16*phi^18*r*u-9*phi^4*u*c+21*phi^20*r*u^2-9*phi^2*c^3-5*phi^2*u^5+25*phi^2*u^3+4*phi^20*r^2+4*phi^10*r*u^3*c+4*phi^15*r*u^3*c+4*phi^20*r*u^3*c-5*phi^23*u^4*r*c-51*phi^16*r*u^2+21*phi^10*r*u^2+21*phi^5*r*u^2+13*phi^9*u^4*c-5*phi^7*u^4*c^2+46*phi^16*u^3*c-39*phi^16*u^2*c^2-3*phi^10*u^3*c+3*phi^10*u^2*c^2-3*phi^5*u^3*c+3*phi^5*u^2*c^2-3*phi^15*u^3*c+21*phi^15*r*u^2+3*phi^15*u^2*c^2-3*phi^20*u^3*c+3*phi^20*u^2*c^2+34*phi^18*r*u*c+78*phi^16*r*u*c+2*phi^13*r*u*c+34*phi^11*r*u*c-34*phi^10*r*u*c-34*phi^5*r*u*c+66*phi^23*r*u^2*c-30*phi^23*u*r*c^2+66*phi^16*r*u^2*c-30*phi^16*u*r*c^2+27*phi^11*r*u^2*c-12*phi^11*u*r*c^2-4*phi^23*r*u^3*c-34*phi^15*r*u*c+phi^14*u-phi^14*c+5*phi^7*c^2+6*phi^7*u^2-4*phi^23*r^2-4*phi^18*r^2-4*phi^11*r^2+4*phi^10*r^2+4*phi^5*r^2-5*phi^16*u^5+4*phi^15*r^2-6*phi^14*u^6-4*phi^9*r^2-phi^7*u^7-11*phi^7*u*c-14*phi^18*r*c^2-21*phi^18*r*u^2-29*phi^16*r*c^2-2*phi^13*r*c^2-14*phi^11*r*c^2+14*phi^10*r*c^2+14*phi^5*r*c^2+3*phi^23*r^2*u+3*phi^16*r^2*u-15*phi^11*r^2*u-3*phi^10*r^2*u-3*phi^5*r^2*u+3*phi^18*u^3*c-3*phi^18*u^2*c^2-40*phi^23*u^3*r-40*phi^16*u^3*r-12*phi^11*u^3*r+13*phi^16*u^4*c-8*phi^16*u^3*c^2-3*phi^20*r^2*u+5*phi^20*r^2*c+14*phi^15*r*c^2+11*phi^14*u^5*c+phi^9*u^5*c+32*phi^9*r*u^3*c-12*phi^9*u^2*c^2*r+34*phi^2*r*u*c-4*phi^2*r*u^3*c-5*phi^14*u^4*c^2-3*phi^15*r^2*u+3*phi^9*r^2*u+phi^7*u^6*c+3*phi^4*r^2*u-25*phi^9*u^4*r-14*phi^2*r*c^2+3*phi^2*u^3*c-3*phi^2*u^2*c^2-21*phi^2*r*u^2-3*phi^11*u^2*c^2-6*phi^21*u^6-5*phi^9*u^5+4*phi^5*r*u^3*c-3*phi^7*r^2*u+13*phi^23*u^4*c-8*phi^23*u^3*c^2+35*phi^14*u^4*c-26*phi^14*u^3*c^2+6*phi^14*u^2*c^3+11*phi^7*u^5*c-phi^7*c+phi^7*u-5*phi^23*u^5-15*phi^14*u^5+3*phi^4*u^3*c+4*phi^4*u^2+3*phi^9*r*c^3+9*phi^16*c^3*u-5*u^4*c^2*phi^21)",\
"phi^21*(-1+6*phi^23*r*c+3*r^2*u-3*phi^2*c+2*phi^16-12*phi^23*r*u+10*u^2+5*u*phi^2-12*u*c+3*c^2+u^5-12*phi^14*u*c+4*r*phi^9+5*u*phi^9+5*phi^23*u-3*phi^23*c+5*phi^16*u-3*phi^16*c+3*phi^14*c^2+10*phi^14*u^2+10*phi^7*u^3-3*phi^9*c+2*phi^9*c^2+6*phi^9*u^2+3*phi^23*u^2*c-12*phi^7*u^2*c+3*phi^7*u*c^2-3*phi^18*r^2*u-8*phi^9*u*c+10*u^2*phi^21+5*phi^14*u-4*phi^14*c+3*phi^7*c^2+10*phi^7*u^2-3*phi^18*r^2-3*phi^23*u^3+3*phi^21*c^2-5*phi^21*u^4+2*phi^4*r*u-12*phi^7*u*c-3*phi^23*r^2*u-3*phi^16*r^2*u-3*phi^11*r^2*u+3*phi^10*r^2*u+3*phi^5*r^2*u-4*phi^16*u^3*r-12*phi^21*u*c+3*phi^20*r^2*u+4*phi^21*u^3*c-6*phi^2*r*u*c+3*phi^15*r^2*u-3*phi^9*r^2*u-3*phi^4*r^2*u-2*phi^4*r*c+12*phi^2*r*u^2-3*phi^2*r^2*u)",\
"phi^23*(4*u-3*c-r^2*phi^16+u^4+phi^2+4*u*phi^21+phi^14+phi^16+phi^23+6*u*phi^2*r+r^2+2*phi^23*u*c-3*phi^23*r+2*u*phi^9-2*phi^23*u^2-4*phi^21*u^3-2*phi^9*c-phi^4*r^2+3*phi^21*u^2*c-2*phi^2*r*c+phi^9-3*phi^21*c-phi^2*r^2+phi^20*r^2-3*phi^16*r*u^2+4*phi^14*u-3*phi^14*c+phi^7*c^2+6*phi^7*u^2-phi^23*r^2-phi^18*r^2-phi^11*r^2+phi^10*r^2+phi^5*r^2+phi^15*r^2-phi^9*r^2-6*phi^7*u*c-3*phi^7*c+4*phi^7*u)",\
"phi^21*(-6*u+5*c+6*phi^23*r*c-3*phi^2+6*r^2*u^2+phi^21+6*phi^16*r*c+24*phi^23*r*u*c+5*phi^2*r+5*r*phi^16-2*phi^11*u*c-6*phi^23*r*u+6*r*u-6*r*phi^16*u-6*u*phi^2*r-30*u^2*c+20*u^3-30*phi^14*u^2*c+u^6-c^3-6*r*c+12*u*c^2-6*phi^4*r*u*c-12*phi^2*r*u^2*c+4*phi^23*u^3*c-18*phi^23*u*c-18*phi^16*u*c-20*phi^14*u*c+6*phi^16*c^2+15*phi^16*u^2+5*phi^23*r+2*r*phi^11+5*r*phi^9+phi^11*u^2-4*phi^23*u^4+10*phi^16*u-6*phi^16*c+6*phi^23*c^2+15*phi^23*u^2+6*phi^14*c^2+15*phi^14*u^2+phi^11*c^2+20*phi^14*u^3-phi^14*c^3+20*phi^7*u^3-phi^7*c^3-phi^13*r^3+15*phi^7*u^4-6*phi^21*u^5+20*phi^21*u^3-phi^21*c^3+12*phi^9*u^3+6*phi^4*r^2+6*phi^9*c^2+15*phi^9*u^2+15*phi^2*u^2+6*phi^2*c^2+6*phi^10*r*u-6*phi^10*r*c+6*phi^5*r*u-6*phi^5*r*c+12*phi^14*u*c^2-30*phi^7*u^2*c+12*phi^7*u*c^2-3*phi^23*r*c^2-30*phi^23*r*u^2-12*phi^18*r^2*u+3*phi^18*r^2*c-20*phi^7*u^3*c+6*phi^7*u^2*c^2-6*phi^23*r^2*u^2-6*phi^18*r^2*u^2-6*phi^16*r^2*u^2-6*phi^11*r^2*u^2+6*phi^10*r^2*u^2+6*phi^5*r^2*u^2-5*phi^16*u^4*r+5*phi^21*u^4*c+6*phi^20*r*u-6*phi^20*r*c-30*phi^21*u^2*c+12*phi^21*u*c^2+6*phi^15*r*u-6*phi^15*r*c+14*phi^9*r*u-18*phi^9*u^2*c-6*phi^9*r*c+6*phi^9*u*c^2+6*phi^20*r^2*u^2+6*phi^15*r^2*u^2-6*phi^9*r^2*u^2-6*phi^4*r^2*u^2+6*phi^4*r*u^2-18*phi^9*u*c-18*phi^2*u*c+20*phi^2*u^3*r+6*phi^2*r*c-6*phi^2*r^2*u^2)",\
"-(-1+phi^4-phi^5+phi^6-phi^7+phi^9-phi^10+phi^11-phi^12+phi^13-phi^15+phi^16-phi^17+phi^18-phi^22+phi^23)*(-4-4*r-14*r*u*c-16*phi^23*r*c+3*phi+4*r*c^2-4*phi^5-4*phi^7-4*r*phi^14-16*phi^16*r*c+14*phi^23*r*u*c+6*phi^21*r*u^2-4*phi^14-4*phi^19+4*phi^16+24*phi^18*r*u^2*c+20*phi^23*r*u-2*phi^19*c-20*r*u-4*phi^10+20*r*phi^16*u-u^2+4*phi^23+4*r*phi^18+5*phi^17*r+20*r*phi^6*u+4*phi^18+4*phi^11+6*r^2+3*phi^3*c^2-4*phi^12+4*u*c+30*u^2*c-13*u^3+30*phi^14*u^2*c+r^3-3*c^2+3*c^3-24*r*u^2*c+6*u*r*c^2-u^4*c+6*r*u^2+16*r*c+20*u^3*r-20*u*c^2-14*phi^19*r*c*u-13*phi^5*u^3+13*phi^16*u^3-phi^12*u^4*c+20*phi^17*r*u^3+6*phi^22*u-16*phi^6*r*c+20*phi^6*u*c^2+15*u^4*phi^22-30*phi^8*u^3*c+13*phi^3*u^3-6*phi^13*r^2-4*phi^23*u*c+4*phi^14*u*c+4*phi^23*r+3*phi^23*c^2+phi^23*u^2-3*phi^14*c^2-phi^14*u^2-13*phi^14*u^3+3*phi^14*c^3-13*phi^7*u^3+3*phi^7*c^3-20*phi^5*r*u+16*phi^5*r*c-30*phi^23*u^2*c+20*phi^23*u*c^2-30*phi^16*u^2*c+20*phi^16*u*c^2-20*phi^14*u*c^2+30*phi^7*u^2*c-20*phi^7*u*c^2+30*phi^5*u^2*c-20*phi^5*u*c^2-4*phi^23*r*c^2-6*phi^23*r*u^2-6*phi^5*r^2*c-40*phi^15*u^2*c+24*phi^15*u*c^2+4*phi^13-4*phi^17+4*phi^6-3*phi^3*c^3+18*phi^8*u^2*c^2-3*phi^8*c^3*u+6*phi^14*r^2+15*phi*u^4-30*phi*u^3*c+18*phi*u^2*c^2+20*phi^19*u^3*r-16*phi^3*r*c-phi^10*u^4*c-u^2*phi^21-20*phi^6*u^3*r-6*phi^3*r^2+4*phi^3*r-3*phi^13*c^3-3*phi*c^3+3*phi^12*c^3-3*phi^8*c^3-u^6*phi^22+20*phi^14*u^3*r+20*phi^12*u^3*r+20*phi^7*u^3*r+6*phi^19*u*r*c^2+phi^22*u^5*c+6*phi^12*r*u^2-3*phi^11*c^3-3*phi^18*c^3+4*phi^8*r-4*phi^7*r+4*phi^13*r+6*phi^19*r^2+20*phi^18*u*c^2-30*phi^18*u^2*c+20*phi^13*u*c^2-30*phi^13*u^2*c-18*phi^12*u*c^2+28*phi^12*u^2*c+20*phi^11*u*c^2-30*phi^11*u^2*c+20*phi^8*u*c^2-30*phi^8*u^2*c+20*phi*u*c^2-30*phi*u^2*c-16*phi^18*r*c-4*phi^3*u*c+20*phi^3*r*u+13*phi^18*u^3+13*phi^13*u^3+13*phi^8*u^3+phi^3*u^2+6*phi^21*r^2+3*phi^19*u*r^2*c-3*phi*c^3*u+20*phi^18*r*u+16*phi^14*r*c-20*phi^14*r*u-16*phi^13*r*c+20*phi^13*r*u+7*phi^12*r*c-12*phi^12*r*u-16*phi^11*r*c-6*phi^19*r^2*u^2+20*phi^11*r*u-16*phi^8*r*c+20*phi^8*r*u-3*phi^16*c^3-4*phi^15*c^3+20*phi^15*u^3-3*phi^6*c^3+3*phi^5*c^3+6*phi^17*u*r*c^2-24*phi^17*r*u^2*c-6*phi^13*u*r*c^2+24*phi^13*r*u^2*c-6*phi^6*u*r*c^2+24*phi^6*r*u^2*c+24*phi^8*r*u^2*c-6*phi^8*u*r*c^2+24*phi*r*u^2*c-6*phi*u*r*c^2+6*phi^19*r*u^2+4*phi^19*r*c^2+30*phi^10*r*u^2+6*phi^5*r*u^2-20*phi^13*u^3*r-20*phi^8*u^3*r-20*phi*u^3*r-6*phi^22*c-3*phi^15*c^3*u-11*phi^10*u^3*c+6*phi^10*u^2*c^2-16*phi*r*c+20*phi*r*u+16*phi^7*r*c-20*phi^7*r*u-30*phi^22*u^3*c+18*phi^22*u^2*c^2-3*phi^22*c^3*u-30*phi^15*u^3*c+18*phi^15*u^2*c^2+14*phi^18*r*u*c+14*phi^13*r*u*c-14*phi^12*r*u*c-36*phi^10*r*u*c-14*phi^7*r*u*c-14*phi^5*r*u*c+24*phi^23*r*u^2*c-6*phi^23*u*r*c^2-6*phi^18*u*r*c^2+24*phi^16*r*u^2*c-6*phi^16*u*r*c^2+24*phi^11*r*u^2*c-6*phi^11*u*r*c^2-24*phi^10*r*u^2*c+6*phi^10*u*r*c^2-27*phi^5*r*u^2*c+6*phi^5*u*r*c^2+6*phi^12*r^2-3*phi^7*c^2-phi^7*u^2-6*phi^23*r^2-6*phi^18*r^2+6*phi^7*r^2+6*phi^5*r^2+13*phi^23*u^3-3*phi^23*c^3-3*phi^21*c^2+4*phi^7*u*c-4*phi^18*r*c^2-6*phi^18*r*u^2-4*phi^13*r*c^2+4*phi^12*r*c^2+9*phi^10*r*c^2+4*phi^7*r*c^2+4*phi^5*r*c^2+12*phi^5*r^2*u-20*phi^23*u^3*r-20*phi^18*u^3*r-20*phi^16*u^3*r-20*phi^11*u^3*r+20*phi^10*u^3*r+20*phi^5*u^3*r+phi^16*u^4*c+4*phi^21*u*c-24*phi^19*r*u^2*c+3*phi^19*c^3-14*phi^14*r*u*c+14*phi^8*r*u*c-14*phi^21*r*u*c-24*phi^14*r*u^2*c+6*phi^14*u*r*c^2-24*phi^12*r*u^2*c+6*phi^12*u*r*c^2-24*phi^7*r*u^2*c+6*phi^7*u*r*c^2-4*phi^3*r*u^3*c+14*phi^3*r*u*c+3*phi^8-4*phi^21*r-20*phi^19*r*u+16*phi^19*r*c+phi^21*r^2*c+phi^23*u^4*c-phi^19*u^4*c+phi^18*u^4*c-phi^14*u^4*c+phi^13*u^4*c+phi^11*u^4*c-9*phi^8*u^4*c+4*phi^8*u^3*c^2-phi^7*u^4*c+phi^6*u^4*c-phi^5*u^4*c+phi*u^4*c-4*phi^18*u*c-29*phi^17*u*c-4*phi^13*u*c-4*phi^8*u*c+25*phi*u*c-20*phi^19*u*c^2+30*phi^19*u^2*c+6*phi^14*r*u^2+4*phi^14*r*c^2-6*phi^13*r*u^2-6*phi^8*r*u^2-4*phi^8*r*c^2+6*phi^7*r*u^2+phi^19*u+6*phi^8*u^5+3*phi^18*c^2+phi^18*u^2+12*phi^17*c^2+18*phi^17*u^2+3*phi^13*c^2+phi^13*u^2+3*phi^8*c^2+phi^8*u^2-10*phi*c^2-15*phi*u^2-13*phi^19*u^3+15*phi^8*u^4+11*phi^3*c-13*phi^3*u-30*phi^3*u^2*c+20*phi^3*u*c^2+5*phi^3*u^4*r+4*phi^21*r*c^2-6*phi^3*r*u^2-4*phi^3*r*c^2-30*phi^6*u^2*c-u^4*c*phi^17+15*phi^15*u^4+4*phi^10*u^4-6*phi^8*r^2-13*phi^12*u^3+13*phi^11*u^3+13*phi^6*u^3+13*phi*u^3)"]

# eqs = map(lambda eq: eq.replace('c', '1'), eqs)
# eqs = map(lambda eq: eq.replace('c', '(-phi^2+phi^4-phi^5-phi^10+phi^11-phi^17+phi^18+phi^21)'), eqs)
eqs = map(lambda eq: eq.replace('c', '(1-phi^2-phi^4+phi^7-phi^9+phi^10-phi^11+phi^12-phi^16+phi^17-phi^18+phi^21-phi^23)'), eqs)

basis = ginv.basisBuild("TQBlockHigh", iD, eqs)

print "         lengthIB = ", basis.lengthIB()
print "         lengthGB = ", basis.lengthGB()
print "     numCriterion = ", basis.numCriterion()
print "         numSpoly = ", basis.numSpoly()
print "     numReduction = ", basis.numReduction()
print "         userTime = ", basis.userTime()
print "          sysTime = ", basis.sysTime()
print "         realTime = ", basis.realTime()
print "hilbertPolynomial = ", basis.hilbertPolynomial()

for p in basis.iterIB():
    print p
