from gzip import GzipFile
import xml.dom.minidom
import ginv

# assur44.xml.gz    eco7.xml.gz         ilias12.xml.gz         rbpl24.xml.gz
# boon.xml.gz       eco8.xml.gz         ilias13.xml.gz         rbpl.xml.gz
# butcher8.xml.gz   eco9.xml.gz         ilias_k_2.xml.gz       redcyc5.xml.gz
# butcher.xml.gz    extcyc4.xml.gz      ilias_k_3.xml.gz       redcyc6.xml.gz
# camera1s.xml.gz   extcyc5.xml.gz      jcf26.xml.gz           redcyc7.xml.gz
# caprasse.xml.gz   extcyc6.xml.gz      katsura10.xml.gz       redcyc8.xml.gz
# cassou.xml.gz     extcyc7.xml.gz      katsura6.xml.gz        redeco10.xml.gz
# chandra4.xml.gz   extcyc8.xml.gz      katsura7.xml.gz        redeco11.xml.gz
# chandra5.xml.gz   f633.xml.gz         katsura8.xml.gz        redeco12.xml.gz
# chandra6.xml.gz   f744.xml.gz         katsura9.xml.gz        redeco7.xml.gz
# chemequs.xml.gz   f855.xml.gz         kin1.xml.gz            redeco8.xml.gz
# chemequ.xml.gz    f966.xml.gz         kinema.xml.gz          redeco9.xml.gz
# chemkin.xml.gz    fabrice24.xml.gz    kotsireas.xml.gz       reif.xml.gz
# cohn2.xml.gz      filter9.xml.gz      ku10.xml.gz            reimer4.xml.gz
# cohn3.xml.gz      geneig.xml.gz       lanconelli.xml.gz      reimer5.xml.gz
# comb3000s.xml.gz  hairer1.xml.gz      lorentz.xml.gz         reimer6.xml.gz
# comb3000.xml.gz   hairer2.xml.gz      matrix.xml.gz          reimer7.xml.gz
# conform1.xml.gz   hairer3.xml.gz      mckay.gls50mod.xml.gz  reimer8.xml.gz
# cpdm5.xml.gz      hairer4.xml.gz      mickey.xml.gz          rose.xml.gz
# cyclic5.xml.gz    hcyclic5.xml.gz     morgenstern.xml.gz     s9_1.xml.gz
# cyclic6.xml.gz    hcyclic6.xml.gz     noon5.xml.gz           solotarev.xml.gz
# cyclic7.xml.gz    hcyclic7.xml.gz     noon6.xml.gz           sparse5.xml.gz
# cyclic8.xml.gz    hcyclic8.xml.gz     noon7.xml.gz           speer.xml.gz
# d1.xml.gz         heart.xml.gz        noon8.xml.gz           tangents.xml.gz
# des18_3.xml.gz    hemmecke.xml.gz     noon9.xml.gz           test.xml.gz
# des22_24.xml.gz   hf744.xml.gz        pinchon1.xml.gz        uteshev_bikker.xml.gz
# discret3.xml.gz   hf855.xml.gz        puma.xml.gz            vernov1.xml.gz
# dl.xml.gz         hietarinta1.xml.gz  quadfor2.xml.gz        virasoro.xml.gz
# eco10.xml.gz      hunecke.xml.gz      quadgrid.xml.gz        wright.xml.gz
# eco11.xml.gz      i1.xml.gz           rabmo.xml.gz

folder = "../examples/polynomial/"
fname = "cyclic7.xml.gz"

def readExample(fname):
  try:
    file = GzipFile(fname, 'rb')
    doc = xml.dom.minidom.parse(file)
    root = doc.documentElement
    description = root.getElementsByTagName('Description').item(0).firstChild.nodeValue.strip()
    systemType = root.getElementsByTagName('SystemType').item(0).getAttribute("System")
    independ = map(lambda var: var.firstChild.nodeValue.strip(), root.getElementsByTagName('Variables').item(0).\
                                                                      getElementsByTagName('Independent').item(0).\
                                                                      getElementsByTagName('Variable'))
    equations = map(lambda eq: eq.firstChild.nodeValue.strip(), root.getElementsByTagName('Equations').item(0).\
                                                                     getElementsByTagName('Equation'))
    return (description, systemType, independ, equations)
  except Exception, val:
    print val
    return None

(description, systemType, independ, equations) = readExample(folder + fname)
print description

equations = map(lambda eq: eq.encode('latin1'), equations)

st = ginv.SystemType(systemType)
im = ginv.MonomInterface("DegRevLexByte", st, independ)
ic = ginv.CoeffInterface("GmpZ", st)
# ic = ginv.CoeffInterface("ModularShort", st, modularShort=2)
ip = ginv.PolyInterface("PolyList", st, im, ic)

lst = [\
"""3888*x4^2*x5^3*x6^3 + (-4464)*x3^2*x4*x5^4*x7 + 4464*x3^3*x5^3*x6*x7 + 4464*x3^2*x5^4*x6*x7 + (-8928)*x3*x5^4*x6^2*x7 + (-5150)*x3^2*x5^2*x6^3*x7 + 119656*x2*x4*x5^2*x6^3*x7 + 126112*x4^2*x5^2*x6^3*x7 + 46606*x2*x5^3*x6^3*x7 + 36992*x3*x5^3*x6^3*x7 + 335458*x4*x5^3*x6^3*x7 + 51070*x5^4*x6^3*x7 + (-576)*x2*x3*x5*x6^4*x7 + 9264*x2*x4*x5*x6^4*x7 + 19356*x3*x4*x5*x6^4*x7 + 9264*x4^2*x5*x6^4*x7 + 5208*x2*x5^2*x6^4*x7 + 58*x3*x5^2*x6^4*x7 + 138856*x4*x5^2*x6^4*x7 + 56964*x5^3*x6^4*x7 + 9264*x4*x5*x6^5*x7 + 4632*x5^2*x6^5*x7 + (-2232)*x3^4*x5^2*x7^2 + (-2232)*x3^3*x5^3*x7^2 + (-117440)*x3^2*x4*x5^3*x7^2 + (-37490)*x2*x4^2*x5^3*x7^2 + (-51374)*x4^3*x5^3*x7^2 + 2232*x2*x3*x5^4*x7^2 + 2232*x3^2*x5^4*x7^2 + (-2232)*x2*x4*x5^4*x7^2 + (-116806)*x3*x4*x5^4*x7^2 + (-55152)*x4^2*x5^4*x7^2 + 2232*x3*x5^5*x7^2 + (-2232)*x4*x5^5*x7^2 + 4658*x3*x4^4*x6*x7^2 + 4590*x3^4*x5*x6*x7^2 + 108156*x2*x4^3*x5*x6*x7^2 + 108156*x4^4*x5*x6*x7^2 + (-49676)*x3^3*x5^2*x6*x7^2 + (-254466)*x3^2*x5^3*x6*x7^2 + (-1267052)*x2*x4*x5^3*x6*x7^2 + (-174190)*x2*x5^4*x6*x7^2 + (-385550)*x3*x5^4*x6*x7^2 + (-1229882)*x4*x5^4*x6*x7^2 + (-174190)*x5^5*x6*x7^2 + 2232*x3^4*x6^2*x7^2 + 4064*x3^2*x4^2*x6^2*x7^2 + 4658*x2*x4^3*x6^2*x7^2 + 21864*x3*x4^3*x6^2*x7^2 + 4658*x4^4*x6^2*x7^2 + 6078*x3^3*x5*x6^2*x7^2 + 12459162*x3*x4^2*x5*x6^2*x7^2 + 112814*x4^3*x5*x6^2*x7^2 + 362278*x2*x3*x5^2*x6^2*x7^2 + 201160*x3^2*x5^2*x6^2*x7^2 + (-9387058)*x2*x4*x5^2*x6^2*x7^2 + (-1800122)*x3*x4*x5^2*x6^2*x7^2 + 243782*x4^2*x5^2*x6^2*x7^2 + (-1061368)*x2*x5^3*x6^2*x7^2 + (-965744)*x3*x5^3*x6^2*x7^2 + (-10464220)*x4*x5^3*x6^2*x7^2 + (-1013232)*x5^4*x6^2*x7^2 + 13712*x3^3*x6^3*x7^2 + 52848*x2*x3*x4*x6^3*x7^2 + (-1054)*x3^2*x4*x6^3*x7^2 + 13948*x2*x4^2*x6^3*x7^2 + 47554*x3*x4^2*x6^3*x7^2 + 18606*x4^3*x6^3*x7^2 + (-490458)*x2*x3*x5*x6^3*x7^2 + (-54470)*x3^2*x5*x6^3*x7^2 + (-8768816)*x2*x4*x5*x6^3*x7^2 + 878288*x3*x4*x5*x6^3*x7^2 + (-8721768)*x4^2*x5*x6^3*x7^2 + (-3684082)*x2*x5^2*x6^3*x7^2 + (-3535216)*x3*x5^2*x6^3*x7^2 + 1122152*x4*x5^2*x6^3*x7^2 + (-4510454)*x5^3*x6^3*x7^2 + (-320)*x2*x3*x6^4*x7^2 + 16096*x3^2*x6^4*x7^2 + 4658*x2*x4*x6^4*x7^2 + 3284*x3*x4*x6^4*x7^2 + 18606*x4^2*x6^4*x7^2 + (-101702)*x2*x5*x6^4*x7^2 + (-171540)*x3*x5*x6^4*x7^2 + (-8787284)*x4*x5*x6^4*x7^2 + (-4218224)*x5^2*x6^4*x7^2 + (-4632)*x2*x6^5*x7^2 + (-16)*x3*x6^5*x7^2 + 26*x4*x6^5*x7^2 + (-111846)*x5*x6^5*x7^2 + (-4632)*x6^6*x7^2 + 6948*x3^4*x5*x7^3 + (-4953982)*x3*x4^3*x5*x7^3 + 814*x3^3*x5^2*x7^3 + (-2967276)*x3^2*x4*x5^2*x7^3 + 410490*x2*x4^2*x5^2*x7^3 + 3979296*x3*x4^2*x5^2*x7^3 + (-3024602)*x4^3*x5^2*x7^3 + (-1922)*x2*x3*x5^3*x7^3 + (-5824)*x3^2*x5^3*x7^3 + 233496*x2*x4*x5^3*x7^3 + (-1490976)*x3*x4*x5^3*x7^3 + 564780*x4^2*x5^3*x7^3 + 2232*x2*x5^4*x7^3 + 2542*x3*x5^4*x7^3 + 233496*x4*x5^4*x7^3 + 2232*x5^5*x7^3 + (-6948)*x3^4*x6*x7^3 + (-7049204)*x3^2*x4^2*x6*x7^3 + (-4658)*x2*x4^3*x6*x7^3 + (-7362118)*x3*x4^3*x6*x7^3 + (-4658)*x4^4*x6*x7^3 + 1056958*x3^3*x5*x6*x7^3 + 9888713*x3^2*x4*x5*x6*x7^3 + (-2918138)*x2*x4^2*x5*x6*x7^3 + (-583798)*x3*x4^2*x5*x6*x7^3 + (-2814640)*x4^3*x5*x6*x7^3 + (-3919924)*x2*x3*x5^2*x6*x7^3 + (-307656)*x3^2*x5^2*x6*x7^3 + 2391858*x2*x4*x5^2*x6*x7^3 + 2200582*x3*x4*x5^2*x6*x7^3 + 937351*x4^2*x5^2*x6*x7^3 + (-1372416)*x2*x5^3*x6*x7^3 + (-2879570)*x3*x5^3*x6*x7^3 + (-2446148)*x4*x5^3*x6*x7^3 + (-1542142)*x5^4*x6*x7^3 + (-104322)*x3^3*x6^2*x7^3 + 20600624*x2*x3*x4*x6^2*x7^3 + 6554668*x3^2*x4*x6^2*x7^3 + (-4182618)*x2*x4^2*x6^2*x7^3 + (-9181548)*x3*x4^2*x6^2*x7^3 + (-4182618)*x4^3*x6^2*x7^3 + 34159672*x2*x3*x5*x6^2*x7^3 + 13633268*x3^2*x5*x6^2*x7^3 + 25419844*x2*x4*x5*x6^2*x7^3 + 78471818*x3*x4*x5*x6^2*x7^3 + 21422230*x4^2*x5*x6^2*x7^3 + 15550700*x2*x5^2*x6^2*x7^3 + 27912196*x3*x5^2*x6^2*x7^3 + 41710938*x4*x5^2*x6^2*x7^3 + 10835378*x5^3*x6^2*x7^3 + (-2298190)*x2*x3*x6^3*x7^3 + 4237916*x3^2*x6^3*x7^3 + 184202*x2*x4*x6^3*x7^3 + 4454574*x3*x4*x6^3*x7^3 + (-3961036)*x4^2*x6^3*x7^3 + (-805952)*x2*x5*x6^3*x7^3 + 16223642*x3*x5*x6^3*x7^3 + 46146016*x4*x5*x6^3*x7^3 + 43787532*x5^2*x6^3*x7^3 + 4364306*x2*x6^4*x7^3 + 8685716*x3*x6^4*x7^3 + 4598710*x4*x6^4*x7^3 + (-3588938)*x5*x6^4*x7^3 + 4354738*x6^5*x7^3 + 4113372*x3^2*x4^2*x7^4 + 4953982*x3*x4^3*x7^4 + 2658582*x3^3*x5*x7^4 + 12836311*x2*x3*x4*x5*x7^4 + (-3665580)*x3^2*x4*x5*x7^4 + 8029958*x2*x4^2*x5*x7^4 + (-6805814)*x3*x4^2*x5*x7^4 + 8029958*x4^3*x5*x7^4 + 2765938*x2*x3*x5^2*x7^4 + 5096838*x3^2*x5^2*x7^4 + (-2174800)*x2*x4*x5^2*x7^4 + (-3266726)*x3*x4*x5^2*x7^4 + (-1704434)*x4^2*x5^2*x7^4 +(-176112)*x2*x5^3*x7^4 + 2271072*x3*x5^3*x7^4 + (-1800584)*x4*x5^3*x7^4 + (-173880)*x5^4*x7^4 + (-2658582)*x3^3*x6*x7^4 + (-19913510)*x2*x3*x4*x6*x7^4 +(-11131996)*x3^2*x4*x6*x7^4 + 9235466*x2*x4^2*x6*x7^4 + (-2642298)*x3*x4^2*x6*x7^4 + 9230808*x4^3*x6*x7^4 + 7911742*x2*x3*x5*x6*x7^4 + (-3464098)*x3^2*x5*x6*x7^4 + 1722484*x2*x4*x5*x6*x7^4 + 3889531*x3*x4*x5*x6*x7^4 + 9588170*x4^2*x5*x6*x7^4 + (-6659050)*x2*x5^2*x6*x7^4 + (-14514656)*x3*x5^2*x6*x7^4 + 12192438*x4*x5^2*x6*x7^4 + (-8385922)*x5^3*x6*x7^4 + (-69356875)*x2*x3*x6^2*x7^4 + (-26114050)*x3^2*x6^2*x7^4 + (-29796390)*x2*x4*x6^2*x7^4 + (-101685399)*x3*x4*x6^2*x7^4 + (-23011262)*x4^2*x6^2*x7^4 + (-39720182)*x2*x5*x6^2*x7^4 + (-55366494)*x3*x5*x6^2*x7^4 + (-88418067)*x4*x5*x6^2*x7^4 + (-28258493)*x5^2*x6^2*x7^4 + (-17218734)*x2*x6^3*x7^4 + (-36160612)*x3*x6^3*x7^4 + (-49274580)*x4*x6^3*x7^4 + (-65761591)*x5*x6^3*x7^4 + (-19480892)*x6^4*x7^4 + (-12499857)*x2*x3*x4*x7^5 + 1978978*x3^2*x4*x7^5 + (-4953982)*x2*x4^2*x7^5 + 1978978*x3*x4^2*x7^5 + (-4953982)*x4^3*x7^5 + 4310266*x2*x3*x5*x7^5 + 9657552*x3^2*x5*x7^5 + 10465880*x2*x4*x5*x7^5 + (-2229901)*x3*x4*x5*x7^5 + 13541856*x4^2*x5*x7^5 + 1221370*x2*x5^2*x7^5 + 10676394*x3*x5^2*x7^5 + 6816798*x4*x5^2*x7^5 + 1045258*x5^3*x7^5 + 25917673*x2*x3*x6*x7^5 + 12189228*x3^2*x6*x7^5 + 33502582*x2*x4*x6*x7^5 + 49426627*x3*x4*x6*x7^5 + 37784066*x4^2*x6*x7^5 + (-22337041)*x2*x5*x6*x7^5 + (-6810803)*x3*x5*x6*x7^5 + 27928202*x4*x5*x6*x7^5 + (-25741343)*x5^2*x6*x7^5 + 39125221*x2*x6^2*x7^5 + 33247959*x3*x6^2*x7^5 + 46226061*x4*x6^2*x7^5 + (-11610093)*x5*x6^2*x7^5 + (-24080630)*x6^3*x7^5 + 2294135*x2*x3*x7^6 + (-6092350)*x3^2*x7^6 + (-11046332)*x2*x4*x7^6 + (-6773219)*x3*x4*x7^6 + (-16000314)*x4^2*x7^6 + (-1680152)*x2*x5*x7^6 + (-766584)*x3*x5*x7^6 + 6125881*x4*x5*x7^6 + (-458782)*x5^2*x7^6 + 24372868*x2*x6*x7^6 + 33121380*x3*x6*x7^6 + 46829118*x4*x6*x7^6 + (-8432327)*x5*x6*x7^6 + 74574900*x6^2*x7^6 + (-14478835)*x2*x7^7 + (-20571185)*x3*x7^7 + (-25525167)*x4*x7^7 + (-16158987)*x5*x7^7 + 18280518*x6*x7^7 + (-14478835)*x7^8 + 4736816*x2 + 3353882*x3 + 8435884*x4 + 4175106*x5 + (-15798036)*x6 + (-11913129)*x7""",\
"""(-192)*x4^2*x5^3*x6^3 + 144*x3^2*x4*x5^4*x7 + (-144)*x3^3*x5^3*x6*x7 + (-144)*x3^2*x5^4*x6*x7 + 288*x3*x5^4*x6^2*x7 + 94*x3^2*x5^2*x6^3*x7 + (-4448)*x2*x4*x5^2*x6^3*x7 + (-4856)*x4^2*x5^2*x6^3*x7 + (-1742)*x2*x5^3*x6^3*x7 + (-1504)*x3*x5^3*x6^3*x7 + (-12458)*x4*x5^3*x6^3*x7 + (-1886)*x5^4*x6^3*x7 + (-48)*x2*x3*x5*x6^4*x7 + (-432)*x2*x4*x5*x6^4*x7 + (-924)*x3*x4*x5*x6^4*x7 + (-432)*x4^2*x5*x6^4*x7 + (-168)*x2*x5^2*x6^4*x7 + (-74)*x3*x5^2*x6^4*x7 + (-5600)*x4*x5^2*x6^4*x7 + (-2004)*x5^3*x6^4*x7 + (-432)*x4*x5*x6^5*x7 + (-216)*x5^2*x6^5*x7 + 72*x3^4*x5^2*x7^2 + 72*x3^3*x5^3*x7^2 + 4432*x3^2*x4*x5^3*x7^2 + 1570*x2*x4^2*x5^3*x7^2 + 1918*x4^3*x5^3*x7^2 + (-72)*x2*x3*x5^4*x7^2 + (-72)*x3^2*x5^4*x7^2 + 72*x2*x4*x5^4*x7^2 + 4406*x3*x4*x5^4*x7^2 + 2112*x4^2*x5^4*x7^2 + (-72)*x3*x5^5*x7^2 + 72*x4*x5^5*x7^2 + (-178)*x3*x4^4*x6*x7^2 + (-198)*x3^4*x5*x6*x7^2 + (-4188)*x2*x4^3*x5*x6*x7^2 + (-4188)*x4^4*x5*x6*x7^2 + 1780*x3^3*x5^2*x6*x7^2 + 9690*x3^2*x5^3*x6*x7^2 + 47908*x2*x4*x5^3*x6*x7^2 + 6590*x2*x5^4*x6*x7^2 + 14662*x3*x5^4*x6*x7^2 + 46426*x4*x5^4*x6*x7^2 + 6590*x5^5*x6*x7^2 + (-72)*x3^4*x6^2*x7^2 + 224*x3^2*x4^2*x6^2*x7^2 + (-178)*x2*x4^3*x6^2*x7^2 + (-672)*x3*x4^3*x6^2*x7^2 + (-178)*x4^4*x6^2*x7^2 + (-246)*x3^3*x5*x6^2*x7^2 + (-471402)*x3*x4^2*x5*x6^2*x7^2 + (-4366)*x4^3*x5*x6^2*x7^2 + (-13190)*x2*x3*x5^2*x6^2*x7^2 + (-7976)*x3^2*x5^2*x6^2*x7^2 + 356378*x2*x4*x5^2*x6^2*x7^2 + 69082*x3*x4*x5^2*x6^2*x7^2 + (-8158)*x4^2*x5^2*x6^2*x7^2 + 40352*x2*x5^3*x6^2*x7^2 + 36424*x3*x5^3*x6^2*x7^2 + 397700*x4*x5^3*x6^2*x7^2 + 38544*x5^4*x6^2*x7^2 + (-520)*x3^3*x6^3*x7^2 + (-2304)*x2*x3*x4*x6^3*x7^2 + 206*x3^2*x4*x6^3*x7^2 + (-572)*x2*x4^2*x6^3*x7^2 + (-1706)*x3*x4^2*x6^3*x7^2 + (-750)*x4^3*x6^3*x7^2 + 17802*x2*x3*x5*x6^3*x7^2 + 1918*x3^2*x5*x6^3*x7^2 + 331480*x2*x4*x5*x6^3*x7^2 + (-34768)*x3*x4*x5*x6^3*x7^2 + 329352*x4^2*x5*x6^3*x7^2 + 139154*x2*x5^2*x6^3*x7^2 + 132704*x3*x5^2*x6^3*x7^2 + (-42568)*x4*x5^2*x6^3*x7^2 + 171526*x5^3*x6^3*x7^2 + 88*x2*x3*x6^4*x7^2 + (-608)*x3^2*x6^4*x7^2 + (-178)*x2*x4*x6^4*x7^2 + 116*x3*x4*x6^4*x7^2 + (-750)*x4^2*x6^4*x7^2 + 4174*x2*x5*x6^4*x7^2 + 6732*x3*x5*x6^4*x7^2 + 331876*x4*x5*x6^4*x7^2 + 158920*x5^2*x6^4*x7^2 + 216*x2*x6^5*x7^2 + 56*x3*x6^5*x7^2 + 38*x4*x6^5*x7^2 + 4590*x5*x6^5*x7^2 + 216*x6^6*x7^2 + (-324)*x3^4*x5*x7^3 + 186710*x3*x4^3*x5*x7^3 + (-398)*x3^3*x5^2*x7^3 + 112164*x3^2*x4*x5^2*x7^3 + (-15522)*x2*x4^2*x5^2*x7^3 + (-149304)*x3*x4^2*x5^2*x7^3 + 114274*x4^3*x5^2*x7^3 + (-110)*x2*x3*x5^3*x7^3 + (-256)*x3^2*x5^3*x7^3 + (-8664)*x2*x4*x5^3*x7^3 + 56352*x3*x4*x5^3*x7^3 + (-21348)*x4^2*x5^3*x7^3 + (-72)*x2*x5^4*x7^3 + (-254)*x3*x5^4*x7^3 +(-8664)*x4*x5^4*x7^3 + (-72)*x5^5*x7^3 + 324*x3^4*x6*x7^3 + 267220*x3^2*x4^2*x6*x7^3 + 178*x2*x4^3*x6*x7^3 + 278174*x3*x4^3*x6*x7^3 + 178*x4^4*x6*x7^3 +(-39494)*x3^3*x5*x6*x7^3 + (-374089)*x3^2*x4*x5*x6*x7^3 + 109042*x2*x4^2*x5*x6*x7^3 + 22766*x3*x4^2*x5*x6*x7^3 + 105032*x4^3*x5*x6*x7^3 + 149708*x2*x3*x5^2*x6*x7^3 + 12288*x3^2*x5^2*x6*x7^3 + (-91122)*x2*x4*x5^2*x6*x7^3 + (-80846)*x3*x4*x5^2*x6*x7^3 + (-34895)*x4^2*x5^2*x6*x7^3 + 52128*x2*x5^3*x6*x7^3 + 109762*x3*x5^3*x6*x7^3 + 92668*x4*x5^3*x6*x7^3 + 58574*x5^4*x6*x7^3 + 4314*x3^3*x6^2*x7^3 + (-779632)*x2*x3*x4*x6^2*x7^3 + (-247916)*x3^2*x4*x6^2*x7^3 + 158010*x2*x4^2*x6^2*x7^3 + 346980*x3*x4^2*x6^2*x7^3 + 158010*x4^3*x6^2*x7^3 + (-1294232)*x2*x3*x5*x6^2*x7^3 + (-515596)*x3^2*x5*x6^2*x7^3 + (-963332)*x2*x4*x5*x6^2*x7^3 + (-2972074)*x3*x4*x5*x6^2*x7^3 + (-813254)*x4^2*x5*x6^2*x7^3 + (-589300)*x2*x5^2*x6^2*x7^3 + (-1058012)*x3*x5^2*x6^2*x7^3 + (-1579362)*x4*x5^2*x6^2*x7^3 + (-409978)*x5^3*x6^2*x7^3 + 87590*x2*x3*x6^3*x7^3 + (-159988)*x3^2*x6^3*x7^3 + (-6802)*x2*x4*x6^3*x7^3 + (-167382)*x3*x4*x6^3*x7^3 + 149636*x4^2*x6^3*x7^3 + 31336*x2*x5*x6^3*x7^3 + (-613954)*x3*x5*x6^3*x7^3 + (-1747136)*x4*x5*x6^3*x7^3 + (-1657884)*x5^2*x6^3*x7^3 + (-164914)*x2*x6^4*x7^3+ (-328300)*x3*x6^4*x7^3 + (-173918)*x4*x6^4*x7^3 + 136906*x5*x6^4*x7^3 + (-164450)*x6^5*x7^3 + (-155460)*x3^2*x4^2*x7^4 + (-186710)*x3*x4^3*x7^4 + (-100758)*x3^3*x5*x7^4 + (-485879)*x2*x3*x4*x5*x7^4 + 138252*x3^2*x4*x5*x7^4 + (-302902)*x2*x4^2*x5*x7^4 + 254758*x3*x4^2*x5*x7^4 + (-302902)*x4^3*x5*x7^4 + (-105242)*x2*x3*x5^2*x7^4 + (-193926)*x3^2*x5^2*x7^4 + 82328*x2*x4*x5^2*x7^4 + 121918*x3*x4*x5^2*x7^4 + 63898*x4^2*x5^2*x7^4 + 6480*x2*x5^3*x7^4 + (-86976)*x3*x5^3*x7^4 + 68248*x4*x5^3*x7^4 + 6408*x5^4*x7^4 + 100758*x3^3*x6*x7^4 + 755686*x2*x3*x4*x6*x7^4 + 420140*x3^2*x4*x6*x7^4 + (-348514)*x2*x4^2*x6*x7^4 + 101298*x3*x4^2*x6*x7^4 + (-348336)*x4^3*x6*x7^4 + (-297302)*x2*x3*x5*x6*x7^4 + 133922*x3^2*x5*x6*x7^4 + (-66572)*x2*x4*x5*x6*x7^4 + (-143243)*x3*x4*x5*x6*x7^4 + (-364186)*x4^2*x5*x6*x7^4 + 251666*x2*x5^2*x6*x7^4 + 551152*x3*x5^2*x6*x7^4 + (-463830)*x4*x5^2*x6*x7^4 + 316826*x5^3*x6*x7^4 + 2625947*x2*x3*x6^2*x7^4 + 989138*x3^2*x6^2*x7^4 + 1126710*x2*x4*x6^2*x7^4 + 3848415*x3*x4*x6^2*x7^4 + 870694*x4^2*x6^2*x7^4 + 1502638*x2*x5*x6^2*x7^4 + 2095566*x3*x5*x6^2*x7^4 + 3346299*x4*x5*x6^2*x7^4 + 1068997*x5^2*x6^2*x7^4 + 650670*x2*x6^3*x7^4 + 1367900*x3*x6^3*x7^4 + 1862916*x4*x6^3*x7^4 + 2487599*x5*x6^3*x7^4 +737020*x6^4*x7^4 + 471225*x2*x3*x4*x7^5 + (-74330)*x3^2*x4*x7^5 + 186710*x2*x4^2*x7^5 + (-74330)*x3*x4^2*x7^5 + 186710*x4^3*x7^5 + (-163082)*x2*x3*x5*x7^5 + (-365664)*x3^2*x5*x7^5 + (-394480)*x2*x4*x5*x7^5 + 83165*x3*x4*x5*x7^5 + (-510672)*x4^2*x5*x7^5 + (-46562)*x2*x5^2*x7^5 + (-405138)*x3*x5^2*x7^5 + (-256566)*x4*x5^2*x7^5 + (-40082)*x5^3*x7^5 + (-982745)*x2*x3*x6*x7^5 + (-459948)*x3^2*x6*x7^5 + (-1265462)*x2*x4*x6*x7^5 + (-1871147)*x3*x4*x6*x7^5 + (-1427266)*x4^2*x6*x7^5 + 845369*x2*x5*x6*x7^5 + 261835*x3*x5*x6*x7^5 + (-1059466)*x4*x5*x6*x7^5 + 973567*x5^2*x6*x7^5 + (-1483565)*x2*x6^2*x7^5 + (-1259415)*x3*x6^2*x7^5 + (-1749621)*x4*x6^2*x7^5 + 434733*x5*x6^2*x7^5 + 908086*x6^3*x7^5 + (-85975)*x2*x3*x7^6 + 229790*x3^2*x7^6 + 416500*x2*x4*x7^6 + 256195*x3*x4*x7^6 + 603210*x4^2*x7^6 + 62632*x2*x5*x7^6 + 27192*x3*x5*x7^6 + (-231113)*x4*x5*x7^6 + 16070*x5^2*x7^6 + (-915044)*x2*x6*x7^6 + (-1245636)*x3*x6*x7^6 + (-1764006)*x4*x6*x7^6 + 324895*x5*x6*x7^6 + (-2820972)*x6^2*x7^6 + 545555*x2*x7^7 + 775345*x3*x7^7 + 962055*x4*x7^7 + 608187*x5*x7^7 + (-685254)*x6*x7^7 + 545555*x7^8 + (-179344)*x2 + (-127426)*x3 + (-319220)*x4 + (-158034)*x5 + 597900*x6 + 449169*x7""",\
"""(-144)*x4^2*x5^3*x6^3 + 144*x3^2*x4*x5^4*x7 + (-144)*x3^3*x5^3*x6*x7 + (-144)*x3^2*x5^4*x6*x7 + 288*x3*x5^4*x6^2*x7 + 146*x3^2*x5^2*x6^3*x7 + (-4024)*x2*x4*x5^2*x6^3*x7 + (-4288)*x4^2*x5^2*x6^3*x7 + (-1570)*x2*x5^3*x6^3*x7 + (-1280)*x3*x5^3*x6^3*x7 + (-11278)*x4*x5^3*x6^3*x7 + (-1714)*x5^4*x6^3*x7 + (-336)*x2*x4*x5*x6^4*x7 + (-708)*x3*x4*x5*x6^4*x7 + (-336)*x4^2*x5*x6^4*x7 + (-168)*x2*x5^2*x6^4*x7 + (-22)*x3*x5^2*x6^4*x7 + (-4792)*x4*x5^2*x6^4*x7 + (-1884)*x5^3*x6^4*x7 + (-336)*x4*x5*x6^5*x7 + (-168)*x5^2*x6^5*x7 + 72*x3^4*x5^2*x7^2 + 72*x3^3*x5^3*x7^2 + 3968*x3^2*x4*x5^3*x7^2 + 1310*x2*x4^2*x5^3*x7^2 + 1730*x4^3*x5^3*x7^2 + (-72)*x2*x3*x5^4*x7^2 + (-72)*x3^2*x5^4*x7^2 + 72*x2*x4*x5^4*x7^2 + 3946*x3*x4*x5^4*x7^2 + 1872*x4^2*x5^4*x7^2 + (-72)*x3*x5^5*x7^2+ 72*x4*x5^5*x7^2 + (-158)*x3*x4^4*x6*x7^2 + (-162)*x3^4*x5*x6*x7^2 + (-3684)*x2*x4^3*x5*x6*x7^2 + (-3684)*x4^4*x5*x6*x7^2 + 1652*x3^3*x5^2*x6*x7^2 + 8622*x3^2*x5^3*x6*x7^2 + 42836*x2*x4*x5^3*x6*x7^2 + 5890*x2*x5^4*x6*x7^2 + 13058*x3*x5^4*x6*x7^2 + 41558*x4*x5^4*x6*x7^2 + 5890*x5^5*x6*x7^2 + (-72)*x3^4*x6^2*x7^2 + (-32)*x3^2*x4^2*x6^2*x7^2 + (-158)*x2*x4^3*x6^2*x7^2 + (-696)*x3*x4^3*x6^2*x7^2 + (-158)*x4^4*x6^2*x7^2 + (-210)*x3^3*x5*x6^2*x7^2 + (-421302)*x3*x4^2*x5*x6^2*x7^2 + (-3842)*x4^3*x5*x6^2*x7^2 + (-12106)*x2*x3*x5^2*x6^2*x7^2 + (-6904)*x3^2*x5^2*x6^2*x7^2 + 317758*x2*x4*x5^2*x6^2*x7^2 + 61142*x3*x4*x5^2*x6^2*x7^2 + (-7946)*x4^2*x5^2*x6^2*x7^2 + 35944*x2*x5^3*x6^2*x7^2 + 32624*x3*x5^3*x6^2*x7^2 + 354340*x4*x5^3*x6^2*x7^2 + 34320*x5^4*x6^2*x7^2 + (-464)*x3^3*x6^3*x7^2 + (-1872)*x2*x3*x4*x6^3*x7^2 + 82*x3^2*x4*x6^3*x7^2 + (-484)*x2*x4^2*x6^3*x7^2 + (-1582)*x3*x4^2*x6^3*x7^2 + (-642)*x4^3*x6^3*x7^2 +16374*x2*x3*x5*x6^3*x7^2 + 1802*x3^2*x5*x6^3*x7^2 + 296432*x2*x4*x5*x6^3*x7^2 + (-30128)*x3*x4*x5*x6^3*x7^2 + 294744*x4^2*x5*x6^3*x7^2 + 124510*x2*x5^2*x6^3*x7^2 + 119248*x3*x5^2*x6^3*x7^2 + (-37976)*x4*x5^2*x6^3*x7^2 + 152762*x5^3*x6^3*x7^2 + 32*x2*x3*x6^4*x7^2 + (-544)*x3^2*x6^4*x7^2 + (-158)*x2*x4*x6^4*x7^2 + (-44)*x3*x4*x6^4*x7^2 + (-642)*x4^2*x6^4*x7^2 + 3530*x2*x5*x6^4*x7^2 + 5868*x3*x5*x6^4*x7^2 + 296972*x4*x5*x6^4*x7^2 + 142448*x5^2*x6^4*x7^2 + 168*x2*x6^5*x7^2 + 16*x3*x6^5*x7^2 + 10*x4*x6^5*x7^2 + 3882*x5*x6^5*x7^2 + 168*x6^6*x7^2 + (-252)*x3^4*x5*x7^3 + 167314*x3*x4^3*x5*x7^3 + (-130)*x3^3*x5^2*x7^3 + 100308*x3^2*x4*x5^2*x7^3 + (-13878)*x2*x4^2*x5^2*x7^3 + (-134208)*x3*x4^2*x5^2*x7^3 + 102230*x4^3*x5^2*x7^3 + 14*x2*x3*x5^3*x7^3 + 64*x3^2*x5^3*x7^3 + (-7848)*x2*x4*x5^3*x7^3 + 50400*x3*x4*x5^3*x7^3 + (-19092)*x4^2*x5^3*x7^3 + (-72)*x2*x5^4*x7^3 + (-130)*x3*x5^4*x7^3 + (-7848)*x4*x5^4*x7^3 + (-72)*x5^5*x7^3 + 252*x3^4*x6*x7^3 + 238508*x3^2*x4^2*x6*x7^3 + 158*x2*x4^3*x6*x7^3 + 248842*x3*x4^3*x6*x7^3 + 158*x4^4*x6*x7^3 + (-35602)*x3^3*x5*x6*x7^3 + (-334367)*x3^2*x4*x5*x6*x7^3 + 98294*x2*x4^2*x5*x6*x7^3 + 19930*x3*x4^2*x5*x6*x7^3 + 94768*x4^3*x5*x6*x7^3 + 132940*x2*x3*x5^2*x6*x7^3 + 10584*x3^2*x5^2*x6*x7^3 + (-81054)*x2*x4*x5^2*x6*x7^3 + (-73738)*x3*x4*x5^2*x6*x7^3 + (-31537)*x4^2*x5^2*x6*x7^3 + 46464*x2*x5^3*x6*x7^3 + 97598*x3*x5^3*x6*x7^3 + 82748*x4*x5^3*x6*x7^3 + 52210*x5^4*x6*x7^3 + 3630*x3^3*x6^2*x7^3 + (-696656)*x2*x3*x4*x6^2*x7^3 + (-221620)*x3^2*x4*x6^2*x7^3 + 141366*x2*x4^2*x6^2*x7^3 + 310356*x3*x4^2*x6^2*x7^3 + 141366*x4^3*x6^2*x7^3 + (-1155592)*x2*x3*x5*x6^2*x7^3 + (-460940)*x3^2*x5*x6^2*x7^3 + (-859996)*x2*x4*x5*x6^2*x7^3 + (-2654342)*x3*x4*x5*x6^2*x7^3 + (-725146)*x4^2*x5*x6^2*x7^3 + (-526100)*x2*x5^2*x6^2*x7^3 + (-944380)*x3*x5^2*x6^2*x7^3 + (-1410774)*x4*x5^2*x6^2*x7^3 + (-366398)*x5^3*x6^2*x7^3 + 77890*x2*x3*x6^3*x7^3 + (-143204)*x3^2*x6^3*x7^3 + (-6182)*x2*x4*x6^3*x7^3 + (-150306)*x3*x4*x6^3*x7^3 + 133876*x4^2*x6^3*x7^3 + 27488*x2*x5*x6^3*x7^3 + (-548630)*x3*x5*x6^3*x7^3 + (-1560736)*x4*x5*x6^3*x7^3 + (-1480980)*x5^2*x6^3*x7^3 + (-147518)*x2*x6^4*x7^3 + (-293612)*x3*x6^4*x7^3 + (-155482)*x4*x6^4*x7^3 + 121670*x5*x6^4*x7^3 + (-147166)*x6^5*x7^3 + (-139044)*x3^2*x4^2*x7^4 + (-167314)*x3*x4^3*x7^4 + (-89946)*x3^3*x5*x7^4 + (-434113)*x2*x3*x4*x5*x7^4 + 123828*x3^2*x4*x5*x7^4 + (-271274)*x2*x4^2*x5*x7^4 + 229370*x3*x4^2*x5*x7^4 + (-271274)*x4^3*x5*x7^4 + (-93694)*x2*x3*x5^2*x7^4 + (-172650)*x3^2*x5^2*x7^4 + 73552*x2*x4*x5^2*x7^4 + 109994*x3*x4*x5^2*x7^4 + 57470*x4^2*x5^2*x7^4 + 5904*x2*x5^3*x7^4 + (-77088)*x3*x5^3*x7^4 + 60920*x4*x5^3*x7^4 + 5832*x5^4*x7^4 + 89946*x3^3*x6*x7^4 + 673994*x2*x3*x4*x6*x7^4 + 376132*x3^2*x4*x6*x7^4 + (-312038)*x2*x4^2*x6*x7^4 + 89718*x3*x4^2*x6*x7^4 + (-311880)*x4^3*x6*x7^4 + (-266962)*x2*x3*x5*x6*x7^4 + 117934*x3^2*x5*x6*x7^4 + (-58636)*x2*x4*x5*x6*x7^4 + (-130429)*x3*x4*x5*x6*x7^4 + (-324614)*x4^2*x5*x6*x7^4+ 225094*x2*x5^2*x6*x7^4 + 491360*x3*x5^2*x6*x7^4 + (-412986)*x4*x5^2*x6*x7^4 + 283438*x5^3*x6*x7^4 + 2345773*x2*x3*x6^2*x7^4 + 883342*x3^2*x6^2*x7^4 + 1007370*x2*x4*x6^2*x7^4 + 3438753*x3*x4*x6^2*x7^4 + 778130*x4^2*x6^2*x7^4 + 1343066*x2*x5*x6^2*x7^4 + 1872402*x3*x5*x6^2*x7^4 + 2990085*x4*x5*x6^2*x7^4 +955499*x5^2*x6^2*x7^4 + 582018*x2*x6^3*x7^4 + 1222684*x3*x6^3*x7^4 + 1665804*x4*x6^3*x7^4 + 2223553*x5*x6^3*x7^4 + 658724*x6^4*x7^4 + 422199*x2*x3*x4*x7^5 + (-66766)*x3^2*x4*x7^5 + 167314*x2*x4^2*x7^5 + (-66766)*x3*x4^2*x7^5 + 167314*x4^3*x7^5 + (-145750)*x2*x3*x5*x7^5 + (-326640)*x3^2*x5*x7^5 + (-353480)*x2*x4*x5*x7^5 + 75067*x3*x4*x5*x7^5 + (-457440)*x4^2*x5*x7^5 + (-41398)*x2*x5^2*x7^5 + (-361350)*x3*x5^2*x7^5 + (-230130)*x4*x5^2*x7^5 + (-35494)*x5^3*x7^5 + (-876991)*x2*x3*x6*x7^5 + (-411828)*x3^2*x6*x7^5 + (-1132282)*x2*x4*x6*x7^5 + (-1671637)*x3*x4*x6*x7^5 + (-1277006)*x4^2*x6*x7^5 + 755383*x2*x5*x6*x7^5 + 231461*x3*x5*x6*x7^5 + (-945158)*x4*x5*x6*x7^5 + 870329*x5^2*x6*x7^5 + (-1323907)*x2*x6^2*x7^5 + (-1124673)*x3*x6^2*x7^5 + (-1563291)*x4*x6^2*x7^5 + 391323*x5*x6^2*x7^5 + 813434*x6^3*x7^5 + (-77345)*x2*x3*x7^6 + 205810*x3^2*x7^6 + 373124*x2*x4*x7^6 + 229013*x3*x4*x7^6 + 540438*x4^2*x7^6 + 56552*x2*x5*x7^6 + 25416*x3*x5*x7^6 + (-206959)*x4*x5*x7^6 + 15154*x5^2*x7^6 + (-822172)*x2*x6*x7^6 + (-1117884)*x3*x6*x7^6 + (-1581330)*x4*x6*x7^6 + 286769*x5*x6*x7^6 + (-2521548)*x6^2*x7^6 + 488965*x2*x7^7 + 694775*x3*x7^7 + 862089*x4*x7^7 + 545517*x5*x7^7 + (-616362)*x6*x7^7 + 488965*x7^8 + (-160208)*x2 + (-113558)*x3 + (-285268)*x4 + (-141198)*x5 + 534252*x6 + 402399*x7""",\
"""18*x4^2*x5^3*x6^3 + (-36)*x3^2*x4*x5^4*x7 + 36*x3^3*x5^3*x6*x7 + 36*x3^2*x5^4*x6*x7 + (-72)*x3*x5^4*x6^2*x7 + (-56)*x3^2*x5^2*x6^3*x7 + 847*x2*x4*x5^2*x6^3*x7 + 859*x4^2*x5^2*x6^3*x7 + 328*x2*x5^3*x6^3*x7 + 236*x3*x5^3*x6^3*x7 + 2377*x4*x5^3*x6^3*x7 + 364*x5^4*x6^3*x7 + (-18)*x2*x3*x5*x6^4*x7 + 48*x2*x4*x5*x6^4*x7 + 96*x3*x4*x5*x6^4*x7 + 48*x4^2*x5*x6^4*x7 + 42*x2*x5^2*x6^4*x7 + (-14)*x3*x5^2*x6^4*x7 + 895*x4*x5^2*x6^4*x7 + 426*x5^3*x6^4*x7 + 48*x4*x5*x6^5*x7 + 24*x5^2*x6^5*x7 + (-18)*x3^4*x5^2*x7^2 + (-18)*x3^3*x5^3*x7^2 + (-818)*x3^2*x4*x5^3*x7^2 + (-230)*x2*x4^2*x5^3*x7^2 + (-362)*x4^3*x5^3*x7^2 + 18*x2*x3*x5^4*x7^2 + 18*x3^2*x5^4*x7^2 + (-18)*x2*x4*x5^4*x7^2 + (-814)*x3*x4*x5^4*x7^2 + (-378)*x4^2*x5^4*x7^2 + 18*x3*x5^5*x7^2 + (-18)*x4*x5^5*x7^2 + 32*x3*x4^4*x6*x7^2 + 27*x3^4*x5*x6*x7^2 + 732*x2*x4^3*x5*x6*x7^2 + 732*x4^4*x5*x6*x7^2 + (-365)*x3^3*x5^2*x6*x7^2 + (-1755)*x3^2*x5^3*x6*x7^2 + (-8807)*x2*x4*x5^3*x6*x7^2 + (-1210)*x2*x5^4*x6*x7^2 + (-2663)*x3*x5^4*x6*x7^2 + (-8564)*x4*x5^4*x6*x7^2 + (-1210)*x5^5*x6*x7^2 + 18*x3^4*x6^2*x7^2 + 104*x3^2*x4^2*x6^2*x7^2 + 32*x2*x4^3*x6^2*x7^2 + 183*x3*x4^3*x6^2*x7^2 + 32*x4^4*x6^2*x7^2 + 39*x3^3*x5*x6^2*x7^2 + 86538*x3*x4^2*x5*x6^2*x7^2 + 764*x4^3*x5*x6^2*x7^2 +2620*x2*x3*x5^2*x6^2*x7^2 + 1324*x3^2*x5^2*x6^2*x7^2 + (-64957)*x2*x4*x5^2*x6^2*x7^2 + (-12308)*x3*x4*x5^2*x6^2*x7^2 + 1907*x4^2*x5^2*x6^2*x7^2 + (-7333)*x2*x5^3*x6^2*x7^2 + (-6731)*x3*x5^3*x6^2*x7^2 + (-72325)*x4*x5^3*x6^2*x7^2 + (-6996)*x5^4*x6^2*x7^2 + 95*x3^3*x6^3*x7^2 + 306*x2*x3*x4*x6^3*x7^2 + 26*x3^2*x4*x6^3*x7^2 + 88*x2*x4^2*x6^3*x7^2 + 349*x3*x4^2*x6^3*x7^2 + 120*x4^3*x6^3*x7^2 + (-3558)*x2*x3*x5*x6^3*x7^2 + (-407)*x3^2*x5*x6^3*x7^2 + (-60965)*x2*x4*x5*x6^3*x7^2 + 5792*x3*x4*x5*x6^3*x7^2 + (-60708)*x4^2*x5*x6^3*x7^2 + (-25636)*x2*x5^2*x6^3*x7^2 + (-24766)*x3*x5^2*x6^3*x7^2 + 7772*x4*x5^2*x6^3*x7^2 + (-31154)*x5^3*x6^3*x7^2 + 13*x2*x3*x6^4*x7^2 + 112*x3^2*x6^4*x7^2 + 32*x2*x4*x6^4*x7^2 + 71*x3*x4*x6^4*x7^2 + 120*x4^2*x6^4*x7^2 + (-641)*x2*x5*x6^4*x7^2 + (-1143)*x3*x5*x6^4*x7^2 + (-61154)*x4*x5*x6^4*x7^2 + (-29435)*x5^2*x6^4*x7^2 + (-24)*x2*x6^5*x7^2 + 11*x3*x6^5*x7^2 + 8*x4*x6^5*x7^2 + (-705)*x5*x6^5*x7^2 + (-24)*x6^6*x7^2 + 36*x3^4*x5*x7^3 + (-34555)*x3*x4^3*x5*x7^3 + (-68)*x3^3*x5^2*x7^3 + (-20631)*x3^2*x4*x5^2*x7^3 + 2853*x2*x4^2*x5^2*x7^3 + 27891*x3*x4^2*x5^2*x7^3 + (-21041)*x4^3*x5^2*x7^3 + (-50)*x2*x3*x5^3*x7^3 + (-136)*x3^2*x5^3*x7^3 + 1656*x2*x4*x5^3*x7^3 + (-10368)*x3*x4*x5^3*x7^3 + 3927*x4^2*x5^3*x7^3 + 18*x2*x5^4*x7^3 + (-14)*x3*x5^4*x7^3 + 1656*x4*x5^4*x7^3 + 18*x5^5*x7^3 + (-36)*x3^4*x6*x7^3 + (-48860)*x3^2*x4^2*x6*x7^3 + (-32)*x2*x4^3*x6*x7^3 + (-51211)*x3*x4^3*x6*x7^3 + (-32)*x4^4*x6*x7^3 + 7441*x3^3*x5*x6*x7^3 + 68696*x3^2*x4*x5*x6*x7^3 + (-20543)*x2*x4^2*x5*x6*x7^3 + (-3919)*x3*x4^2*x5*x6*x7^3 + (-19843)*x4^3*x5*x6*x7^3 + (-26947)*x2*x3*x5^2*x6*x7^3 + (-2007)*x3^2*x5^2*x6*x7^3 + 16488*x2*x4*x5^2*x6*x7^3 + 15769*x3*x4*x5^2*x6*x7^3+ 6625*x4^2*x5^2*x6*x7^3 + (-9492)*x2*x5^3*x6*x7^3 + (-19838)*x3*x5^3*x6*x7^3 + (-16967)*x4*x5^3*x6*x7^3 + (-10666)*x5^4*x6*x7^3 + (-651)*x3^3*x6^2*x7^3+ 143048*x2*x3*x4*x6^2*x7^3 + 45544*x3^2*x4*x6^2*x7^3 + (-29100)*x2*x4^2*x6^2*x7^3 + (-63855)*x3*x4^2*x6^2*x7^3 + (-29100)*x4^3*x6^2*x7^3 + 236908*x2*x3*x5*x6^2*x7^3 + 94739*x3^2*x5*x6^2*x7^3 + 176248*x2*x4*x5*x6^2*x7^3 + 544436*x3*x4*x5*x6^2*x7^3 + 148246*x4^2*x5*x6^2*x7^3 + 107825*x2*x5^2*x6^2*x7^3 + 193483*x3*x5^2*x6^2*x7^3 + 289473*x4*x5^2*x6^2*x7^3 + 75257*x5^3*x6^2*x7^3 + (-15835)*x2*x3*x6^3*x7^3 + 29507*x3^2*x6^3*x7^3 + 1313*x2*x4*x6^3*x7^3 + 31173*x3*x4*x6^3*x7^3 + (-27559)*x4^2*x6^3*x7^3 + (-5429)*x2*x5*x6^3*x7^3 + 112661*x3*x5*x6^3*x7^3 + 320284*x4*x5*x6^3*x7^3 + 303906*x5^2*x6^3*x7^3 + 30356*x2*x6^4*x7^3 + 60395*x3*x6^4*x7^3 + 31957*x4*x6^4*x7^3 + (-24704)*x5*x6^4*x7^3 + 30310*x6^5*x7^3 + 28605*x3^2*x4^2*x7^4 + 34555*x3*x4^3*x7^4 + 18432*x3^3*x5*x7^4 + 89116*x2*x3*x4*x5*x7^4 + (-25548)*x3^2*x4*x5*x7^4 + 55958*x2*x4^2*x5*x7^4 + (-47822)*x3*x4^2*x5*x7^4 + 55958*x4^3*x5*x7^4 + 19093*x2*x3*x5^2*x7^4 + 35184*x3^2*x5^2*x7^4 + (-15097)*x2*x4*x5^2*x7^4 + (-23027)*x3*x4*x5^2*x7^4 + (-11957)*x4^2*x5^2*x7^4 + (-1260)*x2*x5^3*x7^4 + 15564*x3*x5^3*x7^4 + (-12482)*x4*x5^3*x7^4 + (-1242)*x5^4*x7^4 + (-18432)*x3^3*x6*x7^4 + (-137864)*x2*x3*x4*x6*x7^4 + (-77530)*x3^2*x4*x6*x7^4 + 64331*x2*x4^2*x6*x7^4 + (-18087)*x3*x4^2*x6*x7^4 + 64299*x4^3*x6*x7^4 + 55363*x2*x3*x5*x6*x7^4 + (-23488)*x3^2*x5*x6*x7^4 + 11683*x2*x4*x5*x6*x7^4 + 27802*x3*x4*x5*x6*x7^4 + 66314*x4^2*x5*x6*x7^4 + (-46309)*x2*x5^2*x6*x7^4 + (-100418)*x3*x5^2*x6*x7^4 + 84180*x4*x5^2*x6*x7^4 + (-58339)*x5^3*x6*x7^4 + (-481378)*x2*x3*x6^2*x7^4 + (-181162)*x3^2*x6^2*x7^4 + (-207090)*x2*x4*x6^2*x7^4 + (-706065)*x3*x4*x6^2*x7^4 + (-159821)*x4^2*x6^2*x7^4 + (-275927)*x2*x5*x6^2*x7^4 + (-384414)*x3*x5*x6^2*x7^4 + (-613941)*x4*x5*x6^2*x7^4 + (-196313)*x5^2*x6^2*x7^4 + (-119760)*x2*x6^3*x7^4 + (-251215)*x3*x6^3*x7^4 + (-342534)*x4*x6^3*x7^4 + (-456871)*x5*x6^3*x7^4 + (-135320)*x6^4*x7^4 + (-87165)*x2*x3*x4*x7^5 + 13855*x3^2*x4*x7^5 + (-34555)*x2*x4^2*x7^5 + 13855*x3*x4^2*x7^5 + (-34555)*x4^3*x7^5 + 29938*x2*x3*x5*x7^5 + 67026*x3^2*x5*x7^5 + 72995*x2*x4*x5*x7^5 + (-15730)*x3*x4*x5*x7^5 + 94398*x4^2*x5*x7^5 + 8413*x2*x5^2*x7^5 + 73917*x3*x5^2*x7^5 + 47619*x4*x5^2*x7^5 + 7153*x5^3*x7^5 + 179590*x2*x3*x6*x7^5 + 84912*x3^2*x6*x7^5 + 233128*x2*x4*x6*x7^5 + 343093*x3*x4*x6*x7^5 + 262904*x4^2*x6*x7^5 + (-155101)*x2*x5*x6*x7^5 + (-46475)*x3*x5*x6*x7^5 + 193424*x4*x5*x6*x7^5 + (-178868)*x5^2*x6*x7^5 + 271105*x2*x6^2*x7^5 + 230640*x3*x6^2*x7^5 + 320949*x4*x6^2*x7^5 + (-81552)*x5*x6^2*x7^5 + (-167864)*x6^3*x7^5 + 16100*x2*x3*x7^6 + (-42460)*x3^2*x7^6 + (-77015)*x2*x4*x7^6 + (-47060)*x3*x4*x7^6 + (-111570)*x4^2*x7^6 + (-11858)*x2*x5*x7^6 + (-5688)*x3*x5*x7^6 + 42682*x4*x5*x7^6 + (-3445)*x5^2*x7^6 + 170716*x2*x6*x7^6 + 231564*x3*x6*x7^6 + 326829*x4*x6*x7^6 + (-57395)*x5*x6*x7^6 + 518103*x6^2*x7^6 + (-101020)*x2*x7^7 + (-143480)*x3*x7^7 + (-178035)*x4*x7^7 + (-112878)*x5*x7^7 + 128256*x6*x7^7 + (-101020)*x7^8 + 32876*x2 + 23189*x3 + 58585*x4 + 28986*x5 + (-109695)*x6 + (-83061)*x7""",
"""304*x4^2*x5^3*x6^3 + (-240)*x3^2*x4*x5^4*x7 + 240*x3^3*x5^3*x6*x7 + 240*x3^2*x5^4*x6*x7 + (-480)*x3*x5^4*x6^2*x7 + (-174)*x3^2*x5^2*x6^3*x7 + 7272*x2*x4*x5^2*x6^3*x7 + 7904*x4^2*x5^2*x6^3*x7 + 2846*x2*x5^3*x6^3*x7 + 2432*x3*x5^3*x6^3*x7 + 20370*x4*x5^3*x6^3*x7 + 3086*x5^4*x6^3*x7 + 64*x2*x3*x5*x6^4*x7 + 688*x2*x4*x5*x6^4*x7 + 1468*x3*x4*x5*x6^4*x7 + 688*x4^2*x5*x6^4*x7 + 280*x2*x5^2*x6^4*x7 + 106*x3*x5^2*x6^4*x7 + 9064*x4*x5^2*x6^4*x7 + 3300*x5^3*x6^4*x7+ 688*x4*x5*x6^5*x7 + 344*x5^2*x6^5*x7 + (-120)*x3^4*x5^2*x7^2 + (-120)*x3^3*x5^3*x7^2 + (-7232)*x3^2*x4*x5^3*x7^2 + (-2530)*x2*x4^2*x5^3*x7^2 + (-3134)*x4^3*x5^3*x7^2 + 120*x2*x3*x5^4*x7^2 + 120*x3^2*x5^4*x7^2 + (-120)*x2*x4*x5^4*x7^2 + (-7190)*x3*x4*x5^4*x7^2 + (-3440)*x4^2*x5^4*x7^2 + 120*x3*x5^5*x7^2+ (-120)*x4*x5^5*x7^2 + 290*x3*x4^4*x6*x7^2 + 318*x3^4*x5*x6*x7^2 + 6812*x2*x4^3*x5*x6*x7^2 + 6812*x4^4*x5*x6*x7^2 + (-2924)*x3^3*x5^2*x6*x7^2 + (-15794)*x3^2*x5^3*x6*x7^2 + (-78156)*x2*x4*x5^3*x6*x7^2 + (-10750)*x2*x5^4*x6*x7^2 + (-23902)*x3*x5^4*x6*x7^2 + (-75754)*x4*x5^4*x6*x7^2 + (-10750)*x5^5*x6*x7^2 + 120*x3^4*x6^2*x7^2 + (-288)*x3^2*x4^2*x6^2*x7^2 + 290*x2*x4^3*x6^2*x7^2 + 1128*x3*x4^3*x6^2*x7^2 + 290*x4^4*x6^2*x7^2 + 398*x3^3*x5*x6^2*x7^2 + 768970*x3*x4^2*x5*x6^2*x7^2 + 7102*x4^3*x5*x6^2*x7^2 + 21622*x2*x3*x5^2*x6^2*x7^2 + 12936*x3^2*x5^2*x6^2*x7^2 + (-581090)*x2*x4*x5^2*x6^2*x7^2 + (-112490)*x3*x4*x5^2*x6^2*x7^2 + 13526*x4^2*x5^2*x6^2*x7^2 + (-65784)*x2*x5^3*x6^2*x7^2 + (-59440)*x3*x5^3*x6^2*x7^2 + (-648380)*x4*x5^3*x6^2*x7^2 + (-62832)*x5^4*x6^2*x7^2 + 848*x3^3*x6^3*x7^2 + 3696*x2*x3*x4*x6^3*x7^2 + (-302)*x3^2*x4*x6^3*x7^2 + 924*x2*x4^2*x6^3*x7^2 + 2802*x3*x4^2*x6^3*x7^2 + 1214*x4^3*x6^3*x7^2 +(-29194)*x2*x3*x5*x6^3*x7^2 + (-3158)*x3^2*x5*x6^3*x7^2 + (-540784)*x2*x4*x5*x6^3*x7^2 + 56400*x3*x4*x5*x6^3*x7^2 + (-537384)*x4^2*x5*x6^3*x7^2 + (-227042)*x2*x5^2*x6^3*x7^2 + (-216688)*x3*x5^2*x6^3*x7^2 + 69416*x4*x5^2*x6^3*x7^2 + (-279622)*x5^3*x6^3*x7^2 + (-128)*x2*x3*x6^4*x7^2 + 992*x3^2*x6^4*x7^2 + 290*x2*x4*x6^4*x7^2 + (-140)*x3*x4*x6^4*x7^2 + 1214*x4^2*x6^4*x7^2 + (-6742)*x2*x5*x6^4*x7^2 + (-10932)*x3*x5*x6^4*x7^2 + (-541492)*x4*x5*x6^4*x7^2 + (-259376)*x5^2*x6^4*x7^2 + (-344)*x2*x6^5*x7^2 + (-80)*x3*x6^5*x7^2 + (-54)*x4*x6^5*x7^2 + (-7414)*x5*x6^5*x7^2 + (-344)*x6^6*x7^2 + 516*x3^4*x5*x7^3 + (-304718)*x3*x4^3*x5*x7^3 + 574*x3^3*x5^2*x7^3 + (-182988)*x3^2*x4*x5^2*x7^3 + 25322*x2*x4^2*x5^2*x7^3 + 243808*x3*x4^2*x5^2*x7^3 + (-186442)*x4^3*x5^2*x7^3 + 142*x2*x3*x5^3*x7^3 + 320*x3^2*x5^3*x7^3 + 14168*x2*x4*x5^3*x7^3 + (-91936)*x3*x4*x5^3*x7^3 + 34828*x4^2*x5^3*x7^3 + 120*x2*x5^4*x7^3 + 382*x3*x5^4*x7^3 + 14168*x4*x5^4*x7^3 + 120*x5^5*x7^3 + (-516)*x3^4*x6*x7^3 + (-435796)*x3^2*x4^2*x6*x7^3 + (-290)*x2*x4^3*x6*x7^3 + (-453846)*x3*x4^3*x6*x7^3 + (-290)*x4^4*x6*x7^3 + 64526*x3^3*x5*x6*x7^3 + 610241*x3^2*x4*x5*x6*x7^3 + (-178154)*x2*x4^2*x5*x6*x7^3 + (-36998)*x3*x4^2*x5*x6*x7^3 + (-171632)*x4^3*x5*x6*x7^3+ (-243924)*x2*x3*x5^2*x6*x7^3 + (-19912)*x3^2*x5^2*x6*x7^3 + 148514*x2*x4*x5^2*x6*x7^3 + 132374*x3*x4*x5^2*x6*x7^3 + 57039*x4^2*x5^2*x6*x7^3 + (-84992)*x2*x5^3*x6*x7^3 + (-178882)*x3*x5^3*x6*x7^3 + (-151140)*x4*x5^3*x6*x7^3 + (-95502)*x5^4*x6*x7^3 + (-6962)*x3^3*x6^2*x7^3 + 1271728*x2*x3*x4*x6^2*x7^3 + 404428*x3^2*x4*x6^2*x7^3 + (-257802)*x2*x4^2*x6^2*x7^3 + (-566092)*x3*x4^2*x6^2*x7^3 + (-257802)*x4^3*x6^2*x7^3 + 2110840*x2*x3*x5*x6^2*x7^3 + 841108*x3^2*x5*x6^2*x7^3 + 1571108*x2*x4*x5*x6^2*x7^3 + 4847546*x3*x4*x5*x6^2*x7^3 + 1326054*x4^2*x5*x6^2*x7^3 + 961100*x2*x5^2*x6^2*x7^3 + 1725476*x3*x5^2*x6^2*x7^3 + 2576074*x4*x5^2*x6^2*x7^3 + 668770*x5^3*x6^2*x7^3 + (-142750)*x2*x3*x6^3*x7^3 + 261052*x3^2*x6^3*x7^3 + 11130*x2*x4*x6^3*x7^3 + 273278*x3*x4*x6^3*x7^3 + (-244140)*x4^2*x6^3*x7^3 + (-50944)*x2*x5*x6^3*x7^3 + 1001482*x3*x5*x6^3*x7^3 + 2849760*x4*x5*x6^3*x7^3 + 2704172*x5^2*x6^3*x7^3 + 269058*x2*x6^4*x7^3 + 535604*x3*x6^4*x7^3 + 283718*x4*x6^4*x7^3 + (-223098)*x5*x6^4*x7^3 + 268322*x6^5*x7^3 + 253628*x3^2*x4^2*x7^4 + 304718*x3*x4^3*x7^4 + 164326*x3^3*x5*x7^4 + 792543*x2*x3*x4*x5*x7^4 + (-225612)*x3^2*x4*x5*x7^4 + 494294*x2*x4^2*x5*x7^4 + (-416134)*x3*x4^2*x5*x7^4 + 494294*x4^3*x5*x7^4 + 171554*x2*x3*x5^2*x7^4 + 316118*x3^2*x5^2*x7^4 + (-134288)*x2*x4*x5^2*x7^4 + (-199222)*x3*x4*x5^2*x7^4 + (-104354)*x4^2*x5^2*x7^4 + (-10608)*x2*x5^3*x7^4 + 141664*x3*x5^3*x7^4 + (-111304)*x4*x5^3*x7^4 + (-10488)*x5^4*x7^4 + (-164326)*x3^3*x6*x7^4 + (-1232246)*x2*x3*x4*x6*x7^4 + (-685564)*x3^2*x4*x6*x7^4 + 568698*x2*x4^2*x6*x7^4 + (-164970)*x3*x4^2*x6*x7^4 + 568408*x4^3*x6*x7^4 + 485390*x2*x3*x5*x6*x7^4 + (-217874)*x3^2*x5*x6*x7^4 + 108308*x2*x4*x5*x6*x7^4 + 234467*x3*x4*x5*x6*x7^4 + 593786*x4^2*x5*x6*x7^4 + (-410586)*x2*x5^2*x6*x7^4 + (-898656)*x3*x5^2*x6*x7^4 + 756102*x4*x5^2*x6*x7^4 + (-516914)*x5^3*x6*x7^4 + (-4283187)*x2*x3*x6^2*x7^4 + (-1613298)*x3^2*x6^2*x7^4 + (-1838070)*x2*x4*x6^2*x7^4 + (-6277471)*x3*x4*x6^2*x7^4 + (-1420302)*x4^2*x6^2*x7^4 + (-2451206)*x2*x5*x6^2*x7^4 + (-3418222)*x3*x5*x6^2*x7^4 + (-5458427)*x4*x5*x6^2*x7^4 + (-1743829)*x5^2*x6^2*x7^4 + (-1061566)*x2*x6^3*x7^4 + (-2231428)*x3*x6^3*x7^4 + (-3039156)*x4*x6^3*x7^4 + (-4057983)*x5*x6^3*x7^4 + (-1202268)*x6^4*x7^4 + (-769033)*x2*x3*x4*x7^5 + 121362*x3^2*x4*x7^5 + (-304718)*x2*x4^2*x7^5 + 121362*x3*x4^2*x7^5 + (-304718)*x4^3*x7^5 + 266026*x2*x3*x5*x7^5 + 596432*x3^2*x5*x7^5 + 643800*x2*x4*x5*x7^5 + (-135909)*x3*x4*x5*x7^5 + 833376*x4^2*x5*x7^5 + 75882*x2*x5^2*x7^5 + 660634*x3*x5^2*x7^5 + 418798*x4*x5^2*x7^5 + 65274*x5^3*x7^5 + 1602657*x2*x3*x6*x7^5 + 750540*x3^2*x6*x7^5 + 2064710*x2*x4*x6*x7^5 + 3052075*x3*x4*x6*x7^5 + 2328690*x4^2*x6*x7^5 + (-1378953)*x2*x5*x6*x7^5 + (-426267)*x3*x5*x6*x7^5 + 1727674*x4*x5*x6*x7^5 + (-1588199)*x5^2*x6*x7^5 + 2419389*x2*x6^2*x7^5 + 2054111*x3*x6^2*x7^5 + 2853925*x4*x6^2*x7^5 + (-710085)*x5*x6^2*x7^5 + (-1481926)*x6^3*x7^5 + 140415*x2*x3*x7^6 + (-374990)*x3^2*x7^6 + (-679708)*x2*x4*x7^6 + (-417931)*x3*x4*x7^6 + (-984426)*x4^2*x7^6 + (-102360)*x2*x5*x7^6 + (-44728)*x3*x5*x7^6 + 377137*x4*x5*x7^6 + (-26478)*x5^2*x7^6 +1494116*x2*x6*x7^6 + 2033476*x3*x6*x7^6 + 2879118*x4*x6*x7^6 + (-528783)*x5*x6*x7^6 + 4601812*x6^2*x7^6 + (-890395)*x2*x7^7 + (-1265385)*x3*x7^7 + (-1570103)*x4*x7^7 + (-992755)*x5*x7^7 + 1119126*x6*x7^7 + (-890395)*x7^8 + 292528*x2 + 207754*x3 + 520716*x4 + 257778*x5 + (-975284)*x6 + (-733025)*x7""",
"""288*x4^2*x5^3*x6^3 + (-144)*x3^2*x4*x5^4*x7 + 144*x3^3*x5^3*x6*x7 + 144*x3^2*x5^4*x6*x7 + (-288)*x3*x5^4*x6^2*x7 + 10*x3^2*x5^2*x6^3*x7 + 5296*x2*x4*x5^2*x6^3*x7 + 5992*x4^2*x5^2*x6^3*x7 + 2086*x2*x5^3*x6^3*x7 + 1952*x3*x5^3*x6^3*x7 + 14818*x4*x5^3*x6^3*x7 + 2230*x5^4*x6^3*x7 + 144*x2*x3*x5*x6^4*x7 + 624*x2*x4*x5*x6^4*x7 + 1356*x3*x4*x5*x6^4*x7 + 624*x4^2*x5*x6^4*x7 + 168*x2*x5^2*x6^4*x7 + 178*x3*x5^2*x6^4*x7 + 7216*x4*x5^2*x6^4*x7 + 2244*x5^3*x6^4*x7 + 624*x4*x5*x6^5*x7 + 312*x5^2*x6^5*x7 + (-72)*x3^4*x5^2*x7^2 + (-72)*x3^3*x5^3*x7^2 + (-5360)*x3^2*x4*x5^3*x7^2 + (-2090)*x2*x4^2*x5^3*x7^2 + (-2294)*x4^3*x5^3*x7^2 + 72*x2*x3*x5^4*x7^2 + 72*x3^2*x5^4*x7^2 + (-72)*x2*x4*x5^4*x7^2 + (-5326)*x3*x4*x5^4*x7^2 + (-2592)*x4^2*x5^4*x7^2 + 72*x3*x5^5*x7^2 + (-72)*x4*x5^5*x7^2 + 218*x3*x4^4*x6*x7^2 + 270*x3^4*x5*x6*x7^2 + 5196*x2*x4^3*x5*x6*x7^2 + 5196*x4^4*x5*x6*x7^2 + (-2036)*x3^3*x5^2*x6*x7^2 + (-11826)*x3^2*x5^3*x6*x7^2 + (-58052)*x2*x4*x5^3*x6*x7^2 + (-7990)*x2*x5^4*x6*x7^2 + (-17870)*x3*x5^4*x6*x7^2 + (-56162)*x4*x5^4*x6*x7^2 + (-7990)*x5^5*x6*x7^2 + 72*x3^4*x6^2*x7^2 + (-736)*x3^2*x4^2*x6^2*x7^2 + 218*x2*x4^3*x6^2*x7^2 + 624*x3*x4^3*x6^2*x7^2 + 218*x4^4*x6^2*x7^2 + 318*x3^3*x5*x6^2*x7^2 + 571602*x3*x4^2*x5*x6^2*x7^2 + 5414*x4^3*x5*x6^2*x7^2 + 15358*x2*x3*x5^2*x6^2*x7^2 + 10120*x3^2*x5^2*x6^2*x7^2 + (-433618)*x2*x4*x5^2*x6^2*x7^2 + (-84962)*x3*x4*x5^2*x6^2*x7^2 + 8582*x4^2*x5^2*x6^2*x7^2 + (-49168)*x2*x5^3*x6^2*x7^2 + (-44024)*x3*x5^3*x6^2*x7^2 + (-484420)*x4*x5^3*x6^2*x7^2 + (-46992)*x5^4*x6^2*x7^2 + 632*x3^3*x6^3*x7^2 + 3168*x2*x3*x4*x6^3*x7^2 + (-454)*x3^2*x4*x6^3*x7^2 + 748*x2*x4^2*x6^3*x7^2 + 1954*x3*x4^2*x6^3*x7^2 + 966*x4^3*x6^3*x7^2 + (-20658)*x2*x3*x5*x6^3*x7^2 + (-2150)*x3^2*x5*x6^3*x7^2 + (-401576)*x2*x4*x5*x6^3*x7^2 + 44048*x3*x4*x5*x6^3*x7^2 + (-398568)*x4^2*x5*x6^3*x7^2 + (-168442)*x2*x5^2*x6^3*x7^2 + (-159616)*x3*x5^2*x6^3*x7^2 + 51752*x4*x5^2*x6^3*x7^2 + (-209054)*x5^3*x6^3*x7^2 + (-200)*x2*x3*x6^4*x7^2 + 736*x3^2*x6^4*x7^2 + 218*x2*x4*x6^4*x7^2 + (-436)*x3*x4*x6^4*x7^2 + 966*x4^2*x6^4*x7^2 + (-5462)*x2*x5*x6^4*x7^2 + (-8460)*x3*x5*x6^4*x7^2 + (-401684)*x4*x5*x6^4*x7^2 + (-191864)*x5^2*x6^4*x7^2 + (-312)*x2*x6^5*x7^2 + (-136)*x3*x6^5*x7^2 + (-94)*x4*x6^5*x7^2 + (-6006)*x5*x6^5*x7^2 + (-312)*x6^6*x7^2 + 468*x3^4*x5*x7^3 + (-225502)*x3*x4^3*x5*x7^3 + 934*x3^3*x5^2*x7^3 + (-135876)*x3^2*x4*x5^2*x7^3 + 18810*x2*x4^2*x5^2*x7^3 + 179496*x3*x4^2*x5^2*x7^3 + (-138362)*x4^3*x5^2*x7^3 + 358*x2*x3*x5^3*x7^3 + 896*x3^2*x5^3*x7^3 + 10296*x2*x4*x5^3*x7^3 + (-68256)*x3*x4*x5^3*x7^3 + 25860*x4^2*x5^3*x7^3 + 72*x2*x5^4*x7^3 + 502*x3*x5^4*x7^3 + 10296*x4*x5^4*x7^3 + 72*x5^5*x7^3 + (-468)*x3^4*x6*x7^3 + (-324644)*x3^2*x4^2*x6*x7^3 + (-218)*x2*x4^3*x6*x7^3 + (-336838)*x3*x4^3*x6*x7^3 + (-218)*x4^4*x6*x7^3 + 47278*x3^3*x5*x6*x7^3 + 453533*x3^2*x4*x5*x6*x7^3 + (-130538)*x2*x4^2*x5*x6*x7^3 + (-28438)*x3*x4^2*x5*x6*x7^3 + (-125560)*x4^3*x5*x6*x7^3 + (-183244)*x2*x3*x5^2*x6*x7^3 + (-15696)*x3^2*x5^2*x6*x7^3 + 111258*x2*x4*x5^2*x6*x7^3 + 95062*x3*x4*x5^2*x6*x7^3 + 41611*x4^2*x5^2*x6*x7^3 + (-63456)*x2*x5^3*x6*x7^3 + (-134090)*x3*x5^3*x6*x7^3 + (-112508)*x4*x5^3*x6*x7^3 + (-71302)*x5^4*x6*x7^3 + (-5682)*x3^3*x6^2*x7^3 + 945584*x2*x3*x4*x6^2*x7^3 + 300508*x3^2*x4*x6^2*x7^3 + (-191298)*x2*x4^2*x6^2*x7^3 + (-420228)*x3*x4^2*x6^2*x7^3 + (-191298)*x4^3*x6^2*x7^3 + 1571512*x2*x3*x5*x6^2*x7^3 + 624908*x3^2*x5*x6^2*x7^3 + 1170004*x2*x4*x5*x6^2*x7^3 + 3607538*x3*x4*x5*x6^2*x7^3 + 989470*x4^2*x5*x6^2*x7^3 + 715700*x2*x5^2*x6^2*x7^3 + 1285276*x3*x5^2*x6^2*x7^3 + 1916538*x4*x5^2*x6^2*x7^3 + 497138*x5^3*x6^2*x7^3 + (-106990)*x2*x3*x6^3*x7^3 + 193556*x3^2*x6^3*x7^3 + 8042*x2*x4*x6^3*x7^3 + 201534*x3*x4*x6^3*x7^3 + (-181156)*x4^2*x6^3*x7^3 + (-39032)*x2*x5*x6^3*x7^3 + 744602*x3*x5*x6^3*x7^3 + 2119936*x4*x5*x6^3*x7^3 + 2011692*x5^2*x6^3*x7^3 + 199706*x2*x6^4*x7^3 + 397676*x3*x6^4*x7^3 + 210790*x4*x6^4*x7^3 + (-167378)*x5*x6^4*x7^3 + 199018*x6^5*x7^3 + 188292*x3^2*x4^2*x7^4 + 225502*x3*x4^3*x7^4 + 122382*x3^3*x5*x7^4 + 589411*x2*x3*x4*x5*x7^4 + (-167100)*x3^2*x4*x5*x7^4 + 366158*x2*x4^2*x5*x7^4 + (-305534)*x3*x4^2*x5*x7^4 + 366158*x4^3*x5*x7^4 + 128338*x2*x3*x5^2*x7^4 + 236478*x3^2*x5^2*x7^4 + (-99880)*x2*x4*x5^2*x7^4 + (-145766)*x3*x4*x5^2*x7^4 + (-76754)*x4^2*x5^2*x7^4 + (-7632)*x2*x5^3*x7^4 + 106752*x3*x5^3*x7^4 + (-82904)*x4*x5^3*x7^4 + (-7560)*x5^4*x7^4 + (-122382)*x3^3*x6*x7^4 + (-919070)*x2*x3*x4*x6*x7^4 + (-508156)*x3^2*x4*x6*x7^4 + 421466*x2*x4^2*x6*x7^4 + (-124458)*x3*x4^2*x6*x7^4 + 421248*x4^3*x6*x7^4 + 357982*x2*x3*x5*x6*x7^4 + (-165898)*x3^2*x5*x6*x7^4 + 82444*x2*x4*x5*x6*x7^4 + 168871*x3*x4*x5*x6*x7^4 + 443330*x4^2*x5*x6*x7^4 + (-304810)*x2*x5^2*x6*x7^4 + (-670736)*x3*x5^2*x6*x7^4 + 565518*x4*x5^2*x6*x7^4 + (-383602)*x5^3*x6*x7^4 + (-3186295)*x2*x3*x6^2*x7^4 + (-1200730)*x3^2*x6^2*x7^4 + (-1365390)*x2*x4*x6^2*x7^4 + (-4667739)*x3*x4*x6^2*x7^4 + (-1055822)*x4^2*x6^2*x7^4 + (-1821782)*x2*x5*x6^2*x7^4 + (-2541894)*x3*x5*x6^2*x7^4 + (-4058727)*x4*x5*x6^2*x7^4 + (-1295993)*x5^2*x6^2*x7^4 + (-787974)*x2*x6^3*x7^4 + (-1658332)*x3*x6^3*x7^4 + (-2257140)*x4*x6^3*x7^4 + (-3015691)*x5*x6^3*x7^4 + (-893612)*x6^4*x7^4 + (-569277)*x2*x3*x4*x7^5 + 89458*x3^2*x4*x7^5 + (-225502)*x2*x4^2*x7^5 + 89458*x3*x4^2*x7^5 + (-225502)*x4^3*x7^5 + 197746*x2*x3*x5*x7^5 + 443712*x3^2*x5*x7^5 + 476480*x2*x4*x5*x7^5 + (-99361)*x3*x4*x5*x7^5 + 617136*x4^2*x5*x7^5 + 56890*x2*x5^2*x7^5 + 492714*x3*x5^2*x7^5+ 309438*x4*x5^2*x7^5 + 49258*x5^3*x7^5 + 1194253*x2*x3*x6*x7^5 + 556188*x3^2*x6*x7^5 + 1531822*x2*x4*x6*x7^5 + 2270167*x3*x4*x6*x7^5 + 1727786*x4^2*x6*x7^5 + (-1025341)*x2*x5*x6*x7^5 + (-322583)*x3*x5*x6*x7^5 + 1288082*x4*x5*x6*x7^5 + (-1180043)*x5^2*x6*x7^5 + 1802881*x2*x6^2*x7^5 + 1528899*x3*x6^2*x7^5+ 2122281*x4*x6^2*x7^5 + (-521553)*x5*x6^2*x7^5 + (-1097390)*x6^3*x7^5 + 103235*x2*x3*x7^6 + (-277750)*x3^2*x7^6 + (-503252)*x2*x4*x7^6 + (-310559)*x3*x4*x7^6 + (-728754)*x4^2*x7^6 + (-74792)*x2*x5*x7^6 + (-30744)*x3*x5*x7^6 + 279421*x4*x5*x7^6 + (-17902)*x5^2*x7^6 + 1100788*x2*x6*x7^6 + 1501140*x3*x6*x7^6 + 2129358*x4*x6*x7^6 + (-401147)*x5*x6*x7^6 + 3419820*x6^2*x7^6 + (-658735)*x2*x7^7 + (-936485)*x3*x7^7 + (-1161987)*x4*x7^7 + (-733527)*x5*x7^7 + 823038*x6*x7^7 + (-658735)*x7^8 + 217616*x2 + 155162*x3 + 387124*x4 + 191706*x5 + (-725196)*x6 + (-542709)*x7""",\
"""(-18)*x4^2*x5^3*x6^3 + 36*x3^2*x4*x5^4*x7 + (-36)*x3^3*x5^3*x6*x7 + (-36)*x3^2*x5^4*x6*x7 + 72*x3*x5^4*x6^2*x7 + 56*x3^2*x5^2*x6^3*x7 + (-847)*x2*x4*x5^2*x6^3*x7 + (-859)*x4^2*x5^2*x6^3*x7 + (-328)*x2*x5^3*x6^3*x7 + (-236)*x3*x5^3*x6^3*x7 + (-2377)*x4*x5^3*x6^3*x7 + (-364)*x5^4*x6^3*x7 + 18*x2*x3*x5*x6^4*x7 + (-48)*x2*x4*x5*x6^4*x7 + (-96)*x3*x4*x5*x6^4*x7 + (-48)*x4^2*x5*x6^4*x7 + (-42)*x2*x5^2*x6^4*x7 + 14*x3*x5^2*x6^4*x7 + (-895)*x4*x5^2*x6^4*x7 + (-426)*x5^3*x6^4*x7 + (-48)*x4*x5*x6^5*x7 + (-24)*x5^2*x6^5*x7 + 18*x3^4*x5^2*x7^2 + 18*x3^3*x5^3*x7^2 + 818*x3^2*x4*x5^3*x7^2 + 230*x2*x4^2*x5^3*x7^2 + 362*x4^3*x5^3*x7^2 + (-18)*x2*x3*x5^4*x7^2 + (-18)*x3^2*x5^4*x7^2 + 18*x2*x4*x5^4*x7^2 + 814*x3*x4*x5^4*x7^2 + 378*x4^2*x5^4*x7^2 + (-18)*x3*x5^5*x7^2 + 18*x4*x5^5*x7^2 + (-32)*x3*x4^4*x6*x7^2 + (-27)*x3^4*x5*x6*x7^2 + (-732)*x2*x4^3*x5*x6*x7^2 + (-732)*x4^4*x5*x6*x7^2 + 365*x3^3*x5^2*x6*x7^2 + 1755*x3^2*x5^3*x6*x7^2 + 8807*x2*x4*x5^3*x6*x7^2 + 1210*x2*x5^4*x6*x7^2 + 2663*x3*x5^4*x6*x7^2 + 8564*x4*x5^4*x6*x7^2 + 1210*x5^5*x6*x7^2 + (-18)*x3^4*x6^2*x7^2 + (-104)*x3^2*x4^2*x6^2*x7^2 + (-32)*x2*x4^3*x6^2*x7^2 + (-183)*x3*x4^3*x6^2*x7^2 + (-32)*x4^4*x6^2*x7^2 + (-39)*x3^3*x5*x6^2*x7^2 + (-86538)*x3*x4^2*x5*x6^2*x7^2 + (-764)*x4^3*x5*x6^2*x7^2 + (-2620)*x2*x3*x5^2*x6^2*x7^2 + (-1324)*x3^2*x5^2*x6^2*x7^2 + 64957*x2*x4*x5^2*x6^2*x7^2 + 12308*x3*x4*x5^2*x6^2*x7^2 + (-1907)*x4^2*x5^2*x6^2*x7^2 + 7333*x2*x5^3*x6^2*x7^2 + 6731*x3*x5^3*x6^2*x7^2 + 72325*x4*x5^3*x6^2*x7^2 + 6996*x5^4*x6^2*x7^2 + (-95)*x3^3*x6^3*x7^2 + (-306)*x2*x3*x4*x6^3*x7^2 + (-26)*x3^2*x4*x6^3*x7^2 + (-88)*x2*x4^2*x6^3*x7^2 + (-349)*x3*x4^2*x6^3*x7^2 + (-120)*x4^3*x6^3*x7^2 + 3558*x2*x3*x5*x6^3*x7^2 + 407*x3^2*x5*x6^3*x7^2 + 60965*x2*x4*x5*x6^3*x7^2 + (-5792)*x3*x4*x5*x6^3*x7^2 + 60708*x4^2*x5*x6^3*x7^2 + 25636*x2*x5^2*x6^3*x7^2 + 24766*x3*x5^2*x6^3*x7^2 + (-7772)*x4*x5^2*x6^3*x7^2 + 31154*x5^3*x6^3*x7^2 + (-13)*x2*x3*x6^4*x7^2 + (-112)*x3^2*x6^4*x7^2 + (-32)*x2*x4*x6^4*x7^2 + (-71)*x3*x4*x6^4*x7^2 +(-120)*x4^2*x6^4*x7^2 + 641*x2*x5*x6^4*x7^2 + 1143*x3*x5*x6^4*x7^2 + 61154*x4*x5*x6^4*x7^2 + 29435*x5^2*x6^4*x7^2 + 24*x2*x6^5*x7^2 + (-11)*x3*x6^5*x7^2+ (-8)*x4*x6^5*x7^2 + 705*x5*x6^5*x7^2 + 24*x6^6*x7^2 + (-36)*x3^4*x5*x7^3 + 34555*x3*x4^3*x5*x7^3 + 68*x3^3*x5^2*x7^3 + 20631*x3^2*x4*x5^2*x7^3 + (-2853)*x2*x4^2*x5^2*x7^3 + (-27891)*x3*x4^2*x5^2*x7^3 + 21041*x4^3*x5^2*x7^3 + 50*x2*x3*x5^3*x7^3 + 136*x3^2*x5^3*x7^3 + (-1656)*x2*x4*x5^3*x7^3 + 10368*x3*x4*x5^3*x7^3 + (-3927)*x4^2*x5^3*x7^3 + (-18)*x2*x5^4*x7^3 + 14*x3*x5^4*x7^3 + (-1656)*x4*x5^4*x7^3 + (-18)*x5^5*x7^3 + 36*x3^4*x6*x7^3 + 48860*x3^2*x4^2*x6*x7^3 + 32*x2*x4^3*x6*x7^3 + 51211*x3*x4^3*x6*x7^3 + 32*x4^4*x6*x7^3 + (-7441)*x3^3*x5*x6*x7^3 + (-68696)*x3^2*x4*x5*x6*x7^3 + 20543*x2*x4^2*x5*x6*x7^3+ 3919*x3*x4^2*x5*x6*x7^3 + 19843*x4^3*x5*x6*x7^3 + 26947*x2*x3*x5^2*x6*x7^3 + 2007*x3^2*x5^2*x6*x7^3 + (-16488)*x2*x4*x5^2*x6*x7^3 + (-15769)*x3*x4*x5^2*x6*x7^3 + (-6625)*x4^2*x5^2*x6*x7^3 + 9492*x2*x5^3*x6*x7^3 + 19838*x3*x5^3*x6*x7^3 + 16967*x4*x5^3*x6*x7^3 + 10666*x5^4*x6*x7^3 + 651*x3^3*x6^2*x7^3 + (-143048)*x2*x3*x4*x6^2*x7^3 + (-45544)*x3^2*x4*x6^2*x7^3 + 29100*x2*x4^2*x6^2*x7^3 + 63855*x3*x4^2*x6^2*x7^3 + 29100*x4^3*x6^2*x7^3 + (-236908)*x2*x3*x5*x6^2*x7^3 + (-94739)*x3^2*x5*x6^2*x7^3 + (-176248)*x2*x4*x5*x6^2*x7^3 + (-544436)*x3*x4*x5*x6^2*x7^3 + (-148246)*x4^2*x5*x6^2*x7^3 + (-107825)*x2*x5^2*x6^2*x7^3 + (-193483)*x3*x5^2*x6^2*x7^3 + (-289473)*x4*x5^2*x6^2*x7^3 + (-75257)*x5^3*x6^2*x7^3 + 15835*x2*x3*x6^3*x7^3 + (-29507)*x3^2*x6^3*x7^3 + (-1313)*x2*x4*x6^3*x7^3 + (-31173)*x3*x4*x6^3*x7^3 + 27559*x4^2*x6^3*x7^3 + 5429*x2*x5*x6^3*x7^3 + (-112661)*x3*x5*x6^3*x7^3 + (-320284)*x4*x5*x6^3*x7^3 + (-303906)*x5^2*x6^3*x7^3 + (-30356)*x2*x6^4*x7^3 + (-60395)*x3*x6^4*x7^3 + (-31957)*x4*x6^4*x7^3 + 24704*x5*x6^4*x7^3 + (-30310)*x6^5*x7^3 + (-28605)*x3^2*x4^2*x7^4 + (-34555)*x3*x4^3*x7^4 + (-18432)*x3^3*x5*x7^4 + (-89116)*x2*x3*x4*x5*x7^4 + 25548*x3^2*x4*x5*x7^4 + (-55958)*x2*x4^2*x5*x7^4 + 47822*x3*x4^2*x5*x7^4 + (-55958)*x4^3*x5*x7^4 + (-19093)*x2*x3*x5^2*x7^4 + (-35184)*x3^2*x5^2*x7^4 + 15097*x2*x4*x5^2*x7^4 + 23027*x3*x4*x5^2*x7^4 + 11957*x4^2*x5^2*x7^4+ 1260*x2*x5^3*x7^4 + (-15564)*x3*x5^3*x7^4 + 12482*x4*x5^3*x7^4 + 1242*x5^4*x7^4 + 18432*x3^3*x6*x7^4 + 137864*x2*x3*x4*x6*x7^4 + 77530*x3^2*x4*x6*x7^4+ (-64331)*x2*x4^2*x6*x7^4 + 18087*x3*x4^2*x6*x7^4 + (-64299)*x4^3*x6*x7^4 + (-55363)*x2*x3*x5*x6*x7^4 + 23488*x3^2*x5*x6*x7^4 + (-11683)*x2*x4*x5*x6*x7^4 + (-27802)*x3*x4*x5*x6*x7^4 + (-66314)*x4^2*x5*x6*x7^4 + 46309*x2*x5^2*x6*x7^4 + 100418*x3*x5^2*x6*x7^4 + (-84180)*x4*x5^2*x6*x7^4 + 58339*x5^3*x6*x7^4 + 481378*x2*x3*x6^2*x7^4 + 181162*x3^2*x6^2*x7^4 + 207090*x2*x4*x6^2*x7^4 + 706065*x3*x4*x6^2*x7^4 + 159821*x4^2*x6^2*x7^4 + 275927*x2*x5*x6^2*x7^4 + 384414*x3*x5*x6^2*x7^4 + 613941*x4*x5*x6^2*x7^4 + 196313*x5^2*x6^2*x7^4 + 119760*x2*x6^3*x7^4 + 251215*x3*x6^3*x7^4 + 342534*x4*x6^3*x7^4 + 456871*x5*x6^3*x7^4 + 135320*x6^4*x7^4 + 87165*x2*x3*x4*x7^5 + (-13855)*x3^2*x4*x7^5 + 34555*x2*x4^2*x7^5 + (-13855)*x3*x4^2*x7^5 + 34555*x4^3*x7^5 + (-29938)*x2*x3*x5*x7^5 + (-67026)*x3^2*x5*x7^5 + (-72995)*x2*x4*x5*x7^5 + 15730*x3*x4*x5*x7^5 + (-94398)*x4^2*x5*x7^5 + (-8413)*x2*x5^2*x7^5 + (-73917)*x3*x5^2*x7^5 + (-47619)*x4*x5^2*x7^5 + (-7153)*x5^3*x7^5 + (-179590)*x2*x3*x6*x7^5 + (-84912)*x3^2*x6*x7^5 + (-233128)*x2*x4*x6*x7^5 + (-343093)*x3*x4*x6*x7^5 + (-262904)*x4^2*x6*x7^5 + 155101*x2*x5*x6*x7^5 + 46475*x3*x5*x6*x7^5 + (-193424)*x4*x5*x6*x7^5 + 178868*x5^2*x6*x7^5 + (-271105)*x2*x6^2*x7^5 + (-230640)*x3*x6^2*x7^5 + (-320949)*x4*x6^2*x7^5 + 81552*x5*x6^2*x7^5 + 167864*x6^3*x7^5 + (-16100)*x2*x3*x7^6 + 42460*x3^2*x7^6 + 77015*x2*x4*x7^6 + 47060*x3*x4*x7^6 + 111570*x4^2*x7^6 + 11858*x2*x5*x7^6 + 5688*x3*x5*x7^6 + (-42682)*x4*x5*x7^6 + 3445*x5^2*x7^6 + (-170716)*x2*x6*x7^6 + (-231564)*x3*x6*x7^6 + (-326829)*x4*x6*x7^6 + 57395*x5*x6*x7^6 + (-518103)*x6^2*x7^6 + 101020*x2*x7^7 + 143480*x3*x7^7 + 178035*x4*x7^7 + 112878*x5*x7^7 + (-128256)*x6*x7^7 + 101020*x7^8 + (-32876)*x2 + (-23189)*x3 + (-58585)*x4 + (-28986)*x5 + 109695*x6 + 83061*x7""",\
"""(-48)*x4^2*x5^3*x6^3 + 144*x3^2*x4*x5^4*x7 + (-144)*x3^3*x5^3*x6*x7 + (-144)*x3^2*x5^4*x6*x7 + 288*x3*x5^4*x6^2*x7 + 250*x3^2*x5^2*x6^3*x7 + (-3176)*x2*x4*x5^2*x6^3*x7 + (-3152)*x4^2*x5^2*x6^3*x7 + (-1226)*x2*x5^3*x6^3*x7 + (-832)*x3*x5^3*x6^3*x7 + (-8918)*x4*x5^3*x6^3*x7 + (-1370)*x5^4*x6^3*x7 + 96*x2*x3*x5*x6^4*x7 + (-144)*x2*x4*x5*x6^4*x7 + (-276)*x3*x4*x5*x6^4*x7 + (-144)*x4^2*x5*x6^4*x7 + (-168)*x2*x5^2*x6^4*x7 + 82*x3*x5^2*x6^4*x7 + (-3176)*x4*x5^2*x6^4*x7 + (-1644)*x5^3*x6^4*x7 + (-144)*x4*x5*x6^5*x7 + (-72)*x5^2*x6^5*x7 + 72*x3^4*x5^2*x7^2 + 72*x3^3*x5^3*x7^2 + 3040*x3^2*x4*x5^3*x7^2 + 790*x2*x4^2*x5^3*x7^2 + 1354*x4^3*x5^3*x7^2 + (-72)*x2*x3*x5^4*x7^2 + (-72)*x3^2*x5^4*x7^2 + 72*x2*x4*x5^4*x7^2 + 3026*x3*x4*x5^4*x7^2 + 1392*x4^2*x5^4*x7^2 + (-72)*x3*x5^5*x7^2 + 72*x4*x5^5*x7^2 + (-118)*x3*x4^4*x6*x7^2 + (-90)*x3^4*x5*x6*x7^2 + (-2676)*x2*x4^3*x5*x6*x7^2 + (-2676)*x4^4*x5*x6*x7^2 + 1396*x3^3*x5^2*x6*x7^2 + 6486*x3^2*x5^3*x6*x7^2 + 32692*x2*x4*x5^3*x6*x7^2 + 4490*x2*x5^4*x6*x7^2 + 9850*x3*x5^4*x6*x7^2 + 31822*x4*x5^4*x6*x7^2 + 4490*x5^5*x6*x7^2 + (-72)*x3^4*x6^2*x7^2 + (-544)*x3^2*x4^2*x6^2*x7^2 + (-118)*x2*x4^3*x6^2*x7^2 + (-744)*x3*x4^3*x6^2*x7^2 + (-118)*x4^4*x6^2*x7^2 + (-138)*x3^3*x5*x6^2*x7^2 + (-321102)*x3*x4^2*x5*x6^2*x7^2 + (-2794)*x4^3*x5*x6^2*x7^2 + (-9938)*x2*x3*x5^2*x6^2*x7^2 + (-4760)*x3^2*x5^2*x6^2*x7^2 + 240518*x2*x4*x5^2*x6^2*x7^2+ 45262*x3*x4*x5^2*x6^2*x7^2 + (-7522)*x4^2*x5^2*x6^2*x7^2 + 27128*x2*x5^3*x6^2*x7^2 + 25024*x3*x5^3*x6^2*x7^2 + 267620*x4*x5^3*x6^2*x7^2 + 25872*x5^4*x6^2*x7^2 + (-352)*x3^3*x6^3*x7^2 + (-1008)*x2*x3*x4*x6^3*x7^2 + (-166)*x3^2*x4*x6^3*x7^2 + (-308)*x2*x4^2*x6^3*x7^2 + (-1334)*x3*x4^2*x6^3*x7^2 + (-426)*x4^3*x6^3*x7^2 + 13518*x2*x3*x5*x6^3*x7^2 + 1570*x3^2*x5*x6^3*x7^2 + 226336*x2*x4*x5*x6^3*x7^2 + (-20848)*x3*x4*x5*x6^3*x7^2 + 225528*x4^2*x5*x6^3*x7^2 +95222*x2*x5^2*x6^3*x7^2 + 92336*x3*x5^2*x6^3*x7^2 + (-28792)*x4*x5^2*x6^3*x7^2 + 115234*x5^3*x6^3*x7^2 + (-80)*x2*x3*x6^4*x7^2 + (-416)*x3^2*x6^4*x7^2 +(-118)*x2*x4*x6^4*x7^2 + (-364)*x3*x4*x6^4*x7^2 + (-426)*x4^2*x6^4*x7^2 + 2242*x2*x5*x6^4*x7^2 + 4140*x3*x5*x6^4*x7^2 + 227164*x4*x5*x6^4*x7^2 + 109504*x5^2*x6^4*x7^2 + 72*x2*x6^5*x7^2 + (-64)*x3*x6^5*x7^2 + (-46)*x4*x6^5*x7^2 + 2466*x5*x6^5*x7^2 + 72*x6^6*x7^2 + (-108)*x3^4*x5*x7^3 + 128522*x3*x4^3*x5*x7^3 + 406*x3^3*x5^2*x7^3 + 76596*x3^2*x4*x5^2*x7^3 + (-10590)*x2*x4^2*x5^2*x7^3 + (-104016)*x3*x4^2*x5^2*x7^3 + 78142*x4^3*x5^2*x7^3 + 262*x2*x3*x5^3*x7^3 + 704*x3^2*x5^3*x7^3 + (-6216)*x2*x4*x5^3*x7^3 + 38496*x3*x4*x5^3*x7^3 + (-14580)*x4^2*x5^3*x7^3 + (-72)*x2*x5^4*x7^3 + 118*x3*x5^4*x7^3 + (-6216)*x4*x5^4*x7^3 + (-72)*x5^5*x7^3 + 108*x3^4*x6*x7^3 + 181084*x3^2*x4^2*x6*x7^3 + 118*x2*x4^3*x6*x7^3 + 190178*x3*x4^3*x6*x7^3 + 118*x4^4*x6*x7^3 + (-27818)*x3^3*x5*x6*x7^3 + (-254923)*x3^2*x4*x5*x6*x7^3 + 76798*x2*x4^2*x5*x6*x7^3 + 14258*x3*x4^2*x5*x6*x7^3 + 74240*x4^3*x5*x6*x7^3 + 99404*x2*x3*x5^2*x6*x7^3 + 7176*x3^2*x5^2*x6*x7^3 + (-60918)*x2*x4*x5^2*x6*x7^3 + (-59522)*x3*x4*x5^2*x6*x7^3 + (-24821)*x4^2*x5^2*x6*x7^3 + 35136*x2*x5^3*x6*x7^3 + 73270*x3*x5^3*x6*x7^3 + 62908*x4*x5^3*x6*x7^3 + 39482*x5^4*x6*x7^3 + 2262*x3^3*x6^2*x7^3 + (-530704)*x2*x3*x4*x6^2*x7^3 + (-169028)*x3^2*x4*x6^2*x7^3 + 108078*x2*x4^2*x6^2*x7^3 + 237108*x3*x4^2*x6^2*x7^3 + 108078*x4^3*x6^2*x7^3 + (-878312)*x2*x3*x5*x6^2*x7^3 + (-351628)*x3^2*x5*x6^2*x7^3 + (-653324)*x2*x4*x5*x6^2*x7^3 + (-2018878)*x3*x4*x5*x6^2*x7^3 + (-548930)*x4^2*x5*x6^2*x7^3 + (-399700)*x2*x5^2*x6^2*x7^3 + (-717116)*x3*x5^2*x6^2*x7^3 + (-1073598)*x4*x5^2*x6^2*x7^3 + (-279238)*x5^3*x6^2*x7^3 + 58490*x2*x3*x6^3*x7^3 + (-109636)*x3^2*x6^3*x7^3 + (-4942)*x2*x4*x6^3*x7^3 + (-116154)*x3*x4*x6^3*x7^3 + 102356*x4^2*x6^3*x7^3 + 19792*x2*x5*x6^3*x7^3 + (-417982)*x3*x5*x6^3*x7^3 + (-1187936)*x4*x5*x6^3*x7^3 + (-1127172)*x5^2*x6^3*x7^3 + (-112726)*x2*x6^4*x7^3 + (-224236)*x3*x6^4*x7^3 + (-118610)*x4*x6^4*x7^3 + 91198*x5*x6^4*x7^3 + (-112598)*x6^5*x7^3 + (-106212)*x3^2*x4^2*x7^4 + (-128522)*x3*x4^3*x7^4 + (-68322)*x3^3*x5*x7^4 + (-330581)*x2*x3*x4*x5*x7^4 + 94980*x3^2*x4*x5*x7^4 + (-208018)*x2*x4^2*x5*x7^4 + 178594*x3*x4^2*x5*x7^4 + (-208018)*x4^3*x5*x7^4 + (-70598)*x2*x3*x5^2*x7^4 + (-130098)*x3^2*x5^2*x7^4 + 56000*x2*x4*x5^2*x7^4 + 86146*x3*x4*x5^2*x7^4 + 44614*x4^2*x5^2*x7^4 + 4752*x2*x5^3*x7^4 + (-57312)*x3*x5^3*x7^4 + 46264*x4*x5^3*x7^4 + 4680*x5^4*x7^4 + 68322*x3^3*x6*x7^4 + 510610*x2*x3*x4*x6*x7^4 + 288116*x3^2*x4*x6*x7^4 + (-239086)*x2*x4^2*x6*x7^4 + 66558*x3*x4^2*x6*x7^4 + (-238968)*x4^3*x6*x7^4 + (-206282)*x2*x3*x5*x6*x7^4 + 85958*x3^2*x5*x6*x7^4 + (-42764)*x2*x4*x5*x6*x7^4 + (-104801)*x3*x4*x5*x6*x7^4 + (-245470)*x4^2*x5*x6*x7^4 + 171950*x2*x5^2*x6*x7^4 + 371776*x3*x5^2*x6*x7^4 + (-311298)*x4*x5^2*x6*x7^4 + 216662*x5^3*x6*x7^4 + 1785425*x2*x3*x6^2*x7^4 + 671750*x3^2*x6^2*x7^4 + 768690*x2*x4*x6^2*x7^4 + 2619429*x3*x4*x6^2*x7^4 + 593002*x4^2*x6^2*x7^4 + 1023922*x2*x5*x6^2*x7^4 + 1426074*x3*x5*x6^2*x7^4 + 2277657*x4*x5*x6^2*x7^4 + 728503*x5^2*x6^2*x7^4 + 444714*x2*x6^3*x7^4 + 932252*x3*x6^3*x7^4 + 1271580*x4*x6^3*x7^4 + 1695461*x5*x6^3*x7^4 + 502132*x6^4*x7^4 + 324147*x2*x3*x4*x7^5 + (-51638)*x3^2*x4*x7^5 + 128522*x2*x4^2*x7^5 + (-51638)*x3*x4^2*x7^5 + 128522*x4^3*x7^5 + (-111086)*x2*x3*x5*x7^5 + (-248592)*x3^2*x5*x7^5 + (-271480)*x2*x4*x5*x7^5 + 58871*x3*x4*x5*x7^5 + (-350976)*x4^2*x5*x7^5 + (-31070)*x2*x5^2*x7^5 + (-273774)*x3*x5^2*x7^5 + (-177258)*x4*x5^2*x7^5 + (-26318)*x5^3*x7^5 + (-665483)*x2*x3*x6*x7^5 + (-315588)*x3^2*x6*x7^5 + (-865922)*x2*x4*x6*x7^5 + (-1272617)*x3*x4*x6*x7^5 + (-976486)*x4^2*x6*x7^5 + 575411*x2*x5*x6*x7^5 + 170713*x3*x5*x6*x7^5 + (-716542)*x4*x5*x6*x7^5 + 663853*x5^2*x6*x7^5 + (-1004591)*x2*x6^2*x7^5 + (-855189)*x3*x6^2*x7^5 + (-1190631)*x4*x6^2*x7^5 + 304503*x5*x6^2*x7^5 + 624130*x6^3*x7^5 + (-60085)*x2*x3*x7^6 + 157850*x3^2*x7^6 + 286372*x2*x4*x7^6 + 174649*x3*x4*x7^6 + 414894*x4^2*x7^6 + 44392*x2*x5*x7^6 + 21864*x3*x5*x7^6 + (-158651)*x4*x5*x7^6 + 13322*x5^2*x7^6 + (-636428)*x2*x6*x7^6 + (-862380)*x3*x6*x7^6 + (-1215978)*x4*x6*x7^6 + 210517*x5*x6*x7^6 + (-1922700)*x6^2*x7^6 + 375785*x2*x7^7 + 533635*x3*x7^7 + 662157*x4*x7^7 + 420177*x5*x7^7 + (-478578)*x6*x7^7 + 375785*x7^8 + (-121936)*x2 + (-85822)*x3 + (-217364)*x4 + (-107526)*x5 + 406956*x6 + 308859*x7""",\
"""(-720)*x4^2*x5^3*x6^3 + 1008*x3^2*x4*x5^4*x7 + (-1008)*x3^3*x5^3*x6*x7 + (-1008)*x3^2*x5^4*x6*x7 + 2016*x3*x5^4*x6^2*x7 + 1334*x3^2*x5^2*x6^3*x7 + (-25624)*x2*x4*x5^2*x6^3*x7 + (-26608)*x4^2*x5^2*x6^3*x7 + (-9958)*x2*x5^3*x6^3*x7 + (-7616)*x3*x5^3*x6^3*x7 + (-71866)*x4*x5^3*x6^3*x7 + (-10966)*x5^4*x6^3*x7 + 288*x2*x3*x5*x6^4*x7 + (-1776)*x2*x4*x5*x6^4*x7 + (-3660)*x3*x4*x5*x6^4*x7 + (-1776)*x4^2*x5*x6^4*x7 + (-1176)*x2*x5^2*x6^4*x7 + 158*x3*x5^2*x6^4*x7 + (-28696)*x4*x5^2*x6^4*x7 + (-12468)*x5^3*x6^4*x7 + (-1776)*x4*x5*x6^5*x7 + (-888)*x5^2*x6^5*x7 + 504*x3^4*x5^2*x7^2 + 504*x3^3*x5^3*x7^2 + 24992*x3^2*x4*x5^3*x7^2 + 7610*x2*x4^2*x5^3*x7^2 + 10982*x4^3*x5^3*x7^2 + (-504)*x2*x3*x5^4*x7^2 + (-504)*x3^2*x5^4*x7^2 + 504*x2*x4*x5^4*x7^2 + 24862*x3*x4*x5^4*x7^2 + 11664*x4^2*x5^4*x7^2 + (-504)*x3*x5^5*x7^2 + 504*x4*x5^5*x7^2 + (-986)*x3*x4^4*x6*x7^2 + (-918)*x3^4*x5*x6*x7^2 + (-22764)*x2*x4^3*x5*x6*x7^2 + (-22764)*x4^4*x5*x6*x7^2 + 10796*x3^3*x5^2*x6*x7^2 + 53946*x3^2*x5^3*x6*x7^2 + 269420*x2*x4*x5^3*x6*x7^2 + 37030*x2*x5^4*x6*x7^2 + 81782*x3*x5^4*x6*x7^2 + 261698*x4*x5^4*x6*x7^2 + 37030*x5^5*x6*x7^2 + (-504)*x3^4*x6^2*x7^2 + (-1760)*x3^2*x4^2*x6^2*x7^2 + (-986)*x2*x4^3*x6^2*x7^2 + (-5016)*x3*x4^3*x6^2*x7^2 + (-986)*x4^4*x6^2*x7^2 + (-1254)*x3^3*x5*x6^2*x7^2 + (-2648514)*x3*x4^2*x5*x6^2*x7^2 + (-23750)*x4^3*x5*x6^2*x7^2 + (-78238)*x2*x3*x5^2*x6^2*x7^2 + (-41896)*x3^2*x5^2*x6^2*x7^2 + 1992586*x2*x4*x5^2*x6^2*x7^2 + 380354*x3*x4*x5^2*x6^2*x7^2 + (-54350)*x4^2*x5^2*x6^2*x7^2 + 225160*x2*x5^3*x6^2*x7^2 + 205568*x3*x5^3*x6^2*x7^2 + 2220220*x4*x5^3*x6^2*x7^2 + 214896*x5^4*x6^2*x7^2 + (-2912)*x3^3*x6^3*x7^2 + (-10512)*x2*x3*x4*x6^3*x7^2 + (-170)*x3^2*x4*x6^3*x7^2 + (-2860)*x2*x4^2*x6^3*x7^2 + (-10330)*x3*x4^2*x6^3*x7^2 + (-3846)*x4^3*x6^3*x7^2 + 106050*x2*x3*x5*x6^3*x7^2 + 11918*x3^2*x5*x6^3*x7^2 + 1864736*x2*x4*x5*x6^3*x7^2 + (-183056)*x3*x4*x5*x6^3*x7^2 + 1855560*x4^2*x5*x6^3*x7^2 + 783706*x2*x5^2*x6^3*x7^2 + 754000*x3*x5^2*x6^3*x7^2 + (-238280)*x4*x5^2*x6^3*x7^2 + 956750*x5^3*x6^3*x7^2 + (-112)*x2*x3*x6^4*x7^2 + (-3424)*x3^2*x6^4*x7^2 + (-986)*x2*x4*x6^4*x7^2 + (-1268)*x3*x4*x6^4*x7^2 + (-3846)*x4^2*x6^4*x7^2 + 20846*x2*x5*x6^4*x7^2 + 35892*x3*x5*x6^4*x7^2 + 1869380*x4*x5*x6^4*x7^2 + 898304*x5^2*x6^4*x7^2 + 888*x2*x6^5*x7^2 + (-128)*x3*x6^5*x7^2 + (-98)*x4*x6^5*x7^2 + 22926*x5*x6^5*x7^2 + 888*x6^6*x7^2 + (-1332)*x3^4*x5*x7^3 + 1054822*x3*x4^3*x5*x7^3 + 698*x3^3*x5^2*x7^3 + 631020*x3^2*x4*x5^2*x7^3 + (-87282)*x2*x4^2*x5^2*x7^3 + (-848880)*x3*x4^2*x5^2*x7^3 + 643346*x4^3*x5^2*x7^3 + 842*x2*x3*x5^3*x7^3 + 2368*x3^2*x5^3*x7^3 + (-50040)*x2*x4*x5^3*x7^3 + 317088*x3*x4*x5^3*x7^3 + (-120108)*x4^2*x5^3*x7^3 + (-504)*x2*x5^4*x7^3 + (-166)*x3*x5^4*x7^3 + (-50040)*x4*x5^4*x7^3 + (-504)*x5^5*x7^3 + 1332*x3^4*x6*x7^3 + 1497284*x3^2*x4^2*x6*x7^3 + 986*x2*x4^3*x6*x7^3 + 1565902*x3*x4^3*x6*x7^3 + 986*x4^4*x6*x7^3 + (-225862)*x3^3*x5*x6*x7^3 + (-2102237)*x3^2*x4*x5*x6*x7^3 + 623570*x2*x4^2*x5*x6*x7^3 + 122494*x3*x4^2*x5*x6*x7^3 + 601792*x4^3*x5*x6*x7^3 + 829972*x2*x3*x5^2*x6*x7^3 + 63864*x3^2*x5^2*x6*x7^3 + (-506970)*x2*x4*x5^2*x6*x7^3 + (-473518)*x3*x4*x5^2*x6*x7^3 + (-200611)*x4^2*x5^2*x6*x7^3 + 291264*x2*x5^3*x6*x7^3 + 610202*x3*x5^3*x6*x7^3 + 519716*x4*x5^3*x6*x7^3 + 327286*x5^4*x6*x7^3 + 21306*x3^3*x6^2*x7^3 + (-4378736)*x2*x3*x4*x6^2*x7^3 + (-1393564)*x3^2*x4*x6^2*x7^3 + 889698*x2*x4^2*x6^2*x7^3 + 1952748*x3*x4^2*x6^2*x7^3 + 889698*x4^3*x6^2*x7^3 + (-7257304)*x2*x3*x5*x6^2*x7^3 + (-2898644)*x3^2*x5*x6^2*x7^3 + (-5399956)*x2*x4*x5*x6^2*x7^3 + (-16674002)*x3*x4*x5*x6^2*x7^3 + (-4547374)*x4^2*x5*x6^2*x7^3 + (-3303500)*x2*x5^2*x6^2*x7^3 + (-5928868)*x3*x5^2*x6^2*x7^3 + (-8863890)*x4*x5^2*x6^2*x7^3 + (-2303306)*x5^3*x6^2*x7^3 + 487030*x2*x3*x6^3*x7^3 + (-901724)*x3^2*x6^3*x7^3 + (-39554)*x2*x4*x6^3*x7^3 + (-949686)*x3*x4*x6^3*x7^3 + 842572*x4^2*x6^3*x7^3 + 169328*x2*x5*x6^3*x7^3 +(-3448466)*x3*x5*x6^3*x7^3 + (-9806752)*x4*x5*x6^3*x7^3 + (-9305436)*x5^2*x6^3*x7^3 + (-928250)*x2*x6^4*x7^3 + (-1847156)*x3*x6^4*x7^3 + (-977758)*x4*x6^4*x7^3 + 760274*x5*x6^4*x7^3 + (-926458)*x6^5*x7^3 + (-874812)*x3^2*x4^2*x7^4 + (-1054822)*x3*x4^3*x7^4 + (-564750)*x3^3*x5*x7^4 + (-2728195)*x2*x3*x4*x5*x7^4 + 780252*x3^2*x4*x5*x7^4 + (-1709150)*x2*x4^2*x5*x7^4 + 1453262*x3*x4^2*x5*x7^4 + (-1709150)*x4^3*x5*x7^4 + (-586570)*x2*x3*x5^2*x7^4 + (-1080894)*x3^2*x5^2*x7^4 + 462208*x2*x4*x5^2*x7^4 + 698414*x3*x4*x5^2*x7^4 + 363722*x4^2*x5^2*x7^4 + 37872*x2*x5^3*x7^4 + (-480288)*x3*x5^3*x7^4 + 382472*x4*x5^3*x7^4 + 37368*x5^4*x7^4 + 564750*x3^3*x6*x7^4 + 4227806*x2*x3*x4*x6*x7^4 + 2368876*x3^2*x4*x6*x7^4 + (-1965410)*x2*x4^2*x6*x7^4 + 558546*x3*x4^2*x6*x7^4 +(-1964424)*x4^3*x6*x7^4 + (-1686694)*x2*x3*x5*x6*x7^4 + 729610*x3^2*x5*x6*x7^4 + (-362836)*x2*x4*x5*x6*x7^4 + (-836119)*x3*x4*x5*x6*x7^4 + (-2034866)*x4^2*x5*x6*x7^4 + 1416226*x2*x5^2*x6*x7^4 + 3080768*x3*x5^2*x6*x7^4 + (-2585838)*x4*x5^2*x6*x7^4 + 1783738*x5^3*x6*x7^4 + 14739367*x2*x3*x6^2*x7^4 + 5548618*x3^2*x6^2*x7^4 + 6335550*x2*x4*x6^2*x7^4 + 21613299*x3*x4*x6^2*x7^4 + 4891526*x4^2*x6^2*x7^4 + 8444030*x2*x5*x6^2*x7^4 + 11767830*x3*x5*x6^2*x7^4 + 18793311*x4*x5*x6^2*x7^4 + 6007505*x5^2*x6^2*x7^4 + 3662214*x2*x6^3*x7^4 + 7687492*x3*x6^3*x7^4 + 10477956*x4*x6^3*x7^4 + 13980595*x5*x6^3*x7^4 + 4141292*x6^4*x7^4 + 2661237*x2*x3*x4*x7^5 + (-421978)*x3^2*x4*x7^5 + 1054822*x2*x4^2*x7^5 + (-421978)*x3*x4^2*x7^5 + 1054822*x4^3*x7^5 + (-916258)*x2*x3*x5*x7^5 + (-2052336)*x3^2*x5*x7^5 + (-2228360)*x2*x4*x5*x7^5 + 476881*x3*x4*x5*x7^5 + (-2882688)*x4^2*x5*x7^5 + (-258802)*x2*x5^2*x7^5 + (-2266722)*x3*x5^2*x7^5 + (-1452294)*x4*x5^2*x7^5 + (-220930)*x5^3*x7^5 + (-5504413)*x2*x3*x6*x7^5 + (-2594076)*x3^2*x6*x7^5 + (-7126894)*x2*x4*x6*x7^5 + (-10504399)*x3*x4*x6*x7^5+ (-8037482)*x4^2*x6*x7^5 + 4747765*x2*x5*x6*x7^5 + 1437983*x3*x5*x6*x7^5 + (-5930258)*x4*x5*x6*x7^5 + 5472875*x5^2*x6*x7^5 + (-8309401)*x2*x6^2*x7^5 + (-7064259)*x3*x6^2*x7^5 + (-9825057)*x4*x6^2*x7^5 + 2478801*x5*x6^2*x7^5 + 5126126*x6^3*x7^5 + (-489635)*x2*x3*x7^6 + 1296790*x3^2*x7^6 + 2351612*x2*x4*x7^6 + 1439999*x3*x4*x7^6 + 3406434*x4^2*x7^6 + 359384*x2*x5*x7^6 + 167256*x3*x5*x7^6 + (-1303789)*x4*x5*x7^6 + 100582*x5^2*x7^6 + (-5197972)*x2*x6*x7^6 +(-7058676)*x3*x6*x7^6 + (-9973254)*x4*x6*x7^6 + 1778627*x5*x6*x7^6 + (-15854292)*x6^2*x7^6 + 3083215*x2*x7^7 + 4380005*x3*x7^7 + 5434827*x4*x7^7 + 3442599*x5*x7^7 + (-3901182)*x6*x7^7 + 3083215*x7^8 + (-1006640)*x2 + (-711698)*x3 + (-1793164)*x4 + (-887370)*x5 + 3357876*x6 + 2536173*x7""",\
"""18*x4^2*x5^3*x6^3 + (-36)*x3^2*x4*x5^4*x7 + 36*x3^3*x5^3*x6*x7 + 36*x3^2*x5^4*x6*x7 + (-72)*x3*x5^4*x6^2*x7 + (-56)*x3^2*x5^2*x6^3*x7 + 847*x2*x4*x5^2*x6^3*x7 + 859*x4^2*x5^2*x6^3*x7 + 328*x2*x5^3*x6^3*x7 + 236*x3*x5^3*x6^3*x7 + 2377*x4*x5^3*x6^3*x7 + 364*x5^4*x6^3*x7 + (-18)*x2*x3*x5*x6^4*x7 + 48*x2*x4*x5*x6^4*x7 + 96*x3*x4*x5*x6^4*x7 + 48*x4^2*x5*x6^4*x7 + 42*x2*x5^2*x6^4*x7 + (-14)*x3*x5^2*x6^4*x7 + 895*x4*x5^2*x6^4*x7 + 426*x5^3*x6^4*x7 + 48*x4*x5*x6^5*x7 + 24*x5^2*x6^5*x7 + (-18)*x3^4*x5^2*x7^2 + (-18)*x3^3*x5^3*x7^2 + (-818)*x3^2*x4*x5^3*x7^2 + (-230)*x2*x4^2*x5^3*x7^2 + (-362)*x4^3*x5^3*x7^2 + 18*x2*x3*x5^4*x7^2 + 18*x3^2*x5^4*x7^2 + (-18)*x2*x4*x5^4*x7^2 + (-814)*x3*x4*x5^4*x7^2 + (-378)*x4^2*x5^4*x7^2 + 18*x3*x5^5*x7^2 + (-18)*x4*x5^5*x7^2 + 32*x3*x4^4*x6*x7^2 + 27*x3^4*x5*x6*x7^2 + 732*x2*x4^3*x5*x6*x7^2 + 732*x4^4*x5*x6*x7^2 + (-365)*x3^3*x5^2*x6*x7^2 + (-1755)*x3^2*x5^3*x6*x7^2 + (-8807)*x2*x4*x5^3*x6*x7^2 + (-1210)*x2*x5^4*x6*x7^2 + (-2663)*x3*x5^4*x6*x7^2 + (-8564)*x4*x5^4*x6*x7^2 + (-1210)*x5^5*x6*x7^2 + 18*x3^4*x6^2*x7^2 + 104*x3^2*x4^2*x6^2*x7^2 + 32*x2*x4^3*x6^2*x7^2 + 183*x3*x4^3*x6^2*x7^2 + 32*x4^4*x6^2*x7^2 + 39*x3^3*x5*x6^2*x7^2 + 86538*x3*x4^2*x5*x6^2*x7^2 + 764*x4^3*x5*x6^2*x7^2 +2620*x2*x3*x5^2*x6^2*x7^2 + 1324*x3^2*x5^2*x6^2*x7^2 + (-64957)*x2*x4*x5^2*x6^2*x7^2 + (-12308)*x3*x4*x5^2*x6^2*x7^2 + 1907*x4^2*x5^2*x6^2*x7^2 + (-7333)*x2*x5^3*x6^2*x7^2 + (-6731)*x3*x5^3*x6^2*x7^2 + (-72325)*x4*x5^3*x6^2*x7^2 + (-6996)*x5^4*x6^2*x7^2 + 95*x3^3*x6^3*x7^2 + 306*x2*x3*x4*x6^3*x7^2 + 26*x3^2*x4*x6^3*x7^2 + 88*x2*x4^2*x6^3*x7^2 + 349*x3*x4^2*x6^3*x7^2 + 120*x4^3*x6^3*x7^2 + (-3558)*x2*x3*x5*x6^3*x7^2 + (-407)*x3^2*x5*x6^3*x7^2 + (-60965)*x2*x4*x5*x6^3*x7^2 + 5792*x3*x4*x5*x6^3*x7^2 + (-60708)*x4^2*x5*x6^3*x7^2 + (-25636)*x2*x5^2*x6^3*x7^2 + (-24766)*x3*x5^2*x6^3*x7^2 + 7772*x4*x5^2*x6^3*x7^2 + (-31154)*x5^3*x6^3*x7^2 + 13*x2*x3*x6^4*x7^2 + 112*x3^2*x6^4*x7^2 + 32*x2*x4*x6^4*x7^2 + 71*x3*x4*x6^4*x7^2 + 120*x4^2*x6^4*x7^2 + (-641)*x2*x5*x6^4*x7^2 + (-1143)*x3*x5*x6^4*x7^2 + (-61154)*x4*x5*x6^4*x7^2 + (-29435)*x5^2*x6^4*x7^2 + (-24)*x2*x6^5*x7^2 + 11*x3*x6^5*x7^2 + 8*x4*x6^5*x7^2 + (-705)*x5*x6^5*x7^2 + (-24)*x6^6*x7^2 + 36*x3^4*x5*x7^3 + (-34555)*x3*x4^3*x5*x7^3 + (-68)*x3^3*x5^2*x7^3 + (-20631)*x3^2*x4*x5^2*x7^3 + 2853*x2*x4^2*x5^2*x7^3 + 27891*x3*x4^2*x5^2*x7^3 + (-21041)*x4^3*x5^2*x7^3 + (-50)*x2*x3*x5^3*x7^3 + (-136)*x3^2*x5^3*x7^3 + 1656*x2*x4*x5^3*x7^3 + (-10368)*x3*x4*x5^3*x7^3 + 3927*x4^2*x5^3*x7^3 + 18*x2*x5^4*x7^3 + (-14)*x3*x5^4*x7^3 + 1656*x4*x5^4*x7^3 + 18*x5^5*x7^3 + (-36)*x3^4*x6*x7^3 + (-48860)*x3^2*x4^2*x6*x7^3 + (-32)*x2*x4^3*x6*x7^3 + (-51211)*x3*x4^3*x6*x7^3 + (-32)*x4^4*x6*x7^3 + 7441*x3^3*x5*x6*x7^3 + 68696*x3^2*x4*x5*x6*x7^3 + (-20543)*x2*x4^2*x5*x6*x7^3 + (-3919)*x3*x4^2*x5*x6*x7^3 + (-19843)*x4^3*x5*x6*x7^3 + (-26947)*x2*x3*x5^2*x6*x7^3 + (-2007)*x3^2*x5^2*x6*x7^3 + 16488*x2*x4*x5^2*x6*x7^3 + 15769*x3*x4*x5^2*x6*x7^3+ 6625*x4^2*x5^2*x6*x7^3 + (-9492)*x2*x5^3*x6*x7^3 + (-19838)*x3*x5^3*x6*x7^3 + (-16967)*x4*x5^3*x6*x7^3 + (-10666)*x5^4*x6*x7^3 + (-651)*x3^3*x6^2*x7^3+ 143048*x2*x3*x4*x6^2*x7^3 + 45544*x3^2*x4*x6^2*x7^3 + (-29100)*x2*x4^2*x6^2*x7^3 + (-63855)*x3*x4^2*x6^2*x7^3 + (-29100)*x4^3*x6^2*x7^3 + 236908*x2*x3*x5*x6^2*x7^3 + 94739*x3^2*x5*x6^2*x7^3 + 176248*x2*x4*x5*x6^2*x7^3 + 544436*x3*x4*x5*x6^2*x7^3 + 148246*x4^2*x5*x6^2*x7^3 + 107825*x2*x5^2*x6^2*x7^3 + 193483*x3*x5^2*x6^2*x7^3 + 289473*x4*x5^2*x6^2*x7^3 + 75257*x5^3*x6^2*x7^3 + (-15835)*x2*x3*x6^3*x7^3 + 29507*x3^2*x6^3*x7^3 + 1313*x2*x4*x6^3*x7^3 + 31173*x3*x4*x6^3*x7^3 + (-27559)*x4^2*x6^3*x7^3 + (-5429)*x2*x5*x6^3*x7^3 + 112661*x3*x5*x6^3*x7^3 + 320284*x4*x5*x6^3*x7^3 + 303906*x5^2*x6^3*x7^3 + 30356*x2*x6^4*x7^3 + 60395*x3*x6^4*x7^3 + 31957*x4*x6^4*x7^3 + (-24704)*x5*x6^4*x7^3 + 30310*x6^5*x7^3 + 28605*x3^2*x4^2*x7^4 + 34555*x3*x4^3*x7^4 + 18432*x3^3*x5*x7^4 + 89116*x2*x3*x4*x5*x7^4 + (-25548)*x3^2*x4*x5*x7^4 + 55958*x2*x4^2*x5*x7^4 + (-47822)*x3*x4^2*x5*x7^4 + 55958*x4^3*x5*x7^4 + 19093*x2*x3*x5^2*x7^4 + 35184*x3^2*x5^2*x7^4 + (-15097)*x2*x4*x5^2*x7^4 + (-23027)*x3*x4*x5^2*x7^4 + (-11957)*x4^2*x5^2*x7^4 + (-1260)*x2*x5^3*x7^4 + 15564*x3*x5^3*x7^4 + (-12482)*x4*x5^3*x7^4 + (-1242)*x5^4*x7^4 + (-18432)*x3^3*x6*x7^4 + (-137864)*x2*x3*x4*x6*x7^4 + (-77530)*x3^2*x4*x6*x7^4 + 64331*x2*x4^2*x6*x7^4 + (-18087)*x3*x4^2*x6*x7^4 + 64299*x4^3*x6*x7^4 + 55363*x2*x3*x5*x6*x7^4 + (-23488)*x3^2*x5*x6*x7^4 + 11683*x2*x4*x5*x6*x7^4 + 27802*x3*x4*x5*x6*x7^4 + 66314*x4^2*x5*x6*x7^4 + (-46309)*x2*x5^2*x6*x7^4 + (-100418)*x3*x5^2*x6*x7^4 + 84180*x4*x5^2*x6*x7^4 + (-58339)*x5^3*x6*x7^4 + (-481378)*x2*x3*x6^2*x7^4 + (-181162)*x3^2*x6^2*x7^4 + (-207090)*x2*x4*x6^2*x7^4 + (-706065)*x3*x4*x6^2*x7^4 + (-159821)*x4^2*x6^2*x7^4 + (-275927)*x2*x5*x6^2*x7^4 + (-384414)*x3*x5*x6^2*x7^4 + (-613941)*x4*x5*x6^2*x7^4 + (-196313)*x5^2*x6^2*x7^4 + (-119760)*x2*x6^3*x7^4 + (-251215)*x3*x6^3*x7^4 + (-342534)*x4*x6^3*x7^4 + (-456871)*x5*x6^3*x7^4 + (-135320)*x6^4*x7^4 + (-87165)*x2*x3*x4*x7^5 + 13855*x3^2*x4*x7^5 + (-34555)*x2*x4^2*x7^5 + 13855*x3*x4^2*x7^5 + (-34555)*x4^3*x7^5 + 29938*x2*x3*x5*x7^5 + 67026*x3^2*x5*x7^5 + 72995*x2*x4*x5*x7^5 + (-15730)*x3*x4*x5*x7^5 + 94398*x4^2*x5*x7^5 + 8413*x2*x5^2*x7^5 + 73917*x3*x5^2*x7^5 + 47619*x4*x5^2*x7^5 + 7153*x5^3*x7^5 + 179590*x2*x3*x6*x7^5 + 84912*x3^2*x6*x7^5 + 233128*x2*x4*x6*x7^5 + 343093*x3*x4*x6*x7^5 + 262904*x4^2*x6*x7^5 + (-155101)*x2*x5*x6*x7^5 + (-46475)*x3*x5*x6*x7^5 + 193424*x4*x5*x6*x7^5 + (-178868)*x5^2*x6*x7^5 + 271105*x2*x6^2*x7^5 + 230640*x3*x6^2*x7^5 + 320949*x4*x6^2*x7^5 + (-81552)*x5*x6^2*x7^5 + (-167864)*x6^3*x7^5 + 16100*x2*x3*x7^6 + (-42460)*x3^2*x7^6 + (-77015)*x2*x4*x7^6 + (-47060)*x3*x4*x7^6 + (-111570)*x4^2*x7^6 + (-11858)*x2*x5*x7^6 + (-5688)*x3*x5*x7^6 + 42682*x4*x5*x7^6 + (-3445)*x5^2*x7^6 + 170716*x2*x6*x7^6 + 231564*x3*x6*x7^6 + 326829*x4*x6*x7^6 + (-57395)*x5*x6*x7^6 + 518103*x6^2*x7^6 + (-101020)*x2*x7^7 + (-143480)*x3*x7^7 + (-178035)*x4*x7^7 + (-112878)*x5*x7^7 + 128256*x6*x7^7 + (-101020)*x7^8 + 32876*x2 + 23189*x3 + 58585*x4 + 28986*x5 + (-109695)*x6 + (-83061)*x7""",\
"""144*x4^2*x5^3*x6^3 + (-144)*x3^2*x4*x5^4*x7 + 144*x3^3*x5^3*x6*x7 + 144*x3^2*x5^4*x6*x7 + (-288)*x3*x5^4*x6^2*x7 + (-146)*x3^2*x5^2*x6^3*x7 + 4024*x2*x4*x5^2*x6^3*x7 + 4288*x4^2*x5^2*x6^3*x7 + 1570*x2*x5^3*x6^3*x7 + 1280*x3*x5^3*x6^3*x7 + 11278*x4*x5^3*x6^3*x7 + 1714*x5^4*x6^3*x7 + 336*x2*x4*x5*x6^4*x7 +708*x3*x4*x5*x6^4*x7 + 336*x4^2*x5*x6^4*x7 + 168*x2*x5^2*x6^4*x7 + 22*x3*x5^2*x6^4*x7 + 4792*x4*x5^2*x6^4*x7 + 1884*x5^3*x6^4*x7 + 336*x4*x5*x6^5*x7 + 168*x5^2*x6^5*x7 + (-72)*x3^4*x5^2*x7^2 + (-72)*x3^3*x5^3*x7^2 + (-3968)*x3^2*x4*x5^3*x7^2 + (-1310)*x2*x4^2*x5^3*x7^2 + (-1730)*x4^3*x5^3*x7^2 + 72*x2*x3*x5^4*x7^2 + 72*x3^2*x5^4*x7^2 + (-72)*x2*x4*x5^4*x7^2 + (-3946)*x3*x4*x5^4*x7^2 + (-1872)*x4^2*x5^4*x7^2 + 72*x3*x5^5*x7^2 + (-72)*x4*x5^5*x7^2 + 158*x3*x4^4*x6*x7^2 + 162*x3^4*x5*x6*x7^2 + 3684*x2*x4^3*x5*x6*x7^2 + 3684*x4^4*x5*x6*x7^2 + (-1652)*x3^3*x5^2*x6*x7^2 + (-8622)*x3^2*x5^3*x6*x7^2 + (-42836)*x2*x4*x5^3*x6*x7^2 + (-5890)*x2*x5^4*x6*x7^2 + (-13058)*x3*x5^4*x6*x7^2 + (-41558)*x4*x5^4*x6*x7^2 + (-5890)*x5^5*x6*x7^2 + 72*x3^4*x6^2*x7^2 + 32*x3^2*x4^2*x6^2*x7^2 + 158*x2*x4^3*x6^2*x7^2 + 696*x3*x4^3*x6^2*x7^2 + 158*x4^4*x6^2*x7^2 + 210*x3^3*x5*x6^2*x7^2 + 421302*x3*x4^2*x5*x6^2*x7^2 + 3842*x4^3*x5*x6^2*x7^2 + 12106*x2*x3*x5^2*x6^2*x7^2 + 6904*x3^2*x5^2*x6^2*x7^2 + (-317758)*x2*x4*x5^2*x6^2*x7^2 + (-61142)*x3*x4*x5^2*x6^2*x7^2 + 7946*x4^2*x5^2*x6^2*x7^2 + (-35944)*x2*x5^3*x6^2*x7^2 + (-32624)*x3*x5^3*x6^2*x7^2 + (-354340)*x4*x5^3*x6^2*x7^2 + (-34320)*x5^4*x6^2*x7^2 + 464*x3^3*x6^3*x7^2 + 1872*x2*x3*x4*x6^3*x7^2 + (-82)*x3^2*x4*x6^3*x7^2 + 484*x2*x4^2*x6^3*x7^2 + 1582*x3*x4^2*x6^3*x7^2 + 642*x4^3*x6^3*x7^2 + (-16374)*x2*x3*x5*x6^3*x7^2 + (-1802)*x3^2*x5*x6^3*x7^2 + (-296432)*x2*x4*x5*x6^3*x7^2 + 30128*x3*x4*x5*x6^3*x7^2 + (-294744)*x4^2*x5*x6^3*x7^2 + (-124510)*x2*x5^2*x6^3*x7^2 + (-119248)*x3*x5^2*x6^3*x7^2 + 37976*x4*x5^2*x6^3*x7^2 + (-152762)*x5^3*x6^3*x7^2 + (-32)*x2*x3*x6^4*x7^2 + 544*x3^2*x6^4*x7^2 + 158*x2*x4*x6^4*x7^2 + 44*x3*x4*x6^4*x7^2 + 642*x4^2*x6^4*x7^2 + (-3530)*x2*x5*x6^4*x7^2 + (-5868)*x3*x5*x6^4*x7^2 + (-296972)*x4*x5*x6^4*x7^2 + (-142448)*x5^2*x6^4*x7^2 + (-168)*x2*x6^5*x7^2 + (-16)*x3*x6^5*x7^2 + (-10)*x4*x6^5*x7^2 + (-3882)*x5*x6^5*x7^2 + (-168)*x6^6*x7^2 + 252*x3^4*x5*x7^3 + (-167314)*x3*x4^3*x5*x7^3 + 130*x3^3*x5^2*x7^3 + (-100308)*x3^2*x4*x5^2*x7^3 + 13878*x2*x4^2*x5^2*x7^3 + 134208*x3*x4^2*x5^2*x7^3 + (-102230)*x4^3*x5^2*x7^3 + (-14)*x2*x3*x5^3*x7^3 + (-64)*x3^2*x5^3*x7^3 + 7848*x2*x4*x5^3*x7^3 + (-50400)*x3*x4*x5^3*x7^3 + 19092*x4^2*x5^3*x7^3 + 72*x2*x5^4*x7^3 + 130*x3*x5^4*x7^3 + 7848*x4*x5^4*x7^3 + 72*x5^5*x7^3 + (-252)*x3^4*x6*x7^3 + (-238508)*x3^2*x4^2*x6*x7^3 + (-158)*x2*x4^3*x6*x7^3 + (-248842)*x3*x4^3*x6*x7^3 + (-158)*x4^4*x6*x7^3 + 35602*x3^3*x5*x6*x7^3 + 334367*x3^2*x4*x5*x6*x7^3 + (-98294)*x2*x4^2*x5*x6*x7^3 + (-19930)*x3*x4^2*x5*x6*x7^3 + (-94768)*x4^3*x5*x6*x7^3 + (-132940)*x2*x3*x5^2*x6*x7^3 + (-10584)*x3^2*x5^2*x6*x7^3 + 81054*x2*x4*x5^2*x6*x7^3 + 73738*x3*x4*x5^2*x6*x7^3 + 31537*x4^2*x5^2*x6*x7^3 + (-46464)*x2*x5^3*x6*x7^3 + (-97598)*x3*x5^3*x6*x7^3 + (-82748)*x4*x5^3*x6*x7^3 + (-52210)*x5^4*x6*x7^3 + (-3630)*x3^3*x6^2*x7^3 + 696656*x2*x3*x4*x6^2*x7^3 + 221620*x3^2*x4*x6^2*x7^3 + (-141366)*x2*x4^2*x6^2*x7^3 + (-310356)*x3*x4^2*x6^2*x7^3 + (-141366)*x4^3*x6^2*x7^3 + 1155592*x2*x3*x5*x6^2*x7^3 + 460940*x3^2*x5*x6^2*x7^3 + 859996*x2*x4*x5*x6^2*x7^3 + 2654342*x3*x4*x5*x6^2*x7^3 + 725146*x4^2*x5*x6^2*x7^3 + 526100*x2*x5^2*x6^2*x7^3 + 944380*x3*x5^2*x6^2*x7^3 + 1410774*x4*x5^2*x6^2*x7^3 + 366398*x5^3*x6^2*x7^3 + (-77890)*x2*x3*x6^3*x7^3 + 143204*x3^2*x6^3*x7^3 + 6182*x2*x4*x6^3*x7^3 + 150306*x3*x4*x6^3*x7^3 + (-133876)*x4^2*x6^3*x7^3 + (-27488)*x2*x5*x6^3*x7^3 + 548630*x3*x5*x6^3*x7^3 + 1560736*x4*x5*x6^3*x7^3 + 1480980*x5^2*x6^3*x7^3 + 147518*x2*x6^4*x7^3 + 293612*x3*x6^4*x7^3 + 155482*x4*x6^4*x7^3 + (-121670)*x5*x6^4*x7^3 + 147166*x6^5*x7^3 + 139044*x3^2*x4^2*x7^4 + 167314*x3*x4^3*x7^4 + 89946*x3^3*x5*x7^4 + 434113*x2*x3*x4*x5*x7^4 + (-123828)*x3^2*x4*x5*x7^4 + 271274*x2*x4^2*x5*x7^4 + (-229370)*x3*x4^2*x5*x7^4 + 271274*x4^3*x5*x7^4 + 93694*x2*x3*x5^2*x7^4 + 172650*x3^2*x5^2*x7^4 + (-73552)*x2*x4*x5^2*x7^4 + (-109994)*x3*x4*x5^2*x7^4 + (-57470)*x4^2*x5^2*x7^4 + (-5904)*x2*x5^3*x7^4 + 77088*x3*x5^3*x7^4 + (-60920)*x4*x5^3*x7^4 + (-5832)*x5^4*x7^4 + (-89946)*x3^3*x6*x7^4 + (-673994)*x2*x3*x4*x6*x7^4 + (-376132)*x3^2*x4*x6*x7^4 + 312038*x2*x4^2*x6*x7^4 + (-89718)*x3*x4^2*x6*x7^4 + 311880*x4^3*x6*x7^4 + 266962*x2*x3*x5*x6*x7^4 + (-117934)*x3^2*x5*x6*x7^4 + 58636*x2*x4*x5*x6*x7^4 + 130429*x3*x4*x5*x6*x7^4 + 324614*x4^2*x5*x6*x7^4 + (-225094)*x2*x5^2*x6*x7^4 + (-491360)*x3*x5^2*x6*x7^4 + 412986*x4*x5^2*x6*x7^4 + (-283438)*x5^3*x6*x7^4 + (-2345773)*x2*x3*x6^2*x7^4 + (-883342)*x3^2*x6^2*x7^4 + (-1007370)*x2*x4*x6^2*x7^4 + (-3438753)*x3*x4*x6^2*x7^4 + (-778130)*x4^2*x6^2*x7^4 + (-1343066)*x2*x5*x6^2*x7^4 + (-1872402)*x3*x5*x6^2*x7^4 + (-2990085)*x4*x5*x6^2*x7^4 + (-955499)*x5^2*x6^2*x7^4 + (-582018)*x2*x6^3*x7^4 + (-1222684)*x3*x6^3*x7^4 + (-1665804)*x4*x6^3*x7^4 + (-2223553)*x5*x6^3*x7^4 + (-658724)*x6^4*x7^4 + (-422199)*x2*x3*x4*x7^5 + 66766*x3^2*x4*x7^5 + (-167314)*x2*x4^2*x7^5 + 66766*x3*x4^2*x7^5 + (-167314)*x4^3*x7^5 + 145750*x2*x3*x5*x7^5 + 326640*x3^2*x5*x7^5 + 353480*x2*x4*x5*x7^5 + (-75067)*x3*x4*x5*x7^5 + 457440*x4^2*x5*x7^5 + 41398*x2*x5^2*x7^5 + 361350*x3*x5^2*x7^5 + 230130*x4*x5^2*x7^5 + 35494*x5^3*x7^5 + 876991*x2*x3*x6*x7^5 + 411828*x3^2*x6*x7^5 + 1132282*x2*x4*x6*x7^5 + 1671637*x3*x4*x6*x7^5 + 1277006*x4^2*x6*x7^5 + (-755383)*x2*x5*x6*x7^5 + (-231461)*x3*x5*x6*x7^5 + 945158*x4*x5*x6*x7^5 + (-870329)*x5^2*x6*x7^5 + 1323907*x2*x6^2*x7^5 + 1124673*x3*x6^2*x7^5 + 1563291*x4*x6^2*x7^5 + (-391323)*x5*x6^2*x7^5 + (-813434)*x6^3*x7^5 + 77345*x2*x3*x7^6 + (-205810)*x3^2*x7^6 + (-373124)*x2*x4*x7^6 + (-229013)*x3*x4*x7^6 + (-540438)*x4^2*x7^6 + (-56552)*x2*x5*x7^6 + (-25416)*x3*x5*x7^6 + 206959*x4*x5*x7^6 + (-15154)*x5^2*x7^6 + 822172*x2*x6*x7^6 + 1117884*x3*x6*x7^6 + 1581330*x4*x6*x7^6 + (-286769)*x5*x6*x7^6 + 2521548*x6^2*x7^6 + (-488965)*x2*x7^7 + (-694775)*x3*x7^7 + (-862089)*x4*x7^7 + (-545517)*x5*x7^7 + 616362*x6*x7^7 + (-488965)*x7^8 + 160208*x2 + 113558*x3 + 285268*x4 + 141198*x5 + (-534252)*x6 + (-402399)*x7""",\
"""18*x4^2*x5^3*x6^3 + (-36)*x3^2*x4*x5^4*x7 + 36*x3^3*x5^3*x6*x7 + 36*x3^2*x5^4*x6*x7 + (-72)*x3*x5^4*x6^2*x7 + (-56)*x3^2*x5^2*x6^3*x7 + 847*x2*x4*x5^2*x6^3*x7 + 859*x4^2*x5^2*x6^3*x7 + 328*x2*x5^3*x6^3*x7 + 236*x3*x5^3*x6^3*x7 + 2377*x4*x5^3*x6^3*x7 + 364*x5^4*x6^3*x7 + (-18)*x2*x3*x5*x6^4*x7 + 48*x2*x4*x5*x6^4*x7 + 96*x3*x4*x5*x6^4*x7 + 48*x4^2*x5*x6^4*x7 + 42*x2*x5^2*x6^4*x7 + (-14)*x3*x5^2*x6^4*x7 + 895*x4*x5^2*x6^4*x7 + 426*x5^3*x6^4*x7 + 48*x4*x5*x6^5*x7 + 24*x5^2*x6^5*x7 + (-18)*x3^4*x5^2*x7^2 + (-18)*x3^3*x5^3*x7^2 + (-818)*x3^2*x4*x5^3*x7^2 + (-230)*x2*x4^2*x5^3*x7^2 + (-362)*x4^3*x5^3*x7^2 + 18*x2*x3*x5^4*x7^2 + 18*x3^2*x5^4*x7^2 + (-18)*x2*x4*x5^4*x7^2 + (-814)*x3*x4*x5^4*x7^2 + (-378)*x4^2*x5^4*x7^2 + 18*x3*x5^5*x7^2 + (-18)*x4*x5^5*x7^2 + 32*x3*x4^4*x6*x7^2 + 27*x3^4*x5*x6*x7^2 + 732*x2*x4^3*x5*x6*x7^2 + 732*x4^4*x5*x6*x7^2 + (-365)*x3^3*x5^2*x6*x7^2 + (-1755)*x3^2*x5^3*x6*x7^2 + (-8807)*x2*x4*x5^3*x6*x7^2 + (-1210)*x2*x5^4*x6*x7^2 + (-2663)*x3*x5^4*x6*x7^2 + (-8564)*x4*x5^4*x6*x7^2 + (-1210)*x5^5*x6*x7^2 + 18*x3^4*x6^2*x7^2 + 104*x3^2*x4^2*x6^2*x7^2 + 32*x2*x4^3*x6^2*x7^2 + 183*x3*x4^3*x6^2*x7^2 + 32*x4^4*x6^2*x7^2 + 39*x3^3*x5*x6^2*x7^2 + 86538*x3*x4^2*x5*x6^2*x7^2 + 764*x4^3*x5*x6^2*x7^2 +2620*x2*x3*x5^2*x6^2*x7^2 + 1324*x3^2*x5^2*x6^2*x7^2 + (-64957)*x2*x4*x5^2*x6^2*x7^2 + (-12308)*x3*x4*x5^2*x6^2*x7^2 + 1907*x4^2*x5^2*x6^2*x7^2 + (-7333)*x2*x5^3*x6^2*x7^2 + (-6731)*x3*x5^3*x6^2*x7^2 + (-72325)*x4*x5^3*x6^2*x7^2 + (-6996)*x5^4*x6^2*x7^2 + 95*x3^3*x6^3*x7^2 + 306*x2*x3*x4*x6^3*x7^2 + 26*x3^2*x4*x6^3*x7^2 + 88*x2*x4^2*x6^3*x7^2 + 349*x3*x4^2*x6^3*x7^2 + 120*x4^3*x6^3*x7^2 + (-3558)*x2*x3*x5*x6^3*x7^2 + (-407)*x3^2*x5*x6^3*x7^2 + (-60965)*x2*x4*x5*x6^3*x7^2 + 5792*x3*x4*x5*x6^3*x7^2 + (-60708)*x4^2*x5*x6^3*x7^2 + (-25636)*x2*x5^2*x6^3*x7^2 + (-24766)*x3*x5^2*x6^3*x7^2 + 7772*x4*x5^2*x6^3*x7^2 + (-31154)*x5^3*x6^3*x7^2 + 13*x2*x3*x6^4*x7^2 + 112*x3^2*x6^4*x7^2 + 32*x2*x4*x6^4*x7^2 + 71*x3*x4*x6^4*x7^2 + 120*x4^2*x6^4*x7^2 + (-641)*x2*x5*x6^4*x7^2 + (-1143)*x3*x5*x6^4*x7^2 + (-61154)*x4*x5*x6^4*x7^2 + (-29435)*x5^2*x6^4*x7^2 + (-24)*x2*x6^5*x7^2 + 11*x3*x6^5*x7^2 + 8*x4*x6^5*x7^2 + (-705)*x5*x6^5*x7^2 + (-24)*x6^6*x7^2 + 36*x3^4*x5*x7^3 + (-34555)*x3*x4^3*x5*x7^3 + (-68)*x3^3*x5^2*x7^3 + (-20631)*x3^2*x4*x5^2*x7^3 + 2853*x2*x4^2*x5^2*x7^3 + 27891*x3*x4^2*x5^2*x7^3 + (-21041)*x4^3*x5^2*x7^3 + (-50)*x2*x3*x5^3*x7^3 + (-136)*x3^2*x5^3*x7^3 + 1656*x2*x4*x5^3*x7^3 + (-10368)*x3*x4*x5^3*x7^3 + 3927*x4^2*x5^3*x7^3 + 18*x2*x5^4*x7^3 + (-14)*x3*x5^4*x7^3 + 1656*x4*x5^4*x7^3 + 18*x5^5*x7^3 + (-36)*x3^4*x6*x7^3 + (-48860)*x3^2*x4^2*x6*x7^3 + (-32)*x2*x4^3*x6*x7^3 + (-51211)*x3*x4^3*x6*x7^3 + (-32)*x4^4*x6*x7^3 + 7441*x3^3*x5*x6*x7^3 + 68696*x3^2*x4*x5*x6*x7^3 + (-20543)*x2*x4^2*x5*x6*x7^3 + (-3919)*x3*x4^2*x5*x6*x7^3 + (-19843)*x4^3*x5*x6*x7^3 + (-26947)*x2*x3*x5^2*x6*x7^3 + (-2007)*x3^2*x5^2*x6*x7^3 + 16488*x2*x4*x5^2*x6*x7^3 + 15769*x3*x4*x5^2*x6*x7^3+ 6625*x4^2*x5^2*x6*x7^3 + (-9492)*x2*x5^3*x6*x7^3 + (-19838)*x3*x5^3*x6*x7^3 + (-16967)*x4*x5^3*x6*x7^3 + (-10666)*x5^4*x6*x7^3 + (-651)*x3^3*x6^2*x7^3+ 143048*x2*x3*x4*x6^2*x7^3 + 45544*x3^2*x4*x6^2*x7^3 + (-29100)*x2*x4^2*x6^2*x7^3 + (-63855)*x3*x4^2*x6^2*x7^3 + (-29100)*x4^3*x6^2*x7^3 + 236908*x2*x3*x5*x6^2*x7^3 + 94739*x3^2*x5*x6^2*x7^3 + 176248*x2*x4*x5*x6^2*x7^3 + 544436*x3*x4*x5*x6^2*x7^3 + 148246*x4^2*x5*x6^2*x7^3 + 107825*x2*x5^2*x6^2*x7^3 + 193483*x3*x5^2*x6^2*x7^3 + 289473*x4*x5^2*x6^2*x7^3 + 75257*x5^3*x6^2*x7^3 + (-15835)*x2*x3*x6^3*x7^3 + 29507*x3^2*x6^3*x7^3 + 1313*x2*x4*x6^3*x7^3 + 31173*x3*x4*x6^3*x7^3 + (-27559)*x4^2*x6^3*x7^3 + (-5429)*x2*x5*x6^3*x7^3 + 112661*x3*x5*x6^3*x7^3 + 320284*x4*x5*x6^3*x7^3 + 303906*x5^2*x6^3*x7^3 + 30356*x2*x6^4*x7^3 + 60395*x3*x6^4*x7^3 + 31957*x4*x6^4*x7^3 + (-24704)*x5*x6^4*x7^3 + 30310*x6^5*x7^3 + 28605*x3^2*x4^2*x7^4 + 34555*x3*x4^3*x7^4 + 18432*x3^3*x5*x7^4 + 89116*x2*x3*x4*x5*x7^4 + (-25548)*x3^2*x4*x5*x7^4 + 55958*x2*x4^2*x5*x7^4 + (-47822)*x3*x4^2*x5*x7^4 + 55958*x4^3*x5*x7^4 + 19093*x2*x3*x5^2*x7^4 + 35184*x3^2*x5^2*x7^4 + (-15097)*x2*x4*x5^2*x7^4 + (-23027)*x3*x4*x5^2*x7^4 + (-11957)*x4^2*x5^2*x7^4 + (-1260)*x2*x5^3*x7^4 + 15564*x3*x5^3*x7^4 + (-12482)*x4*x5^3*x7^4 + (-1242)*x5^4*x7^4 + (-18432)*x3^3*x6*x7^4 + (-137864)*x2*x3*x4*x6*x7^4 + (-77530)*x3^2*x4*x6*x7^4 + 64331*x2*x4^2*x6*x7^4 + (-18087)*x3*x4^2*x6*x7^4 + 64299*x4^3*x6*x7^4 + 55363*x2*x3*x5*x6*x7^4 + (-23488)*x3^2*x5*x6*x7^4 + 11683*x2*x4*x5*x6*x7^4 + 27802*x3*x4*x5*x6*x7^4 + 66314*x4^2*x5*x6*x7^4 + (-46309)*x2*x5^2*x6*x7^4 + (-100418)*x3*x5^2*x6*x7^4 + 84180*x4*x5^2*x6*x7^4 + (-58339)*x5^3*x6*x7^4 + (-481378)*x2*x3*x6^2*x7^4 + (-181162)*x3^2*x6^2*x7^4 + (-207090)*x2*x4*x6^2*x7^4 + (-706065)*x3*x4*x6^2*x7^4 + (-159821)*x4^2*x6^2*x7^4 + (-275927)*x2*x5*x6^2*x7^4 + (-384414)*x3*x5*x6^2*x7^4 + (-613941)*x4*x5*x6^2*x7^4 + (-196313)*x5^2*x6^2*x7^4 + (-119760)*x2*x6^3*x7^4 + (-251215)*x3*x6^3*x7^4 + (-342534)*x4*x6^3*x7^4 + (-456871)*x5*x6^3*x7^4 + (-135320)*x6^4*x7^4 + (-87165)*x2*x3*x4*x7^5 + 13855*x3^2*x4*x7^5 + (-34555)*x2*x4^2*x7^5 + 13855*x3*x4^2*x7^5 + (-34555)*x4^3*x7^5 + 29938*x2*x3*x5*x7^5 + 67026*x3^2*x5*x7^5 + 72995*x2*x4*x5*x7^5 + (-15730)*x3*x4*x5*x7^5 + 94398*x4^2*x5*x7^5 + 8413*x2*x5^2*x7^5 + 73917*x3*x5^2*x7^5 + 47619*x4*x5^2*x7^5 + 7153*x5^3*x7^5 + 179590*x2*x3*x6*x7^5 + 84912*x3^2*x6*x7^5 + 233128*x2*x4*x6*x7^5 + 343093*x3*x4*x6*x7^5 + 262904*x4^2*x6*x7^5 + (-155101)*x2*x5*x6*x7^5 + (-46475)*x3*x5*x6*x7^5 + 193424*x4*x5*x6*x7^5 + (-178868)*x5^2*x6*x7^5 + 271105*x2*x6^2*x7^5 + 230640*x3*x6^2*x7^5 + 320949*x4*x6^2*x7^5 + (-81552)*x5*x6^2*x7^5 + (-167864)*x6^3*x7^5 + 16100*x2*x3*x7^6 + (-42460)*x3^2*x7^6 + (-77015)*x2*x4*x7^6 + (-47060)*x3*x4*x7^6 + (-111570)*x4^2*x7^6 + (-11858)*x2*x5*x7^6 + (-5688)*x3*x5*x7^6 + 42682*x4*x5*x7^6 + (-3445)*x5^2*x7^6 + 170716*x2*x6*x7^6 + 231564*x3*x6*x7^6 + 326829*x4*x6*x7^6 + (-57395)*x5*x6*x7^6 + 518103*x6^2*x7^6 + (-101020)*x2*x7^7 + (-143480)*x3*x7^7 + (-178035)*x4*x7^7 + (-112878)*x5*x7^7 + 128256*x6*x7^7 + (-101020)*x7^8 + 32876*x2 + 23189*x3 + 58585*x4 + 28986*x5 + (-109695)*x6 + (-83061)*x7""",\
"""144*x4^2*x5^3*x6^3 + (-144)*x3^2*x4*x5^4*x7 + 144*x3^3*x5^3*x6*x7 + 144*x3^2*x5^4*x6*x7 + (-288)*x3*x5^4*x6^2*x7 + (-146)*x3^2*x5^2*x6^3*x7 + 4024*x2*x4*x5^2*x6^3*x7 + 4288*x4^2*x5^2*x6^3*x7 + 1570*x2*x5^3*x6^3*x7 + 1280*x3*x5^3*x6^3*x7 + 11278*x4*x5^3*x6^3*x7 + 1714*x5^4*x6^3*x7 + 336*x2*x4*x5*x6^4*x7 +708*x3*x4*x5*x6^4*x7 + 336*x4^2*x5*x6^4*x7 + 168*x2*x5^2*x6^4*x7 + 22*x3*x5^2*x6^4*x7 + 4792*x4*x5^2*x6^4*x7 + 1884*x5^3*x6^4*x7 + 336*x4*x5*x6^5*x7 + 168*x5^2*x6^5*x7 + (-72)*x3^4*x5^2*x7^2 + (-72)*x3^3*x5^3*x7^2 + (-3968)*x3^2*x4*x5^3*x7^2 + (-1310)*x2*x4^2*x5^3*x7^2 + (-1730)*x4^3*x5^3*x7^2 + 72*x2*x3*x5^4*x7^2 + 72*x3^2*x5^4*x7^2 + (-72)*x2*x4*x5^4*x7^2 + (-3946)*x3*x4*x5^4*x7^2 + (-1872)*x4^2*x5^4*x7^2 + 72*x3*x5^5*x7^2 + (-72)*x4*x5^5*x7^2 + 158*x3*x4^4*x6*x7^2 + 162*x3^4*x5*x6*x7^2 + 3684*x2*x4^3*x5*x6*x7^2 + 3684*x4^4*x5*x6*x7^2 + (-1652)*x3^3*x5^2*x6*x7^2 + (-8622)*x3^2*x5^3*x6*x7^2 + (-42836)*x2*x4*x5^3*x6*x7^2 + (-5890)*x2*x5^4*x6*x7^2 + (-13058)*x3*x5^4*x6*x7^2 + (-41558)*x4*x5^4*x6*x7^2 + (-5890)*x5^5*x6*x7^2 + 72*x3^4*x6^2*x7^2 + 32*x3^2*x4^2*x6^2*x7^2 + 158*x2*x4^3*x6^2*x7^2 + 696*x3*x4^3*x6^2*x7^2 + 158*x4^4*x6^2*x7^2 + 210*x3^3*x5*x6^2*x7^2 + 421302*x3*x4^2*x5*x6^2*x7^2 + 3842*x4^3*x5*x6^2*x7^2 + 12106*x2*x3*x5^2*x6^2*x7^2 + 6904*x3^2*x5^2*x6^2*x7^2 + (-317758)*x2*x4*x5^2*x6^2*x7^2 + (-61142)*x3*x4*x5^2*x6^2*x7^2 + 7946*x4^2*x5^2*x6^2*x7^2 + (-35944)*x2*x5^3*x6^2*x7^2 + (-32624)*x3*x5^3*x6^2*x7^2 + (-354340)*x4*x5^3*x6^2*x7^2 + (-34320)*x5^4*x6^2*x7^2 + 464*x3^3*x6^3*x7^2 + 1872*x2*x3*x4*x6^3*x7^2 + (-82)*x3^2*x4*x6^3*x7^2 + 484*x2*x4^2*x6^3*x7^2 + 1582*x3*x4^2*x6^3*x7^2 + 642*x4^3*x6^3*x7^2 + (-16374)*x2*x3*x5*x6^3*x7^2 + (-1802)*x3^2*x5*x6^3*x7^2 + (-296432)*x2*x4*x5*x6^3*x7^2 + 30128*x3*x4*x5*x6^3*x7^2 + (-294744)*x4^2*x5*x6^3*x7^2 + (-124510)*x2*x5^2*x6^3*x7^2 + (-119248)*x3*x5^2*x6^3*x7^2 + 37976*x4*x5^2*x6^3*x7^2 + (-152762)*x5^3*x6^3*x7^2 + (-32)*x2*x3*x6^4*x7^2 + 544*x3^2*x6^4*x7^2 + 158*x2*x4*x6^4*x7^2 + 44*x3*x4*x6^4*x7^2 + 642*x4^2*x6^4*x7^2 + (-3530)*x2*x5*x6^4*x7^2 + (-5868)*x3*x5*x6^4*x7^2 + (-296972)*x4*x5*x6^4*x7^2 + (-142448)*x5^2*x6^4*x7^2 + (-168)*x2*x6^5*x7^2 + (-16)*x3*x6^5*x7^2 + (-10)*x4*x6^5*x7^2 + (-3882)*x5*x6^5*x7^2 + (-168)*x6^6*x7^2 + 252*x3^4*x5*x7^3 + (-167314)*x3*x4^3*x5*x7^3 + 130*x3^3*x5^2*x7^3 + (-100308)*x3^2*x4*x5^2*x7^3 + 13878*x2*x4^2*x5^2*x7^3 + 134208*x3*x4^2*x5^2*x7^3 + (-102230)*x4^3*x5^2*x7^3 + (-14)*x2*x3*x5^3*x7^3 + (-64)*x3^2*x5^3*x7^3 + 7848*x2*x4*x5^3*x7^3 + (-50400)*x3*x4*x5^3*x7^3 + 19092*x4^2*x5^3*x7^3 + 72*x2*x5^4*x7^3 + 130*x3*x5^4*x7^3 + 7848*x4*x5^4*x7^3 + 72*x5^5*x7^3 + (-252)*x3^4*x6*x7^3 + (-238508)*x3^2*x4^2*x6*x7^3 + (-158)*x2*x4^3*x6*x7^3 + (-248842)*x3*x4^3*x6*x7^3 + (-158)*x4^4*x6*x7^3 + 35602*x3^3*x5*x6*x7^3 + 334367*x3^2*x4*x5*x6*x7^3 + (-98294)*x2*x4^2*x5*x6*x7^3 + (-19930)*x3*x4^2*x5*x6*x7^3 + (-94768)*x4^3*x5*x6*x7^3 + (-132940)*x2*x3*x5^2*x6*x7^3 + (-10584)*x3^2*x5^2*x6*x7^3 + 81054*x2*x4*x5^2*x6*x7^3 + 73738*x3*x4*x5^2*x6*x7^3 + 31537*x4^2*x5^2*x6*x7^3 + (-46464)*x2*x5^3*x6*x7^3 + (-97598)*x3*x5^3*x6*x7^3 + (-82748)*x4*x5^3*x6*x7^3 + (-52210)*x5^4*x6*x7^3 + (-3630)*x3^3*x6^2*x7^3 + 696656*x2*x3*x4*x6^2*x7^3 + 221620*x3^2*x4*x6^2*x7^3 + (-141366)*x2*x4^2*x6^2*x7^3 + (-310356)*x3*x4^2*x6^2*x7^3 + (-141366)*x4^3*x6^2*x7^3 + 1155592*x2*x3*x5*x6^2*x7^3 + 460940*x3^2*x5*x6^2*x7^3 + 859996*x2*x4*x5*x6^2*x7^3 + 2654342*x3*x4*x5*x6^2*x7^3 + 725146*x4^2*x5*x6^2*x7^3 + 526100*x2*x5^2*x6^2*x7^3 + 944380*x3*x5^2*x6^2*x7^3 + 1410774*x4*x5^2*x6^2*x7^3 + 366398*x5^3*x6^2*x7^3 + (-77890)*x2*x3*x6^3*x7^3 + 143204*x3^2*x6^3*x7^3 + 6182*x2*x4*x6^3*x7^3 + 150306*x3*x4*x6^3*x7^3 + (-133876)*x4^2*x6^3*x7^3 + (-27488)*x2*x5*x6^3*x7^3 + 548630*x3*x5*x6^3*x7^3 + 1560736*x4*x5*x6^3*x7^3 + 1480980*x5^2*x6^3*x7^3 + 147518*x2*x6^4*x7^3 + 293612*x3*x6^4*x7^3 + 155482*x4*x6^4*x7^3 + (-121670)*x5*x6^4*x7^3 + 147166*x6^5*x7^3 + 139044*x3^2*x4^2*x7^4 + 167314*x3*x4^3*x7^4 + 89946*x3^3*x5*x7^4 + 434113*x2*x3*x4*x5*x7^4 + (-123828)*x3^2*x4*x5*x7^4 + 271274*x2*x4^2*x5*x7^4 + (-229370)*x3*x4^2*x5*x7^4 + 271274*x4^3*x5*x7^4 + 93694*x2*x3*x5^2*x7^4 + 172650*x3^2*x5^2*x7^4 + (-73552)*x2*x4*x5^2*x7^4 + (-109994)*x3*x4*x5^2*x7^4 + (-57470)*x4^2*x5^2*x7^4 + (-5904)*x2*x5^3*x7^4 + 77088*x3*x5^3*x7^4 + (-60920)*x4*x5^3*x7^4 + (-5832)*x5^4*x7^4 + (-89946)*x3^3*x6*x7^4 + (-673994)*x2*x3*x4*x6*x7^4 + (-376132)*x3^2*x4*x6*x7^4 + 312038*x2*x4^2*x6*x7^4 + (-89718)*x3*x4^2*x6*x7^4 + 311880*x4^3*x6*x7^4 + 266962*x2*x3*x5*x6*x7^4 + (-117934)*x3^2*x5*x6*x7^4 + 58636*x2*x4*x5*x6*x7^4 + 130429*x3*x4*x5*x6*x7^4 + 324614*x4^2*x5*x6*x7^4 + (-225094)*x2*x5^2*x6*x7^4 + (-491360)*x3*x5^2*x6*x7^4 + 412986*x4*x5^2*x6*x7^4 + (-283438)*x5^3*x6*x7^4 + (-2345773)*x2*x3*x6^2*x7^4 + (-883342)*x3^2*x6^2*x7^4 + (-1007370)*x2*x4*x6^2*x7^4 + (-3438753)*x3*x4*x6^2*x7^4 + (-778130)*x4^2*x6^2*x7^4 + (-1343066)*x2*x5*x6^2*x7^4 + (-1872402)*x3*x5*x6^2*x7^4 + (-2990085)*x4*x5*x6^2*x7^4 + (-955499)*x5^2*x6^2*x7^4 + (-582018)*x2*x6^3*x7^4 + (-1222684)*x3*x6^3*x7^4 + (-1665804)*x4*x6^3*x7^4 + (-2223553)*x5*x6^3*x7^4 + (-658724)*x6^4*x7^4 + (-422199)*x2*x3*x4*x7^5 + 66766*x3^2*x4*x7^5 + (-167314)*x2*x4^2*x7^5 + 66766*x3*x4^2*x7^5 + (-167314)*x4^3*x7^5 + 145750*x2*x3*x5*x7^5 + 326640*x3^2*x5*x7^5 + 353480*x2*x4*x5*x7^5 + (-75067)*x3*x4*x5*x7^5 + 457440*x4^2*x5*x7^5 + 41398*x2*x5^2*x7^5 + 361350*x3*x5^2*x7^5 + 230130*x4*x5^2*x7^5 + 35494*x5^3*x7^5 + 876991*x2*x3*x6*x7^5 + 411828*x3^2*x6*x7^5 + 1132282*x2*x4*x6*x7^5 + 1671637*x3*x4*x6*x7^5 + 1277006*x4^2*x6*x7^5 + (-755383)*x2*x5*x6*x7^5 + (-231461)*x3*x5*x6*x7^5 + 945158*x4*x5*x6*x7^5 + (-870329)*x5^2*x6*x7^5 + 1323907*x2*x6^2*x7^5 + 1124673*x3*x6^2*x7^5 + 1563291*x4*x6^2*x7^5 + (-391323)*x5*x6^2*x7^5 + (-813434)*x6^3*x7^5 + 77345*x2*x3*x7^6 + (-205810)*x3^2*x7^6 + (-373124)*x2*x4*x7^6 + (-229013)*x3*x4*x7^6 + (-540438)*x4^2*x7^6 + (-56552)*x2*x5*x7^6 + (-25416)*x3*x5*x7^6 + 206959*x4*x5*x7^6 + (-15154)*x5^2*x7^6 + 822172*x2*x6*x7^6 + 1117884*x3*x6*x7^6 + 1581330*x4*x6*x7^6 + (-286769)*x5*x6*x7^6 + 2521548*x6^2*x7^6 + (-488965)*x2*x7^7 + (-694775)*x3*x7^7 + (-862089)*x4*x7^7 + (-545517)*x5*x7^7 + 616362*x6*x7^7 + (-488965)*x7^8 + 160208*x2 + 113558*x3 + 285268*x4 + 141198*x5 + (-534252)*x6 + (-402399)*x7""",\
"""(-144)*x4^2*x5^3*x6^3 + 144*x3^2*x4*x5^4*x7 + (-144)*x3^3*x5^3*x6*x7 + (-144)*x3^2*x5^4*x6*x7 + 288*x3*x5^4*x6^2*x7 + 146*x3^2*x5^2*x6^3*x7 + (-4024)*x2*x4*x5^2*x6^3*x7 + (-4288)*x4^2*x5^2*x6^3*x7 + (-1570)*x2*x5^3*x6^3*x7 + (-1280)*x3*x5^3*x6^3*x7 + (-11278)*x4*x5^3*x6^3*x7 + (-1714)*x5^4*x6^3*x7 + (-336)*x2*x4*x5*x6^4*x7 + (-708)*x3*x4*x5*x6^4*x7 + (-336)*x4^2*x5*x6^4*x7 + (-168)*x2*x5^2*x6^4*x7 + (-22)*x3*x5^2*x6^4*x7 + (-4792)*x4*x5^2*x6^4*x7 + (-1884)*x5^3*x6^4*x7 + (-336)*x4*x5*x6^5*x7 + (-168)*x5^2*x6^5*x7 + 72*x3^4*x5^2*x7^2 + 72*x3^3*x5^3*x7^2 + 3968*x3^2*x4*x5^3*x7^2 + 1310*x2*x4^2*x5^3*x7^2 + 1730*x4^3*x5^3*x7^2 + (-72)*x2*x3*x5^4*x7^2 + (-72)*x3^2*x5^4*x7^2 + 72*x2*x4*x5^4*x7^2 + 3946*x3*x4*x5^4*x7^2 + 1872*x4^2*x5^4*x7^2 + (-72)*x3*x5^5*x7^2+ 72*x4*x5^5*x7^2 + (-158)*x3*x4^4*x6*x7^2 + (-162)*x3^4*x5*x6*x7^2 + (-3684)*x2*x4^3*x5*x6*x7^2 + (-3684)*x4^4*x5*x6*x7^2 + 1652*x3^3*x5^2*x6*x7^2 + 8622*x3^2*x5^3*x6*x7^2 + 42836*x2*x4*x5^3*x6*x7^2 + 5890*x2*x5^4*x6*x7^2 + 13058*x3*x5^4*x6*x7^2 + 41558*x4*x5^4*x6*x7^2 + 5890*x5^5*x6*x7^2 + (-72)*x3^4*x6^2*x7^2 + (-32)*x3^2*x4^2*x6^2*x7^2 + (-158)*x2*x4^3*x6^2*x7^2 + (-696)*x3*x4^3*x6^2*x7^2 + (-158)*x4^4*x6^2*x7^2 + (-210)*x3^3*x5*x6^2*x7^2 + (-421302)*x3*x4^2*x5*x6^2*x7^2 + (-3842)*x4^3*x5*x6^2*x7^2 + (-12106)*x2*x3*x5^2*x6^2*x7^2 + (-6904)*x3^2*x5^2*x6^2*x7^2 + 317758*x2*x4*x5^2*x6^2*x7^2 + 61142*x3*x4*x5^2*x6^2*x7^2 + (-7946)*x4^2*x5^2*x6^2*x7^2 + 35944*x2*x5^3*x6^2*x7^2 + 32624*x3*x5^3*x6^2*x7^2 + 354340*x4*x5^3*x6^2*x7^2 + 34320*x5^4*x6^2*x7^2 + (-464)*x3^3*x6^3*x7^2 + (-1872)*x2*x3*x4*x6^3*x7^2 + 82*x3^2*x4*x6^3*x7^2 + (-484)*x2*x4^2*x6^3*x7^2 + (-1582)*x3*x4^2*x6^3*x7^2 + (-642)*x4^3*x6^3*x7^2 +16374*x2*x3*x5*x6^3*x7^2 + 1802*x3^2*x5*x6^3*x7^2 + 296432*x2*x4*x5*x6^3*x7^2 + (-30128)*x3*x4*x5*x6^3*x7^2 + 294744*x4^2*x5*x6^3*x7^2 + 124510*x2*x5^2*x6^3*x7^2 + 119248*x3*x5^2*x6^3*x7^2 + (-37976)*x4*x5^2*x6^3*x7^2 + 152762*x5^3*x6^3*x7^2 + 32*x2*x3*x6^4*x7^2 + (-544)*x3^2*x6^4*x7^2 + (-158)*x2*x4*x6^4*x7^2 + (-44)*x3*x4*x6^4*x7^2 + (-642)*x4^2*x6^4*x7^2 + 3530*x2*x5*x6^4*x7^2 + 5868*x3*x5*x6^4*x7^2 + 296972*x4*x5*x6^4*x7^2 + 142448*x5^2*x6^4*x7^2 + 168*x2*x6^5*x7^2 + 16*x3*x6^5*x7^2 + 10*x4*x6^5*x7^2 + 3882*x5*x6^5*x7^2 + 168*x6^6*x7^2 + (-252)*x3^4*x5*x7^3 + 167314*x3*x4^3*x5*x7^3 + (-130)*x3^3*x5^2*x7^3 + 100308*x3^2*x4*x5^2*x7^3 + (-13878)*x2*x4^2*x5^2*x7^3 + (-134208)*x3*x4^2*x5^2*x7^3 + 102230*x4^3*x5^2*x7^3 + 14*x2*x3*x5^3*x7^3 + 64*x3^2*x5^3*x7^3 + (-7848)*x2*x4*x5^3*x7^3 + 50400*x3*x4*x5^3*x7^3 + (-19092)*x4^2*x5^3*x7^3 + (-72)*x2*x5^4*x7^3 + (-130)*x3*x5^4*x7^3 + (-7848)*x4*x5^4*x7^3 + (-72)*x5^5*x7^3 + 252*x3^4*x6*x7^3 + 238508*x3^2*x4^2*x6*x7^3 + 158*x2*x4^3*x6*x7^3 + 248842*x3*x4^3*x6*x7^3 + 158*x4^4*x6*x7^3 + (-35602)*x3^3*x5*x6*x7^3 + (-334367)*x3^2*x4*x5*x6*x7^3 + 98294*x2*x4^2*x5*x6*x7^3 + 19930*x3*x4^2*x5*x6*x7^3 + 94768*x4^3*x5*x6*x7^3 + 132940*x2*x3*x5^2*x6*x7^3 + 10584*x3^2*x5^2*x6*x7^3 + (-81054)*x2*x4*x5^2*x6*x7^3 + (-73738)*x3*x4*x5^2*x6*x7^3 + (-31537)*x4^2*x5^2*x6*x7^3 + 46464*x2*x5^3*x6*x7^3 + 97598*x3*x5^3*x6*x7^3 + 82748*x4*x5^3*x6*x7^3 + 52210*x5^4*x6*x7^3 + 3630*x3^3*x6^2*x7^3 + (-696656)*x2*x3*x4*x6^2*x7^3 + (-221620)*x3^2*x4*x6^2*x7^3 + 141366*x2*x4^2*x6^2*x7^3 + 310356*x3*x4^2*x6^2*x7^3 + 141366*x4^3*x6^2*x7^3 + (-1155592)*x2*x3*x5*x6^2*x7^3 + (-460940)*x3^2*x5*x6^2*x7^3 + (-859996)*x2*x4*x5*x6^2*x7^3 + (-2654342)*x3*x4*x5*x6^2*x7^3 + (-725146)*x4^2*x5*x6^2*x7^3 + (-526100)*x2*x5^2*x6^2*x7^3 + (-944380)*x3*x5^2*x6^2*x7^3 + (-1410774)*x4*x5^2*x6^2*x7^3 + (-366398)*x5^3*x6^2*x7^3 + 77890*x2*x3*x6^3*x7^3 + (-143204)*x3^2*x6^3*x7^3 + (-6182)*x2*x4*x6^3*x7^3 + (-150306)*x3*x4*x6^3*x7^3 + 133876*x4^2*x6^3*x7^3 + 27488*x2*x5*x6^3*x7^3 + (-548630)*x3*x5*x6^3*x7^3 + (-1560736)*x4*x5*x6^3*x7^3 + (-1480980)*x5^2*x6^3*x7^3 + (-147518)*x2*x6^4*x7^3 + (-293612)*x3*x6^4*x7^3 + (-155482)*x4*x6^4*x7^3 + 121670*x5*x6^4*x7^3 + (-147166)*x6^5*x7^3 + (-139044)*x3^2*x4^2*x7^4 + (-167314)*x3*x4^3*x7^4 + (-89946)*x3^3*x5*x7^4 + (-434113)*x2*x3*x4*x5*x7^4 + 123828*x3^2*x4*x5*x7^4 + (-271274)*x2*x4^2*x5*x7^4 + 229370*x3*x4^2*x5*x7^4 + (-271274)*x4^3*x5*x7^4 + (-93694)*x2*x3*x5^2*x7^4 + (-172650)*x3^2*x5^2*x7^4 + 73552*x2*x4*x5^2*x7^4 + 109994*x3*x4*x5^2*x7^4 + 57470*x4^2*x5^2*x7^4 + 5904*x2*x5^3*x7^4 + (-77088)*x3*x5^3*x7^4 + 60920*x4*x5^3*x7^4 + 5832*x5^4*x7^4 + 89946*x3^3*x6*x7^4 + 673994*x2*x3*x4*x6*x7^4 + 376132*x3^2*x4*x6*x7^4 + (-312038)*x2*x4^2*x6*x7^4 + 89718*x3*x4^2*x6*x7^4 + (-311880)*x4^3*x6*x7^4 + (-266962)*x2*x3*x5*x6*x7^4 + 117934*x3^2*x5*x6*x7^4 + (-58636)*x2*x4*x5*x6*x7^4 + (-130429)*x3*x4*x5*x6*x7^4 + (-324614)*x4^2*x5*x6*x7^4+ 225094*x2*x5^2*x6*x7^4 + 491360*x3*x5^2*x6*x7^4 + (-412986)*x4*x5^2*x6*x7^4 + 283438*x5^3*x6*x7^4 + 2345773*x2*x3*x6^2*x7^4 + 883342*x3^2*x6^2*x7^4 + 1007370*x2*x4*x6^2*x7^4 + 3438753*x3*x4*x6^2*x7^4 + 778130*x4^2*x6^2*x7^4 + 1343066*x2*x5*x6^2*x7^4 + 1872402*x3*x5*x6^2*x7^4 + 2990085*x4*x5*x6^2*x7^4 +955499*x5^2*x6^2*x7^4 + 582018*x2*x6^3*x7^4 + 1222684*x3*x6^3*x7^4 + 1665804*x4*x6^3*x7^4 + 2223553*x5*x6^3*x7^4 + 658724*x6^4*x7^4 + 422199*x2*x3*x4*x7^5 + (-66766)*x3^2*x4*x7^5 + 167314*x2*x4^2*x7^5 + (-66766)*x3*x4^2*x7^5 + 167314*x4^3*x7^5 + (-145750)*x2*x3*x5*x7^5 + (-326640)*x3^2*x5*x7^5 + (-353480)*x2*x4*x5*x7^5 + 75067*x3*x4*x5*x7^5 + (-457440)*x4^2*x5*x7^5 + (-41398)*x2*x5^2*x7^5 + (-361350)*x3*x5^2*x7^5 + (-230130)*x4*x5^2*x7^5 + (-35494)*x5^3*x7^5 + (-876991)*x2*x3*x6*x7^5 + (-411828)*x3^2*x6*x7^5 + (-1132282)*x2*x4*x6*x7^5 + (-1671637)*x3*x4*x6*x7^5 + (-1277006)*x4^2*x6*x7^5 + 755383*x2*x5*x6*x7^5 + 231461*x3*x5*x6*x7^5 + (-945158)*x4*x5*x6*x7^5 + 870329*x5^2*x6*x7^5 + (-1323907)*x2*x6^2*x7^5 + (-1124673)*x3*x6^2*x7^5 + (-1563291)*x4*x6^2*x7^5 + 391323*x5*x6^2*x7^5 + 813434*x6^3*x7^5 + (-77345)*x2*x3*x7^6 + 205810*x3^2*x7^6 + 373124*x2*x4*x7^6 + 229013*x3*x4*x7^6 + 540438*x4^2*x7^6 + 56552*x2*x5*x7^6 + 25416*x3*x5*x7^6 + (-206959)*x4*x5*x7^6 + 15154*x5^2*x7^6 + (-822172)*x2*x6*x7^6 + (-1117884)*x3*x6*x7^6 + (-1581330)*x4*x6*x7^6 + 286769*x5*x6*x7^6 + (-2521548)*x6^2*x7^6 + 488965*x2*x7^7 + 694775*x3*x7^7 + 862089*x4*x7^7 + 545517*x5*x7^7 + (-616362)*x6*x7^7 + 488965*x7^8 + (-160208)*x2 + (-113558)*x3 + (-285268)*x4 + (-141198)*x5 + 534252*x6 + 402399*x7"""]

plst = map(lambda s: ginv.Poly(ip, s), lst)
for p in plst:
  print p.lc()

from sets import Set as set

pset = map(lambda p: set(map(lambda mc: str(mc[0]), p)), plst)
for i in range(1,len(pset)):
  print pset[0].difference(pset[i])

for p in plst[1:]:
  print p.reduction(plst[0])
